SystemOrganization addCategory: #'A4BP-Tests-BPEL20-source'!

TestCase subclass: #BPEL20BPSourceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-Tests-BPEL20-source'!

BPEL20BPSourceTest subclass: #BPEL20BPCFCMetricScenarios
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-Tests-BPEL20-source'!

!BPEL20BPCFCMetricScenarios methodsFor: 'src' stamp: 'AlvaroJosePeraltaOcampo 11/12/2014 09:47'!
bankLoanProcessV001
^ 
'
<?xml version = "1.0" encoding = "UTF-8" ?>
<!!--
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  Oracle JDeveloper BPEL Designer 
  
  Created: Mon Apr 21 10:39:40 CLST 2014
  Author:  aljo
  Type: BPEL 2.0 Process
  Purpose: Asynchronous BPEL Process
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
-->
<process name="BankLoanProcessV001"
         targetNamespace="http://xmlns.oracle.com/CFCMetricScenario/Project1/BankLoanProcessV001"
         xmlns="http://docs.oasis-open.org/wsbpel/2.0/process/executable"
         xmlns:client="http://xmlns.oracle.com/CFCMetricScenario/Project1/BankLoanProcessV001"
         xmlns:ora="http://schemas.oracle.com/xpath/extension"
         xmlns:bpelx="http://schemas.oracle.com/bpel/extension"
         xmlns:bpel="http://docs.oasis-open.org/wsbpel/2.0/process/executable">

    <import namespace="http://xmlns.oracle.com/CFCMetricScenario/Project1/BankLoanProcessV001" location="BankLoanProcessV001.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <!!-- 
      ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
        PARTNERLINKS                                                      
        List of services participating in this BPEL process               
      ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    --> 
    <partnerLinks>
        <!!-- 
      The ''client'' role represents the requester of this service. It is 
      used for callback. The location and correlation information associated
      with the client role are automatically set using WS-Addressing.
    -->
        <partnerLink name="bankloanprocessv001_client" partnerLinkType="client:BankLoanProcessV001" myRole="BankLoanProcessV001Provider" partnerRole="BankLoanProcessV001Requester"/>
    </partnerLinks>

    <!!-- 
      ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
        VARIABLES                                                        
        List of messages and XML documents used within this BPEL process 
      ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    -->
    <variables>
        <!!-- Reference to the message passed as input during initiation -->
        <variable name="inputVariable" messageType="client:BankLoanProcessV001RequestMessage"/>

        <!!-- Reference to the message that will be sent back to the requester during callback -->
        <variable name="outputVariable" messageType="client:BankLoanProcessV001ResponseMessage"/>
    </variables>

    <!!-- 
      ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
       ORCHESTRATION LOGIC                                               
       Set of activities coordinating the flow of messages across the    
       services integrated within this business process                  
      ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    -->
    <sequence name="main">
        <!!-- Receive input from requestor. (Note: This maps to operation defined in BankLoanProcessV001.wsdl) -->
        <receive name="receiveInput" partnerLink="bankloanprocessv001_client" portType="client:BankLoanProcessV001" operation="process" variable="inputVariable" createInstance="yes"/>
        <empty name="FillLoanRequest"/>
        <empty name="CheckEducationLoan"/>
        <empty name="NotifyEducationLoanClient"/>
        <empty name="ArchiveApplication"/>
        <!!-- 
          Asynchronous callback to the requester. (Note: the callback location and correlation id is transparently handled using WS-addressing.)
        -->
        <invoke name="callbackClient" partnerLink="bankloanprocessv001_client" portType="client:BankLoanProcessV001Callback" operation="processResponse" inputVariable="outputVariable"/>
    </sequence>
</process>
'! !

!BPEL20BPCFCMetricScenarios methodsFor: 'testCFCMetric' stamp: 'AlvaroJosePeraltaOcampo 11/12/2014 09:47'!
testBankLoanProcessV001
	"comment stating purpose of message"

	| parser process value |
	parser := BPParserBPEL new.
	parser parseString: BPCFCMetricScenarios new bankLoanProcessV001.
	process := parser processes at: 1.
	value := process calculateCFC.
	self assert: value = 6! !

BPEL20BPSourceTest subclass: #BPEL20BPSourceComplexityScorer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-Tests-BPEL20-source'!

!BPEL20BPSourceComplexityScorer methodsFor: 'bpel' stamp: 'AlvaroJosePeraltaOcampo 11/12/2014 09:46'!
bpel_DisputeEvent
^ '
<process name="DisputeEvent">
  <sequence name="main">
    <receive name="CustSubmit" partnerLink="client"
             portType="ns1:DisputeCustomerChannel" operation="submit"
             variable="request" createInstance="yes"/>
    <assign name="SetOpsSubmit">
      <copy>
        <from expression="string(''ReviewCapture'')"/>
        <to variable="request" part="dispute" query="/ns1:Dispute/ns1:action"/>
      </copy>
    </assign>
    <invoke name="OpsSubmit" partnerLink="Ops"
            portType="ns1:DisputeOperationsChannel" operation="pickup"
            inputVariable="request"/>
    <while name="While" condition="bpws:getVariableData(''moreEvents'')=true()">
      <pick name="Pick">
        <onMessage portType="ns1:DisputeCustomerChannel" operation="cancel"
                   variable="request" partnerLink="client">
          <switch name="Switch">
            <case condition="contains(bpws:getVariableData(''nextEvents''), ''cancel'')">
              <sequence name="Sequence">
                <assign name="SetAction">
                  <copy>
                    <from expression="string(''Cancelled'')"/>
                    <to variable="request" part="dispute"
                        query="/ns1:Dispute/ns1:action"/>
                  </copy>
                </assign>
                <invoke name="notifyCust" partnerLink="client"
                        portType="ns1:DisputeCustomerCallback"
                        operation="completed" inputVariable="request"/>
                <invoke name="notifyOps" partnerLink="Ops"
                        portType="ns1:DisputeOperationsChannel"
                        operation="cancel" inputVariable="request"/>
                <assign name="SetDone">
                  <copy>
                    <from expression="false()"/>
                    <to variable="moreEvents"/>
                  </copy>
                </assign>
              </sequence>
            </case>
          </switch>
        </onMessage>
        <onMessage portType="ns1:DisputeCustomerChannel" operation="update"
                   variable="request" partnerLink="client">
          <switch name="Switch">
            <case condition="contains(bpws:getVariableData(''nextEvents''), ''update'')">
              <sequence name="Sequence">
                <switch name="Switch">
                  <case condition="bpws:getVariableData(''isCaptured'')=true()">
                    <sequence name="Sequence">
                      <assign name="SetAction">
                        <copy>
                          <from expression="string(''ReviewCustOnDraft'')"/>
                          <to variable="request" part="dispute"
                              query="/ns1:Dispute/ns1:action"/>
                        </copy>
                      </assign>
                      <assign name="SetNext">
                        <copy>
                          <from expression="''rejected chargedBack''"/>
                          <to variable="nextEvents"/>
                        </copy>
                      </assign>
                    </sequence>
                  </case>
                  <otherwise>
                    <sequence name="Sequence">
                      <assign name="SetAction">
                        <copy>
                          <from expression="string(''ReviewCapture'')"/>
                          <to variable="request" part="dispute"
                              query="/ns1:Dispute/ns1:action"/>
                        </copy>
                      </assign>
                      <assign name="SetNext">
                        <copy>
                          <from expression="''rejected writtenOff requestedDocs captured cancel''"/>
                          <to variable="nextEvents"/>
                        </copy>
                      </assign>
                    </sequence>
                  </otherwise>
                </switch>
                <invoke name="ops" partnerLink="Ops"
                        portType="ns1:DisputeOperationsChannel"
                        operation="pickup" inputVariable="request"/>
              </sequence>
            </case>
          </switch>
        </onMessage>
        <onMessage portType="ns1:DisputeCustomerChannel" operation="simTimeout"
                   variable="request" partnerLink="client">
          <switch name="Switch">
            <case condition="contains(bpws:getVariableData(''nextEvents''), ''simTimeoutCust'')">
              <switch name="Switch">
                <case condition="bpws:getVariableData(''isCaptured'')=true()">
                  <sequence name="Sequence">
                    <assign name="SetAction">
                      <copy>
                        <from expression="string(''OpsContactingCust'')"/>
                        <to variable="request" part="dispute"
                            query="/ns1:Dispute/ns1:action"/>
                      </copy>
                    </assign>
                    <assign name="SetNext">
                      <copy>
                        <from expression="''rejected chargedBack''"/>
                        <to variable="nextEvents"/>
                      </copy>
                    </assign>
                    <invoke name="ops" partnerLink="Ops"
                            portType="ns1:DisputeOperationsChannel"
                            operation="pickup" inputVariable="request"/>
                  </sequence>
                </case>
                <otherwise>
                  <sequence name="Sequence">
                    <assign name="SetAction">
                      <copy>
                        <from expression="string(''Rejected'')"/>
                        <to variable="request" part="dispute"
                            query="/ns1:Dispute/ns1:action"/>
                      </copy>
                    </assign>
                    <assign name="setDone">
                      <copy>
                        <from expression="false()"/>
                        <to variable="moreEvents"/>
                      </copy>
                    </assign>
                    <invoke name="notifyCust" partnerLink="client"
                            portType="ns1:DisputeCustomerCallback"
                            operation="completed" inputVariable="request"/>
                  </sequence>
                </otherwise>
              </switch>
            </case>
          </switch>
        </onMessage>
        <onMessage portType="ns1:DisputeOperationsCallback" operation="rejected"
                   variable="request" partnerLink="Ops">
          <switch name="Switch">
            <case condition="contains(bpws:getVariableData(''nextEvents''), ''rejected'')">
              <sequence name="Sequence">
                <assign name="SetAction">
                  <copy>
                    <from expression="string(''Rejected'')"/>
                    <to variable="request" part="dispute"
                        query="/ns1:Dispute/ns1:action"/>
                  </copy>
                </assign>
                <invoke name="notifyCust" partnerLink="client"
                        portType="ns1:DisputeCustomerCallback"
                        operation="completed" inputVariable="request"/>
                <assign name="SetDone">
                  <copy>
                    <from expression="false()"/>
                    <to variable="moreEvents"/>
                  </copy>
                </assign>
              </sequence>
            </case>
          </switch>
        </onMessage>
        <onMessage portType="ns1:DisputeOperationsCallback"
                   operation="writtenOff" variable="request" partnerLink="Ops">
          <switch name="Switch">
            <case condition="contains(bpws:getVariableData(''nextEvents''), ''writtenOff'')">
              <sequence name="Sequence">
                <switch name="Switch">
                  <case condition="bpws:getVariableData(''arbRequested'')=true()">
                    <invoke name="RejectArb" partnerLink="Net"
                            portType="ns1:DisputeChannel"
                            operation="rejectArbitration"
                            inputVariable="request"/>
                  </case>
                </switch>
                <assign name="SetAction">
                  <copy>
                    <from expression="string(''WrittenOff'')"/>
                    <to variable="request" part="dispute"
                        query="/ns1:Dispute/ns1:action"/>
                  </copy>
                </assign>
                <assign name="SetDone">
                  <copy>
                    <from expression="false()"/>
                    <to variable="moreEvents"/>
                  </copy>
                </assign>
                <invoke name="notifyCust" partnerLink="client"
                        portType="ns1:DisputeCustomerCallback"
                        operation="completed" inputVariable="request"/>
              </sequence>
            </case>
          </switch>
        </onMessage>
        <onMessage portType="ns1:DisputeOperationsCallback" operation="captured"
                   variable="request" partnerLink="Ops">
          <switch name="Switch">
            <case condition="contains(bpws:getVariableData(''nextEvents''), ''captured'')">
              <sequence name="Sequence">
                <assign name="SetAction">
                  <copy>
                    <from expression="string(''Captured'')"/>
                    <to variable="request" part="dispute"
                        query="/ns1:Dispute/ns1:action"/>
                  </copy>
                </assign>
                <invoke name="ops" partnerLink="Ops"
                        portType="ns1:DisputeOperationsChannel"
                        operation="pickup" inputVariable="request"/>
                <assign name="SetNext">
                  <copy>
                    <from expression="''rejected writtenOff chargedBack requestedDocs''"/>
                    <to variable="nextEvents"/>
                  </copy>
                </assign>
                <assign name="SetCaptured">
                  <copy>
                    <from expression="true()"/>
                    <to variable="isCaptured"/>
                  </copy>
                </assign>
              </sequence>
            </case>
          </switch>
        </onMessage>
        <onMessage portType="ns1:DisputeOperationsCallback"
                   operation="requestedDocs" variable="request"
                   partnerLink="Ops">
          <switch name="Switch">
            <case condition="contains(bpws:getVariableData(''nextEvents''), ''requestedDocs'')">
              <sequence name="Sequence">
                <switch name="Switch">
                  <case condition="bpws:getVariableData(''gotDraft'')=true()">
                    <sequence>
                      <invoke name="notifyCust" partnerLink="client"
                              portType="ns1:DisputeCustomerCallback"
                              operation="updateRequired" inputVariable="request"/>
                      <assign name="setNext">
                        <copy>
                          <from expression="''update simTimeoutCust''"/>
                          <to variable="nextEvents"/>
                        </copy>
                      </assign>
                    </sequence>
                  </case>
                  <case condition="bpws:getVariableData(''isCaptured'')=true()">
                    <sequence name="Sequence">
                      <invoke name="netDraft" partnerLink="Net"
                              portType="ns1:DisputeChannel"
                              operation="requestDraft" inputVariable="request"/>
                      <assign name="setNext">
                        <copy>
                          <from expression="''draft simTimeoutNet''"/>
                          <to variable="nextEvents"/>
                        </copy>
                      </assign>
                    </sequence>
                  </case>
                  <otherwise>
                    <sequence>
                      <invoke name="notifyCust" partnerLink="client"
                              portType="ns1:DisputeCustomerCallback"
                              operation="updateRequired" inputVariable="request"/>
                      <assign name="setNext">
                        <copy>
                          <from expression="''cancel update simTimeoutCust''"/>
                          <to variable="nextEvents"/>
                        </copy>
                      </assign>
                    </sequence>
                  </otherwise>
                </switch>
              </sequence>
            </case>
          </switch>
        </onMessage>
        <onMessage portType="ns1:DisputeOperationsCallback"
                   operation="chargedBack" variable="request" partnerLink="Ops">
          <switch name="Switch">
            <case condition="contains(bpws:getVariableData(''nextEvents''), ''chargedBack'')">
              <sequence name="Sequence">
                <switch name="Switch">
                  <case condition="bpws:getVariableData(''isRepresented'')=true()">
                    <assign name="setNext">
                      <copy>
                        <from expression="''credited arbitrationRequested simTimeoutNet''"/>
                        <to variable="nextEvents"/>
                      </copy>
                    </assign>
                  </case>
                  <otherwise>
                    <sequence name="Sequence">
                      <invoke name="Credit" partnerLink="client"
                              portType="ns1:DisputeCustomerCallback"
                              operation="credited" inputVariable="request"/>
                      <assign name="setNext">
                        <copy>
                          <from expression="''credited represented simTimeoutNet''"/>
                          <to variable="nextEvents"/>
                        </copy>
                      </assign>
                    </sequence>
                  </otherwise>
                </switch>
                <invoke name="NetCB" partnerLink="Net"
                        portType="ns1:DisputeChannel" operation="chargeback"
                        inputVariable="request"/>
                <assign name="SetCB">
                  <copy>
                    <from expression="true()"/>
                    <to variable="isChargedBack"/>
                  </copy>
                </assign>
              </sequence>
            </case>
          </switch>
        </onMessage>
        <onMessage portType="ns1:DisputeOperationsCallback"
                   operation="acceptedArbitration" variable="request"
                   partnerLink="Ops">
          <switch name="Switch">
            <case condition="contains(bpws:getVariableData(''nextEvents''), ''acceptedArbitration'')">
              <sequence name="Sequence">
                <assign name="setNext">
                  <copy>
                    <from expression="''rulingWon rulingLost''"/>
                    <to variable="nextEvents"/>
                  </copy>
                </assign>
                <invoke name="NetArbAccept" partnerLink="Net"
                        portType="ns1:DisputeChannel"
                        operation="acceptArbitration" inputVariable="request"/>
              </sequence>
            </case>
          </switch>
        </onMessage>
        <onMessage portType="ns1:DisputeCallback" operation="draft"
                   variable="request" partnerLink="Net">
          <switch name="Switch">
            <case condition="contains(bpws:getVariableData(''nextEvents''), ''draft'')">
              <sequence name="Sequence">
                <assign name="SetAction">
                  <copy>
                    <from expression="string(''ExaminingDraft'')"/>
                    <to variable="request" part="dispute"
                        query="/ns1:Dispute/ns1:action"/>
                  </copy>
                </assign>
                <invoke name="ops" partnerLink="Ops"
                        portType="ns1:DisputeOperationsChannel"
                        operation="pickup" inputVariable="request"/>
                <assign name="setNext">
                  <copy>
                    <from expression="''rejected chargedBack requestedDocs''"/>
                    <to variable="nextEvents"/>
                  </copy>
                </assign>
                <assign name="SetGotDraft">
                  <copy>
                    <from expression="true()"/>
                    <to variable="gotDraft"/>
                  </copy>
                </assign>
              </sequence>
            </case>
          </switch>
        </onMessage>
        <onMessage portType="ns1:DisputeCallback" operation="represented"
                   variable="request" partnerLink="Net">
          <switch name="Switch">
            <case condition="contains(bpws:getVariableData(''nextEvents''), ''represented'')">
              <sequence name="Sequence">
                <assign name="SetAction">
                  <copy>
                    <from expression="string(''Represented'')"/>
                    <to variable="request" part="dispute"
                        query="/ns1:Dispute/ns1:action"/>
                  </copy>
                </assign>
                <invoke name="ops" partnerLink="Ops"
                        portType="ns1:DisputeOperationsChannel"
                        operation="pickup" inputVariable="request"/>
                <assign name="setNext">
                  <copy>
                    <from expression="''rejected chargedBack writtenOff''"/>
                    <to variable="nextEvents"/>
                  </copy>
                </assign>
                <assign name="setRepresentd">
                  <copy>
                    <from expression="true()''"/>
                    <to variable="isRepresented"/>
                  </copy>
                </assign>
              </sequence>
            </case>
          </switch>
        </onMessage>
        <onMessage portType="ns1:DisputeCallback" operation="credited"
                   variable="request" partnerLink="Net">
          <switch name="Switch">
            <case condition="contains(bpws:getVariableData(''nextEvents''), ''credited'')">
              <sequence name="Sequence">
                <assign name="SetAction">
                  <copy>
                    <from expression="string(''Won'')"/>
                    <to variable="request" part="dispute"
                        query="/ns1:Dispute/ns1:action"/>
                  </copy>
                </assign>
                <invoke name="notifyCust" partnerLink="client"
                        portType="ns1:DisputeCustomerCallback"
                        operation="completed" inputVariable="request"/>
                <assign name="setDone">
                  <copy>
                    <from expression="false()"/>
                    <to variable="moreEvents"/>
                  </copy>
                </assign>
              </sequence>
            </case>
          </switch>
        </onMessage>
        <onMessage portType="ns1:DisputeCallback"
                   operation="arbitrationRequested" variable="request"
                   partnerLink="Net">
          <switch name="Switch">
            <case condition="contains(bpws:getVariableData(''nextEvents''), ''arbitrationRequested'')">
              <sequence name="Sequence">
                <assign name="SetAction">
                  <copy>
                    <from expression="string(''Arbitration'')"/>
                    <to variable="request" part="dispute"
                        query="/ns1:Dispute/ns1:action"/>
                  </copy>
                </assign>
                <invoke name="ops" partnerLink="Ops"
                        portType="ns1:DisputeOperationsChannel"
                        operation="pickup" inputVariable="request"/>
                <assign name="setNext">
                  <copy>
                    <from expression="''acceptedArbitration writtenOff''"/>
                    <to variable="nextEvents"/>
                  </copy>
                </assign>
                <assign name="SetArbReq">
                  <copy>
                    <from expression="true()''"/>
                    <to variable="arbRequested"/>
                  </copy>
                </assign>
              </sequence>
            </case>
          </switch>
        </onMessage>
        <onMessage portType="ns1:DisputeCallback" operation="rulingWon"
                   variable="request" partnerLink="Net">
          <switch name="Switch">
            <case condition="contains(bpws:getVariableData(''nextEvents''), ''rulingWon'')">
              <sequence name="Sequence">
                <assign name="SetAction">
                  <copy>
                    <from expression="string(''Won'')"/>
                    <to variable="request" part="dispute"
                        query="/ns1:Dispute/ns1:action"/>
                  </copy>
                </assign>
                <invoke name="notifyCust" partnerLink="client"
                        portType="ns1:DisputeCustomerCallback"
                        operation="completed" inputVariable="request"/>
                <assign name="setDone">
                  <copy>
                    <from expression="false()"/>
                    <to variable="moreEvents"/>
                  </copy>
                </assign>
              </sequence>
            </case>
          </switch>
        </onMessage>
        <onMessage portType="ns1:DisputeCallback" operation="rulingLost"
                   variable="request" partnerLink="Net">
          <switch name="Switch">
            <case condition="contains(bpws:getVariableData(''nextEvents''), ''rulingLost'')">
              <sequence name="Sequence">
                <assign name="SetAction">
                  <copy>
                    <from expression="string(''Lost'')"/>
                    <to variable="request" part="dispute"
                        query="/ns1:Dispute/ns1:action"/>
                  </copy>
                </assign>
                <invoke name="notifyCust" partnerLink="client"
                        portType="ns1:DisputeCustomerCallback"
                        operation="completed" inputVariable="request"/>
                <assign name="setDone">
                  <copy>
                    <from expression="false()"/>
                    <to variable="moreEvents"/>
                  </copy>
                </assign>
              </sequence>
            </case>
          </switch>
        </onMessage>
        <onMessage portType="ns1:DisputeCallback" operation="simTimeout"
                   variable="request" partnerLink="Net">
          <switch name="Switch">
            <case condition="contains(bpws:getVariableData(''nextEvents''), ''simTimeoutNet'')">
              <switch name="Switch">
                <case condition="bpws:getVariableData(''isChargedBack'')=true()">
                  <sequence name="Sequence">
                    <invoke name="opsClose" partnerLink="Ops"
                            portType="ns1:DisputeOperationsChannel"
                            operation="close" inputVariable="request"/>
                    <assign name="setAction">
                      <copy>
                        <from expression="string(''Won'')"/>
                        <to variable="request" part="dispute"
                            query="/ns1:Dispute/ns1:action"/>
                      </copy>
                    </assign>
                    <invoke name="custComplete" partnerLink="client"
                            portType="ns1:DisputeCustomerCallback"
                            operation="completed" inputVariable="request"/>
                    <assign name="setDone">
                      <copy>
                        <from expression="false()"/>
                        <to variable="moreEvents"/>
                      </copy>
                    </assign>
                  </sequence>
                </case>
                <otherwise>
                  <sequence name="Sequence">
                    <assign name="setAction">
                      <copy>
                        <from expression="string(''OpsContactingMerchant'')"/>
                        <to variable="request" part="dispute"
                            query="/ns1:Dispute/ns1:action"/>
                      </copy>
                    </assign>
                    <invoke name="Ops" partnerLink="Ops"
                            portType="ns1:DisputeOperationsChannel"
                            operation="pickup" inputVariable="request"/>
                    <assign name="setNext">
                      <copy>
                        <from expression="string(''rejected chargedBack requestedDocs'')"/>
                        <to variable="nextEvents"/>
                      </copy>
                    </assign>
                    <assign name="SetGotDraft">
                      <copy>
                        <from expression="true()"/>
                        <to variable="gotDraft"/>
                      </copy>
                    </assign>
                  </sequence>
                </otherwise>
              </switch>
            </case>
          </switch>
        </onMessage>
      </pick>
    </while>
  </sequence>
</process>
'! !

!BPEL20BPSourceComplexityScorer methodsFor: 'bpel' stamp: 'AlvaroJosePeraltaOcampo 11/12/2014 09:46'!
bpel_DisputeFlow
	^ '<process name="DisputeFlow">
  <partnerLinks>
    <partnerLink name="client" partnerLinkType="ns1:DisputeCust"
                 myRole="Cust2Process" partnerRole="Process2Cust"/>
    <partnerLink myRole="Ops2Process" name="Ops" partnerRole="Process2Ops"
                 partnerLinkType="ns1:DisputeOps"/>
    <partnerLink myRole="Net2Process" name="Net" partnerRole="Process2Net"
                 partnerLinkType="ns1:DisputeNet"/>
  </partnerLinks>
  <variables>
    <variable name="route" type="xsd:string"/>
    <variable name="keepGoing" type="xsd:boolean"/>
    <variable name="request" messageType="ns1:DisputeMessage"/>
  </variables>
  <sequence name="main">
    <receive name="submitDispute" partnerLink="client"
             portType="ns1:DisputeCustomerChannel" operation="submit"
             variable="request" createInstance="yes"/>
    <scope name="ScopeInit">
      <sequence name="Sequence">
        <invoke name="InitOps" partnerLink="Ops"
                portType="ns1:DisputeOperationsChannel" operation="startup"
                inputVariable="request"/>
        <invoke name="InitNet" partnerLink="Net" portType="ns1:DisputeChannel"
                operation="startup" inputVariable="request"/>
        <assign name="InitVars">
          <copy>
            <from expression="string(''ReviewCapture'')"/>
            <to variable="route"/>
          </copy>
          <copy>
            <from expression="true()"/>
            <to variable="keepGoing"/>
          </copy>
        </assign>
      </sequence>
    </scope>
    <while name="While" condition="bpws:getVariableData(''keepGoing'')=true()">
      <switch name="Switch">
        <case condition="bpws:getVariableData(''route'')=''Rejected''">
          <sequence name="Sequence">
            <assign name="SetAction">
              <copy>
                <from expression="string(''Rejected'')"/>
                <to variable="request" part="dispute"
                    query="/ns1:Dispute/ns1:action"/>
              </copy>
            </assign>
            <assign name="RouteCompleted">
              <copy>
                <from expression="string(''Completed'')"/>
                <to variable="route"/>
              </copy>
            </assign>
          </sequence>
        </case>
        <case condition="bpws:getVariableData(''route'')=''WrittenOff''">
          <sequence name="Sequence">
            <assign name="SetAction">
              <copy>
                <from expression="string(''WrittenOff'')"/>
                <to variable="request" part="dispute"
                    query="/ns1:Dispute/ns1:action"/>
              </copy>
            </assign>
            <assign name="RouteCompleted">
              <copy>
                <from expression="string(''Completed'')"/>
                <to variable="route"/>
              </copy>
            </assign>
          </sequence>
        </case>
        <case condition="bpws:getVariableData(''route'')=''Cancelled''">
          <sequence name="Sequence">
            <assign name="SetAction">
              <copy>
                <from expression="string(''Cancelled'')"/>
                <to variable="request" part="dispute"
                    query="/ns1:Dispute/ns1:action"/>
              </copy>
            </assign>
            <invoke name="OpsCancel" partnerLink="Ops"
                    portType="ns1:DisputeOperationsChannel" operation="cancel"
                    inputVariable="request"/>
            <assign name="RouteCompleted">
              <copy>
                <from expression="string(''Completed'')"/>
                <to variable="route"/>
              </copy>
            </assign>
          </sequence>
        </case>
        <case condition="bpws:getVariableData(''route'')=''Completed''">
          <sequence>
            <invoke name="CustCompleted" partnerLink="client"
                    portType="ns1:DisputeCustomerCallback" operation="completed"
                    inputVariable="request"/>
            <assign name="SetDone">
              <copy>
                <from expression="false()"/>
                <to variable="keepGoing"/>
              </copy>
            </assign>
          </sequence>
        </case>
        <case condition="bpws:getVariableData(''route'')=''ReviewCapture''">
          <sequence name="Sequence">
            <assign name="SetAction">
              <copy>
                <from expression="string(''ReviewCapture'')"/>
                <to variable="request" part="dispute"
                    query="/ns1:Dispute/ns1:action"/>
              </copy>
            </assign>
            <invoke name="Ops" partnerLink="Ops"
                    portType="ns1:DisputeOperationsChannel" operation="pickup"
                    inputVariable="request"/>
            <pick name="Pick">
              <onMessage portType="ns1:DisputeOperationsCallback"
                         operation="rejected" variable="request"
                         partnerLink="Ops">
                <assign name="RouteRejected">
                  <copy>
                    <from expression="string(''Rejected'')"/>
                    <to variable="route"/>
                  </copy>
                </assign>
              </onMessage>
              <onMessage portType="ns1:DisputeOperationsCallback"
                         operation="writtenOff" variable="request"
                         partnerLink="Ops">
                <assign name="RouteWrittenOff">
                  <copy>
                    <from expression="string(''WrittenOff'')"/>
                    <to variable="route"/>
                  </copy>
                </assign>
              </onMessage>
              <onMessage portType="ns1:DisputeOperationsCallback"
                         operation="captured" variable="request"
                         partnerLink="Ops">
                <assign name="RouteCaptured">
                  <copy>
                    <from expression="string(''Captured'')"/>
                    <to variable="route"/>
                  </copy>
                </assign>
              </onMessage>
              <onMessage portType="ns1:DisputeOperationsCallback"
                         operation="requestedDocs" variable="request"
                         partnerLink="Ops">
                <sequence name="Sequence">
                  <invoke name="CustUpdate" partnerLink="client"
                          portType="ns1:DisputeCustomerCallback"
                          operation="updateRequired" inputVariable="request"/>
                  <pick name="Pick">
                    <onMessage portType="ns1:DisputeCustomerChannel"
                               operation="update" variable="request"
                               partnerLink="client">
                      <assign name="RouteReviewCapture">
                        <copy>
                          <from expression="string(''ReviewCapture'')"/>
                          <to variable="route"/>
                        </copy>
                      </assign>
                    </onMessage>
                    <onMessage portType="ns1:DisputeCustomerChannel"
                               operation="cancel" variable="request"
                               partnerLink="client">
                      <assign name="RouteCancel">
                        <copy>
                          <from expression="string(''Cancelled'')"/>
                          <to variable="route"/>
                        </copy>
                      </assign>
                    </onMessage>
                    <onMessage portType="ns1:DisputeCustomerChannel"
                               operation="simTimeout" variable="request"
                               partnerLink="client">
                      <sequence name="Sequence">
                        <invoke name="OpsClose" partnerLink="Ops"
                                portType="ns1:DisputeOperationsChannel"
                                operation="close" inputVariable="request"/>
                        <assign name="Rejected">
                          <copy>
                            <from expression="string(''Rejected'')"/>
                            <to variable="route"/>
                          </copy>
                        </assign>
                      </sequence>
                    </onMessage>
                  </pick>
                </sequence>
              </onMessage>
              <onMessage portType="ns1:DisputeCustomerChannel"
                         operation="cancel" variable="request"
                         partnerLink="client">
                <assign name="RouteCancel">
                  <copy>
                    <from expression="string(''Cancelled'')"/>
                    <to variable="route"/>
                  </copy>
                </assign>
              </onMessage>
            </pick>
          </sequence>
        </case>
        <case condition="bpws:getVariableData(''route'')=''Captured''">
          <sequence name="Sequence">
            <assign name="SetAction">
              <copy>
                <from expression="string(''Captured'')"/>
                <to variable="request" part="dispute"
                    query="/ns1:Dispute/ns1:action"/>
              </copy>
            </assign>
            <invoke name="Ops" partnerLink="Ops"
                    portType="ns1:DisputeOperationsChannel" operation="pickup"
                    inputVariable="request"/>
            <pick name="Pick">
              <onMessage portType="ns1:DisputeOperationsCallback"
                         operation="rejected" variable="request"
                         partnerLink="Ops">
                <assign name="RouteRejected">
                  <copy>
                    <from expression="string(''Rejected'')"/>
                    <to variable="route"/>
                  </copy>
                </assign>
              </onMessage>
              <onMessage portType="ns1:DisputeOperationsCallback"
                         operation="writtenOff" variable="request"
                         partnerLink="Ops">
                <assign name="RouteWrittenOff">
                  <copy>
                    <from expression="string(''WrittenOff'')"/>
                    <to variable="route"/>
                  </copy>
                </assign>
              </onMessage>
              <onMessage portType="ns1:DisputeOperationsCallback"
                         operation="requestedDocs" variable="request"
                         partnerLink="Ops">
                <sequence name="Sequence">
                  <invoke name="NetDraft" partnerLink="Net"
                          portType="ns1:DisputeChannel" operation="requestDraft"
                          inputVariable="request"/>
                  <pick name="Pick">
                    <onMessage portType="ns1:DisputeCallback" operation="draft"
                               variable="request" partnerLink="Net">
                      <sequence name="Sequence">
                        <assign name="SetAction">
                          <copy>
                            <from expression="string(''ExaminingDraft'')"/>
                            <to variable="request" part="dispute"
                                query="/ns1:Dispute/ns1:action"/>
                          </copy>
                        </assign>
                        <assign name="RouteDraft">
                          <copy>
                            <from expression="string(''Draft'')"/>
                            <to variable="route"/>
                          </copy>
                        </assign>
                      </sequence>
                    </onMessage>
                    <onMessage portType="ns1:DisputeCallback"
                               operation="simTimeout" variable="request"
                               partnerLink="Net">
                      <sequence name="Sequence">
                        <assign name="SetAction">
                          <copy>
                            <from expression="string(''OpsContactingMerchant'')"/>
                            <to variable="request" part="dispute"
                                query="/ns1:Dispute/ns1:action"/>
                          </copy>
                        </assign>
                        <assign name="RouteDraft">
                          <copy>
                            <from expression="string(''Draft'')"/>
                            <to variable="route"/>
                          </copy>
                        </assign>
                      </sequence>
                    </onMessage>
                  </pick>
                </sequence>
              </onMessage>
              <onMessage portType="ns1:DisputeOperationsCallback"
                         operation="chargedBack" variable="request"
                         partnerLink="Ops">
                <assign name="RouteChargedBack">
                  <copy>
                    <from expression="string(''ChargedBack'')"/>
                    <to variable="route"/>
                  </copy>
                </assign>
              </onMessage>
            </pick>
          </sequence>
        </case>
        <case condition="bpws:getVariableData(''route'')=''Draft''">
          <sequence name="Sequence">
            <invoke name="Ops" partnerLink="Ops"
                    portType="ns1:DisputeOperationsChannel" operation="pickup"
                    inputVariable="request"/>
            <pick name="Pick">
              <onMessage portType="ns1:DisputeOperationsCallback"
                         operation="rejected" variable="request"
                         partnerLink="Ops">
                <assign name="RouteRejected">
                  <copy>
                    <from expression="string(''Rejected'')"/>
                    <to variable="route"/>
                  </copy>
                </assign>
              </onMessage>
              <onMessage portType="ns1:DisputeOperationsCallback"
                         operation="chargedBack" variable="request"
                         partnerLink="Ops">
                <assign name="RouteChargedBack">
                  <copy>
                    <from expression="string(''ChargedBack'')"/>
                    <to variable="route"/>
                  </copy>
                </assign>
              </onMessage>
              <onMessage portType="ns1:DisputeOperationsCallback"
                         operation="requestedDocs" variable="request"
                         partnerLink="Ops">
                <sequence name="Sequence">
                  <invoke name="CustUpdate" partnerLink="client"
                          portType="ns1:DisputeCustomerCallback"
                          operation="updateRequired" inputVariable="request"/>
                  <pick name="Pick">
                    <onMessage portType="ns1:DisputeCustomerChannel"
                               operation="update" variable="request"
                               partnerLink="client">
                      <sequence name="Sequence">
                        <assign name="SetAction">
                          <copy>
                            <from expression="string(''ExaminingCustOnDraft'')"/>
                            <to variable="request" part="dispute"
                                query="/ns1:Dispute/ns1:action"/>
                          </copy>
                        </assign>
                        <assign name="RouteCustOnDraft">
                          <copy>
                            <from expression="string(''CustOnDraft'')"/>
                            <to variable="route"/>
                          </copy>
                        </assign>
                      </sequence>
                    </onMessage>
                    <onMessage portType="ns1:DisputeCustomerChannel"
                               operation="simTimeout" variable="request"
                               partnerLink="client">
                      <sequence name="Sequence">
                        <assign name="SetAction">
                          <copy>
                            <from expression="string(''OpsContactingCust'')"/>
                            <to variable="request" part="dispute"
                                query="/ns1:Dispute/ns1:action"/>
                          </copy>
                        </assign>
                        <assign name="RouteCustOnDraft">
                          <copy>
                            <from expression="string(''CustOnDraft'')"/>
                            <to variable="route"/>
                          </copy>
                        </assign>
                      </sequence>
                    </onMessage>
                  </pick>
                </sequence>
              </onMessage>
            </pick>
          </sequence>
        </case>
        <case condition="bpws:getVariableData(''route'')=''CustOnDraft''">
          <sequence name="Sequence">
            <invoke name="Ops" partnerLink="Ops"
                    portType="ns1:DisputeOperationsChannel" operation="pickup"
                    inputVariable="request"/>
            <pick name="Pick">
              <onMessage portType="ns1:DisputeOperationsCallback"
                         operation="rejected" variable="request"
                         partnerLink="Ops">
                <assign name="RouteRejected">
                  <copy>
                    <from expression="string(''Rejected'')"/>
                    <to variable="route"/>
                  </copy>
                </assign>
              </onMessage>
              <onMessage portType="ns1:DisputeOperationsCallback"
                         operation="chargedBack" variable="request"
                         partnerLink="Ops">
                <assign name="RouteChargedBack">
                  <copy>
                    <from expression="string(''ChargedBack'')"/>
                    <to variable="route"/>
                  </copy>
                </assign>
              </onMessage>
            </pick>
          </sequence>
        </case>
        <case condition="bpws:getVariableData(''route'')=''ChargedBack''">
          <sequence name="Sequence">
            <invoke name="CustCredit" partnerLink="client"
                    portType="ns1:DisputeCustomerCallback" operation="credited"
                    inputVariable="request"/>
            <invoke name="NetCB" partnerLink="Net" portType="ns1:DisputeChannel"
                    operation="chargeback" inputVariable="request"/>
            <pick name="Pick">
              <onMessage portType="ns1:DisputeCallback" operation="credited"
                         variable="request" partnerLink="Net">
                <assign name="RouteWon">
                  <copy>
                    <from expression="string(''Won'')"/>
                    <to variable="route"/>
                  </copy>
                </assign>
              </onMessage>
              <onMessage portType="ns1:DisputeCallback" operation="simTimeout"
                         variable="request" partnerLink="Net">
                <assign name="RouteTimeoutWon">
                  <copy>
                    <from expression="string(''TimeoutWon'')"/>
                    <to variable="route"/>
                  </copy>
                </assign>
              </onMessage>
              <onMessage portType="ns1:DisputeCallback" operation="represented"
                         variable="request" partnerLink="Net">
                <sequence name="Sequence">
                  <assign name="SetAction">
                    <copy>
                      <from expression="string(''Represented'')"/>
                      <to variable="request" part="dispute"
                          query="/ns1:Dispute/ns1:action"/>
                    </copy>
                  </assign>
                  <invoke name="Ops" partnerLink="Ops"
                          portType="ns1:DisputeOperationsChannel"
                          operation="pickup" inputVariable="request"/>
                  <pick name="Pick">
                    <onMessage portType="ns1:DisputeOperationsCallback"
                               operation="rejected" variable="request"
                               partnerLink="Ops">
                      <assign name="RouteRejected">
                        <copy>
                          <from expression="string(''Rejected'')"/>
                          <to variable="route"/>
                        </copy>
                      </assign>
                    </onMessage>
                    <onMessage portType="ns1:DisputeOperationsCallback"
                               operation="writtenOff" variable="request"
                               partnerLink="Ops">
                      <assign name="RouteWrittenOff">
                        <copy>
                          <from expression="string(''WrittenOff'')"/>
                          <to variable="route"/>
                        </copy>
                      </assign>
                    </onMessage>
                    <onMessage portType="ns1:DisputeOperationsCallback"
                               operation="chargedBack" variable="request"
                               partnerLink="Ops">
                      <assign name="RouteCB2">
                        <copy>
                          <from expression="string(''CB2'')"/>
                          <to variable="route"/>
                        </copy>
                      </assign>
                    </onMessage>
                  </pick>
                </sequence>
              </onMessage>
            </pick>
          </sequence>
        </case>
        <case condition="bpws:getVariableData(''route'')=''TimeoutWon'' or bpws:getVariableData(''route'')=''WonArb''">
          <sequence name="Sequence">
            <invoke name="OpsClose" partnerLink="Ops"
                    portType="ns1:DisputeOperationsChannel" operation="close"
                    inputVariable="request"/>
            <assign name="RouteWon">
              <copy>
                <from expression="string(''Won'')"/>
                <to variable="route"/>
              </copy>
            </assign>
          </sequence>
        </case>
        <case condition="bpws:getVariableData(''route'')=''Won''">
          <sequence name="Sequence">
            <assign name="SetAction">
              <copy>
                <from expression="string(''Won'')"/>
                <to variable="request" part="dispute"
                    query="/ns1:Dispute/ns1:action"/>
              </copy>
            </assign>
            <assign name="RouteCompleted">
              <copy>
                <from expression="string(''Completed'')"/>
                <to variable="route"/>
              </copy>
            </assign>
          </sequence>
        </case>
        <case condition="bpws:getVariableData(''route'')=''CB2''">
          <sequence name="Sequence">
            <invoke name="NetCB" partnerLink="Net" portType="ns1:DisputeChannel"
                    operation="chargeback" inputVariable="request"/>
            <pick name="Pick">
              <onMessage portType="ns1:DisputeCallback" operation="credited"
                         variable="request" partnerLink="Net">
                <assign name="RouteWon">
                  <copy>
                    <from expression="string(''Won'')"/>
                    <to variable="route"/>
                  </copy>
                </assign>
              </onMessage>
              <onMessage portType="ns1:DisputeCallback"
                         operation="arbitrationRequested" variable="request"
                         partnerLink="Net">
                <sequence name="Sequence">
                  <assign name="SetAction">
                    <copy>
                      <from expression="string(''Arbitration'')"/>
                      <to variable="request" part="dispute"
                          query="/ns1:Dispute/ns1:action"/>
                    </copy>
                  </assign>
                  <invoke name="Ops" partnerLink="Ops"
                          portType="ns1:DisputeOperationsChannel"
                          operation="pickup" inputVariable="request"/>
                  <pick name="Pick">
                    <onMessage portType="ns1:DisputeOperationsCallback"
                               operation="acceptedArbitration"
                               variable="request" partnerLink="Ops">
                      <sequence name="Sequence">
                        <invoke name="NetAccept" partnerLink="Net"
                                portType="ns1:DisputeChannel"
                                operation="acceptArbitration"
                                inputVariable="request"/>
                        <pick name="Pick">
                          <onMessage portType="ns1:DisputeCallback"
                                     operation="rulingWon" variable="request"
                                     partnerLink="Net">
                            <assign name="RouteWonArb">
                              <copy>
                                <from expression="string(''Won'')"/>
                                <to variable="route"/>
                              </copy>
                            </assign>
                          </onMessage>
                          <onMessage portType="ns1:DisputeCallback"
                                     operation="rulingLost" variable="request"
                                     partnerLink="Net">
                            <sequence name="Sequence">
                              <invoke name="OpsClose" partnerLink="Ops"
                                      portType="ns1:DisputeOperationsChannel"
                                      operation="close" inputVariable="request"/>
                              <assign name="SetAction">
                                <copy>
                                  <from expression="string(''Lost'')"/>
                                  <to variable="request" part="dispute"
                                      query="/ns1:Dispute/ns1:action"/>
                                </copy>
                              </assign>
                              <assign name="RouteCompleted">
                                <copy>
                                  <from expression="string(''Completed'')"/>
                                  <to variable="route"/>
                                </copy>
                              </assign>
                            </sequence>
                          </onMessage>
                        </pick>
                      </sequence>
                    </onMessage>
                    <onMessage portType="ns1:DisputeOperationsCallback"
                               operation="writtenOff" variable="request"
                               partnerLink="Ops">
                      <sequence name="Sequence">
                        <invoke name="NetReject" partnerLink="Net"
                                portType="ns1:DisputeChannel"
                                operation="rejectArbitration"
                                inputVariable="request"/>
                        <assign name="RouteWrittenOff">
                          <copy>
                            <from expression="string(''WrittenOff'')"/>
                            <to variable="route"/>
                          </copy>
                        </assign>
                      </sequence>
                    </onMessage>
                  </pick>
                </sequence>
              </onMessage>
              <onMessage portType="ns1:DisputeCallback" operation="simTimeout"
                         variable="request" partnerLink="Net">
                <assign name="RouteTimeoutWon">
                  <copy>
                    <from expression="string(''TimeoutWon'')"/>
                    <to variable="route"/>
                  </copy>
                </assign>
              </onMessage>
            </pick>
          </sequence>
        </case>
        <otherwise>
          <throw name="Throw" faultName="bpws:selectionFailure"/>
        </otherwise>
      </switch>
    </while>
    <scope name="ScopeCleanup">
      <sequence name="Sequence">
        <invoke name="CleanOps" partnerLink="Ops"
                portType="ns1:DisputeOperationsChannel" operation="shutdown"
                inputVariable="request"/>
        <invoke name="CleanNet" partnerLink="Net" portType="ns1:DisputeChannel"
                operation="shutdown" inputVariable="request"/>
      </sequence>
    </scope>
  </sequence>
</process>
'! !

!BPEL20BPSourceComplexityScorer methodsFor: 'bpel' stamp: 'AlvaroJosePeraltaOcampo 11/12/2014 09:46'!
bpel_DisputeState
	^ '<process name="DisputeState" >
  <partnerLinks>
    <partnerLink name="client" partnerLinkType="ns3:DisputeCust"
                 myRole="Cust2Process" partnerRole="Process2Cust"/>
    <partnerLink myRole="Ops2Process" name="Ops" partnerRole="Process2Ops"
                 partnerLinkType="ns3:DisputeOps"/>
    <partnerLink myRole="Net2Process" name="Net" partnerRole="Process2Net"
                 partnerLinkType="ns3:DisputeNet"/>
  </partnerLinks>
  <variables>
    <variable name="request" messageType="client:DisputeMessage"/>
    <variable name="state" type="xsd:string"/>
    <variable name="capturingState" type="xsd:string"/>
    <variable name="investigatingState" type="xsd:string"/>
    <variable name="chargingBackState" type="xsd:string"/>
    <variable name="stateHist" type="xsd:string"/>
    <variable name="loopContinue" type="xsd:boolean"/>
  </variables>
  <sequence name="main">
    <receive name="CustSubmit" partnerLink="client"
             portType="ns3:DisputeCustomerChannel" operation="submit"
             variable="request" createInstance="yes"/>
    <scope name="ScopeInit">
      <sequence name="Sequence">
        <invoke name="initOps" partnerLink="Ops"
                portType="ns3:DisputeOperationsChannel" operation="startup"
                inputVariable="request"/>
        <invoke name="initNet" partnerLink="Net" portType="ns3:DisputeChannel"
                operation="startup" inputVariable="request"/>
        <assign name="initVars">
          <copy>
            <from expression="string(''Capturing'')"/>
            <to variable="state"/>
          </copy>
          <copy>
            <from expression="string(''InitiallyCaptured'')"/>
            <to variable="capturingState"/>
          </copy>
          <copy>
            <from expression="string(''FullyCaptured'')"/>
            <to variable="investigatingState"/>
          </copy>
          <copy>
            <from expression="string(''ChargedBack'')"/>
            <to variable="chargingBackState"/>
          </copy>
          <copy>
            <from expression="true()"/>
            <to variable="loopContinue"/>
          </copy>
          <copy>
            <from expression="string(''*Started'')"/>
            <to variable="stateHist"/>
          </copy>
        </assign>
      </sequence>
    </scope>
    <while name="While" condition="bpws:getVariableData(''loopContinue'')=true()">
      <switch name="topStateSwitch">
        <case condition="bpws:getVariableData(''state'')=''Rejected''  or  bpws:getVariableData(''state'')=''WrittenOff'' or bpws:getVariableData(''state'')=''Won'' or bpws:getVariableData(''state'')=''Lost''">
          <sequence name="Sequence">
            <assign name="saveState">
              <copy>
                <from expression="concat(concat(bpws:getVariableData(''stateHist''),'' ''),bpws:getVariableData(''state''))"/>
                <to variable="stateHist"/>
              </copy>
              <copy>
                <from variable="state"/>
                <to variable="request" part="dispute"
                    query="/ns3:Dispute/ns3:action"/>
              </copy>
            </assign>
            <invoke name="notifyCust" partnerLink="client"
                    portType="ns3:DisputeCustomerCallback" operation="completed"
                    inputVariable="request"/>
            <assign name="setDone">
              <copy>
                <from expression="false()"/>
                <to variable="loopContinue"/>
              </copy>
            </assign>
          </sequence>
        </case>
        <case condition="bpws:getVariableData(''state'')=''Capturing''">
          <sequence name="Sequence">
            <assign name="saveState">
              <copy>
                <from expression="concat(concat(concat(concat(bpws:getVariableData(''stateHist''),'' ''),bpws:getVariableData(''state'')), ''.''), bpws:getVariableData(''capturingState''))"/>
                <to variable="stateHist"/>
              </copy>
            </assign>
            <switch name="Switch">
              <case condition="bpws:getVariableData(''capturingState'')=''AwaitingDocs''">
                <sequence name="Sequence">
                  <invoke name="custUpdate" partnerLink="client"
                          portType="ns3:DisputeCustomerCallback"
                          operation="updateRequired" inputVariable="request"/>
                  <pick name="Pick">
                    <onMessage portType="ns3:DisputeCustomerChannel"
                               operation="cancel" variable="request"
                               partnerLink="client">
                      <assign name="setState">
                        <copy>
                          <from expression="string(''Cancelled'')"/>
                          <to variable="state"/>
                        </copy>
                      </assign>
                    </onMessage>
                    <onMessage portType="ns3:DisputeCustomerChannel"
                               operation="update" variable="request"
                               partnerLink="client">
                      <assign name="setState">
                        <copy>
                          <from expression="string(''ExaminingDocs'')"/>
                          <to variable="capturingState"/>
                        </copy>
                      </assign>
                    </onMessage>
                    <onMessage portType="ns3:DisputeCustomerChannel"
                               operation="simTimeout" variable="request"
                               partnerLink="client">
                      <sequence>
                        <invoke name="ops" partnerLink="Ops"
                                portType="ns3:DisputeOperationsChannel"
                                operation="close" inputVariable="request"/>
                        <assign name="setState">
                          <copy>
                            <from expression="string(''Rejected'')"/>
                            <to variable="state"/>
                          </copy>
                        </assign>
                      </sequence>
                    </onMessage>
                  </pick>
                </sequence>
              </case>
              <case condition="bpws:getVariableData(''capturingState'')=''InitiallyCaptured'' or bpws:getVariableData(''capturingState'')=''ExaminingDocs''">
                <sequence name="Sequence">
                  <assign name="SetAction">
                    <copy>
                      <from expression="string(''ReviewCapture'')"/>
                      <to variable="request" part="dispute"
                          query="/ns3:Dispute/ns3:action"/>
                    </copy>
                  </assign>
                  <invoke name="ops" partnerLink="Ops"
                          portType="ns3:DisputeOperationsChannel"
                          operation="pickup" inputVariable="request"/>
                  <pick name="Pick">
                    <onMessage portType="ns3:DisputeOperationsCallback"
                               operation="rejected" variable="request"
                               partnerLink="Ops">
                      <assign name="setState">
                        <copy>
                          <from expression="string(''Rejected'')"/>
                          <to variable="state"/>
                        </copy>
                      </assign>
                    </onMessage>
                    <onMessage portType="ns3:DisputeOperationsCallback"
                               operation="writtenOff" variable="request"
                               partnerLink="Ops">
                      <assign name="setState">
                        <copy>
                          <from expression="string(''WrittenOff'')"/>
                          <to variable="state"/>
                        </copy>
                      </assign>
                    </onMessage>
                    <onMessage portType="ns3:DisputeOperationsCallback"
                               operation="captured" variable="request"
                               partnerLink="Ops">
                      <assign name="setState">
                        <copy>
                          <from expression="string(''Investigating'')"/>
                          <to variable="state"/>
                        </copy>
                      </assign>
                    </onMessage>
                    <onMessage portType="ns3:DisputeOperationsCallback"
                               operation="requestedDocs" variable="request"
                               partnerLink="Ops">
                      <assign name="setState">
                        <copy>
                          <from expression="string(''AwaitingDocs'')"/>
                          <to variable="capturingState"/>
                        </copy>
                      </assign>
                    </onMessage>
                    <onMessage portType="ns3:DisputeCustomerChannel"
                               operation="cancel" variable="request"
                               partnerLink="client">
                      <assign name="setState">
                        <copy>
                          <from expression="string(''Cancelled'')"/>
                          <to variable="state"/>
                        </copy>
                      </assign>
                    </onMessage>
                  </pick>
                </sequence>
              </case>
              <otherwise>
                <throw name="Throw" faultName="bpws:selectionFailure"/>
              </otherwise>
            </switch>
          </sequence>
        </case>
        <case condition="bpws:getVariableData(''state'')=''Investigating''">
          <sequence name="Sequence">
            <assign name="saveState">
              <copy>
                <from expression="concat(concat(concat(concat(bpws:getVariableData(''stateHist''),'' ''),bpws:getVariableData(''state'')), ''.''), bpws:getVariableData(''investigatingState''))"/>
                <to variable="stateHist"/>
              </copy>
            </assign>
            <switch name="Switch">
              <case condition="bpws:getVariableData(''investigatingState'')=''ExaminingCustOnDraft'' or bpws:getVariableData(''investigatingState'')=''OpsContactingCust''">
                <sequence name="Sequence">
                  <assign name="SetAction">
                    <copy>
                      <from variable="investigatingState"/>
                      <to variable="request" part="dispute"
                          query="/ns3:Dispute/ns3:action"/>
                    </copy>
                  </assign>
                  <invoke name="ops" partnerLink="Ops"
                          portType="ns3:DisputeOperationsChannel"
                          operation="pickup" inputVariable="request"/>
                  <pick name="Pick">
                    <onMessage portType="ns3:DisputeOperationsCallback"
                               operation="rejected" variable="request"
                               partnerLink="Ops">
                      <assign name="setState">
                        <copy>
                          <from expression="string(''Rejected'')"/>
                          <to variable="state"/>
                        </copy>
                      </assign>
                    </onMessage>
                    <onMessage portType="ns3:DisputeOperationsCallback"
                               operation="chargedBack" variable="request"
                               partnerLink="Ops">
                      <assign name="setState">
                        <copy>
                          <from expression="string(''ChargingBack'')"/>
                          <to variable="state"/>
                        </copy>
                      </assign>
                    </onMessage>
                  </pick>
                </sequence>
              </case>
              <case condition="bpws:getVariableData(''investigatingState'')=''AwaitingCustOnDraft''">
                <sequence name="Sequence">
                  <invoke name="custUpdate" partnerLink="client"
                          portType="ns3:DisputeCustomerCallback"
                          operation="updateRequired" inputVariable="request"/>
                  <pick name="Pick">
                    <onMessage portType="ns3:DisputeCustomerChannel"
                               operation="update" variable="request"
                               partnerLink="client">
                      <assign name="setState">
                        <copy>
                          <from expression="string(''ExaminingCustOnDraft'')"/>
                          <to variable="investigatingState"/>
                        </copy>
                      </assign>
                    </onMessage>
                    <onMessage portType="ns3:DisputeCustomerChannel"
                               operation="simTimeout" variable="request"
                               partnerLink="client">
                      <assign name="setState">
                        <copy>
                          <from expression="string(''OpsContactingCust'')"/>
                          <to variable="investigatingState"/>
                        </copy>
                      </assign>
                    </onMessage>
                  </pick>
                </sequence>
              </case>
              <case condition="bpws:getVariableData(''investigatingState'')=''ExaminingDraft'' or bpws:getVariableData(''investigatingState'')=''OpsContactingMerchant''">
                <sequence name="Sequence">
                  <assign name="SetAction">
                    <copy>
                      <from variable="investigatingState"/>
                      <to variable="request" part="dispute"
                          query="/ns3:Dispute/ns3:action"/>
                    </copy>
                  </assign>
                  <invoke name="ops" partnerLink="Ops"
                          portType="ns3:DisputeOperationsChannel"
                          operation="pickup" inputVariable="request"/>
                  <pick name="Pick">
                    <onMessage portType="ns3:DisputeOperationsCallback"
                               operation="rejected" variable="request"
                               partnerLink="Ops">
                      <assign name="setState">
                        <copy>
                          <from expression="string(''Rejected'')"/>
                          <to variable="state"/>
                        </copy>
                      </assign>
                    </onMessage>
                    <onMessage portType="ns3:DisputeOperationsCallback"
                               operation="chargedBack" variable="request"
                               partnerLink="Ops">
                      <assign name="setState">
                        <copy>
                          <from expression="string(''ChargingBack'')"/>
                          <to variable="state"/>
                        </copy>
                      </assign>
                    </onMessage>
                    <onMessage portType="ns3:DisputeOperationsCallback"
                               operation="requestedDocs" variable="request"
                               partnerLink="Ops">
                      <assign name="setState">
                        <copy>
                          <from expression="string(''AwaitingCustOnDraft'')"/>
                          <to variable="investigatingState"/>
                        </copy>
                      </assign>
                    </onMessage>
                  </pick>
                </sequence>
              </case>
              <case condition="bpws:getVariableData(''investigatingState'')=''AwaitingDraft''">
                <sequence name="Sequence">
                  <invoke name="NetDraft" partnerLink="Net"
                          portType="ns3:DisputeChannel" operation="requestDraft"
                          inputVariable="request"/>
                  <pick name="Pick">
                    <onMessage portType="ns3:DisputeCallback" operation="draft"
                               variable="request" partnerLink="Net">
                      <assign name="setState">
                        <copy>
                          <from expression="string(''ExaminingDraft'')"/>
                          <to variable="investigatingState"/>
                        </copy>
                      </assign>
                    </onMessage>
                    <onMessage portType="ns3:DisputeCallback"
                               operation="simTimeout" variable="request"
                               partnerLink="Net">
                      <assign name="setState">
                        <copy>
                          <from expression="string(''OpsContactingMerchant'')"/>
                          <to variable="investigatingState"/>
                        </copy>
                      </assign>
                    </onMessage>
                  </pick>
                </sequence>
              </case>
              <case condition="bpws:getVariableData(''investigatingState'')=''FullyCaptured''">
                <sequence name="Sequence">
                  <assign name="SetAction">
                    <copy>
                      <from expression="string(''Captured'')"/>
                      <to variable="request" part="dispute"
                          query="/ns3:Dispute/ns3:action"/>
                    </copy>
                  </assign>
                  <invoke name="ops" partnerLink="Ops"
                          portType="ns3:DisputeOperationsChannel"
                          operation="pickup" inputVariable="request"/>
                  <pick name="Pick">
                    <onMessage portType="ns3:DisputeOperationsCallback"
                               operation="rejected" variable="request"
                               partnerLink="Ops">
                      <assign name="setState">
                        <copy>
                          <from expression="string(''Rejected'')"/>
                          <to variable="state"/>
                        </copy>
                      </assign>
                    </onMessage>
                    <onMessage portType="ns3:DisputeOperationsCallback"
                               operation="writtenOff" variable="request"
                               partnerLink="Ops">
                      <assign name="setState">
                        <copy>
                          <from expression="string(''WrittenOff'')"/>
                          <to variable="state"/>
                        </copy>
                      </assign>
                    </onMessage>
                    <onMessage portType="ns3:DisputeOperationsCallback"
                               operation="chargedBack" variable="request"
                               partnerLink="Ops">
                      <assign name="setState">
                        <copy>
                          <from expression="string(''ChargingBack'')"/>
                          <to variable="state"/>
                        </copy>
                      </assign>
                    </onMessage>
                    <onMessage portType="ns3:DisputeOperationsCallback"
                               operation="requestedDocs" variable="request"
                               partnerLink="Ops">
                      <assign name="setState">
                        <copy>
                          <from expression="string(''AwaitingDraft'')"/>
                          <to variable="investigatingState"/>
                        </copy>
                      </assign>
                    </onMessage>
                  </pick>
                </sequence>
              </case>
              <otherwise>
                <throw name="Throw" faultName="bpws:selectionFailure"/>
              </otherwise>
            </switch>
          </sequence>
        </case>
        <case condition="bpws:getVariableData(''state'')=''ChargingBack''">
          <sequence name="Sequence">
            <assign name="saveState">
              <copy>
                <from expression="concat(concat(concat(concat(bpws:getVariableData(''stateHist''),'' ''),bpws:getVariableData(''state'')), ''.''), bpws:getVariableData(''chargingBackState''))"/>
                <to variable="stateHist"/>
              </copy>
            </assign>
            <switch name="Switch">
              <case condition="bpws:getVariableData(''chargingBackState'')=''InArbitration''">
                <sequence name="Sequence">
                  <pick name="Pick">
                    <onMessage portType="ns3:DisputeCallback"
                               operation="rulingWon" variable="request"
                               partnerLink="Net">
                      <assign name="setState">
                        <copy>
                          <from expression="string(''Won'')"/>
                          <to variable="state"/>
                        </copy>
                      </assign>
                    </onMessage>
                    <onMessage portType="ns3:DisputeCallback"
                               operation="rulingLost" variable="request"
                               partnerLink="Net">
                      <assign name="setState">
                        <copy>
                          <from expression="string(''Lost'')"/>
                          <to variable="state"/>
                        </copy>
                      </assign>
                    </onMessage>
                  </pick>
                    <invoke name="ops" partnerLink="Ops"
                            portType="ns3:DisputeOperationsChannel"
                            operation="close" inputVariable="request"/>
                </sequence>
              </case>
              <case condition="bpws:getVariableData(''chargingBackState'')=''ArbitrationRequested''">
                <sequence name="Sequence">
                  <assign name="SetAction">
                    <copy>
                      <from expression="string(''Arbitration'')"/>
                      <to variable="request" part="dispute"
                          query="/ns3:Dispute/ns3:action"/>
                    </copy>
                  </assign>
                  <invoke name="ops" partnerLink="Ops"
                          portType="ns3:DisputeOperationsChannel"
                          operation="pickup" inputVariable="request"/>
                  <pick name="Pick">
                    <onMessage portType="ns3:DisputeOperationsCallback"
                               operation="acceptedArbitration"
                               variable="request" partnerLink="Ops">
                      <sequence name="Sequence">
                        <invoke name="acceptArb" partnerLink="Net"
                                portType="ns3:DisputeChannel"
                                operation="acceptArbitration"
                                inputVariable="request"/>
                        <assign name="setState">
                          <copy>
                            <from expression="string(''InArbitration'')"/>
                            <to variable="chargingBackState"/>
                          </copy>
                        </assign>
                      </sequence>
                    </onMessage>
                    <onMessage portType="ns3:DisputeOperationsCallback"
                               operation="writtenOff" variable="request"
                               partnerLink="Ops">
                      <sequence name="Sequence">
                        <invoke name="rejectArb" partnerLink="Net"
                                portType="ns3:DisputeChannel"
                                operation="rejectArbitration"
                                inputVariable="request"/>
                        <assign name="setState">
                          <copy>
                            <from expression="string(''WrittenOff'')"/>
                            <to variable="state"/>
                          </copy>
                        </assign>
                      </sequence>
                    </onMessage>
                  </pick>
                </sequence>
              </case>
              <case condition="bpws:getVariableData(''chargingBackState'')=''ChargedBackAgain''">
                <sequence name="Sequence">
                  <invoke name="NetCB" partnerLink="Net"
                          portType="ns3:DisputeChannel" operation="chargeback"
                          inputVariable="request"/>
                  <pick name="Pick">
                    <onMessage portType="ns3:DisputeCallback"
                               operation="credited" variable="request"
                               partnerLink="Net">
                      <assign name="setState">
                        <copy>
                          <from expression="string(''Won'')"/>
                          <to variable="state"/>
                        </copy>
                      </assign>
                    </onMessage>
                    <onMessage portType="ns3:DisputeCallback"
                               operation="arbitrationRequested"
                               variable="request" partnerLink="Net">
                      <assign name="setState">
                        <copy>
                          <from expression="string(''ArbitrationRequested'')"/>
                          <to variable="chargingBackState"/>
                        </copy>
                      </assign>
                    </onMessage>
                    <onMessage portType="ns3:DisputeCallback"
                               operation="simTimeout" variable="request"
                               partnerLink="Net">
                      <sequence name="Sequence">
                        <invoke name="ops" partnerLink="Ops"
                                portType="ns3:DisputeOperationsChannel"
                                operation="close" inputVariable="request"/>
                        <assign name="setState">
                          <copy>
                            <from expression="string(''Won'')"/>
                            <to variable="state"/>
                          </copy>
                        </assign>
                      </sequence>
                    </onMessage>
                  </pick>
                </sequence>
              </case>
              <case condition="bpws:getVariableData(''chargingBackState'')=''Represented''">
                <sequence name="Sequence">
                  <assign name="SetAction">
                    <copy>
                      <from expression="string(''Represented'')"/>
                      <to variable="request" part="dispute"
                          query="/ns3:Dispute/ns3:action"/>
                    </copy>
                  </assign>
                  <invoke name="ops" partnerLink="Ops"
                          portType="ns3:DisputeOperationsChannel"
                          operation="pickup" inputVariable="request"/>
                  <pick name="Pick">
                    <onMessage portType="ns3:DisputeOperationsCallback"
                               operation="rejected" variable="request"
                               partnerLink="Ops">
                      <assign name="setState">
                        <copy>
                          <from expression="string(''Rejected'')"/>
                          <to variable="state"/>
                        </copy>
                      </assign>
                    </onMessage>
                    <onMessage portType="ns3:DisputeOperationsCallback"
                               operation="writtenOff" variable="request"
                               partnerLink="Ops">
                      <assign name="setState">
                        <copy>
                          <from expression="string(''WrittenOff'')"/>
                          <to variable="state"/>
                        </copy>
                      </assign>
                    </onMessage>
                    <onMessage portType="ns3:DisputeOperationsCallback"
                               operation="chargedBack" variable="request"
                               partnerLink="Ops">
                      <assign name="setState">
                        <copy>
                          <from expression="string(''ChargedBackAgain'')"/>
                          <to variable="chargingBackState"/>
                        </copy>
                      </assign>
                    </onMessage>
                  </pick>
                </sequence>
              </case>
              <case condition="bpws:getVariableData(''chargingBackState'')=''ChargedBack''">
                <sequence name="Sequence">
                  <invoke name="CustCredit" partnerLink="client"
                          portType="ns3:DisputeCustomerCallback"
                          operation="credited" inputVariable="request"/>
                  <invoke name="NetCB" partnerLink="Net"
                          portType="ns3:DisputeChannel" operation="chargeback"
                          inputVariable="request"/>
                  <pick name="Pick">
                    <onMessage portType="ns3:DisputeCallback"
                               operation="credited" variable="request"
                               partnerLink="Net">
                      <assign name="setState">
                        <copy>
                          <from expression="string(''Won'')"/>
                          <to variable="state"/>
                        </copy>
                      </assign>
                    </onMessage>
                    <onMessage portType="ns3:DisputeCallback"
                               operation="represented" variable="request"
                               partnerLink="Net">
                      <assign name="setState">
                        <copy>
                          <from expression="string(''Represented'')"/>
                          <to variable="chargingBackState"/>
                        </copy>
                      </assign>
                    </onMessage>
                    <onMessage portType="ns3:DisputeCallback"
                               operation="simTimeout" variable="request"
                               partnerLink="Net">
                      <sequence name="Sequence">
                        <invoke name="ops" partnerLink="Ops"
                                portType="ns3:DisputeOperationsChannel"
                                operation="close" inputVariable="request"/>
                        <assign name="setState">
                          <copy>
                            <from expression="string(''Won'')"/>
                            <to variable="state"/>
                          </copy>
                        </assign>
                      </sequence>
                    </onMessage>
                  </pick>
                </sequence>
              </case>
              <otherwise>
                <throw name="Throw" faultName="bpws:selectionFailure"/>
              </otherwise>
            </switch>
          </sequence>
        </case>
        <case condition="bpws:getVariableData(''state'')=''Cancelled''">
          <sequence name="Sequence">
            <assign name="saveState">
              <copy>
                <from expression="concat(concat(bpws:getVariableData(''stateHist''),'' ''),bpws:getVariableData(''state''))"/>
                <to variable="stateHist"/>
              </copy>
            </assign>
            <invoke name="notifyCust" partnerLink="client"
                    portType="ns3:DisputeCustomerCallback" operation="completed"
                    inputVariable="request"/>
            <invoke name="notifyOps" partnerLink="Ops"
                    portType="ns3:DisputeOperationsChannel" operation="cancel"
                    inputVariable="request"/>
            <assign name="setDone">
              <copy>
                <from expression="false()"/>
                <to variable="loopContinue"/>
              </copy>
            </assign>
          </sequence>
        </case>
        <otherwise>
          <throw name="Throw" faultName="bpws:selectionFailure"/>
        </otherwise>
      </switch>
    </while>
    <scope name="ScopeCleanup">
      <sequence name="Sequence">
        <invoke name="cleanOps" partnerLink="Ops"
                portType="ns3:DisputeOperationsChannel" operation="shutdown"
                inputVariable="request"/>
        <invoke name="cleanNet" partnerLink="Net" portType="ns3:DisputeChannel"
                operation="shutdown" inputVariable="request"/>
        <assign name="saveState">
          <copy>
            <from expression="concat(bpws:getVariableData(''stateHist''),'' Completed*'')"/>
            <to variable="stateHist"/>
          </copy>
        </assign>
      </sequence>
    </scope>
  </sequence>
</process>
'! !

BPEL20BPSourceTest subclass: #BPEL20BPSourceInstrumentation001
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-Tests-BPEL20-source'!

!BPEL20BPSourceInstrumentation001 methodsFor: 'bpel' stamp: 'AlvaroJosePeraltaOcampo 11/12/2014 09:47'!
bpel_BPELProcess004
^ '<?xml version = "1.0" encoding = "UTF-8" ?>
<!!--
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  Oracle JDeveloper BPEL Designer 
  
  Created: Sat Jul 19 18:18:47 CLT 2014
  Author:  alvarojose
  Type: BPEL 2.0 Process
  Purpose: Asynchronous BPEL Process
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
-->
<process name="BPELProcess004"
         targetNamespace="http://xmlns.oracle.com/A4BPInstrumentation/ProyectoA4BPTest001/BPELProcess004"
         xmlns="http://docs.oasis-open.org/wsbpel/2.0/process/executable"
         xmlns:client="http://xmlns.oracle.com/A4BPInstrumentation/ProyectoA4BPTest001/BPELProcess004"
         xmlns:ora="http://schemas.oracle.com/xpath/extension"
         xmlns:ui="http://xmlns.oracle.com/soa/designer"
         xmlns:bpelx="http://schemas.oracle.com/bpel/extension"
         xmlns:bpel="http://docs.oasis-open.org/wsbpel/2.0/process/executable"
         xmlns:ns1="http://xmlns.oracle.com/A4BPInstrumentation/ProyectoA4BPTest001/a4bpInstrumentationREST"
         xmlns:xp20="http://www.oracle.com/XSL/Transform/java/oracle.tip.pc.services.functions.Xpath20"
         xmlns:bpws="http://schemas.xmlsoap.org/ws/2003/03/business-process/"
         xmlns:oraext="http://www.oracle.com/XSL/Transform/java/oracle.tip.pc.services.functions.ExtFunc"
         xmlns:dvm="http://www.oracle.com/XSL/Transform/java/oracle.tip.dvm.LookupValue"
         xmlns:hwf="http://xmlns.oracle.com/bpel/workflow/xpath"
         xmlns:ids="http://xmlns.oracle.com/bpel/services/IdentityService/xpath"
         xmlns:bpm="http://xmlns.oracle.com/bpmn20/extensions" xmlns:ess="http://xmlns.oracle.com/scheduler"
         xmlns:xdk="http://schemas.oracle.com/bpel/extension/xpath/function/xdk"
         xmlns:xref="http://www.oracle.com/XSL/Transform/java/oracle.tip.xref.xpath.XRefXPathFunctions"
         xmlns:ldap="http://schemas.oracle.com/xpath/extension/ldap" xmlns:ns2="http://www.a4bp.com">

    <import ui:processWSDL="true" namespace="http://xmlns.oracle.com/A4BPInstrumentation/ProyectoA4BPTest001/BPELProcess004" location="../WSDLs/BPELProcess004.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <!!-- 
      ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
        PARTNERLINKS                                                      
        List of services participating in this BPEL process               
      ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    --> 
    <partnerLinks>
        <!!-- 
      The ''client'' role represents the requester of this service. It is 
      used for callback. The location and correlation information associated
      with the client role are automatically set using WS-Addressing.
    -->
        <partnerLink name="bpelprocess004_client" partnerLinkType="client:BPELProcess004" myRole="BPELProcess004Provider" partnerRole="BPELProcess004Requester"/>
        <partnerLink name="a4bpInstrumentationREST" partnerLinkType="ns1:a4bpInstrumentationREST"
                     partnerRole="a4bpInstrumentationRESTProvider"/>
    </partnerLinks>

    <!!-- 
      ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
        VARIABLES                                                        
        List of messages and XML documents used within this BPEL process 
      ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    -->
    <variables>
        <!!-- Reference to the message passed as input during initiation -->
        <variable name="inputVariable" messageType="client:BPELProcess004RequestMessage"/>

        <!!-- Reference to the message that will be sent back to the requester during callback -->
        <variable name="outputVariable" messageType="client:BPELProcess004ResponseMessage"/>
        <variable name="a4bpInInstrumentation" messageType="ns1:instrumentation_inputMessage"/>
        <variable name="a4bpOutInstrumentation" messageType="ns1:Rest_EmptyMessage"/>
    </variables>

    <!!-- 
      ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
       ORCHESTRATION LOGIC                                               
       Set of activities coordinating the flow of messages across the    
       services integrated within this business process                  
      ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    -->
    <sequence name="main">
        <!!-- Receive input from requestor. (Note: This maps to operation defined in BPELProcess004.wsdl) -->
        <receive name="receiveInput" partnerLink="bpelprocess004_client" portType="client:BPELProcess004" operation="process" variable="inputVariable" createInstance="yes"/>
        
        <assign name="ActivityToBeAnalyze001">
            <copy>
                <from>$inputVariable.payload</from>
                <to>$outputVariable.payload</to>
            </copy>
        </assign>
        <!!-- 
          Asynchronous callback to the requester. (Note: the callback location and correlation id is transparently handled using WS-addressing.)
        -->
        <invoke name="callbackClient" partnerLink="bpelprocess004_client" portType="client:BPELProcess004Callback" operation="processResponse" inputVariable="outputVariable"/>
    </sequence>
</process>'.! !

BPEL20BPSourceTest subclass: #BPEL20BPXSDSourceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-Tests-BPEL20-source'!

!BPEL20BPXSDSourceTest methodsFor: 'xsd' stamp: 'AlvaroJosePeraltaOcampo 11/12/2014 09:47'!
xsd_ApprovalHumanTaskWorkflowTask
^ '<schema xmlns="http://www.w3.org/2001/XMLSchema" xmlns:tns="http://xmlns.oracle.com/bpel/workflow/task" xmlns:evidence="http://xmlns.oracle.com/bpel/workflow/TaskEvidenceService" xmlns:tsc="http://xmlns.oracle.com/bpel/workflow/common/tsc" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:jaxb="http://java.sun.com/xml/ns/jaxb" targetNamespace="http://xmlns.oracle.com/bpel/workflow/task" jaxb:version="1.0" elementFormDefault="qualified" blockDefault="#all"><xsd:include xmlns="" schemaLocation="ApprovalHumanTaskPayload.xsd" /><xsd:annotation><xsd:appinfo><jaxb:schemaBindings><jaxb:package name="oracle.bpel.services.workflow.task.model" /></jaxb:schemaBindings></xsd:appinfo></xsd:annotation><import namespace="http://xmlns.oracle.com/bpel/workflow/TaskEvidenceService" schemaLocation="oramds:/soa/shared/workflow/TaskEvidenceService.xsd" /><import namespace="http://xmlns.oracle.com/bpel/workflow/common/tsc" schemaLocation="oramds:/soa/shared/workflow/TaskSequenceChanges.xsd" /><element name="task"><complexType><sequence><element name="title" type="xsd:string" minOccurs="0" /><element name="payload" type="tns:ApprovalHumanTaskPayloadType" minOccurs="0" maxOccurs="1" /><element name="taskDefinitionURI" type="xsd:string" minOccurs="0" /><element name="creator" type="xsd:string" minOccurs="0" /><element name="ownerUser" type="xsd:string" minOccurs="0" /><element name="ownerGroup" type="xsd:string" minOccurs="0" /><element name="ownerRole" minOccurs="0" type="xsd:string" /><element name="priority" type="tns:priorityType" minOccurs="0" /><element name="identityContext" type="xsd:string" minOccurs="0" /><element name="userComment" type="tns:commentType" minOccurs="0" maxOccurs="unbounded" /><element name="attachment" type="tns:attachmentType" minOccurs="0" maxOccurs="unbounded" /><element name="processInfo" type="tns:processType" minOccurs="0" /><element name="systemAttributes" type="tns:systemAttributesType" minOccurs="0" /><element name="systemMessageAttributes" type="tns:systemMessageAttributesType" minOccurs="0" /><element name="titleResourceKey" type="xsd:string" minOccurs="0" /><element name="callback" type="tns:callbackType" minOccurs="0" /><element name="identificationKey" type="xsd:string" minOccurs="0" /><element name="category" type="xsd:string" minOccurs="0" /><element name="startDate" type="xsd:dateTime" minOccurs="0" /><element name="dueDate" type="xsd:dateTime" minOccurs="0" /><element name="isPublic" type="xsd:boolean" minOccurs="0" /><element name="percentageComplete" type="xsd:double" minOccurs="0" /><element name="sca" type="tns:scaType" minOccurs="0" /><element name="applicationContext" type="xsd:string" minOccurs="0" /><element name="evidence" type="evidence:EvidenceType" minOccurs="0" maxOccurs="1" /><element name="taskDefinitionId" type="xsd:string" minOccurs="0" /><element name="subcategory" type="xsd:string" minOccurs="0" /><element name="taskDisplayUrl" type="xsd:string" minOccurs="0" /><element name="correlationId" type="xsd:string" minOccurs="0" /></sequence></complexType></element><complexType name="commentType"><sequence><element name="comment" type="xsd:string" minOccurs="0" /><element name="updatedBy" type="tns:identityType" minOccurs="0" /><element name="updatedDate" type="xsd:dateTime" minOccurs="0" /><element name="displayNameLanguage" type="xsd:string" minOccurs="0" /><element name="action" type="xsd:string" minOccurs="0" /><element name="systemVersionFlag" type="xsd:string" minOccurs="0" /><element name="acl" type="xsd:string" minOccurs="0" /><element name="doesBelongToParent" type="xsd:boolean" minOccurs="0" /><element name="isSystemComment" type="xsd:boolean" minOccurs="0" /></sequence></complexType><complexType name="processType"><sequence><element name="domainId" type="xsd:string" minOccurs="0" maxOccurs="1" /><element name="instanceId" type="xsd:string" minOccurs="0" maxOccurs="1" /><element name="processId" type="xsd:string" minOccurs="1" maxOccurs="1" /><element name="processName" type="xsd:string" minOccurs="0" maxOccurs="1" /><element name="processType" type="tns:processTypeEnum" minOccurs="1" maxOccurs="1" /><element name="processVersion" type="xsd:string" minOccurs="1" maxOccurs="1" /></sequence></complexType><complexType name="scaType"><sequence><element name="applicationName" type="xsd:string" minOccurs="0" maxOccurs="1" /><element name="componentName" type="xsd:string" minOccurs="0" maxOccurs="1" /><element name="compositeDN" type="xsd:string" minOccurs="0" maxOccurs="1" /><element name="compositeInstanceId" type="xsd:string" minOccurs="0" maxOccurs="1" /><element name="compositeName" type="xsd:string" minOccurs="0" maxOccurs="1" /><element name="compositeVersion" type="xsd:string" minOccurs="0" maxOccurs="1" /><element name="ecId" type="xsd:string" minOccurs="0" maxOccurs="1" /><element name="parentComponentInstanceId" type="xsd:string" minOccurs="0" maxOccurs="1" /><element name="parentComponentInstanceRefId" type="xsd:string" minOccurs="0" maxOccurs="1" /><element name="headerProperties" type="xsd:string" minOccurs="0" maxOccurs="1" /><element name="invokedComponent" type="xsd:string" minOccurs="0" maxOccurs="1"><annotation><documentation>
              Records the component invoked to create this Task version instance.
              E.g. the decision component invoked for advanced routing rules.
            </documentation></annotation></element></sequence></complexType><simpleType name="processTypeEnum"><restriction base="xsd:string"><enumeration value="BPEL" /><enumeration value="OWF" /><enumeration value="OTHER" /></restriction></simpleType><complexType name="callbackType"><sequence><element name="context" type="xsd:string" minOccurs="0" /><element name="id" type="xsd:string" minOccurs="0" /><element name="type" type="xsd:string" minOccurs="0" /><element name="converstationId" type="xsd:string" minOccurs="0" maxOccurs="1" /></sequence></complexType><element name="attachment" type="tns:attachmentType" /><complexType name="attachmentType"><sequence><element name="content" type="xsd:string" minOccurs="0" /><element name="mimeType" type="xsd:string" minOccurs="0" /><element name="name" type="xsd:string" minOccurs="0" /><element name="updatedBy" type="xsd:string" minOccurs="0" /><element name="URI" type="xsd:string" minOccurs="0" /><element name="systemVersionFlag" type="xsd:string" minOccurs="0" /><element name="taskId" type="xsd:string" minOccurs="0" /><element name="version" type="xsd:integer" minOccurs="0" /><element name="acl" type="xsd:string" minOccurs="0" /><element name="doesBelongToParent" type="xsd:boolean" minOccurs="0" /><element name="updatedDate" type="xsd:dateTime" minOccurs="0" /></sequence></complexType><complexType name="identityType"><sequence><element name="id" type="xsd:string" minOccurs="0" /><element name="displayName" type="xsd:string" minOccurs="0" /><element name="type" type="tns:identityTypeEnum" minOccurs="0" /><element name="systemVersionFlag" type="xsd:string" minOccurs="0" /></sequence></complexType><simpleType name="identityTypeEnum"><restriction base="xsd:string"><enumeration value="user" /><enumeration value="group" /><enumeration value="application_role" /></restriction></simpleType><complexType name="systemAttributesType"><sequence><element name="accessKey" type="xsd:string" minOccurs="0" /><element name="acquiredBy" type="xsd:string" minOccurs="0" /><element name="approvalDuration" type="xsd:long" minOccurs="0" /><element name="approvers" type="xsd:string" minOccurs="0" /><element name="assignedDate" type="xsd:dateTime" minOccurs="0" /><element name="assigneeGroups" type="tns:identityType" minOccurs="0" maxOccurs="unbounded" /><element name="assigneeUsers" type="tns:identityType" minOccurs="0" maxOccurs="unbounded" /><element name="createdDate" type="xsd:dateTime" minOccurs="0" /><element name="customActions" type="tns:actionType" minOccurs="0" maxOccurs="unbounded" /><element name="digitalSignatureRequired" type="xsd:boolean" minOccurs="0" /><element name="displayInfo" type="tns:displayInfoType" maxOccurs="unbounded" minOccurs="0" /><element name="elapsedTime" type="xsd:long" minOccurs="0" /><element name="endDate" type="xsd:dateTime" minOccurs="0" /><element name="expirationDate" type="xsd:dateTime" minOccurs="0" /><element name="expirationDuration" type="xsd:duration" minOccurs="0" /><element name="fromUser" type="tns:identityType" minOccurs="0" /><element name="hasSubTasks" type="xsd:boolean" minOccurs="0" /><element name="inShortHistory" type="xsd:boolean" minOccurs="0" /><element name="isGroup" type="xsd:boolean" minOccurs="0" /><element name="language" type="xsd:string" minOccurs="0" /><element name="mailStatus" type="tns:mailStatusEnum" minOccurs="0" /><element name="numberOfTimesModified" type="xsd:integer" minOccurs="0" /><element name="originalAssigneeUser" type="xsd:string" minOccurs="0" /><element name="outcome" type="xsd:string" minOccurs="0" /><element name="parallelOutcomeCount" type="xsd:string" minOccurs="0" /><element name="passwordRequiredOnUpdate" type="xsd:boolean" minOccurs="0" /><element name="pushbackSequence" type="xsd:string" minOccurs="0" /><element name="secureNotifications" type="xsd:boolean" minOccurs="0" /><element name="shortHistory" type="tns:shortHistoryType" minOccurs="0" /><element name="state" type="tns:stateEnum" minOccurs="0" /><element name="substate" type="tns:substateEnum" minOccurs="0" /><element name="systemActions" type="tns:actionType" minOccurs="0" maxOccurs="unbounded" /><element name="systemString1" type="xsd:string" minOccurs="0" /><element name="systemString2" type="xsd:string" minOccurs="0" /><element name="systemString3" type="xsd:string" minOccurs="0" /><element name="taskGroupId" type="xsd:string" minOccurs="0" /><element name="taskId" type="xsd:string" minOccurs="0" /><element name="taskNumber" type="xsd:integer" minOccurs="0" /><element name="updatedBy" type="tns:identityType" minOccurs="0" /><element name="updatedDate" type="xsd:dateTime" minOccurs="0" /><element name="version" type="xsd:integer" minOccurs="0" /><element name="versionReason" type="xsd:string" minOccurs="0" /><element name="taskDefinitionId" type="xsd:string" minOccurs="0" /><element name="taskDefinitionName" type="xsd:string" minOccurs="0" /><element name="workflowPattern" type="xsd:string" minOccurs="0" /><element name="isTestTask" type="xsd:boolean" minOccurs="0" /><element name="participantName" type="xsd:string" minOccurs="0" /><element name="readByUsers" type="xsd:string" minOccurs="0" /><element name="reviewers" type="tns:identityType" minOccurs="0" maxOccurs="unbounded" /><element name="assignees" type="tns:identityType" minOccurs="0" maxOccurs="unbounded" /><element name="taskGroupInstanceId" type="xsd:string" minOccurs="0" /><element name="subTaskGroupInstanceId" type="xsd:string" minOccurs="0" /><element name="parentTaskVersion" type="xsd:integer" minOccurs="0" /><element name="agRootId" type="xsd:string" minOccurs="0" /><element name="agMileStonePath" type="xsd:string" minOccurs="0" /><element name="rootTaskId" type="xsd:string" minOccurs="0" /><element name="parentTaskId" type="xsd:string" minOccurs="0" /><element name="systemStringActions" type="xsd:string" minOccurs="0" /><element name="approvalStage" type="xsd:string" minOccurs="0" /><element name="messageAttributeGroup" type="xsd:string" minOccurs="0" /><element name="isApprovalTask" type="xsd:boolean" minOccurs="0" /><element name="restrictedActions" type="tns:actionType" minOccurs="0" maxOccurs="unbounded" /><element name="dimensionIdentifier" type="xsd:string" minOccurs="0" /><element name="chainIdentifier" type="xsd:string" minOccurs="0" /><element name="change" type="tsc:taskSequenceChangeType" minOccurs="0" /><element name="updatedNotificationId" type="xsd:string" minOccurs="0" /><element name="stage" type="xsd:string" minOccurs="0" /><element name="assignmentContext" type="xsd:string" minOccurs="0" /><element ref="tns:collectionTarget" minOccurs="0" maxOccurs="unbounded" /></sequence></complexType><element name="collectionTarget" type="tns:collectionTargetType" /><complexType name="collectionTargetType"><sequence><element name="xpath" type="xsd:string" minOccurs="1" maxOccurs="1" /><element name="collectionName" type="xsd:string" minOccurs="1" maxOccurs="1" /><element name="type" type="tns:collectionTargetTypeEnum" minOccurs="1" maxOccurs="1" /><choice minOccurs="1" maxOccurs="1"><element name="targetIndex" type="xsd:integer" /><element ref="tns:keyList" /></choice><element name="status" type="xsd:string" minOccurs="0" maxOccurs="1" /></sequence></complexType><simpleType name="collectionTargetTypeEnum"><restriction base="xsd:string"><enumeration value="PRIMARY" /><enumeration value="AGGREGATED" /></restriction></simpleType><element name="keyList" type="tns:keyListType" /><complexType name="keyListType"><sequence><element name="key" type="tns:keyType" minOccurs="1" maxOccurs="unbounded" /></sequence></complexType><complexType name="keyType"><sequence><element name="name" type="xsd:string" minOccurs="1" maxOccurs="1" /><element name="value" type="xsd:string" minOccurs="1" maxOccurs="1" /></sequence></complexType><complexType name="actionType"><sequence><element name="action" type="xsd:string" minOccurs="0" /><element name="displayName" type="xsd:string" minOccurs="0" /></sequence></complexType><complexType name="shortHistoryType"><sequence><element name="task" type="tns:shortHistoryTaskType" minOccurs="0" maxOccurs="unbounded" /></sequence></complexType><complexType name="shortHistoryTaskType"><sequence><element name="state" type="xsd:string" minOccurs="0" /><element name="outcome" type="xsd:string" minOccurs="0" /><element name="comments" type="xsd:string" minOccurs="0" /><element name="updatedBy" type="tns:identityType" minOccurs="0" /><element name="updatedDate" type="xsd:dateTime" minOccurs="0" /><element name="version" type="xsd:integer" minOccurs="0" /><element name="versionReason" type="xsd:string" minOccurs="0" /></sequence></complexType><complexType name="displayInfoType"><sequence><element name="applicationName" type="xsd:string" /><element name="hostname" type="xsd:string" /><element name="httpPort" type="xsd:string" /><element name="httpsPort" type="xsd:string" /><element name="uri" type="xsd:string" /></sequence></complexType><simpleType name="stateEnum"><restriction base="xsd:string"><enumeration value="ASSIGNED" /><enumeration value="COMPLETED" /><enumeration value="ERRORED" /><enumeration value="EXPIRED" /><enumeration value="INFO_REQUESTED" /><enumeration value="OUTCOME_UPDATED" /><enumeration value="STALE" /><enumeration value="SUSPENDED" /><enumeration value="WITHDRAWN" /></restriction></simpleType><simpleType name="substateEnum"><restriction base="xsd:string"><enumeration value="ACQUIRED" /><enumeration value="ADHOC_ROUTED" /><enumeration value="ASSIGNED" /><enumeration value="DELEGATED" /><enumeration value="ESCALATED" /><enumeration value="INFO_SUBMITTED" /><enumeration value="PUSHED_BACK" /><enumeration value="REASSIGNED" /><enumeration value="RELEASED" /><enumeration value="RENEWED" /><enumeration value="RESUMED" /><enumeration value="ROUTED" /></restriction></simpleType><simpleType name="taskActionEnum"><restriction base="xsd:string"><enumeration value="ACQUIRE" /><enumeration value="ADHOC_ROUTE" /><enumeration value="AUTO_RELEASE" /><enumeration value="COMPLETE" /><enumeration value="DELEGATE" /><enumeration value="ERROR" /><enumeration value="ESCALATE" /><enumeration value="EXPIRE" /><enumeration value="INFO_REQUEST" /><enumeration value="INFO_SUBMIT" /><enumeration value="INITIATE" /><enumeration value="OUTCOME_UPDATE" /><enumeration value="OUTCOME_UPDATE_ROUTE" /><enumeration value="OVERRIDE_ROUTING_SLIP" /><enumeration value="PUSH_BACK" /><enumeration value="REASSIGN" /><enumeration value="REINITIATE" /><enumeration value="RELEASE" /><enumeration value="RENEW" /><enumeration value="RESUME" /><enumeration value="SKIP_CURRENT_ASSIGNMENT" /><enumeration value="SUBTASK_OUTCOME_UPDATE" /><enumeration value="SUSPEND" /><enumeration value="UPDATE" /><enumeration value="WITHDRAW" /></restriction></simpleType><simpleType name="mailStatusEnum"><restriction base="xsd:string"><enumeration value="ERRORED" /><enumeration value="RETRY" /><enumeration value="SENT" /></restriction></simpleType><complexType name="systemMessageAttributesType"><sequence><element name="textAttribute1" type="xsd:string" minOccurs="0" /><element name="textAttribute2" type="xsd:string" minOccurs="0" /><element name="textAttribute3" type="xsd:string" minOccurs="0" /><element name="textAttribute4" type="xsd:string" minOccurs="0" /><element name="textAttribute5" type="xsd:string" minOccurs="0" /><element name="textAttribute6" type="xsd:string" minOccurs="0" /><element name="textAttribute7" type="xsd:string" minOccurs="0" /><element name="textAttribute8" type="xsd:string" minOccurs="0" /><element name="textAttribute9" type="xsd:string" minOccurs="0" /><element name="textAttribute10" type="xsd:string" minOccurs="0" /><element name="formAttribute1" type="xsd:string" minOccurs="0" /><element name="formAttribute2" type="xsd:string" minOccurs="0" /><element name="formAttribute3" type="xsd:string" minOccurs="0" /><element name="formAttribute4" type="xsd:string" minOccurs="0" /><element name="formAttribute5" type="xsd:string" minOccurs="0" /><element name="urlAttribute1" type="xsd:string" minOccurs="0" /><element name="urlAttribute2" type="xsd:string" minOccurs="0" /><element name="urlAttribute3" type="xsd:string" minOccurs="0" /><element name="urlAttribute4" type="xsd:string" minOccurs="0" /><element name="urlAttribute5" type="xsd:string" minOccurs="0" /><element name="dateAttribute1" type="xsd:dateTime" minOccurs="0" /><element name="dateAttribute2" type="xsd:dateTime" minOccurs="0" /><element name="dateAttribute3" type="xsd:dateTime" minOccurs="0" /><element name="dateAttribute4" type="xsd:dateTime" minOccurs="0" /><element name="dateAttribute5" type="xsd:dateTime" minOccurs="0" /><element name="numberAttribute1" type="xsd:double" minOccurs="0" /><element name="numberAttribute2" type="xsd:double" minOccurs="0" /><element name="numberAttribute3" type="xsd:double" minOccurs="0" /><element name="numberAttribute4" type="xsd:double" minOccurs="0" /><element name="numberAttribute5" type="xsd:double" minOccurs="0" /><element name="protectedTextAttribute1" type="xsd:string" minOccurs="0" /><element name="protectedTextAttribute2" type="xsd:string" minOccurs="0" /><element name="protectedTextAttribute3" type="xsd:string" minOccurs="0" /><element name="protectedTextAttribute4" type="xsd:string" minOccurs="0" /><element name="protectedTextAttribute5" type="xsd:string" minOccurs="0" /><element name="protectedTextAttribute6" type="xsd:string" minOccurs="0" /><element name="protectedTextAttribute7" type="xsd:string" minOccurs="0" /><element name="protectedTextAttribute8" type="xsd:string" minOccurs="0" /><element name="protectedTextAttribute9" type="xsd:string" minOccurs="0" /><element name="protectedTextAttribute10" type="xsd:string" minOccurs="0" /><element name="protectedFormAttribute1" type="xsd:string" minOccurs="0" /><element name="protectedFormAttribute2" type="xsd:string" minOccurs="0" /><element name="protectedFormAttribute3" type="xsd:string" minOccurs="0" /><element name="protectedFormAttribute4" type="xsd:string" minOccurs="0" /><element name="protectedFormAttribute5" type="xsd:string" minOccurs="0" /><element name="protectedURLAttribute1" type="xsd:string" minOccurs="0" /><element name="protectedURLAttribute2" type="xsd:string" minOccurs="0" /><element name="protectedURLAttribute3" type="xsd:string" minOccurs="0" /><element name="protectedURLAttribute4" type="xsd:string" minOccurs="0" /><element name="protectedURLAttribute5" type="xsd:string" minOccurs="0" /><element name="protectedDateAttribute1" type="xsd:dateTime" minOccurs="0" /><element name="protectedDateAttribute2" type="xsd:dateTime" minOccurs="0" /><element name="protectedDateAttribute3" type="xsd:dateTime" minOccurs="0" /><element name="protectedDateAttribute4" type="xsd:dateTime" minOccurs="0" /><element name="protectedDateAttribute5" type="xsd:dateTime" minOccurs="0" /><element name="protectedNumberAttribute1" type="xsd:double" minOccurs="0" /><element name="protectedNumberAttribute2" type="xsd:double" minOccurs="0" /><element name="protectedNumberAttribute3" type="xsd:double" minOccurs="0" /><element name="protectedNumberAttribute4" type="xsd:double" minOccurs="0" /><element name="protectedNumberAttribute5" type="xsd:double" minOccurs="0" /></sequence></complexType><simpleType name="priorityType"><restriction base="xsd:integer"><minInclusive value="1" /></restriction></simpleType></schema>'! !

!BPEL20BPXSDSourceTest methodsFor: 'xsd' stamp: 'AlvaroJosePeraltaOcampo 11/12/2014 09:47'!
xsd_MeteoWebService_WeatherWebServiceTypes
^ '<?xml version="1.0" encoding="UTF-8"?>
<xsd:schema targetNamespace="http://www.superwebservice.com/publictypes"
	xmlns:tns="http://www.superwebservice.com/publictypes" xmlns:xsd="http://www.w3.org/2001/XMLSchema"
	elementFormDefault="qualified">

	<xsd:element name="WeatherPacket">
		<xsd:complexType>
			<xsd:sequence>

				<xsd:element name="WeatherRequest">
					<xsd:complexType>
						<xsd:sequence>
							<xsd:element minOccurs="0" maxOccurs="1" name="CityName"
								type="xsd:string" />
							<xsd:element minOccurs="0" maxOccurs="1" name="CountryName"
								type="xsd:string" />
						</xsd:sequence>
					</xsd:complexType>
				</xsd:element>

				<!!-- On a un complextype "produitS" compose de plusieurs "produit" -->
				<xsd:element name="WeatherResponse">
					<xsd:complexType>
						<xsd:sequence>
							<xsd:element name="lieu" type="xsd:string" />
							<xsd:element name="date_heure" type="xsd:string" />
							<xsd:element name="vent" type="xsd:string" />
							<xsd:element name="visibilite" type="xsd:string" />
							<xsd:element name="ciel" type="xsd:string" />
							<xsd:element name="temperature" type="xsd:string" />
							<xsd:element name="point_rosee" type="xsd:string" />
							<xsd:element name="humidite" type="xsd:string" />
							<xsd:element name="pression" type="xsd:string" />
							<xsd:element name="status" type="xsd:string" />
							<xsd:element name="unique_token" type="xsd:string" />
						</xsd:sequence>
					</xsd:complexType>
				</xsd:element>

			</xsd:sequence>
		</xsd:complexType>
	</xsd:element>
</xsd:schema>
'! !

!BPEL20BPXSDSourceTest methodsFor: 'xsd' stamp: 'AlvaroJosePeraltaOcampo 11/12/2014 09:47'!
xsd_MeteoWebService_exemple
^ '<?xml version="1.0" encoding="UTF-8"?><xsd:schema targetNamespace="http://www.leuville.com/commande" 
	xmlns:tns="http://www.leuville.com/commande" 
	xmlns:xsd="http://www.w3.org/2001/XMLSchema"
	elementFormDefault="qualified">
	<xsd:element name="situation-meteo" >
	<xsd:complexType>
		<xsd:sequence>
		 <tns:element name="GetWeather">
			<tns:complexType>
			    <tns:sequence>
			       <tns:element minOccurs="0" maxOccurs="1" name="CityName" type="tns:string" />
			       <tns:element minOccurs="0" maxOccurs="1" name="CountryName" type="tns:string" />
			    </tns:sequence>
		    </tns:complexType>
		  </tns:element>
			<!!--  On a un complextype "produitS" composé de plusieurs "produit" -->
			<xsd:element name="reponse-meteo">
				<xsd:complexType>
					<xsd:element name="meteo">
						<xsd:complexType>
							<xsd:sequence>							             
								<xsd:element name="lieu" type="xsd:string" />   
								<xsd:element name="date-heure" type="xsd:string" />
								<xsd:element name="vent" type="xsd:string" />
								<xsd:element name="visibilite" type="xsd:string" />
								<xsd:element name="ciel" type="xsd:string" />
								<xsd:element name="temperature" type="xsd:string" /> 
								<xsd:element name="point-rosee" type="xsd:string" />
								<xsd:element name="humidite" type="xsd:string" />
								<xsd:element name="pression" type="xsd:string" />
								<xsd:element name="status" type="xsd:string" />        						             
							</xsd:sequence>
					</xsd:complexType>
					</xsd:element>
				</xsd:complexType>
			</xsd:element>
	<xsd:complexType name="produit">
		<xsd:sequence>
			<xsd:element name="reference" type="xsd:string" />
			<xsd:element name="quantite" type="xsd:int" />
			<xsd:element name="prixUnitaireHT" type="xsd:float" minOccurs="0" />
		</xsd:sequence>
	</xsd:complexType>
</xsd:schema>'! !

BPEL20BPSourceTest subclass: #BPEL20BpelAnalyzerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-Tests-BPEL20-source'!

!BPEL20BpelAnalyzerTest methodsFor: 'bpel_source' stamp: 'AlvaroJosePeraltaOcampo 11/12/2014 09:47'!
AddNonStandarizedContractsBPEL
^ '<?xml version="1.0" encoding="UTF-8"?>
<process
    name="mergeContractsProcess"
    targetNamespace="http://enterprise.netbeans.org/bpel/AddNonStandarizedContractsBPEL/mergeContractsProcess"
    xmlns="http://docs.oasis-open.org/wsbpel/2.0/process/executable"
    xmlns:xsd="http://www.w3.org/2001/XMLSchema"
    xmlns:sxt="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/Trace" 
    xmlns:sxed="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/Editor"
    xmlns:sxeh="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/ErrorHandling"
    xmlns:tns="http://enterprise.netbeans.org/bpel/AddNonStandarizedContractsBPEL/mergeContractsProcess">
    <import namespace="http://j2ee.netbeans.org/wsdl/AddNonStandarizedContractsBPEL/getRemoteStandarizedFileWSDL" location="getRemoteStandarizedFileWSDL.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://enterprise.netbeans.org/bpel/ContractsServiceWrapper" location="ContractsServiceWrapper.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://data.contracts.otc.crcc.com/" location="externalWSDL/ContractsService.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://j2ee.netbeans.org/wsdl/AddNonStandarizedContractsBPEL/putAllContractsRemoteWSDL" location="putAllContractsRemoteWSDL.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <partnerLinks>
        <partnerLink name="contractsFacade" xmlns:tns="http://enterprise.netbeans.org/bpel/ContractsServiceWrapper" partnerLinkType="tns:ContractsServiceLinkType" partnerRole="ContractsServiceRole"/>
        <partnerLink name="putRemoteFile" xmlns:tns="http://j2ee.netbeans.org/wsdl/AddNonStandarizedContractsBPEL/putAllContractsRemoteWSDL" partnerLinkType="tns:putAllContractsRemoteWSDL" partnerRole="OutboundOneWayTransferringPortTypeRole"/>
        <partnerLink name="getRemoteFile" xmlns:tns="http://j2ee.netbeans.org/wsdl/AddNonStandarizedContractsBPEL/getRemoteStandarizedFileWSDL" partnerLinkType="tns:getRemoteStandarizedFileWSDL" myRole="InboundOneWayTransferringPortTypeRole"/>
    </partnerLinks>
    <variables>
        <variable name="requestPutRemoteFileIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/AddNonStandarizedContractsBPEL/putAllContractsRemoteWSDL" messageType="tns:OutboundOneWayTransferringOperationRequest"/>
        <variable name="responseGetNonStandarizedOut" xmlns:tns="http://data.contracts.otc.crcc.com/" messageType="tns:getContractsConsFilesResponse"/>
        <variable name="requestGetNonStandarizedIn" xmlns:tns="http://data.contracts.otc.crcc.com/" messageType="tns:getContractsConsFiles"/>
        <variable name="requestFileIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/AddNonStandarizedContractsBPEL/getRemoteStandarizedFileWSDL" messageType="tns:InboundOneWayTransferringOperationRequest"/>
    </variables>
    <sequence>
        <receive name="getFTPFile" createInstance="yes" partnerLink="getRemoteFile" operation="InboundOneWayTransferringOperation" xmlns:tns="http://j2ee.netbeans.org/wsdl/AddNonStandarizedContractsBPEL/getRemoteStandarizedFileWSDL" portType="tns:InboundOneWayTransferringPortType" variable="requestFileIn"/>
        <assign name="datas">
            <copy>
                <from>''C2''</from>
                <to>$requestGetNonStandarizedIn.parameters/environment</to>
            </copy>
            <copy>
                <from>''01''</from>
                <to>$requestGetNonStandarizedIn.parameters/group</to>
            </copy>
        </assign>
        <invoke name="toGetNonStandarizedContracts" partnerLink="contractsFacade" operation="getContractsConsFiles" xmlns:tns="http://data.contracts.otc.crcc.com/" portType="tns:ContractsService" inputVariable="requestGetNonStandarizedIn" outputVariable="responseGetNonStandarizedOut"/>
        <assign name="standarized2All">
            <copy>
                <from>concat($requestFileIn.part1, $responseGetNonStandarizedOut.parameters/return)</from>
                <to variable="requestPutRemoteFileIn" part="part1"/>
            </copy>
        </assign>
        <invoke name="toPutRemoteFile" partnerLink="putRemoteFile" operation="OutboundOneWayTransferringOperation" xmlns:tns="http://j2ee.netbeans.org/wsdl/AddNonStandarizedContractsBPEL/putAllContractsRemoteWSDL" portType="tns:OutboundOneWayTransferringPortType" inputVariable="requestPutRemoteFileIn"/>
    </sequence>
</process>
'! !

!BPEL20BpelAnalyzerTest methodsFor: 'bpel_source' stamp: 'AlvaroJosePeraltaOcampo 11/12/2014 09:47'!
CallBackSendingMessageBPEL
^ '<?xml version="1.0" encoding="UTF-8"?>
<process
    name="CallBackMessage"
    targetNamespace="http://enterprise.netbeans.org/bpel/CallBackSendingMessageBPEL/CallBackMessage"
    xmlns="http://docs.oasis-open.org/wsbpel/2.0/process/executable"
    xmlns:xsd="http://www.w3.org/2001/XMLSchema"
    xmlns:sxt="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/Trace" 
    xmlns:sxed="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/Editor"
    xmlns:sxeh="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/ErrorHandling"
    xmlns:tns="http://enterprise.netbeans.org/bpel/CallBackSendingMessageBPEL/CallBackMessage" xmlns:ns0="http://j2ee.netbeans.org/xsd/tableSchema" xmlns:ns1="http://xml.netbeans.org/schema/runtimePartner" xmlns:ns2="http://schemas.xmlsoap.org/ws/2004/08/addressing">
    <import namespace="http://j2ee.netbeans.org/wsdl/pollingViewDBSendingMessageWSDL" location="pollingViewDBSendingMessageWSDL.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://j2ee.netbeans.org/wsdl/processNovateTradeBPEL/invokeCallbackPartnerLinkWSDL" location="externalWSDL/invokeCallbackPartnerLinkWSDL.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <partnerLinks>
        <partnerLink name="invokeCallBack" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeBPEL/invokeCallbackPartnerLinkWSDL" partnerLinkType="tns:invokeCallbackPartnerLinkWSDL" partnerRole="invokeCallbackPartnerLinkWSDLPortTypeRole"/>
        <partnerLink name="pollView" xmlns:tns="http://j2ee.netbeans.org/wsdl/pollingViewDBSendingMessageWSDL" partnerLinkType="tns:jdbcpartner" myRole="jdbcPortTypeRole"/>
    </partnerLinks>
    <variables>
        <variable name="responsePollRecordsIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/pollingViewDBSendingMessageWSDL" messageType="tns:inputMsg"/>
        <variable name="requestInvokeCallbackOperationIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeBPEL/invokeCallbackPartnerLinkWSDL" messageType="tns:invokeCallbackPartnerLinkWSDLOperationRequest"/>
    </variables>
    <sequence>
        <receive name="getSendingMessage" createInstance="yes" partnerLink="pollView" operation="pollrecords" xmlns:tns="http://j2ee.netbeans.org/wsdl/pollingViewDBSendingMessageWSDL" portType="tns:jdbcPortType" variable="responsePollRecordsIn"/>
        <if name="FindMessages">
            <condition>$responsePollRecordsIn.part/ns0:CallBackMessage_Record</condition>
            <sequence name="Sequence1">
                <assign name="settingMessage">
                    <copy>
                        <from>$responsePollRecordsIn.part/ns0:CallBackMessage_Record/ns0:ID</from>
                            <to>$requestInvokeCallbackOperationIn.part1/ns1:fpmlMessageFK</to>
                    </copy>
                        <copy>
                        <from>$responsePollRecordsIn.part/ns0:CallBackMessage_Record/ns0:partyID</from>
                            <to>$requestInvokeCallbackOperationIn.part1/ns1:senderPartyID</to>
                    </copy>
                        <copy>
                        <from>$responsePollRecordsIn.part/ns0:CallBackMessage_Record/ns0:serviceAddress</from>
                            <to>$requestInvokeCallbackOperationIn.part1/ns1:endPointReference/ns2:Address</to>
                    </copy>
                        <copy>
                        <from>$responsePollRecordsIn.part/ns0:CallBackMessage_Record/ns0:message</from>
                            <to>$requestInvokeCallbackOperationIn.part1/ns1:fpMLMessageAsString</to>
                    </copy>
                        <copy>
                        <from>$responsePollRecordsIn.part/ns0:CallBackMessage_Record/ns0:portName</from>
                            <to>$requestInvokeCallbackOperationIn.part1/ns1:endPointReference/ns2:ServiceName/@PortName</to>
                    </copy>
                        <copy>
                        <from>$responsePollRecordsIn.part/ns0:CallBackMessage_Record/ns0:serviceName</from>
                            <to>$requestInvokeCallbackOperationIn.part1/ns1:endPointReference/ns2:ServiceName</to>
                    </copy>
                </assign>
                <invoke name="toInvokeCallBack" partnerLink="invokeCallBack" operation="invokeCallbackPartnerLinkWSDLOperation" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeBPEL/invokeCallbackPartnerLinkWSDL" portType="tns:invokeCallbackPartnerLinkWSDLPortType" inputVariable="requestInvokeCallbackOperationIn"/>
            </sequence>
        </if>
    </sequence>
</process>
'! !

!BPEL20BpelAnalyzerTest methodsFor: 'bpel_source' stamp: 'AlvaroJosePeraltaOcampo 11/12/2014 09:47'!
ClientProcessNovateTradeResponse
^ '<?xml version="1.0" encoding="UTF-8"?>
<process
    name="processNovateTradeResponse"
    targetNamespace="http://enterprise.netbeans.org/bpel/ClientProcessNovateTradeResponse/processNovateTradeResponse"
    xmlns="http://docs.oasis-open.org/wsbpel/2.0/process/executable"
    xmlns:xsd="http://www.w3.org/2001/XMLSchema"
    xmlns:sxt="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/Trace" 
    xmlns:sxed="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/Editor"
    xmlns:sxeh="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/ErrorHandling"
    xmlns:tns="http://enterprise.netbeans.org/bpel/ClientProcessNovateTradeResponse/processNovateTradeResponse" xmlns:ns0="http://xml.netbeans.org/schema/xsdNovateTrade" xmlns:sxxf="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/XPathFunctions">
    <import namespace="http://j2ee.netbeans.org/wsdl/novateTradeClient-bpl/processNovateResponseWSDL" location="externalWSDL/processNovateResponseWSDL.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://j2ee.netbeans.org/wsdl/ClientProcessNovateTradeResponse/fileWSDL" location="fileWSDL.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <partnerLinks>
        <partnerLink name="file" xmlns:tns="http://j2ee.netbeans.org/wsdl/ClientProcessNovateTradeResponse/fileWSDL" partnerLinkType="tns:fileWSDL" partnerRole="FileOutboundPortTypeRole"/>
        <partnerLink name="processNovateResponse" xmlns:tns="http://j2ee.netbeans.org/wsdl/novateTradeClient-bpl/processNovateResponseWSDL" partnerLinkType="tns:processNovateResponseWSDL" myRole="processNovateResponseWSDLPortTypeRole"/>
    </partnerLinks>
    <variables>
        <variable name="ProcessNovateResponseIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/novateTradeClient-bpl/processNovateResponseWSDL" messageType="tns:processNovateResponse"/>
        <variable name="WriteIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/ClientProcessNovateTradeResponse/fileWSDL" messageType="tns:WriteInputMessage"/>
    </variables>
    <sequence>
        <receive name="Receive1" createInstance="yes" partnerLink="processNovateResponse" operation="processNovateResponse" xmlns:tns="http://j2ee.netbeans.org/wsdl/novateTradeClient-bpl/processNovateResponseWSDL" portType="tns:processNovateResponseWSDLPortType" variable="ProcessNovateResponseIn">
            <sxt:trace>
                <sxt:log level="fine" location="onStart">
                    <from>concat(''START: receiveMessage'', sxxf:current-time())</from>
                </sxt:log>
            </sxt:trace>
        </receive>
        <assign name="Assign1">
            <copy>
                <from>$ProcessNovateResponseIn.fpMLMessage/ns0:fpMLMessage</from>
                <to variable="WriteIn" part="part1"/>
            </copy>
        </assign>
        <invoke name="Invoke1" partnerLink="file" operation="write" xmlns:tns="http://j2ee.netbeans.org/wsdl/ClientProcessNovateTradeResponse/fileWSDL" portType="tns:FileOutboundPortType" inputVariable="WriteIn">
            <sxt:trace>
                <sxt:log level="fine" location="onComplete">
                    <from>concat(''FINISHED: writeMessage'', sxxf:current-time())</from>
                </sxt:log>
            </sxt:trace>
        </invoke>
    </sequence>
</process>
'! !

!BPEL20BpelAnalyzerTest methodsFor: 'bpel_source' stamp: 'AlvaroJosePeraltaOcampo 11/12/2014 09:47'!
ManageAccountsAndParticipantsBPEL
^ '<?xml version="1.0" encoding="UTF-8"?>
<process
    name="ManageMEFFAccountsAndParticipants"
    targetNamespace="http://enterprise.netbeans.org/bpel/ManageAccountsAndParticipantsBPEL/ManageMEFFAccountsAndParticipants"
    xmlns="http://docs.oasis-open.org/wsbpel/2.0/process/executable"
    xmlns:xsd="http://www.w3.org/2001/XMLSchema"
    xmlns:sxt="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/Trace" 
    xmlns:sxed="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/Editor"
    xmlns:sxeh="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/ErrorHandling"
    xmlns:tns="http://enterprise.netbeans.org/bpel/ManageAccountsAndParticipantsBPEL/ManageMEFFAccountsAndParticipants">
   <import namespace="http://j2ee.netbeans.org/wsdl/ManageAccountsAndParticipantsBPEL/ReceiveAccountRemoteFileWSDL" location="ReceiveAccountRemoteFileWSDL.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
   <import namespace="http://j2ee.netbeans.org/wsdl/ManageAccountsAndParticipantsBPEL/getParticipantRemoteFileWSDL" location="GetPartiesRemoteFileWSDL.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
   <import namespace="http://enterprise.netbeans.org/bpel/PartiesAccountsServiceServiceWrapper" location="PartiesAccountsServiceServiceWrapper.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
   <import namespace="http://services.accounts.otc.crcc.com/" location="externalWSDL/PartiesAccountsServiceService.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
   <partnerLinks>
      <partnerLink name="plRemoteParticip" xmlns:tns="http://j2ee.netbeans.org/wsdl/ManageAccountsAndParticipantsBPEL/getParticipantRemoteFileWSDL" partnerLinkType="tns:getParticipantRemoteFileWSDL" partnerRole="ReceiveTransferringPortTypeRole">
         <documentation>this object do a ftp request on demand to get de participants information.
The kind from this object is: On demand receive transfer</documentation>
      </partnerLink>
      <partnerLink name="plAccountsServices" xmlns:tns="http://enterprise.netbeans.org/bpel/PartiesAccountsServiceServiceWrapper" partnerLinkType="tns:PartiesAccountsServiceLinkType" partnerRole="PartiesAccountsServiceRole">
         <documentation>This object do the comunication with the web service which expose the upgrade Accounts and parties method.
This method is located in the AccountsEJB project and follow the next steps in order to do the update
1. Inactivate all the parties an its accounts
2. Activate the participants and accounts which exist in the local BD.
3. activate the new participants
4. activate the new accounts</documentation>
      </partnerLink>
      <partnerLink name="plRemoteAccounts" xmlns:tns="http://j2ee.netbeans.org/wsdl/ManageAccountsAndParticipantsBPEL/ReceiveAccountRemoteFileWSDL" partnerLinkType="tns:ReceiveAccountRemoteFileWSDL" myRole="InboundOneWayTransferringPortTypeRole">
         <documentation>This object do a ftp poll in order to find an accounts file in the temporal file.
file name searched: cuentas
Object type: receive request</documentation>
      </partnerLink>
   </partnerLinks>
   <variables>
      <variable name="upgradeAccountsOut" xmlns:tns="http://services.accounts.otc.crcc.com/" messageType="tns:upgradeAccountsResponse"/>
      <variable name="upgradeAccountsIn" xmlns:tns="http://services.accounts.otc.crcc.com/" messageType="tns:upgradeAccounts"/>
      <variable name="getParticipantsOut" xmlns:tns="http://j2ee.netbeans.org/wsdl/ManageAccountsAndParticipantsBPEL/getParticipantRemoteFileWSDL" messageType="tns:ReceiveTransferringOperationResponse"/>
      <variable name="getParticipantsIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/ManageAccountsAndParticipantsBPEL/getParticipantRemoteFileWSDL" messageType="tns:ReceiveTransferringOperationRequest"/>
      <variable name="receivingAccountsIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/ManageAccountsAndParticipantsBPEL/ReceiveAccountRemoteFileWSDL" messageType="tns:InboundOneWayTransferringOperationRequest"/>
   </variables>
   <sequence>
      <receive name="receiveAccounts" createInstance="yes" partnerLink="plRemoteAccounts" operation="InboundOneWayTransferringOperation" xmlns:tns="http://j2ee.netbeans.org/wsdl/ManageAccountsAndParticipantsBPEL/ReceiveAccountRemoteFileWSDL" portType="tns:InboundOneWayTransferringPortType" variable="receivingAccountsIn">
         <documentation>This is the receiver from the poll object wich get the accounts information</documentation>
      </receive>
      <repeatUntil name="repeatUntilParticipantsNotLoaded">
         <documentation>This loop finish when the program find the pariticipants file. When it finish the system could be sure that both files are in the ftp remote location and it can start to do the rest of the process</documentation>
         <sequence name="LookingForParties">
            <assign name="intializeParticipantIn">
               <documentation>this is the first assign to the variable which is used to ask for the participants file.</documentation>
               <copy>
                  <from>''</from>
                     <to variable="getParticipantsIn" part="part1"/>
               </copy>
            </assign>
            <invoke name="getParties" partnerLink="plRemoteParticip" operation="ReceiveTransferringOperation" xmlns:tns="http://j2ee.netbeans.org/wsdl/ManageAccountsAndParticipantsBPEL/getParticipantRemoteFileWSDL" portType="tns:ReceiveTransferringPortType" inputVariable="getParticipantsIn" outputVariable="getParticipantsOut">
               <documentation>This object do the invoke to the object which is able to get the participant file
the filename from the archive is: particip</documentation>
            </invoke>
            <wait name="WaitForSomeSeconds">
               <documentation>this object introduce a delay for the next request from the participantes file (if it doesn''t exist)</documentation>
               <for>''P0Y0M0DT0H0M5.0S''</for>
            </wait>
         </sequence>
         <condition>$getParticipantsOut.part1 !!= ''</condition>
      </repeatUntil>
      <assign name="File2UpgradeAccounts">
         <documentation>after the system has both files, this object do the assign for the cuentas an particip files to the remote method called upgradeAccounts</documentation>
         <copy>
               <from variable="receivingAccountsIn" part="part1"/>
                  <to>$upgradeAccountsIn.parameters/accounts</to>
            </copy>
            <copy>
               <from variable="getParticipantsOut" part="part1"/>
                  <to>$upgradeAccountsIn.parameters/parties</to>
            </copy>
      </assign>
      <invoke name="toUpgradeAccounts" partnerLink="plAccountsServices" operation="upgradeAccounts" xmlns:tns="http://services.accounts.otc.crcc.com/" portType="tns:PartiesAccountsService" inputVariable="upgradeAccountsIn" outputVariable="upgradeAccountsOut">
         <documentation>This method do the invoke to the object who call the remote web service</documentation>
      </invoke>
   </sequence>
</process>
'! !

!BPEL20BpelAnalyzerTest methodsFor: 'bpel_source' stamp: 'AlvaroJosePeraltaOcampo 11/12/2014 09:47'!
MeffServicesBPEL
^ '<?xml version="1.0" encoding="UTF-8"?>
<process
    name="RequesTradeProcess"
    targetNamespace="http://enterprise.netbeans.org/bpel/MeffServicesBPEL/RequesTradeProcess"
    xmlns="http://docs.oasis-open.org/wsbpel/2.0/process/executable"
    xmlns:xsd="http://www.w3.org/2001/XMLSchema"
    xmlns:sxt="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/Trace" 
    xmlns:sxed="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/Editor"
    xmlns:sxeh="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/ErrorHandling"
    xmlns:tns="http://enterprise.netbeans.org/bpel/MeffServicesBPEL/RequesTradeProcess" xmlns:ns0="http://xml.netbeans.org/schema/Meff" xmlns:sxnmp="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/NMProperty">
    <import namespace="http://j2ee.netbeans.org/wsdl/MeffServicesBPEL/RequestTradeWSDL" location="RequestTradeWSDL.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://enterprise.netbeans.org/bpel/MeffServiceWrapper" location="MeffServiceWrapper.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://facade.data.otc.crcc.com/" location="externalWSDL/MeffService.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <partnerLinks>
        <partnerLink name="meffFacade" xmlns:tns="http://enterprise.netbeans.org/bpel/MeffServiceWrapper" partnerLinkType="tns:MeffServiceLinkType" partnerRole="MeffServiceRole"/>        
        <partnerLink name="requestTrade" xmlns:tns="http://j2ee.netbeans.org/wsdl/MeffServicesBPEL/RequestTradeWSDL" partnerLinkType="tns:RequestTradeWSDL" myRole="RequestTradeWSDLPortTypeRole"/>
    </partnerLinks>
    <variables>
        <variable name="requestAddTradeIn" xmlns:tns="http://facade.data.otc.crcc.com/" messageType="tns:addTrade"/>
        <variable name="Trade2StringOut" xmlns:tns="http://facade.data.otc.crcc.com/" messageType="tns:trade2StringResponse"/>
        <variable name="Trade2StringIn" xmlns:tns="http://facade.data.otc.crcc.com/" messageType="tns:trade2String"/>
        <variable name="responseTradeOut" xmlns:tns="http://j2ee.netbeans.org/wsdl/MeffServicesBPEL/RequestTradeWSDL" messageType="tns:RequestTradeWSDLOperationResponse"/>
        <variable name="requestTradeIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/MeffServicesBPEL/RequestTradeWSDL" messageType="tns:RequestTradeWSDLOperationRequest"/>
    </variables>
    <faultHandlers>
        <catchAll>
            <sequence name="Sequence1">
                <assign name="Assign1">
                    <copy>
                        <from>''MEFF SERVICES ERROR TEMP''</from>
                        <to>$responseTradeOut.response/ns0:response/ns0:meffTradeID</to>
                    </copy>
                </assign>
                <reply name="Reply1" partnerLink="requestTrade" operation="RequestTradeWSDLOperation" xmlns:tns="http://j2ee.netbeans.org/wsdl/MeffServicesBPEL/RequestTradeWSDL" portType="tns:RequestTradeWSDLPortType" variable="responseTradeOut"/>
            </sequence>
        </catchAll>
    </faultHandlers>
    <sequence>
        <receive name="getRequestTrade" createInstance="yes" partnerLink="requestTrade" operation="RequestTradeWSDLOperation" xmlns:tns="http://j2ee.netbeans.org/wsdl/MeffServicesBPEL/RequestTradeWSDL" portType="tns:RequestTradeWSDLPortType" variable="requestTradeIn"/>
        <assign name="request2String">
            <copy>
                <from>$requestTradeIn.request/ns0:request/ns0:contractId</from>
                <to>$requestAddTradeIn.parameters/trade/contrato</to>
            </copy>
            <copy>
                <from>$requestTradeIn.request/ns0:request/ns0:buyerAccount</from>
                <to>$requestAddTradeIn.parameters/trade/cuentaSubcuentaCompradora</to>
            </copy>
            <copy>
                <from>$requestTradeIn.request/ns0:request/ns0:sellerAccount</from>
                <to>$requestAddTradeIn.parameters/trade/cuentaSubcuentaVendedora</to>
            </copy>
            <copy>
                <from>$requestTradeIn.request/ns0:request/ns0:price</from>
                <to>$requestAddTradeIn.parameters/trade/precio</to>
            </copy>
            <copy>
                <from>$requestTradeIn.request/ns0:request/ns0:amount</from>
                <to>$requestAddTradeIn.parameters/trade/volumen</to>
            </copy>
            <copy>
                <from>$requestTradeIn.request/ns0:request/ns0:operationType</from>
                <to>$requestAddTradeIn.parameters/trade/tipoOperacion</to>
            </copy>
            <copy>
                <from>$requestTradeIn.request/ns0:request/ns0:originalTradeId</from>
                <to>$requestAddTradeIn.parameters/trade/numeroRegistroNegociacion</to>
            </copy>
            <copy>
                <from>$requestTradeIn.request/ns0:request/ns0:date</from>
                <to>$requestAddTradeIn.parameters/trade/fechaEjecucion</to>
            </copy>
            <copy>
                <from>$requestTradeIn.request/ns0:request/ns0:time</from>
                <to>$requestAddTradeIn.parameters/trade/horaEjecucion</to>
            </copy>
            <copy>
                <from>$requestTradeIn.request/ns0:request/ns0:buyerCode</from>
                <to>$requestAddTradeIn.parameters/trade/miembroComprador</to>
            </copy>
            <copy>
                <from>$requestTradeIn.request/ns0:request/ns0:sellerCode</from>
                <to>$requestAddTradeIn.parameters/trade/miembroVendedor</to>
            </copy>
            <copy>
                <from>''CRCC''</from>
                <to>$requestAddTradeIn.parameters/trade/miembroIntermediario</to>
            </copy>
            <copy>
                <from>$requestTradeIn.request/ns0:request/ns0:registrationSystem</from>
                <to>$requestAddTradeIn.parameters/trade/referenciaIntermediario</to>
            </copy>
        </assign>
        <invoke name="toAddTrade" partnerLink="meffFacade" operation="addTrade" xmlns:tns="http://facade.data.otc.crcc.com/" portType="tns:MeffService" inputVariable="requestAddTradeIn"/>
        <assign name="JMS2Response">
            <copy>
                <from>''ACEPTADO''</from>
                <to>$responseTradeOut.response/ns0:response/ns0:meffTradeID</to>
            </copy>
        </assign>
        <reply name="response" partnerLink="requestTrade" operation="RequestTradeWSDLOperation" xmlns:tns="http://j2ee.netbeans.org/wsdl/MeffServicesBPEL/RequestTradeWSDL" portType="tns:RequestTradeWSDLPortType" variable="responseTradeOut"/>
    </sequence>
</process>'! !

!BPEL20BpelAnalyzerTest methodsFor: 'bpel_source' stamp: 'AlvaroJosePeraltaOcampo 11/12/2014 09:47'!
novateTradeClientProcess
^ '<?xml version="1.0" encoding="UTF-8"?>
<process
    name="novateTradeClientProcess"
    targetNamespace="http://enterprise.netbeans.org/bpel/novateTradeClient-bpl/novateTradeClientProcess"
    xmlns="http://docs.oasis-open.org/wsbpel/2.0/process/executable"
    xmlns:xsd="http://www.w3.org/2001/XMLSchema"
    xmlns:sxt="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/Trace" 
    xmlns:sxed="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/Editor"
    xmlns:sxeh="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/ErrorHandling"
    xmlns:tns="http://enterprise.netbeans.org/bpel/novateTradeClient-bpl/novateTradeClientProcess" xmlns:ns0="http://xml.netbeans.org/schema/xsdNovateTrade">
    <import namespace="http://j2ee.netbeans.org/wsdl/novateTradeClient-bpl/sendTradeToCRCCWSDL" location="sendTradeToCRCCWSDL.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://j2ee.netbeans.org/wsdl/novateTrade-bpel/novateTradeWSDL" location="server/novateTradeWSDL.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <partnerLinks>
        <partnerLink name="plInvokeCRCC" xmlns:tns="http://j2ee.netbeans.org/wsdl/novateTrade-bpel/novateTradeWSDL" partnerLinkType="tns:novateTradeWSDL" partnerRole="novateTradeWSDLPortTypeRole"/>
        <partnerLink name="plInput" xmlns:tns="http://j2ee.netbeans.org/wsdl/novateTradeClient-bpl/sendTradeToCRCCWSDL" partnerLinkType="tns:sendTradeToCRCCWSDL" myRole="sendTradeToCRCCWSDLPortTypeRole"/>
    </partnerLinks>
    <variables>
        <variable name="NovateTradeIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/novateTrade-bpel/novateTradeWSDL" messageType="tns:novateTradeRequest"/>
        <variable name="SendTradeToCRCCIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/novateTradeClient-bpl/sendTradeToCRCCWSDL" messageType="tns:sendTradeToCRCCRequest"/>
    </variables>
    <sequence>
        <receive name="receiveInput" createInstance="yes" partnerLink="plInput" operation="sendTradeToCRCC" xmlns:tns="http://j2ee.netbeans.org/wsdl/novateTradeClient-bpl/sendTradeToCRCCWSDL" portType="tns:sendTradeToCRCCWSDLPortType" variable="SendTradeToCRCCIn"/>
        <assign name="Input2novateTrade">
            <copy>
                <from>concat(''BUYER: '', $SendTradeToCRCCIn.part1/ns0:comprador, ''SELLER: '', $SendTradeToCRCCIn.part1/ns0:vendedor)</from>
                <to>$NovateTradeIn.rtc/ns0:fpMLMessage</to>
            </copy>
        </assign>
        <invoke name="invokeNovateTrade" partnerLink="plInvokeCRCC" operation="novateTrade" xmlns:tns="http://j2ee.netbeans.org/wsdl/novateTrade-bpel/novateTradeWSDL" portType="tns:novateTradeWSDLPortType" inputVariable="NovateTradeIn"/>
    </sequence>
</process>
'! !

!BPEL20BpelAnalyzerTest methodsFor: 'bpel_source' stamp: 'AlvaroJosePeraltaOcampo 11/12/2014 09:47'!
novateTradeProcess
^ '<?xml version="1.0" encoding="UTF-8"?>
<process
    name="novateTrade"
    targetNamespace="http://enterprise.netbeans.org/bpel/novateTradeProcess/novateTrade"
    xmlns="http://docs.oasis-open.org/wsbpel/2.0/process/executable"
    xmlns:xsd="http://www.w3.org/2001/XMLSchema"
    xmlns:sxt="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/Trace" 
    xmlns:sxed="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/Editor"
    xmlns:sxeh="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/ErrorHandling"
    xmlns:tns="http://enterprise.netbeans.org/bpel/novateTradeProcess/novateTrade" xmlns:ns0="http://xml.netbeans.org/schema/xsdNovateTrade" xmlns:ns1="http://schemas.xmlsoap.org/ws/2004/08/addressing" xmlns:sxxf="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/XPathFunctions">
    <import namespace="http://j2ee.netbeans.org/wsdl/novateTrade-bpel/novateTradeWSDL" location="externalWSDL/novateTradeWSDL.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://j2ee.netbeans.org/wsdl/novateTradeProcess/putIncomingMessageToJMS" location="putIncomingMessageToJMS.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <partnerLinks>
        <partnerLink name="putToJMS" xmlns:tns="http://j2ee.netbeans.org/wsdl/novateTradeProcess/putIncomingMessageToJMS" partnerLinkType="tns:putIncomingMessageToJMS" partnerRole="JMSOutPortTypeRole"/>
        <partnerLink name="novateTradePL" xmlns:tns="http://j2ee.netbeans.org/wsdl/novateTrade-bpel/novateTradeWSDL" partnerLinkType="tns:novateTradeWSDL" myRole="novateTradeWSDLPortTypeRole"/>
    </partnerLinks>
    <variables>
        <variable name="requestNovateTradeIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/novateTrade-bpel/novateTradeWSDL" messageType="tns:novateTradeRequest"/>
        <variable name="requestJMSOutOperationIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/novateTradeProcess/putIncomingMessageToJMS" messageType="tns:JMSInputMessage"/>
    </variables>
    <sequence>
        <receive name="getIncomingMessage" createInstance="yes" partnerLink="novateTradePL" operation="novateTrade" xmlns:tns="http://j2ee.netbeans.org/wsdl/novateTrade-bpel/novateTradeWSDL" portType="tns:novateTradeWSDLPortType" variable="requestNovateTradeIn">
            <documentation>This activity get the incoming message for external client</documentation>
            <sxt:trace>
                <sxt:log level="fine" location="onStart">
                    <from>concat(''START: getIncomingMessage RTC :'', sxxf:current-dateTime())</from>
                </sxt:log>                
            </sxt:trace>
        </receive>
        <assign name="settingJMS">
            <copy>
                <from>$requestNovateTradeIn.rtc/ns0:fpMLMessage</from>
                <to>$requestJMSOutOperationIn.part1/ns0:novateTrade/ns0:fpMLMessage</to>
            </copy>
            <copy>
                <from>$requestNovateTradeIn.headerPart/ns1:EndpointReference</from>
                <to>$requestJMSOutOperationIn.part1/ns0:headerCRCC/ns1:EndpointReference</to>
            </copy>
        </assign>
        <invoke name="toPutToJMS" partnerLink="putToJMS" operation="JMSOutOperation" xmlns:tns="http://j2ee.netbeans.org/wsdl/novateTradeProcess/putIncomingMessageToJMS" portType="tns:JMSOutPortType" inputVariable="requestJMSOutOperationIn">
            <documentation>Invoke the PL to put the incoming message to JMS QUEUE</documentation>
            <sxt:trace>
                <sxt:log level="fine" location="onComplete">
                    <from>concat(''FINISHED: getIncomingMessage putting on JMS :'', sxxf:current-dateTime())</from>
                </sxt:log>                
            </sxt:trace>
        </invoke>
    </sequence>
</process>'! !

!BPEL20BpelAnalyzerTest methodsFor: 'bpel_source' stamp: 'AlvaroJosePeraltaOcampo 11/12/2014 09:47'!
novateTrade_bpel
^ '<?xml version="1.0" encoding="UTF-8"?>
<process
    name="novateTradeProcess"
    targetNamespace="http://enterprise.netbeans.org/bpel/novateTrade-bpel/novateTradeProcess"
    xmlns="http://docs.oasis-open.org/wsbpel/2.0/process/executable"
    xmlns:xsd="http://www.w3.org/2001/XMLSchema"
    xmlns:sxt="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/Trace" 
    xmlns:sxed="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/Editor"
    xmlns:sxeh="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/ErrorHandling"
    xmlns:tns="http://enterprise.netbeans.org/bpel/novateTrade-bpel/novateTradeProcess" xmlns:ns0="http://xml.netbeans.org/schema/xsdNovateTrade">
    <import namespace="http://j2ee.netbeans.org/wsdl/novateTrade-bpel/novateTradeWSDL" location="novateTradeWSDL.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://j2ee.netbeans.org/wsdl/novateTrade-bpel/fileWSDL" location="fileWSDL.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://j2ee.netbeans.org/wsdl/novateTradeClient-bpl/processNovateResponseWSDL" location="registrySystem/processNovateResponseWSDLPort.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <partnerLinks>
        <partnerLink name="plFile" xmlns:tns="http://j2ee.netbeans.org/wsdl/novateTrade-bpel/fileWSDL" partnerLinkType="tns:fileWSDL" partnerRole="FileOutboundPortTypeRole"/>
        <partnerLink name="plRegistrySystem" xmlns:tns="http://j2ee.netbeans.org/wsdl/novateTradeClient-bpl/processNovateResponseWSDL" partnerLinkType="tns:processNovateResponseWSDL" partnerRole="processNovateResponseWSDLPortTypeRole"/>
        <partnerLink name="plNovateTrade" xmlns:tns="http://j2ee.netbeans.org/wsdl/novateTrade-bpel/novateTradeWSDL" partnerLinkType="tns:novateTradeWSDL" myRole="novateTradeWSDLPortTypeRole"/>
    </partnerLinks>
    <variables>
        <variable name="ProcessNovateResponseIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/novateTradeClient-bpl/processNovateResponseWSDL" messageType="tns:processNovateResponseRequest"/>
        <variable name="WriteIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/novateTrade-bpel/fileWSDL" messageType="tns:WriteInputMessage"/>
        <variable name="NovateTradeIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/novateTrade-bpel/novateTradeWSDL" messageType="tns:novateTradeRequest"/>
    </variables>
    <sequence>
        <receive name="receiveNovateTrade" createInstance="yes" partnerLink="plNovateTrade" operation="novateTrade" xmlns:tns="http://j2ee.netbeans.org/wsdl/novateTrade-bpel/novateTradeWSDL" portType="tns:novateTradeWSDLPortType" variable="NovateTradeIn"/>
        <assign name="string2File">
            <copy>
                <from>$NovateTradeIn.rtc/ns0:fpMLMessage</from>
                <to variable="WriteIn" part="part1"/>
            </copy>
            <copy>
                <from>$NovateTradeIn.rtc/ns0:fpMLMessage</from>
                <to>$ProcessNovateResponseIn.fpMLMessage/ns0:fpMLMessage</to>
            </copy>
        </assign>
        <invoke name="toWriteFile" partnerLink="plFile" operation="write" xmlns:tns="http://j2ee.netbeans.org/wsdl/novateTrade-bpel/fileWSDL" portType="tns:FileOutboundPortType" inputVariable="WriteIn"/>
        <invoke name="toInvokeRegistrySystem" partnerLink="plRegistrySystem" operation="processNovateResponse" xmlns:tns="http://j2ee.netbeans.org/wsdl/novateTradeClient-bpl/processNovateResponseWSDL" portType="tns:processNovateResponseWSDLPortType" inputVariable="ProcessNovateResponseIn"/>
    </sequence>
</process>
'! !

!BPEL20BpelAnalyzerTest methodsFor: 'bpel_source' stamp: 'AlvaroJosePeraltaOcampo 11/12/2014 09:47'!
processNovateResponseProcess
^ '<?xml version="1.0" encoding="UTF-8"?>
<process
    name="processNovateResponseProcess"
    targetNamespace="http://enterprise.netbeans.org/bpel/novateTradeClient-bpl/processNovateResponseProcess"
    xmlns="http://docs.oasis-open.org/wsbpel/2.0/process/executable"
    xmlns:xsd="http://www.w3.org/2001/XMLSchema"
    xmlns:sxt="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/Trace" 
    xmlns:sxed="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/Editor"
    xmlns:sxeh="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/ErrorHandling"
    xmlns:tns="http://enterprise.netbeans.org/bpel/novateTradeClient-bpl/processNovateResponseProcess" xmlns:ns0="http://xml.netbeans.org/schema/xsdNovateTrade">
    <import namespace="http://j2ee.netbeans.org/wsdl/novateTradeClient-bpl/responsesClientWriterWSDL" location="responsesClientWriterWSDL.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://j2ee.netbeans.org/wsdl/novateTradeClient-bpl/processNovateResponseWSDL" location="processNovateResponseWSDL.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <partnerLinks>
        <partnerLink name="plProcessNovateResponse" xmlns:tns="http://j2ee.netbeans.org/wsdl/novateTradeClient-bpl/processNovateResponseWSDL" partnerLinkType="tns:processNovateResponseWSDL" myRole="processNovateResponseWSDLPortTypeRole"/>
        <partnerLink name="plWriter" xmlns:tns="http://j2ee.netbeans.org/wsdl/novateTradeClient-bpl/responsesClientWriterWSDL" partnerLinkType="tns:responsesClientWriterWSDL" partnerRole="FileOutboundPortTypeRole"/>
    </partnerLinks>
    <variables>
        <variable name="WriteIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/novateTradeClient-bpl/responsesClientWriterWSDL" messageType="tns:WriteInputMessage"/>
        <variable name="FpmlIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/novateTradeClient-bpl/processNovateResponseWSDL" messageType="tns:processNovateResponseRequest"/>
    </variables>
    <sequence>
        <receive name="getFmpl" createInstance="yes" partnerLink="plProcessNovateResponse" operation="processNovateResponse" xmlns:tns="http://j2ee.netbeans.org/wsdl/novateTradeClient-bpl/processNovateResponseWSDL" portType="tns:processNovateResponseWSDLPortType" variable="FpmlIn"/>
        <assign name="Fpml2Writer">
            <copy>
                <from>$FpmlIn.fpMLMessage/ns0:fpMLMessage</from>
                <to variable="WriteIn" part="part1"/>
            </copy>
        </assign>
        <invoke name="toWriteResponse" partnerLink="plWriter" operation="write" xmlns:tns="http://j2ee.netbeans.org/wsdl/novateTradeClient-bpl/responsesClientWriterWSDL" portType="tns:FileOutboundPortType" inputVariable="WriteIn"/>
    </sequence>
</process>'! !

!BPEL20BpelAnalyzerTest methodsFor: 'bpel_source2_processNovateTradeProcess' stamp: 'AlvaroJosePeraltaOcampo 11/12/2014 09:47'!
processNovateTradeProcess_invokeCallbackProcess
^ '<?xml version="1.0" encoding="UTF-8"?>
<process
    name="invokeCallbackProcess"
    targetNamespace="http://enterprise.netbeans.org/bpel/processNovateTradeBPEL/invokeCallbackProcess"
    xmlns="http://docs.oasis-open.org/wsbpel/2.0/process/executable"
    xmlns:xsd="http://www.w3.org/2001/XMLSchema"
    xmlns:sxt="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/Trace" 
    xmlns:sxed="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/Editor"
    xmlns:sxeh="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/ErrorHandling"
    xmlns:tns="http://enterprise.netbeans.org/bpel/processNovateTradeBPEL/invokeCallbackProcess" xmlns:ns0="http://docs.oasis-open.org/wsbpel/2.0/process/executable" xmlns:ns1="http://xml.netbeans.org/schema/runtimePartner" xmlns:ns2="http://xml.netbeans.org/schema/xsdNovateTrade" xmlns:ns3="http://j2ee.netbeans.org/wsdl/processNovateTradeBPEL/invokeCallbackPartnerLinkWSDL" xmlns:ns4="http://schemas.xmlsoap.org/ws/2004/08/addressing" xmlns:sxxf="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/XPathFunctions" xmlns:ns5="http://j2ee.netbeans.org/xsd/tableSchema">
    <documentation>The process allow to invoke dinamically a registration system by using the partyID of sender (placed on "send by" field on the header of original incoming request trade confirmation message). In addition the process get a URL form end point reference and add a ? wsdl in order to get the WSDL URL. based on partyID, go to database to get the certificate serial number</documentation>
    <import namespace="http://j2ee.netbeans.org/wsdl/novateTradeClient-bpl/processNovateResponseWSDL" location="externalWSDL/processNovateTradeResponse/processNovateResponseWSDL.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://j2ee.netbeans.org/wsdl/processNovateTradeBPEL/invokeCallbackPartnerLinkWSDL" location="invokeCallbackPartnerLinkWSDL.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://xml.netbeans.org/schema/runtimePartner" location="externalWSDL/xsd/runtimePartner.xsd" importType="http://www.w3.org/2001/XMLSchema"/>
    <import namespace="http://enterprise.netbeans.org/bpel/ProcessNovateTradeResponseConsumerServiceWrapper" location="ProcessNovateTradeResponseConsumerServiceWrapper.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://otc.crcc.com/" location="externalWSDL/processNovateTradeConsumer/ProcessNovateTradeResponseConsumerService.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://facade.manage.data.otc.crcc.com/" location="externalWSDL/ManageSystem/ManageSystemService.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://enterprise.netbeans.org/bpel/ManageSystemServiceWrapper" location="ManageSystemServiceWrapper.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://j2ee.netbeans.org/wsdl/sendingMessageControl" location="sendingMessageControl.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <partnerLinks>
        <partnerLink name="ManageSystemService" xmlns:tns="http://enterprise.netbeans.org/bpel/ManageSystemServiceWrapper" partnerLinkType="tns:ManageSystemServiceLinkType" partnerRole="ManageSystemServiceRole"/>
        <partnerLink name="processNovateTradeResponseConsumer" xmlns:tns="http://enterprise.netbeans.org/bpel/ProcessNovateTradeResponseConsumerServiceWrapper" partnerLinkType="tns:processNovateTradeResponseConsumerLinkType" partnerRole="processNovateTradeResponseConsumerRole">
            <documentation>Invoke dynamically the registration system based on wsdl URL and cert serail number</documentation>
        </partnerLink>
        <partnerLink name="toInserStateMessage" xmlns:tns="http://j2ee.netbeans.org/wsdl/sendingMessageControl" partnerLinkType="tns:jdbcpartner" partnerRole="jdbcPortTypeRole"/>
        <partnerLink name="invokeCallback" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeBPEL/invokeCallbackPartnerLinkWSDL" partnerLinkType="tns:invokeCallbackPartnerLinkWSDL" myRole="invokeCallbackPartnerLinkWSDLPortTypeRole">
            <documentation>This partner get the request form external usert that pretend send message to external system</documentation>
        </partnerLink>
    </partnerLinks>
    <variables>
        <variable name="requestUpdateBadMessageIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/sendingMessageControl" messageType="tns:inputMsg"/>
        <variable name="responseFindBadMessageOut" xmlns:tns="http://j2ee.netbeans.org/wsdl/sendingMessageControl" messageType="tns:outputMsg"/>
        <variable name="requestFindBadMessageIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/sendingMessageControl" messageType="tns:inputMsg"/>
        <variable name="requestMessageUpdateIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/sendingMessageControl" messageType="tns:inputMsg"/>
        <variable name="responseMessageFindOut" xmlns:tns="http://j2ee.netbeans.org/wsdl/sendingMessageControl" messageType="tns:outputMsg"/>
        <variable name="requestFindMessageIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/sendingMessageControl" messageType="tns:inputMsg"/>
        <variable name="responseInsertBadMessageOut" xmlns:tns="http://j2ee.netbeans.org/wsdl/sendingMessageControl" messageType="tns:insertRetMsg"/>
        <variable name="requestInsertBadMessageIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/sendingMessageControl" messageType="tns:inputMsg"/>
        <variable name="responseInsertGoodMessageOut" xmlns:tns="http://j2ee.netbeans.org/wsdl/sendingMessageControl" messageType="tns:insertRetMsg"/>
        <variable name="requestInsertGoodMessageIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/sendingMessageControl" messageType="tns:inputMsg"/>
        <variable name="responseManageGetRegistrationSystemOut" xmlns:tns="http://facade.manage.data.otc.crcc.com/" messageType="tns:getRegistrationSystemResponse"/>
        <variable name="requestManageGetRegistrationSystemIn" xmlns:tns="http://facade.manage.data.otc.crcc.com/" messageType="tns:getRegistrationSystem"/>
        <variable name="finalizationMessage" type="xsd:string"/>
        <variable name="responseConsumeRegistrationSystemOut" xmlns:tns="http://otc.crcc.com/" messageType="tns:consumeRegistrationSystemResponse"/>
        <variable name="requestConsumeRegistrationSystemIn" xmlns:tns="http://otc.crcc.com/" messageType="tns:consumeRegistrationSystem"/>
        <variable name="InvokeCallbackPartnerLinkWSDLOperationIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeBPEL/invokeCallbackPartnerLinkWSDL" messageType="tns:invokeCallbackPartnerLinkWSDLOperationRequest"/>        
    </variables>
    <sequence>
        <receive name="getAddress" createInstance="yes" partnerLink="invokeCallback" operation="invokeCallbackPartnerLinkWSDLOperation" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeBPEL/invokeCallbackPartnerLinkWSDL" portType="tns:invokeCallbackPartnerLinkWSDLPortType" variable="InvokeCallbackPartnerLinkWSDLOperationIn">
            <documentation>This activity get the incoming message</documentation>
        </receive>        
        <assign name="incoming2GetRegistrationSystem">
            <documentation>assing from incoming message to getRegistration System</documentation>
            <copy>
                <from>$InvokeCallbackPartnerLinkWSDLOperationIn.part1/ns1:senderPartyID</from>
                <to>$requestManageGetRegistrationSystemIn.parameters/partyID</to>
            </copy>
        </assign>
        <invoke name="toGetRegistrationSystem" partnerLink="ManageSystemService" operation="getRegistrationSystem" xmlns:tns="http://facade.manage.data.otc.crcc.com/" portType="tns:ManageSystemService" inputVariable="requestManageGetRegistrationSystemIn" outputVariable="responseManageGetRegistrationSystemOut"/>
        <assign name="incomingMessage2Callback">
            <documentation>to Get the information related with registration system. Exactly that nedd the certSerialNumber</documentation>
            <copy>
                <from>concat(string($InvokeCallbackPartnerLinkWSDLOperationIn.part1/ns1:endPointReference/ns4:Address), ''?wsdl'')</from>
                <to>$requestConsumeRegistrationSystemIn.parameters/uRL</to>
            </copy>
            <copy>
                <from>$InvokeCallbackPartnerLinkWSDLOperationIn.part1/ns1:fpMLMessageAsString</from>
                <to>$requestConsumeRegistrationSystemIn.parameters/response</to>
            </copy>
            <copy>
                <from>$responseManageGetRegistrationSystemOut.parameters/return/certSerialNumber</from>
                <to>$requestConsumeRegistrationSystemIn.parameters/certSerialNumber</to>
            </copy>
        </assign>
        <invoke name="toInvokeCallback" partnerLink="processNovateTradeResponseConsumer" operation="consumeRegistrationSystem" xmlns:tns="http://otc.crcc.com/" portType="tns:processNovateTradeResponseConsumer" inputVariable="requestConsumeRegistrationSystemIn" outputVariable="responseConsumeRegistrationSystemOut">
            <documentation>To invoke the callback method on registration system in order to delivery the fpml message</documentation>
        </invoke>
        <if name="IfInvokeCallback">
            <condition>$responseConsumeRegistrationSystemOut.parameters/return</condition>
            <sequence name="Sequence1">
                <assign name="settingGoodFinalizationMessage">
                    <documentation>In this fragment a info log is write on the system to indicate the response was delivered sucessfully</documentation>
                        <sxt:trace>
                            <sxt:log level="info" location="onComplete">
                                    <from variable="finalizationMessage"/>
                                </sxt:log>
                        </sxt:trace>
                        <copy>
                            <from>concat(''The response message was delivered sucessfully to: '', $InvokeCallbackPartnerLinkWSDLOperationIn.part1/ns1:senderPartyID, '' At: '', sxxf:current-dateTime(), '' On: '', $InvokeCallbackPartnerLinkWSDLOperationIn.part1/ns1:endPointReference/ns4:Address)</from>
                                <to variable="finalizationMessage"/>
                        </copy>
                </assign>
                <if name="Secuence3">
                    <documentation>If fpmlMessageFK is null not insert to the table sendingMessage</documentation>
                    <condition>$InvokeCallbackPartnerLinkWSDLOperationIn.part1/ns1:fpmlMessageFK !!= 0</condition>
                    <sequence name="Sequence3">
                        <assign name="settingFindMessage">
                            <copy>
                                <from>$InvokeCallbackPartnerLinkWSDLOperationIn.part1/ns1:fpmlMessageFK</from>
                                <to>$requestFindMessageIn.part/ns5:FPML_SENDING_MESSAGE_ESTATE_Record/ns5:message_ID</to>
                            </copy>
                        </assign>
                        <invoke name="findMessageOnDB" partnerLink="toInserStateMessage" operation="find" xmlns:tns="http://j2ee.netbeans.org/wsdl/sendingMessageControl" portType="tns:jdbcPortType" inputVariable="requestFindMessageIn" outputVariable="responseMessageFindOut"/>
                        <if name="Secuence5">
                            <documentation>Condition to Find message Id null or no exists, so insert message and state.</documentation>
                            <condition>$responseMessageFindOut.part/ns5:FPML_SENDING_MESSAGE_ESTATE_Record/ns5:message_ID</condition>
                            <sequence name="Sequence5">
                                <assign name="settingupdateMessage">
                                    <copy>
                                            <from>$responseMessageFindOut.part/ns5:FPML_SENDING_MESSAGE_ESTATE_Record/ns5:message_ID</from>
                                                <to>$requestMessageUpdateIn.part/ns5:FPML_SENDING_MESSAGE_ESTATE_Record/ns5:message_ID</to>
                                        </copy>
                                        <copy>
                                            <from>1</from>
                                                <to>$requestMessageUpdateIn.part/ns5:FPML_SENDING_MESSAGE_ESTATE_Record/ns5:state_operation</to>
                                        </copy>
                                </assign>
                                <invoke name="updateMessageOnDB" partnerLink="toInserStateMessage" operation="update" xmlns:tns="http://j2ee.netbeans.org/wsdl/sendingMessageControl" portType="tns:jdbcPortType" inputVariable="requestMessageUpdateIn"/>
                            </sequence>
                            <else>
                                <sequence name="Sequence6">
                                    <assign name="settingGodMessagePool">
                                        <documentation>To Insert God Message in a table sendinMessagePool</documentation>
                                            <copy>
                                            <from>1</from>
                                                <to>$requestInsertGoodMessageIn.part/ns5:FPML_SENDING_MESSAGE_ESTATE_Record/ns5:state_operation</to>
                                        </copy>
                                            <copy>
                                            <from>$InvokeCallbackPartnerLinkWSDLOperationIn.part1/ns1:fpmlMessageFK</from>
                                                <to>$requestInsertGoodMessageIn.part/ns5:FPML_SENDING_MESSAGE_ESTATE_Record/ns5:message_ID</to>
                                        </copy>
                                    </assign>
                                    <invoke name="insertGodMessage" partnerLink="toInserStateMessage" operation="insert" xmlns:tns="http://j2ee.netbeans.org/wsdl/sendingMessageControl" portType="tns:jdbcPortType" inputVariable="requestInsertGoodMessageIn" outputVariable="responseInsertGoodMessageOut"/>
                                </sequence>
                            </else>
                        </if>
                    </sequence>
                </if>
            </sequence>
            <else>
                <sequence name="Sequence2">
                    <assign name="settingBadFinalizationMessage">
                        <documentation>In this fragment a info log is write on the system to indicate the response was delivered unsucessfully</documentation>
                        <sxt:trace>
                            <sxt:log level="severe" location="onComplete">
                                <ns0:from variable="finalizationMessage"/>
                            </sxt:log>
                        </sxt:trace>
                        <copy>
                                <from>concat(''We could not delivery the response message to: '', $InvokeCallbackPartnerLinkWSDLOperationIn.part1/ns1:senderPartyID, '' At: '', sxxf:current-dateTime(), '' On: '', $InvokeCallbackPartnerLinkWSDLOperationIn.part1/ns1:endPointReference/ns4:Address, ''Please contact your system administrator'')</from>
                                    <to variable="finalizationMessage"/>
                            </copy>
                    </assign>
                    <if name="Secuence4">
                        <documentation>If fpmlMessage is null not insert to the table sendingMessage</documentation>
                        <condition>0 !!= $InvokeCallbackPartnerLinkWSDLOperationIn.part1/ns1:fpmlMessageFK</condition>
                        <sequence name="Sequence4">
                            <assign name="settingFindBadMessage">
                                <copy>
                                    <from>$InvokeCallbackPartnerLinkWSDLOperationIn.part1/ns1:fpmlMessageFK</from>
                                    <to>$requestFindBadMessageIn.part/ns5:FPML_SENDING_MESSAGE_ESTATE_Record/ns5:message_ID</to>
                                </copy>
                            </assign>
                            <invoke name="findBadMessageOnDB" partnerLink="toInserStateMessage" operation="find" xmlns:tns="http://j2ee.netbeans.org/wsdl/sendingMessageControl" portType="tns:jdbcPortType" inputVariable="requestFindBadMessageIn" outputVariable="responseFindBadMessageOut"/>
                            <if>
                                <condition>$responseFindBadMessageOut.part/ns5:FPML_SENDING_MESSAGE_ESTATE_Record/ns5:message_ID</condition>
                                <sequence name="Sequence8">
                                    <assign name="settingUpdateBadmessageOnDB">
                                        <copy>
                                            <from>$responseFindBadMessageOut.part/ns5:FPML_SENDING_MESSAGE_ESTATE_Record/ns5:message_ID</from>
                                            <to>$requestUpdateBadMessageIn.part/ns5:FPML_SENDING_MESSAGE_ESTATE_Record/ns5:message_ID</to>
                                        </copy>
                                        <copy>
                                            <from>2</from>
                                            <to>$requestUpdateBadMessageIn.part/ns5:FPML_SENDING_MESSAGE_ESTATE_Record/ns5:state_operation</to>
                                        </copy>
                                    </assign>
                                    <invoke name="updateBadMessage" partnerLink="toInserStateMessage" operation="update" xmlns:tns="http://j2ee.netbeans.org/wsdl/sendingMessageControl" portType="tns:jdbcPortType" inputVariable="requestUpdateBadMessageIn"/>
                                </sequence>
                                <else>
                                    <sequence name="Sequence7">
                                        <assign name="settingBadMessagePool">
                                            <documentation>To Insert God Message in a table sendinMessagePool</documentation>
                                                <copy>
                                                <from>$InvokeCallbackPartnerLinkWSDLOperationIn.part1/ns1:fpmlMessageFK</from>
                                                    <to>$requestInsertBadMessageIn.part/ns5:FPML_SENDING_MESSAGE_ESTATE_Record/ns5:message_ID</to>
                                            </copy>
                                                <copy>
                                                <from>2</from>
                                                    <to>$requestInsertBadMessageIn.part/ns5:FPML_SENDING_MESSAGE_ESTATE_Record/ns5:state_operation</to>
                                            </copy>
                                        </assign>
                                        <invoke name="InsertBadmessage" partnerLink="toInserStateMessage" operation="insert" xmlns:tns="http://j2ee.netbeans.org/wsdl/sendingMessageControl" portType="tns:jdbcPortType" inputVariable="requestInsertBadMessageIn" outputVariable="responseInsertBadMessageOut"/>
                                    </sequence>
                                </else>
                            </if>
                        </sequence>
                    </if>
                </sequence>
            </else>
        </if>
    </sequence>
</process>
'! !

!BPEL20BpelAnalyzerTest methodsFor: 'bpel_source2_processNovateTradeProcess' stamp: 'AlvaroJosePeraltaOcampo 11/12/2014 09:47'!
processNovateTradeProcess_processNovateTradeProcess
^ '<?xml version="1.0" encoding="UTF-8"?>
<process
    name="processNovateTradeProcess"
    targetNamespace="http://enterprise.netbeans.org/bpel/processNovateTradeProcess/processNovateTradeProcess"
    xmlns="http://docs.oasis-open.org/wsbpel/2.0/process/executable"
    xmlns:xsd="http://www.w3.org/2001/XMLSchema"
    xmlns:sxt="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/Trace" 
    xmlns:sxed="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/Editor"
    xmlns:sxeh="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/ErrorHandling"
    xmlns:tns="http://enterprise.netbeans.org/bpel/processNovateTradeProcess/processNovateTradeProcess" 
    xmlns:ns0="http://xml.netbeans.org/schema/xsdNovateTrade" 
    xmlns:ns1="http://www.fpml.org/2008/FpML-4-5" 
    xmlns:ns2="http://xml.netbeans.org/schema/processTradeConfirmed" 
    xmlns:ns3="http://schemas.xmlsoap.org/ws/2004/08/addressing" 
    xmlns:ns4="http://xml.netbeans.org/schema/processOTCError" 
    xmlns:sxxf="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/XPathFunctions" xmlns:ns5="http://j2ee.netbeans.org/xsd/tableSchema" xmlns:ns6="http://facade.manage.data.otc.crcc.com/">
    <documentation>This process is a sequence of activities for novate a trade</documentation>
    <import namespace="http://enterprise.netbeans.org/bpel/FpMLParserWrapper" location="FpMLParserWrapper.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://parsing.trade.otc.crcc.com/" location="externalWSDL/FpMLParser/FpMLParser.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://enterprise.netbeans.org/bpel/MeffServiceWrapper" location="MeffServiceWrapper.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://facade.data.otc.crcc.com/" location="externalWSDL/commons/MeffService.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/getIncomingMessageFromJMSWSDL" location="getIncomingMessageFromJMSWSDL.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://enterprise.netbeans.org/bpel/RiskServiceWSWrapper" location="RiskServiceWSWrapper.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://facade.data.risk.otc.crcc.com/" location="externalWSDL/riskEJB/RiskServiceWS.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/processTradeConfirmedWSDL" location="processTradeConfirmedWSDL.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/putToParsingErrorJMSWSDL" location="putToParsingErrorJMSWSDL.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/putToRiskErrorJMSWSDL" location="putToRiskErrorJMSWSDL.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/putToUnknownErrorJMSWSDL" location="putToUnknownErrorJMSWSDL.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://j2ee.netbeans.org/wsdl/fpmlSoapAttachmentWSDL" location="fpmlSoapAttachmentWSDL.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://enterprise.netbeans.org/bpel/ManageSystemServiceWrapper" location="ManageSystemServiceWrapper.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://facade.manage.data.otc.crcc.com/" location="externalWSDL/ManageSystem/ManageSystemService.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <partnerLinks>
        <partnerLink name="ManageSystemService" xmlns:tns="http://enterprise.netbeans.org/bpel/ManageSystemServiceWrapper" partnerLinkType="tns:ManageSystemServiceLinkType" partnerRole="ManageSystemServiceRole"/>
        <partnerLink name="getMessageFormJMSPL" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/getIncomingMessageFromJMSWSDL" partnerLinkType="tns:getIncomingMessageFromJMSWSDL" myRole="JMSInPortTypeRole">
            <documentation>This PL get the message from OTCIncomingTopicQUEUE message by message</documentation>
        </partnerLink>
        <partnerLink name="FpMLParser" xmlns:tns="http://enterprise.netbeans.org/bpel/FpMLParserWrapper" partnerLinkType="tns:FpMLParserLinkType" partnerRole="FpMLParserRole"/>
        <partnerLink name="UnknownError" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/putToUnknownErrorJMSWSDL" partnerLinkType="tns:putToUnknownErrorJMSWSDL" partnerRole="JMSOutPortTypeRole"/>
        <partnerLink name="soapAttachment" xmlns:tns="http://j2ee.netbeans.org/wsdl/fpmlSoapAttachmentWSDL" partnerLinkType="tns:jdbcpartner" partnerRole="jdbcPortTypeRole"/>
        <partnerLink name="ParsingErrorJMS" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/putToParsingErrorJMSWSDL" partnerLinkType="tns:putToParsingErrorJMSWSDL" partnerRole="JMSOutPortTypeRole"/>
        <partnerLink name="RiskErrorJMS" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/putToRiskErrorJMSWSDL" partnerLinkType="tns:putToRiskErrorJMSWSDL" partnerRole="JMSOutPortTypeRole"/>
        <partnerLink name="RiskEJB" xmlns:tns="http://enterprise.netbeans.org/bpel/RiskServiceWSWrapper" partnerLinkType="tns:RiskServiceWSLinkType" partnerRole="RiskServiceWSRole"/>
        <partnerLink name="processTradeConfirmed" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/processTradeConfirmedWSDL" partnerLinkType="tns:processTradeConfirmedWSDL" partnerRole="processTradeConfirmedWSDLPortTypeRole"/>
    </partnerLinks>
    <variables>
        <variable name="responseManageParseFpMLNonValidatedOut" xmlns:tns="http://parsing.trade.otc.crcc.com/" messageType="tns:parseFpMLNonValidatedResponse"/>
        <variable name="requestManageParseFpMLNonValidatedOut" xmlns:tns="http://parsing.trade.otc.crcc.com/" messageType="tns:parseFpMLNonValidatedResponse"/>
        <variable name="requestManageParseFpMLNonValidatedIn" xmlns:tns="http://parsing.trade.otc.crcc.com/" messageType="tns:parseFpMLNonValidated"/>
        <variable name="requestManageJMSOutOperationIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/putToRiskErrorJMSWSDL" messageType="tns:JMSInputMessage"/>
        <variable name="requestGetCurrentSystemStateOut" messageType="ns6:getCurrentSystemStateResponse"/>
        <variable name="requestGetCurrentSystemStateIn" messageType="ns6:getCurrentSystemState"/>
        <variable name="requestJMSOutOperationIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/putToRiskErrorJMSWSDL" messageType="tns:JMSInputMessage"/>
        <variable name="responseInsertSoapAttachmentParsingOut" xmlns:tns="http://j2ee.netbeans.org/wsdl/fpmlSoapAttachmentWSDL" messageType="tns:insertRetMsg"/>
        <variable name="requestInsertSoapAttachmentParsingIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/fpmlSoapAttachmentWSDL" messageType="tns:inputMsg"/>
        <variable name="responseInsertSoapAttachmentOut" xmlns:tns="http://j2ee.netbeans.org/wsdl/fpmlSoapAttachmentWSDL" messageType="tns:insertRetMsg"/>
        <variable name="requestInsertSoapAttachmentIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/fpmlSoapAttachmentWSDL" messageType="tns:inputMsg"/>
        <variable name="responseInsertMessageFPMLErrorOut" xmlns:tns="http://facade.data.risk.otc.crcc.com/" messageType="tns:insertMessageFPMLResponse"/>
        <variable name="requestInsertMessageFPMLErrorIn" xmlns:tns="http://facade.data.risk.otc.crcc.com/" messageType="tns:insertMessageFPML"/>
        <variable name="putUnknownErrorJMSOutOperationIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/putToUnknownErrorJMSWSDL" messageType="tns:JMSInputMessage"/>
        <variable name="responseParseFpMLNonValidatedOut" xmlns:tns="http://parsing.trade.otc.crcc.com/" messageType="tns:parseFpMLNonValidatedResponse"/>
        <variable name="requestParseFpMLNonValidatedIn" xmlns:tns="http://parsing.trade.otc.crcc.com/" messageType="tns:parseFpMLNonValidated"/>
        <variable name="requestRiskJMSOutOperationIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/putToRiskErrorJMSWSDL" messageType="tns:JMSInputMessage"/>
        <variable name="requestParsingJMSOutOperationIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/putToParsingErrorJMSWSDL" messageType="tns:JMSInputMessage"/>
        <variable name="requestProcessTradeConfirmedWSDLOperationIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/processTradeConfirmedWSDL" messageType="tns:processTradeConfirmedWSDLOperationRequest"/>
        <variable name="responseInsertMessageFPMLOut" xmlns:tns="http://facade.data.risk.otc.crcc.com/" messageType="tns:insertMessageFPMLResponse"/>
        <variable name="requestInsertMessageFPMLIn" xmlns:tns="http://facade.data.risk.otc.crcc.com/" messageType="tns:insertMessageFPML"/>
        <variable name="responseValidateMemberOut" xmlns:tns="http://facade.data.risk.otc.crcc.com/" messageType="tns:validateMemberResponse"/>
        <variable name="requestValidateMemberIn" xmlns:tns="http://facade.data.risk.otc.crcc.com/" messageType="tns:validateMember"/>
        <variable name="responseEvaluateRiskOut" xmlns:tns="http://facade.data.risk.otc.crcc.com/" messageType="tns:evaluateRiskResponse"/>
        <variable name="requestEvaluateRiskIn" xmlns:tns="http://facade.data.risk.otc.crcc.com/" messageType="tns:evaluateRisk"/>
        <variable name="responseParseFpMLOut" xmlns:tns="http://parsing.trade.otc.crcc.com/" messageType="tns:parseFpMLResponse"/>
        <variable name="requestParseFpMLIn" xmlns:tns="http://parsing.trade.otc.crcc.com/" messageType="tns:parseFpML"/>
        <variable name="JMSInOperationIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/getIncomingMessageFromJMSWSDL" messageType="tns:JMSInputMessage"/>
    </variables>
    <faultHandlers>
        <catch xmlns:tns="http://parsing.trade.otc.crcc.com/" faultMessageType="tns:ValidationException" faultName="tns:ValidationException" faultVariable="parsingException">
            <documentation>This catch manages every validation exception generated by FpML parser not related 
with a not well formed XML, just considers the validation issues, is a not well formed exception 
is throws it be catche by an internal </documentation>
            <sequence name="handlingParsingException">
                <assign name="parsingError2JMS">
                    <documentation>Catch a parsing exception and send to JMS queue in order to other process the parsing error</documentation>
                    <copy>
                        <from variable="parsingException" part="fault"/>
                        <to>$requestParsingJMSOutOperationIn.part1/ns4:validationException</to>
                    </copy>
                    <copy>
                        <from>$JMSInOperationIn.part1/ns0:headerCRCC/ns3:EndpointReference</from>
                        <to>$requestParsingJMSOutOperationIn.part1/ns4:callbackAddress</to>
                    </copy>
                    <copy>
                        <from>$JMSInOperationIn.part1/ns0:novateTrade/ns0:fpMLMessage</from>
                        <to>$requestParseFpMLNonValidatedIn.parameters/fpml</to>
                    </copy>
                </assign>
                <if name="ifNotDefaultProcessingErrorCode">
                    <documentation>If the error was not a default parsing error then execute a parsing FPML, otherwise create a Unknown parsing error</documentation>
                    <condition>''200'' !!= $parsingException.fault/reasonCode</condition>
                    <sequence name="noDefaultErrorSeq">
                        <documentation>Execute some activities when the string is well formed</documentation>
                        <invoke name="toParseNonValidated" partnerLink="FpMLParser" operation="parseFpMLNonValidated" portType="tns:FpMLParser" inputVariable="requestParseFpMLNonValidatedIn" outputVariable="responseParseFpMLNonValidatedOut">
                            <documentation>To parse the string without validate fpml</documentation>
                        </invoke>
                        <assign name="settingFpMLMessage">
                            <documentation>Set up the fpml string</documentation>
                            <copy>
                                <from>$responseParseFpMLNonValidatedOut.parameters/return</from>
                                <to>$requestInsertMessageFPMLErrorIn.parameters/rtc</to>
                            </copy>
                        </assign>
                        <invoke name="toInsertFpMLMessage" partnerLink="RiskEJB" operation="insertMessageFPML" xmlns:tns="http://facade.data.risk.otc.crcc.com/" portType="tns:RiskServiceWS" inputVariable="requestInsertMessageFPMLErrorIn" outputVariable="responseInsertMessageFPMLErrorOut">
                            <documentation>Insert the incoming message on a databasepossible to insert message that no contain the sender information, in this case the system save the recors without sender information</documentation>
                        </invoke>
                        <assign name="settingInsertSoapAttachmentParsing">
                            <copy>
                                <from>string($JMSInOperationIn.part1/ns0:headerCRCC/ns3:EndpointReference/ns3:ServiceName/@PortName)</from>
                                <to>$requestInsertSoapAttachmentParsingIn.part/ns5:FPML_SOAP_ATTACHMENT_Record/ns5:portName</to>
                            </copy>
                            <copy>
                                <from>string($JMSInOperationIn.part1/ns0:headerCRCC/ns3:EndpointReference/ns3:ServiceName)</from>
                                <to>$requestInsertSoapAttachmentParsingIn.part/ns5:FPML_SOAP_ATTACHMENT_Record/ns5:serviceName</to>
                            </copy>
                            <copy>
                                <from>string($JMSInOperationIn.part1/ns0:headerCRCC/ns3:EndpointReference/ns3:PortType)</from>
                                <to>$requestInsertSoapAttachmentParsingIn.part/ns5:FPML_SOAP_ATTACHMENT_Record/ns5:portType</to>
                            </copy>
                            <copy>
                                <from>string($JMSInOperationIn.part1/ns0:headerCRCC/ns3:EndpointReference/ns3:Address)</from>
                                <to>$requestInsertSoapAttachmentParsingIn.part/ns5:FPML_SOAP_ATTACHMENT_Record/ns5:serviceAddress</to>
                            </copy>
                            <copy>
                                <from>$JMSInOperationIn.part1/ns0:novateTrade/ns0:fpMLMessage</from>
                                <to>$requestInsertSoapAttachmentParsingIn.part/ns5:FPML_SOAP_ATTACHMENT_Record/ns5:message</to>
                            </copy>
                            <copy>
                                <from>$responseInsertMessageFPMLErrorOut.parameters/return</from>
                                <to>$requestInsertSoapAttachmentParsingIn.part/ns5:FPML_SOAP_ATTACHMENT_Record/ns5:message_FK</to>
                            </copy>
                        </assign>
                        <invoke name="toInvokeSoapAttachmentParsing" partnerLink="soapAttachment" operation="insert" xmlns:tns="http://j2ee.netbeans.org/wsdl/fpmlSoapAttachmentWSDL" portType="tns:jdbcPortType" inputVariable="requestInsertSoapAttachmentParsingIn" outputVariable="responseInsertSoapAttachmentParsingOut"/>
                        <assign name="settingParsingJMS">
                            <documentation>Set up the message tha will be send it to JMS parsing error</documentation>
                            <copy>
                                    <from>$responseParseFpMLNonValidatedOut.parameters/return/ns1:header</from>
                                        <to>$requestParsingJMSOutOperationIn.part1/ns4:requestMessageHeader</to>
                                </copy>
                            <copy>
                                <from variable="parsingException" part="fault"/>
                                <to>$requestParsingJMSOutOperationIn.part1/ns4:validationException</to>
                            </copy>
                            <copy>
                                <from>$JMSInOperationIn.part1/ns0:headerCRCC/ns3:EndpointReference</from>
                                <to>$requestParsingJMSOutOperationIn.part1/ns4:callbackAddress</to>
                            </copy>
                            <copy>
                                <from>$responseInsertMessageFPMLErrorOut.parameters/return</from>
                                <to>$requestParsingJMSOutOperationIn.part1/ns4:rtcInternalID</to>
                            </copy>
                        </assign>
                        <invoke name="toPutParsingJMS" partnerLink="ParsingErrorJMS" operation="JMSOutOperation" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/putToParsingErrorJMSWSDL" portType="tns:JMSOutPortType" inputVariable="requestParsingJMSOutOperationIn">
                            <documentation>Put the parsing error to JMS in order to process it</documentation>
                        </invoke>
                    </sequence>
                    <else>
                        <sequence name="Sequence4">
                            <assign name="settingUnknownError">
                                <sxt:trace>
                                    <sxt:log level="warning" location="onStart">
                                        <from>concat(''FPML NOT WELL FORMED: '', $JMSInOperationIn.part1/ns0:novateTrade/ns0:fpMLMessage)</from>
                                    </sxt:log>
                                </sxt:trace>
                                <copy>
                                    <from>$JMSInOperationIn.part1/ns0:novateTrade/ns0:fpMLMessage</from>
                                    <to variable="putUnknownErrorJMSOutOperationIn" part="part1"/>
                                </copy>
                            </assign>
                            <invoke name="toPutUnknownErrorrJMS" partnerLink="UnknownError" operation="JMSOutOperation" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/putToUnknownErrorJMSWSDL" portType="tns:JMSOutPortType" inputVariable="putUnknownErrorJMSOutOperationIn"/>
                        </sequence>
                    </else>
                </if>
            </sequence>
        </catch>
        <catch xmlns:tns="http://facade.data.risk.otc.crcc.com/" faultMessageType="tns:ValidationException" faultVariable="riskException" faultName="tns:ValidationException">
            <documentation>This catch manages every validation exception generated by Risk  EJB  </documentation>
            <sequence name="handlingRiskError">
                <assign name="riskError2JMS">
                    <copy>
                        <from variable="riskException" part="fault"/>
                        <to>$requestRiskJMSOutOperationIn.part1/ns4:validationException</to>
                    </copy>
                    <copy>
                        <from>$JMSInOperationIn.part1/ns0:headerCRCC/ns3:EndpointReference</from>
                        <to>$requestRiskJMSOutOperationIn.part1/ns4:callbackAddress</to>
                    </copy>
                    <copy>
                        <from>$responseParseFpMLOut.parameters/return/ns1:header</from>
                        <to>$requestRiskJMSOutOperationIn.part1/ns4:requestMessageHeader</to>
                    </copy>
                </assign>
                <if name="IfNotMessageAlreadyExist">
                    <condition>''513'' !!= $riskException.fault/reasonCode</condition>
                    <assign name="setPriorMessage">
                        <copy>
                            <from>$responseInsertMessageFPMLOut.parameters/return</from>
                            <to>$requestRiskJMSOutOperationIn.part1/ns4:rtcInternalID</to>
                        </copy>
                    </assign>
                </if>
                <invoke name="toPutRiskJMS" partnerLink="RiskErrorJMS" operation="JMSOutOperation" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/putToRiskErrorJMSWSDL" portType="tns:JMSOutPortType" inputVariable="requestRiskJMSOutOperationIn"/>
            </sequence>
        </catch>
        <catch faultName="ns6:ValidationException" faultMessageType="ns6:ValidationException" faultVariable="manageSystemValidation">
            <documentation>Exception to System available</documentation>
            <sequence name="HandlingManageSystemExeception">
                <assign name="parseFpmlNoValidate">
                    <copy>
                        <from>$JMSInOperationIn.part1/ns0:novateTrade/ns0:fpMLMessage</from>
                        <to>$requestManageParseFpMLNonValidatedIn.parameters/fpml</to>
                    </copy>
                </assign>
                <invoke name="toParseFpmlNonValidated" partnerLink="FpMLParser" operation="parseFpMLNonValidated" xmlns:tns="http://parsing.trade.otc.crcc.com/" portType="tns:FpMLParser" inputVariable="requestManageParseFpMLNonValidatedIn" outputVariable="responseManageParseFpMLNonValidatedOut"/>
                <assign name="toSendManageError">
                    <copy>
                        <from>$responseManageParseFpMLNonValidatedOut.parameters/return/ns1:header</from>
                        <to>$requestManageJMSOutOperationIn.part1/ns4:requestMessageHeader</to>
                    </copy>
                    <copy>
                        <from>$JMSInOperationIn.part1/ns0:headerCRCC/ns3:EndpointReference</from>
                        <to>$requestManageJMSOutOperationIn.part1/ns4:callbackAddress</to>
                    </copy>
                    <copy>
                        <from>$manageSystemValidation.fault/additionalData</from>
                        <to>$requestManageJMSOutOperationIn.part1/ns4:validationException/additionalData</to>
                    </copy>
                    <copy>
                        <from>$manageSystemValidation.fault/location</from>
                        <to>$requestManageJMSOutOperationIn.part1/ns4:validationException/location</to>
                    </copy>
                    <copy>
                        <from>$manageSystemValidation.fault/message</from>
                        <to>$requestManageJMSOutOperationIn.part1/ns4:validationException/message</to>
                    </copy>
                    <copy>
                        <from>$manageSystemValidation.fault/reasonCode</from>
                        <to>$requestManageJMSOutOperationIn.part1/ns4:validationException/reasonCode</to>
                    </copy>
                    <copy>
                        <from>$manageSystemValidation.fault/semanticRuleDescription</from>
                        <to>$requestManageJMSOutOperationIn.part1/ns4:validationException/semanticRuleDescription</to>
                    </copy>
                    <copy>
                        <from>$manageSystemValidation.fault/semanticRuleId</from>
                        <to>$requestManageJMSOutOperationIn.part1/ns4:validationException/semanticRuleId</to>
                    </copy>
                </assign>
                <invoke name="toPutRiskJMSManage" partnerLink="RiskErrorJMS" operation="JMSOutOperation" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/putToRiskErrorJMSWSDL" portType="tns:JMSOutPortType" inputVariable="requestManageJMSOutOperationIn"/>
            </sequence>
        </catch>
    </faultHandlers>
    <sequence>
        <receive name="getMessageFromJMS" createInstance="yes" partnerLink="getMessageFormJMSPL" operation="JMSInOperation" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/getIncomingMessageFromJMSWSDL" portType="tns:JMSInPortType" variable="JMSInOperationIn">
            <documentation>Get the message from JMS to BPEL</documentation>
            <sxt:trace>
                <sxt:log level="fine" location="onStart">
                    <from>concat(''START getMessageFromJMS FpmL :'', sxxf:current-dateTime())</from>
                </sxt:log>
            </sxt:trace>
        </receive>
        <assign name="initializeRequestGetSystem">
            <copy>
                <from>''</from>
                <to variable="requestGetCurrentSystemStateIn" part="parameters"/>
            </copy>
        </assign>
        <invoke name="toGetManageSystem" partnerLink="ManageSystemService" operation="getCurrentSystemState" portType="ns6:ManageSystemService" inputVariable="requestGetCurrentSystemStateIn" outputVariable="requestGetCurrentSystemStateOut">
            <documentation>To get the OTC current system state, if not avalaible an exception is thrown, it is handled by Handler Manage System Exception</documentation>
        </invoke>
        <assign name="JMS2Parser">
            <documentation>Get the fpml String and put it on incoming parameter of FpML parser</documentation>
            <copy>
                <from>$JMSInOperationIn.part1/ns0:novateTrade/ns0:fpMLMessage</from>
                <to>$requestParseFpMLIn.parameters/fpml</to>
            </copy>
        </assign>
        <invoke name="toParseFpML" partnerLink="FpMLParser" operation="parseFpML" xmlns:tns="http://parsing.trade.otc.crcc.com/" portType="tns:FpMLParser" inputVariable="requestParseFpMLIn" outputVariable="responseParseFpMLOut">
            <documentation>Invoke parse FpmL that can thorw a handling Parsing Exception</documentation>
            <sxt:trace>
                <sxt:log level="fine" location="onStart">
                    <from>concat(''START Parsing FpmL :'', sxxf:current-dateTime())</from>
                </sxt:log>
                <sxt:log level="fine" location="onComplete">
                    <from>concat(''FINISHED  Parsing FpmL :'', sxxf:current-dateTime())</from>
                </sxt:log>
            </sxt:trace>
        </invoke>
        <assign name="Parser2Risk">
            <documentation>once time the parser return a RTC that message is sent to Risk facade to make some risk validation</documentation>
            <copy>
                <from>$responseParseFpMLOut.parameters/return</from>
                <to>$requestValidateMemberIn.parameters/rtc</to>
            </copy>
            <copy>
                <from>$responseParseFpMLOut.parameters/return</from>
                <to>$requestEvaluateRiskIn.parameters/rtc</to>
            </copy>
            <copy>
                <from>$responseParseFpMLOut.parameters/return</from>
                <to>$requestInsertMessageFPMLIn.parameters/rtc</to>
            </copy>
        </assign>
        <invoke name="toInsertFpML" partnerLink="RiskEJB" operation="insertMessageFPML" xmlns:tns="http://facade.data.risk.otc.crcc.com/" portType="tns:RiskServiceWS" inputVariable="requestInsertMessageFPMLIn" outputVariable="responseInsertMessageFPMLOut">
            <documentation>This method insert the incoming message on database</documentation>
            <sxt:trace>
                <sxt:log level="fine" location="onStart">
                    <from>concat(''START toInsertFpML  :'', sxxf:current-dateTime())</from>
                </sxt:log>
                <sxt:log level="fine" location="onComplete">
                    <from>concat(''FINISHED  toInsertFpML :'', sxxf:current-dateTime())</from>
                </sxt:log>
            </sxt:trace>
        </invoke>
        <assign name="settingSoapAttachment">
            <documentation>setting the soap attachmente by including messageFK</documentation>
            <copy>
                <from>string($JMSInOperationIn.part1/ns0:headerCRCC/ns3:EndpointReference/ns3:ServiceName/@PortName)</from>
                <to>$requestInsertSoapAttachmentIn.part/ns5:FPML_SOAP_ATTACHMENT_Record/ns5:portName</to>
            </copy>
            <copy>
                <from>string($JMSInOperationIn.part1/ns0:headerCRCC/ns3:EndpointReference/ns3:ServiceName)</from>
                <to>$requestInsertSoapAttachmentIn.part/ns5:FPML_SOAP_ATTACHMENT_Record/ns5:serviceName</to>
            </copy>
            <copy>
                <from>string($JMSInOperationIn.part1/ns0:headerCRCC/ns3:EndpointReference/ns3:PortType)</from>
                <to>$requestInsertSoapAttachmentIn.part/ns5:FPML_SOAP_ATTACHMENT_Record/ns5:portType</to>
            </copy>
            <copy>
                <from>string($JMSInOperationIn.part1/ns0:headerCRCC/ns3:EndpointReference/ns3:Address)</from>
                <to>$requestInsertSoapAttachmentIn.part/ns5:FPML_SOAP_ATTACHMENT_Record/ns5:serviceAddress</to>
            </copy>
            <copy>
                <from>$responseInsertMessageFPMLOut.parameters/return</from>
                <to>$requestInsertSoapAttachmentIn.part/ns5:FPML_SOAP_ATTACHMENT_Record/ns5:message_FK</to>
            </copy>
            <copy>
                <from>$JMSInOperationIn.part1/ns0:novateTrade/ns0:fpMLMessage</from>
                <to>$requestInsertSoapAttachmentIn.part/ns5:FPML_SOAP_ATTACHMENT_Record/ns5:message</to>
            </copy>
        </assign>
        <invoke name="toInsertSoapAttachment" partnerLink="soapAttachment" operation="insert" xmlns:tns="http://j2ee.netbeans.org/wsdl/fpmlSoapAttachmentWSDL" portType="tns:jdbcPortType" inputVariable="requestInsertSoapAttachmentIn" outputVariable="responseInsertSoapAttachmentOut">
            <documentation>to insert the soapMessage</documentation>
        </invoke>
        <invoke name="toValidateMembers" partnerLink="RiskEJB" operation="validateMember" xmlns:tns="http://facade.data.risk.otc.crcc.com/" portType="tns:RiskServiceWS" inputVariable="requestValidateMemberIn" outputVariable="responseValidateMemberOut">
            <documentation>To validate if every member included on RTC message exist on OTC database</documentation>
            <sxt:trace>
                <sxt:log level="fine" location="onStart">
                    <from>concat(''START toValidateMembers  :'', sxxf:current-dateTime())</from>
                </sxt:log>
                <sxt:log level="fine" location="onComplete">
                    <from>concat(''FINISHED  toValidateMembers :'', sxxf:current-dateTime())</from>
                </sxt:log>
            </sxt:trace>
        </invoke>            
        <invoke name="toEvaluateRisk" partnerLink="RiskEJB" operation="evaluateRisk" xmlns:tns="http://facade.data.risk.otc.crcc.com/" portType="tns:RiskServiceWS" inputVariable="requestEvaluateRiskIn" outputVariable="responseEvaluateRiskOut">
            <documentation>To verify the current risk of member</documentation>
            <sxt:trace>
                <sxt:log level="fine" location="onStart">
                    <from>concat(''START toEvaluateRisk :'', sxxf:current-dateTime())</from>
                </sxt:log>
                <sxt:log level="fine" location="onComplete">
                    <from>concat(''FINISHED  toEvaluateRisk :'', sxxf:current-dateTime())</from>
                </sxt:log>
            </sxt:trace>
        </invoke>
        <assign name="EvaluateRisk2ProcessTradeC">
            <documentation>If the evaluate risk was sucessfull then get the retun value an assign it to the process trade confirmed process.</documentation>
            <copy>
                <from>$responseEvaluateRiskOut.parameters/return</from>
                <to>$requestProcessTradeConfirmedWSDLOperationIn.tradeConfirmedIn/ns2:tradeConfirmed</to>
            </copy>
            <copy>
                <from>$JMSInOperationIn.part1/ns0:headerCRCC/ns3:EndpointReference</from>
                <to>$requestProcessTradeConfirmedWSDLOperationIn.tradeConfirmedIn/ns2:header/ns3:EndpointReference</to>
            </copy>
            <copy>
                <from>$responseInsertMessageFPMLOut.parameters/return</from>
                <to>$requestProcessTradeConfirmedWSDLOperationIn.tradeConfirmedIn/ns2:rtcInternalID</to>
            </copy>
        </assign>
        <invoke name="toProcessTradeConfirmed" partnerLink="processTradeConfirmed" operation="processTradeConfirmedWSDLOperation" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/processTradeConfirmedWSDL" portType="tns:processTradeConfirmedWSDLPortType" inputVariable="requestProcessTradeConfirmedWSDLOperationIn">
            <documentation>Invoke the bpel that process the confirmed trade</documentation>
            <sxt:trace>
                <sxt:log level="fine" location="onStart">
                    <from>concat(''START ProcessTradeConfirmed :'', sxxf:current-dateTime())</from>
                </sxt:log>
                <sxt:log level="fine" location="onComplete">
                    <from>concat(''FINISHED  ProcessTradeConfirmed :'', sxxf:current-dateTime())</from>
                </sxt:log>
            </sxt:trace>
        </invoke>        
    </sequence>
</process>
'! !

!BPEL20BpelAnalyzerTest methodsFor: 'bpel_source2_processNovateTradeProcess' stamp: 'AlvaroJosePeraltaOcampo 11/12/2014 09:47'!
processNovateTradeProcess_processTradeConfirmed
^ '<?xml version="1.0" encoding="UTF-8"?>
<process
    name="processTradeConfirmed"
    targetNamespace="http://enterprise.netbeans.org/bpel/processNovateTradeProcess/processTradeConfirmed"
    xmlns="http://docs.oasis-open.org/wsbpel/2.0/process/executable"
    xmlns:xsd="http://www.w3.org/2001/XMLSchema"
    xmlns:sxt="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/Trace" 
    xmlns:sxed="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/Editor"
    xmlns:sxeh="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/ErrorHandling"
    xmlns:tns="http://enterprise.netbeans.org/bpel/processNovateTradeProcess/processTradeConfirmed" xmlns:ns0="http://xml.netbeans.org/schema/processTradeConfirmed" xmlns:ns1="http://www.fpml.org/2008/FpML-4-5" xmlns:ns2="http://xml.netbeans.org/schema/Meff" xmlns:sxxf="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/XPathFunctions" xmlns:ns3="http://xml.netbeans.org/schema/runtimePartner" xmlns:ns4="http://schemas.xmlsoap.org/ws/2004/08/addressing" xmlns:ns5="http://j2ee.netbeans.org/xsd/tableSchema">
    <documentation>Se agregan 3 variables globales 

tradeId = corresponde al codigo alfanumerico que envian los sistemas de registro.

tradeIdLength = Longitud total del tradeId enviado por los sistemas de registro

tradeIdFinal = variable que es calculada por la longitud del tradeId y un numero constante para obtener un tamaño de 10 caracteres en la variable.

Por otra parte estos cambios se realizan para tener el registro el numero de negociacion de los sistemas de registro que el sistema Meff no visualiza en las terminales de las herramientas de camara. Este codigo queda en el campo  referencia intermediario concadenado con el codigo del sistema de registro Ej: CRCC-12345678AS.</documentation>        
    <import namespace="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/processTradeConfirmedWSDL" location="processTradeConfirmedWSDL.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://enterprise.netbeans.org/bpel/RiskServiceWSWrapper" location="RiskServiceWSWrapper.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://facade.data.risk.otc.crcc.com/" location="externalWSDL/riskEJB/RiskServiceWS.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://enterprise.netbeans.org/bpel/FpMLParserWrapper" location="FpMLParserWrapper.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://parsing.trade.otc.crcc.com/" location="externalWSDL/FpMLParser/FpMLParser.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://enterprise.netbeans.org/bpel/MeffServiceWrapper" location="MeffServiceWrapper.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://facade.data.otc.crcc.com/" location="externalWSDL/commons/MeffService.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://j2ee.netbeans.org/wsdl/MeffServicesBPEL/RequestTradeWSDL" location="externalWSDL/meffServicesBPEL/RequestTradeWSDL.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://j2ee.netbeans.org/wsdl/processNovateTradeBPEL/invokeCallbackPartnerLinkWSDL" location="invokeCallbackPartnerLinkWSDL.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://j2ee.netbeans.org/wsdl/fpMLMessageOnDBWSDL" location="fpMLMessageOnDBWSDL.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://j2ee.netbeans.org/wsdl/fpmlSoapAttachmentWSDL" location="fpmlSoapAttachmentWSDL.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <partnerLinks>
        <partnerLink name="FpMLParser" xmlns:tns="http://enterprise.netbeans.org/bpel/FpMLParserWrapper" partnerLinkType="tns:FpMLParserLinkType" partnerRole="FpMLParserRole"/>
        <partnerLink name="fpMLSoapAttachment" xmlns:tns="http://j2ee.netbeans.org/wsdl/fpmlSoapAttachmentWSDL" partnerLinkType="tns:jdbcpartner" partnerRole="jdbcPortTypeRole"/>
        <partnerLink name="OTCDB" xmlns:tns="http://j2ee.netbeans.org/wsdl/fpMLMessageOnDBWSDL" partnerLinkType="tns:jdbcpartner" partnerRole="jdbcPortTypeRole"/>
        <partnerLink name="CommonServices" xmlns:tns="http://enterprise.netbeans.org/bpel/MeffServiceWrapper" partnerLinkType="tns:MeffServiceLinkType" partnerRole="MeffServiceRole"/>
        <partnerLink name="MeffService" xmlns:tns="http://j2ee.netbeans.org/wsdl/MeffServicesBPEL/RequestTradeWSDL" partnerLinkType="tns:RequestTradeWSDL" partnerRole="RequestTradeWSDLPortTypeRole"/>
        <partnerLink name="RiskEJB" xmlns:tns="http://enterprise.netbeans.org/bpel/RiskServiceWSWrapper" partnerLinkType="tns:RiskServiceWSLinkType" partnerRole="RiskServiceWSRole"/>
        <partnerLink name="invokeCallback" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeBPEL/invokeCallbackPartnerLinkWSDL" partnerLinkType="tns:invokeCallbackPartnerLinkWSDL" partnerRole="invokeCallbackPartnerLinkWSDLPortTypeRole"/>
        <partnerLink name="processTradeConfirmed" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/processTradeConfirmedWSDL" partnerLinkType="tns:processTradeConfirmedWSDL" myRole="processTradeConfirmedWSDLPortTypeRole"/>
    </partnerLinks>
    <variables>
        <variable name="tradeIDFinal" type="xsd:string"/>
        <variable name="tradeIdLenght" type="xsd:int"/>
        <variable name="tradeID" type="xsd:string"/>        
        <variable name="responseFindFpmlMessageOut" xmlns:tns="http://j2ee.netbeans.org/wsdl/fpMLMessageOnDBWSDL" messageType="tns:outputMsg"/>
        <variable name="requestFindFpmlMessageIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/fpMLMessageOnDBWSDL" messageType="tns:inputMsg"/>
        <variable name="responseInsertFpmLSoapOut" xmlns:tns="http://j2ee.netbeans.org/wsdl/fpmlSoapAttachmentWSDL" messageType="tns:insertRetMsg"/>
        <variable name="requestInsertFpmLSoapIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/fpmlSoapAttachmentWSDL" messageType="tns:inputMsg"/>
        <variable name="responseInsertFpMLMessageOut" xmlns:tns="http://j2ee.netbeans.org/wsdl/fpMLMessageOnDBWSDL" messageType="tns:insertRetMsg"/>
        <variable name="requestInsertFpMLMessageIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/fpMLMessageOnDBWSDL" messageType="tns:inputMsg"/>
        <variable name="requestInvokeCallbackPartnerLinkWSDLOperationIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeBPEL/invokeCallbackPartnerLinkWSDL" messageType="tns:invokeCallbackPartnerLinkWSDLOperationRequest"/>
        <variable name="responseContractPriceIDOut" xmlns:tns="http://facade.data.risk.otc.crcc.com/" messageType="tns:contractPriceIDResponse"/>
        <variable name="requestContractPriceIDIn" xmlns:tns="http://facade.data.risk.otc.crcc.com/" messageType="tns:contractPriceID"/>
        <variable name="responseTradeWSDLOperationOut" xmlns:tns="http://j2ee.netbeans.org/wsdl/MeffServicesBPEL/RequestTradeWSDL" messageType="tns:RequestTradeWSDLOperationResponse"/>
        <variable name="requestTradeWSDLOperationIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/MeffServicesBPEL/RequestTradeWSDL" messageType="tns:RequestTradeWSDLOperationRequest"/>
        <variable name="responseTradeConfirmedAsStringOut" xmlns:tns="http://parsing.trade.otc.crcc.com/" messageType="tns:tradeConfirmedAsStringResponse"/>
        <variable name="requestTradeConfirmedAsStringIn" xmlns:tns="http://parsing.trade.otc.crcc.com/" messageType="tns:tradeConfirmedAsString"/>
        <variable name="responseGetIdMessageOut" xmlns:tns="http://facade.data.otc.crcc.com/" messageType="tns:getIdMessageResponse"/>
        <variable name="requestGetIdMessageIn" xmlns:tns="http://facade.data.otc.crcc.com/" messageType="tns:getIdMessage"/>
        <variable name="ProcessTradeConfirmedWSDLOperationIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/processTradeConfirmedWSDL" messageType="tns:processTradeConfirmedWSDLOperationRequest"/>
    </variables>
    <sequence>
        <receive name="getTradeConfirmed" createInstance="yes" partnerLink="processTradeConfirmed" operation="processTradeConfirmedWSDLOperation" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/processTradeConfirmedWSDL" portType="tns:processTradeConfirmedWSDLPortType" variable="ProcessTradeConfirmedWSDLOperationIn"/>
        <assign name="initializeVariables">
            <documentation>set the contract ID variable
set the getSequence variable</documentation>
            <copy>
                <from>''</from>
                <to variable="requestGetIdMessageIn" part="parameters"/>
            </copy>
            <copy>
                <from>$ProcessTradeConfirmedWSDLOperationIn.tradeConfirmedIn/ns0:tradeConfirmed</from>
                <to>$requestTradeConfirmedAsStringIn.parameters/tradeConfirmed</to>
            </copy>
            <copy>
                <from>substring($ProcessTradeConfirmedWSDLOperationIn.tradeConfirmedIn/ns0:tradeConfirmed/ns1:trade/ns1:fxSingleLeg/ns1:valueDate, 1, 10)</from>
                <to>$requestContractPriceIDIn.parameters/valueDate</to>
            </copy>
        </assign>
        <invoke name="toGetSequence" partnerLink="CommonServices" operation="getIdMessage" xmlns:tns="http://facade.data.otc.crcc.com/" portType="tns:MeffService" inputVariable="requestGetIdMessageIn" outputVariable="responseGetIdMessageOut"/>
        <invoke name="toGetContractID" partnerLink="RiskEJB" operation="contractPriceID" xmlns:tns="http://facade.data.risk.otc.crcc.com/" portType="tns:RiskServiceWS" inputVariable="requestContractPriceIDIn" outputVariable="responseContractPriceIDOut"/>
        <assign name="setMessageId">
            <copy>
                <from>$responseGetIdMessageOut.parameters/return</from>
                <to>$requestTradeConfirmedAsStringIn.parameters/tradeConfirmed/ns1:header/ns1:messageId</to>
            </copy>
        </assign>
        <assign name="setMessageIdSchema">
            <copy>
                <from>''http://www.camaraderiesgo.com/messageId''</from>
                <to>$requestTradeConfirmedAsStringIn.parameters/tradeConfirmed/ns1:header/ns1:messageId/@messageIdScheme</to>
            </copy>
        </assign>
        <invoke name="toGetStringFromTradeConfirmed" partnerLink="FpMLParser" operation="tradeConfirmedAsString" xmlns:tns="http://parsing.trade.otc.crcc.com/" portType="tns:FpMLParser" inputVariable="requestTradeConfirmedAsStringIn" outputVariable="responseTradeConfirmedAsStringOut"/>
        <assign name="FPML2OTCDB">
            <copy>
                <from>1</from>
                <to>$requestInsertFpMLMessageIn.part/ns5:FPML_MESSAGE_Record/ns5:sender_FK</to>
            </copy>
            <copy>
                <from>$ProcessTradeConfirmedWSDLOperationIn.tradeConfirmedIn/ns0:rtcInternalID</from>
                <to>$requestInsertFpMLMessageIn.part/ns5:FPML_MESSAGE_Record/ns5:priorMessage_FK</to>
            </copy>
            <copy>
                <from>string($ProcessTradeConfirmedWSDLOperationIn.tradeConfirmedIn/ns0:tradeConfirmed/ns1:header/ns1:messageId/@messageIdScheme)</from>
                <to>$requestInsertFpMLMessageIn.part/ns5:FPML_MESSAGE_Record/ns5:messageSchemaID</to>
            </copy>
            <copy>
                <from>3</from>
                <to>$requestInsertFpMLMessageIn.part/ns5:FPML_MESSAGE_Record/ns5:messageType_FK</to>
            </copy>
            <copy>
                <from>$responseGetIdMessageOut.parameters/return</from>
                <to>$requestInsertFpMLMessageIn.part/ns5:FPML_MESSAGE_Record/ns5:messageID</to>
            </copy>
            <copy>
                <from>string($ProcessTradeConfirmedWSDLOperationIn.tradeConfirmedIn/ns0:tradeConfirmed/ns1:trade/ns1:tradeHeader/ns1:partyTradeIdentifier/ns1:tradeId)</from>
                <to variable="tradeID"/>
            </copy>
            <copy>
                <from>string-length($ProcessTradeConfirmedWSDLOperationIn.tradeConfirmedIn/ns0:tradeConfirmed/ns1:trade/ns1:tradeHeader/ns1:partyTradeIdentifier/ns1:tradeId)</from>
                <to variable="tradeIdLenght"/>
            </copy>
        </assign>
        <invoke name="toInsertOnOTCDB" partnerLink="OTCDB" operation="insert" xmlns:tns="http://j2ee.netbeans.org/wsdl/fpMLMessageOnDBWSDL" portType="tns:jdbcPortType" inputVariable="requestInsertFpMLMessageIn" outputVariable="responseInsertFpMLMessageOut"/>
        <if name="ConditionalReceiver">
            <condition>$ProcessTradeConfirmedWSDLOperationIn.tradeConfirmedIn/ns0:tradeConfirmed/ns1:party[@id = $ProcessTradeConfirmedWSDLOperationIn.tradeConfirmedIn/ns0:tradeConfirmed/ns1:trade/ns1:fxSingleLeg/ns1:exchangedCurrency1/ns1:receiverPartyReference/@href]/ns1:account/ns1:accountId</condition>
            <assign name="setAccountReceiverNull">
                <copy>
                    <from>$ProcessTradeConfirmedWSDLOperationIn.tradeConfirmedIn/ns0:tradeConfirmed/ns1:party[@id = $ProcessTradeConfirmedWSDLOperationIn.tradeConfirmedIn/ns0:tradeConfirmed/ns1:trade/ns1:fxSingleLeg/ns1:exchangedCurrency1/ns1:receiverPartyReference/@href]/ns1:account/ns1:accountId</from>
                    <to>$requestTradeWSDLOperationIn.request/ns2:request/ns2:buyerAccount</to>
                </copy>
                    
            </assign>            
            <else>
                <assign name="setAccountReceiverNotNull">
                    
                     <copy>
                        <from>''P0101''</from>
                        <to>$requestTradeWSDLOperationIn.request/ns2:request/ns2:buyerAccount</to>
                    </copy>
                    
                </assign>
            </else>
        </if>
        
        <if name="ConditionalPayer">
            <condition>$ProcessTradeConfirmedWSDLOperationIn.tradeConfirmedIn/ns0:tradeConfirmed/ns1:party[@id = $ProcessTradeConfirmedWSDLOperationIn.tradeConfirmedIn/ns0:tradeConfirmed/ns1:trade/ns1:fxSingleLeg/ns1:exchangedCurrency1/ns1:payerPartyReference/@href]/ns1:account/ns1:accountId</condition>
            <assign name="setAccountPayerNull">
                <copy>
                    <from>$ProcessTradeConfirmedWSDLOperationIn.tradeConfirmedIn/ns0:tradeConfirmed/ns1:party[@id = $ProcessTradeConfirmedWSDLOperationIn.tradeConfirmedIn/ns0:tradeConfirmed/ns1:trade/ns1:fxSingleLeg/ns1:exchangedCurrency1/ns1:payerPartyReference/@href]/ns1:account/ns1:accountId</from>
                    <to>$requestTradeWSDLOperationIn.request/ns2:request/ns2:sellerAccount</to>
                </copy>            
                    
            </assign>            
            <else>
                <assign name="setAccountPayerNotNull">
                    
                    <copy>
                        <from>''P0101''</from>
                        <to>$requestTradeWSDLOperationIn.request/ns2:request/ns2:sellerAccount</to>
                    </copy>
                    
                </assign>
            </else>
        </if>
        
        <assign name="FpML2MEFF">
            <copy>
                <from>$ProcessTradeConfirmedWSDLOperationIn.tradeConfirmedIn/ns0:tradeConfirmed/ns1:party[@id = $ProcessTradeConfirmedWSDLOperationIn.tradeConfirmedIn/ns0:tradeConfirmed/ns1:trade/ns1:fxSingleLeg/ns1:exchangedCurrency1/ns1:receiverPartyReference/@href]/ns1:partyId</from>
                <to>$requestTradeWSDLOperationIn.request/ns2:request/ns2:buyerCode</to>
            </copy>
            <copy>
                <from>$ProcessTradeConfirmedWSDLOperationIn.tradeConfirmedIn/ns0:tradeConfirmed/ns1:party[@id = $ProcessTradeConfirmedWSDLOperationIn.tradeConfirmedIn/ns0:tradeConfirmed/ns1:trade/ns1:fxSingleLeg/ns1:exchangedCurrency1/ns1:payerPartyReference/@href]/ns1:partyId</from>
                <to>$requestTradeWSDLOperationIn.request/ns2:request/ns2:sellerCode</to>
            </copy>
            <copy>
                <from>''H''</from>
                <to>$requestTradeWSDLOperationIn.request/ns2:request/ns2:operationType</to>
            </copy>
            <copy>
                <from>sxxf:current-date()</from>
                <to>$requestTradeWSDLOperationIn.request/ns2:request/ns2:date</to>
            </copy>
            <copy>
                <from>sxxf:current-time()</from>
                <to>$requestTradeWSDLOperationIn.request/ns2:request/ns2:time</to>
            </copy>
            <copy>
                <from>string($ProcessTradeConfirmedWSDLOperationIn.tradeConfirmedIn/ns0:tradeConfirmed/ns1:trade/ns1:fxSingleLeg/ns1:exchangeRate/ns1:rate)</from>
                <to>$requestTradeWSDLOperationIn.request/ns2:request/ns2:price</to>
            </copy>
            <copy>
                <from>string($ProcessTradeConfirmedWSDLOperationIn.tradeConfirmedIn/ns0:tradeConfirmed/ns1:trade/ns1:fxSingleLeg/ns1:exchangedCurrency1/ns1:paymentAmount/ns1:amount)</from>
                <to>$requestTradeWSDLOperationIn.request/ns2:request/ns2:amount</to>
            </copy>
            <copy>
                <from>$responseContractPriceIDOut.parameters/return/name</from>
                <to>$requestTradeWSDLOperationIn.request/ns2:request/ns2:contractId</to>
            </copy>
            <copy>
                <from>substring($tradeID, $tradeIdLenght - 10, 10)</from>
                <to variable="tradeIDFinal"/>
            </copy>
            <copy>
                <from>string($tradeIDFinal)</from>
                <to>$requestTradeWSDLOperationIn.request/ns2:request/ns2:originalTradeId</to>
            </copy>
            <copy>
                <from>concat(string($ProcessTradeConfirmedWSDLOperationIn.tradeConfirmedIn/ns0:tradeConfirmed/ns1:header/ns1:sendTo), ''-'', $tradeIDFinal)</from>
                <to>$requestTradeWSDLOperationIn.request/ns2:request/ns2:registrationSystem</to>
            </copy>
        </assign>
        <assign name="settingSelectFpML">
            <copy>
                <from>$responseGetIdMessageOut.parameters/return</from>
                <to>$requestFindFpmlMessageIn.part/ns5:FPML_MESSAGE_Record/ns5:messageID</to>
            </copy>
            <copy>
                <from>''http://www.camaraderiesgo.com/messageId''</from>
                <to>$requestFindFpmlMessageIn.part/ns5:FPML_MESSAGE_Record/ns5:messageSchemaID</to>
            </copy>
        </assign>
        <invoke name="toFindFpMLMessage" partnerLink="OTCDB" operation="find" xmlns:tns="http://j2ee.netbeans.org/wsdl/fpMLMessageOnDBWSDL" portType="tns:jdbcPortType" inputVariable="requestFindFpmlMessageIn" outputVariable="responseFindFpmlMessageOut"/>
        <assign name="settingFpMLSoap">
            <copy>
                <from>string($ProcessTradeConfirmedWSDLOperationIn.tradeConfirmedIn/ns0:header/ns4:EndpointReference/ns4:ServiceName/@PortName)</from>
                <to>$requestInsertFpmLSoapIn.part/ns5:FPML_SOAP_ATTACHMENT_Record/ns5:portName</to>
            </copy>
            <copy>
                <from>string($ProcessTradeConfirmedWSDLOperationIn.tradeConfirmedIn/ns0:header/ns4:EndpointReference/ns4:ServiceName)</from>
                <to>$requestInsertFpmLSoapIn.part/ns5:FPML_SOAP_ATTACHMENT_Record/ns5:serviceName</to>
            </copy>
            <copy>
                <from>string($ProcessTradeConfirmedWSDLOperationIn.tradeConfirmedIn/ns0:header/ns4:EndpointReference/ns4:PortType)</from>
                <to>$requestInsertFpmLSoapIn.part/ns5:FPML_SOAP_ATTACHMENT_Record/ns5:portType</to>
            </copy>
            <copy>
                <from>string($ProcessTradeConfirmedWSDLOperationIn.tradeConfirmedIn/ns0:header/ns4:EndpointReference/ns4:Address)</from>
                <to>$requestInsertFpmLSoapIn.part/ns5:FPML_SOAP_ATTACHMENT_Record/ns5:serviceAddress</to>
            </copy>
            <copy>
                <from>$responseTradeConfirmedAsStringOut.parameters/return</from>
                <to>$requestInsertFpmLSoapIn.part/ns5:FPML_SOAP_ATTACHMENT_Record/ns5:message</to>
            </copy>
            <copy>
                <from>$responseFindFpmlMessageOut.part/ns5:FPML_MESSAGE_Record/ns5:ID</from>
                <to>$requestInsertFpmLSoapIn.part/ns5:FPML_SOAP_ATTACHMENT_Record/ns5:message_FK</to>
            </copy>
        </assign>
        <invoke name="toInsertFpMLSoap" partnerLink="fpMLSoapAttachment" operation="insert" xmlns:tns="http://j2ee.netbeans.org/wsdl/fpmlSoapAttachmentWSDL" portType="tns:jdbcPortType" inputVariable="requestInsertFpmLSoapIn" outputVariable="responseInsertFpmLSoapOut"/>
        <invoke name="toSendTradeToMeff" partnerLink="MeffService" operation="RequestTradeWSDLOperation" xmlns:tns="http://j2ee.netbeans.org/wsdl/MeffServicesBPEL/RequestTradeWSDL" portType="tns:RequestTradeWSDLPortType" inputVariable="requestTradeWSDLOperationIn" outputVariable="responseTradeWSDLOperationOut"/>
        <assign name="settingInvokeCallback">
            <copy>
                <from>$responseTradeConfirmedAsStringOut.parameters/return</from>
                <to>$requestInvokeCallbackPartnerLinkWSDLOperationIn.part1/ns3:fpMLMessageAsString</to>
            </copy>
            <copy>
                <from>$ProcessTradeConfirmedWSDLOperationIn.tradeConfirmedIn/ns0:header/ns4:EndpointReference</from>
                <to>$requestInvokeCallbackPartnerLinkWSDLOperationIn.part1/ns3:endPointReference</to>
            </copy>
            <copy>
                <from>$ProcessTradeConfirmedWSDLOperationIn.tradeConfirmedIn/ns0:tradeConfirmed/ns1:header/ns1:sendTo</from>
                <to>$requestInvokeCallbackPartnerLinkWSDLOperationIn.part1/ns3:senderPartyID</to>
            </copy>
            <copy>
                <from>$responseFindFpmlMessageOut.part/ns5:FPML_MESSAGE_Record/ns5:ID</from>
                <to>$requestInvokeCallbackPartnerLinkWSDLOperationIn.part1/ns3:fpmlMessageFK</to>
            </copy>
        </assign>
        <invoke name="toInvokeCallBack" partnerLink="invokeCallback" operation="invokeCallbackPartnerLinkWSDLOperation" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeBPEL/invokeCallbackPartnerLinkWSDL" portType="tns:invokeCallbackPartnerLinkWSDLPortType" inputVariable="requestInvokeCallbackPartnerLinkWSDLOperationIn"/>
    </sequence>
</process>
'! !

!BPEL20BpelAnalyzerTest methodsFor: 'bpel_source' stamp: 'AlvaroJosePeraltaOcampo 11/12/2014 09:47'!
processOTCParsingError
^ '<?xml version="1.0" encoding="UTF-8"?>
<process
    name="processOTCParsingError"
    targetNamespace="http://enterprise.netbeans.org/bpel/processOTCBusinessError/processOTCParsingError"
    xmlns="http://docs.oasis-open.org/wsbpel/2.0/process/executable"
    xmlns:xsd="http://www.w3.org/2001/XMLSchema"
    xmlns:sxt="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/Trace" 
    xmlns:sxed="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/Editor"
    xmlns:sxeh="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/ErrorHandling"
    xmlns:tns="http://enterprise.netbeans.org/bpel/processOTCBusinessError/processOTCBusinessError" xmlns:ns0="http://xml.netbeans.org/schema/processOTCError" xmlns:ns1="http://www.fpml.org/2008/FpML-4-5" xmlns:sxxf="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/XPathFunctions" xmlns:ns2="http://xml.netbeans.org/schema/runtimePartner" xmlns:ns3="http://j2ee.netbeans.org/xsd/tableSchema">
    <documentation>This process execute some activies in order to manage a parsing error</documentation>
    <import namespace="http://j2ee.netbeans.org/wsdl/processOTCBusinessError/getIncomingOTCParsingErrorWSDL" location="getIncomingOTCParsingErrorWSDL.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://j2ee.netbeans.org/wsdl/processNovateTradeBPEL/invokeCallbackPartnerLinkWSDL" location="externalWSDL/invokeCallbackPartnerLinkWSDL.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://enterprise.netbeans.org/bpel/FpMLParserWrapper" location="FpMLParserWrapper.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://parsing.trade.otc.crcc.com/" location="externalWSDL/FpMLParser/FpMLParser.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://enterprise.netbeans.org/bpel/RiskServiceWSWrapper" location="RiskServiceWSWrapper.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://facade.data.risk.otc.crcc.com/" location="externalWSDL/riskEJB/RiskServiceWS.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://enterprise.netbeans.org/bpel/MeffServiceWrapper" location="MeffServiceWrapper.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://facade.data.otc.crcc.com/" location="externalWSDL/commons/MeffService.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://j2ee.netbeans.org/wsdl/fpMLMessageInDBWSDL" location="fpMLMessageInDBWSDL.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <partnerLinks>        
        <partnerLink name="meffService" xmlns:tns="http://enterprise.netbeans.org/bpel/MeffServiceWrapper" partnerLinkType="tns:MeffServiceLinkType" partnerRole="MeffServiceRole">
            <documentation>Contain the Risk EJB</documentation>
        </partnerLink>
        <partnerLink name="FpMLParser" xmlns:tns="http://enterprise.netbeans.org/bpel/FpMLParserWrapper" partnerLinkType="tns:FpMLParserLinkType" partnerRole="FpMLParserRole"/>
        <partnerLink name="invokeCallBack" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeBPEL/invokeCallbackPartnerLinkWSDL" partnerLinkType="tns:invokeCallbackPartnerLinkWSDL" partnerRole="invokeCallbackPartnerLinkWSDLPortTypeRole"/>
        <partnerLink name="OTCMessage" xmlns:tns="http://j2ee.netbeans.org/wsdl/fpMLMessageInDBWSDL" partnerLinkType="tns:jdbcpartner" partnerRole="jdbcPortTypeRole"/>
        <partnerLink name="getJMS" xmlns:tns="http://j2ee.netbeans.org/wsdl/processOTCBusinessError/getIncomingOTCParsingErrorWSDL" partnerLinkType="tns:getIncomingOTCParsingErrorWSDL" myRole="JMSInPortTypeRole">
            <documentation>partner link that get message from JMS</documentation>
        </partnerLink>
    </partnerLinks>
    <variables>
        <variable name="responseInsertFpMLMessageOut" xmlns:tns="http://j2ee.netbeans.org/wsdl/fpMLMessageInDBWSDL" messageType="tns:insertRetMsg"/>
        <variable name="requestInsertFpMLMessageIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/fpMLMessageInDBWSDL" messageType="tns:inputMsg"/>
        <variable name="requestInvokeCallbackPartnerLinkWSDLOperationIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeBPEL/invokeCallbackPartnerLinkWSDL" messageType="tns:invokeCallbackPartnerLinkWSDLOperationRequest"/>
        <variable name="responseMessageRejectedAsStringOut" xmlns:tns="http://parsing.trade.otc.crcc.com/" messageType="tns:messageRejectedAsStringResponse"/>
        <variable name="requestMessageRejectedAsStringIn" xmlns:tns="http://parsing.trade.otc.crcc.com/" messageType="tns:messageRejectedAsString"/>
        <variable name="responseGetIdMessageOut" xmlns:tns="http://facade.data.otc.crcc.com/" messageType="tns:getIdMessageResponse"/>
        <variable name="requestGetIdMessageIn" xmlns:tns="http://facade.data.otc.crcc.com/" messageType="tns:getIdMessage"/>
        <variable name="IncomingError" xmlns:tns="http://j2ee.netbeans.org/wsdl/processOTCBusinessError/getIncomingOTCParsingErrorWSDL" messageType="tns:JMSInputMessage"/>
    </variables>
    <sequence>
        <receive name="getError" createInstance="yes" partnerLink="getJMS" operation="JMSInOperation" xmlns:tns="http://j2ee.netbeans.org/wsdl/processOTCBusinessError/getIncomingOTCParsingErrorWSDL" portType="tns:JMSInPortType" variable="IncomingError">
            <documentation>Receive the incoming Error</documentation>
            <sxt:trace>
                <sxt:log level="fine" location="onStart">
                    <from>concat(''START Receive the incoming parsing error: '', sxxf:current-dateTime())</from>
                </sxt:log>
                <sxt:log level="fine" location="onComplete">
                    <from>concat(''FINISHED  Receive the incoming parsing error: '', sxxf:current-dateTime())</from>
                </sxt:log>
            </sxt:trace>
        </receive>
        <if name="IfDefaultProccesingError">
            <documentation>Verifiy is the incoming error is a 200: Default message processing error code</documentation>
            <condition>''200'' !!= $IncomingError.part1/ns0:validationException/reasonCode</condition>
            <sequence name="nonDefaultErrorSeq">
                <documentation>Execute some activities when the error is not default parsing</documentation>
                <assign name="settingMessageId">
                    <documentation>Setting up the incoming parameter for get messageId</documentation>
                        <copy>
                        <from>''''</from>
                            <to variable="requestGetIdMessageIn" part="parameters"/>
                    </copy>
                </assign>
                <invoke name="toGetMessageId" partnerLink="meffService" operation="getIdMessage" xmlns:tns="http://facade.data.otc.crcc.com/" portType="tns:MeffService" inputVariable="requestGetIdMessageIn" outputVariable="responseGetIdMessageOut">
                    <documentation>Get the next message ID generated by CRCC</documentation>
                </invoke>
                <assign name="settingOTCMessage">
                    <documentation>set up the MEFF message</documentation>
                    <copy>
                        <from>$IncomingError.part1/ns0:rtcInternalID</from>
                        <to>$requestInsertFpMLMessageIn.part/ns3:FPML_MESSAGE_Record/ns3:priorMessage_FK</to>
                    </copy>
                    <copy>
                        <from>$responseGetIdMessageOut.parameters/return</from>
                        <to>$requestInsertFpMLMessageIn.part/ns3:FPML_MESSAGE_Record/ns3:messageID</to>
                    </copy>
                    <copy>
                        <from>2</from>
                        <to>$requestInsertFpMLMessageIn.part/ns3:FPML_MESSAGE_Record/ns3:messageType_FK</to>
                    </copy>
                    <copy>
                        <from>1</from>
                        <to>$requestInsertFpMLMessageIn.part/ns3:FPML_MESSAGE_Record/ns3:sender_FK</to>
                    </copy>
                    <copy>
                        <from>''http://www.camaraderiesgo.com/messageId''</from>
                        <to>$requestInsertFpMLMessageIn.part/ns3:FPML_MESSAGE_Record/ns3:messageSchemaID</to>
                    </copy>
                </assign>
                <invoke name="toInsertFpMLInDB" partnerLink="OTCMessage" operation="insert" xmlns:tns="http://j2ee.netbeans.org/wsdl/fpMLMessageInDBWSDL" portType="tns:jdbcPortType" inputVariable="requestInsertFpMLMessageIn" outputVariable="responseInsertFpMLMessageOut">
                    <documentation>Insert a message on FPML_MESSAGE table</documentation>
                </invoke>
                <assign name="settingMessageRejected">
                    <documentation>Set up the message rejected information</documentation>
                    <copy>
                            <from>$IncomingError.part1/ns0:validationException/location</from>
                                <to>$requestMessageRejectedAsStringIn.parameters/messageRejected/ns1:reason/ns1:location</to>
                        </copy>
                        <copy>
                            <from>$IncomingError.part1/ns0:validationException/message</from>
                                <to>$requestMessageRejectedAsStringIn.parameters/messageRejected/ns1:reason/ns1:description</to>
                        </copy>
                        <copy>
                            <from>$IncomingError.part1/ns0:validationException/reasonCode</from>
                                <to>$requestMessageRejectedAsStringIn.parameters/messageRejected/ns1:reason/ns1:reasonCode</to>
                        </copy>
                        <copy>
                            <from>$IncomingError.part1/ns0:validationException/semanticRuleId</from>
                                <to>$requestMessageRejectedAsStringIn.parameters/messageRejected/ns1:reason/ns1:validationRuleId</to>
                        </copy>
                        <copy>
                            <from>$IncomingError.part1/ns0:validationException/semanticRuleDescription</from>
                                <to>$requestMessageRejectedAsStringIn.parameters/messageRejected/ns1:reason/ns1:additionalData</to>
                        </copy>
                        <copy>
                            <from>$IncomingError.part1/ns0:requestMessageHeader/ns1:messageId</from>
                                <to>$requestMessageRejectedAsStringIn.parameters/messageRejected/ns1:header/ns1:inReplyTo</to>
                        </copy>
                        <copy>
                            <from>$IncomingError.part1/ns0:requestMessageHeader/ns1:sentBy</from>
                                <to>$requestMessageRejectedAsStringIn.parameters/messageRejected/ns1:header/ns1:sendTo</to>
                        </copy>
                        <copy>
                            <from>''CRCC''</from>
                                <to>$requestMessageRejectedAsStringIn.parameters/messageRejected/ns1:header/ns1:sentBy</to>
                        </copy>
                        <copy>
                            <from>''http://www.camaraderiesgo.com.co/partyId''</from>
                                <to>$requestMessageRejectedAsStringIn.parameters/messageRejected/ns1:header/ns1:sentBy/@partyIdScheme</to>
                        </copy>
                        <copy>
                            <from>$responseGetIdMessageOut.parameters/return</from>
                                <to>$requestMessageRejectedAsStringIn.parameters/messageRejected/ns1:header/ns1:messageId</to>
                        </copy>
                        <copy>
                            <from>''4-5''</from>
                                <to>$requestMessageRejectedAsStringIn.parameters/messageRejected/@version</to>
                        </copy>
                        <copy>
                            <from>sxxf:current-dateTime()</from>
                                <to>$requestMessageRejectedAsStringIn.parameters/messageRejected/ns1:header/ns1:creationTimestamp</to>
                        </copy>
                        <copy>
                            <from>$IncomingError.part1/ns0:validationException/semanticRuleDescription</from>
                                <to>$requestMessageRejectedAsStringIn.parameters/messageRejected/ns1:additionalData</to>
                        </copy>
                    <copy>
                        <from>0</from>
                        <to>$requestInsertFpMLMessageIn.part/ns3:FPML_MESSAGE_Record/ns3:ID</to>
                    </copy>
                    <copy>
                        <from>sxxf:current-date()</from>
                        <to>$requestInsertFpMLMessageIn.part/ns3:FPML_MESSAGE_Record/ns3:creationDateTime</to>
                    </copy>
                    <copy>
                        <from>0</from>
                        <to>$requestInsertFpMLMessageIn.part/ns3:FPML_MESSAGE_Record/ns3:messageType_FK</to>
                    </copy>
                    <copy>
                        <from>''messageSchemaID''</from>
                        <to>$requestInsertFpMLMessageIn.part/ns3:FPML_MESSAGE_Record/ns3:messageSchemaID</to>
                    </copy>
                    <copy>
                        <from>''messageID''</from>
                        <to>$requestInsertFpMLMessageIn.part/ns3:FPML_MESSAGE_Record/ns3:messageID</to>
                    </copy>
                    <copy>
                        <from>0</from>
                        <to>$requestInsertFpMLMessageIn.part/ns3:FPML_MESSAGE_Record/ns3:priorMessage_FK</to>
                    </copy>
                    <copy>
                        <from>sxxf:current-date()</from>
                        <to>$requestInsertFpMLMessageIn.part/ns3:FPML_MESSAGE_Record/ns3:receptionDateSystem</to>
                    </copy>
                    <copy>
                        <from>0</from>
                        <to>$requestInsertFpMLMessageIn.part/ns3:FPML_MESSAGE_Record/ns3:sender_FK</to>
                    </copy>
                </assign>
                <assign name="setMessageIdScheme">
                    <copy>
                            <from>''http://www.camaraderiesgo.com.co/messageId''</from>
                                <to>$requestMessageRejectedAsStringIn.parameters/messageRejected/ns1:header/ns1:messageId/@messageIdScheme</to>
                        </copy>
                </assign>
                <invoke name="toGetMessageRejectedAsString" partnerLink="FpMLParser" operation="messageRejectedAsString" xmlns:tns="http://parsing.trade.otc.crcc.com/" portType="tns:FpMLParser" inputVariable="requestMessageRejectedAsStringIn" outputVariable="responseMessageRejectedAsStringOut">
                    <documentation>Get the message rejected as string</documentation>
                </invoke>
                <assign name="settingInvokeCallback">
                    <documentation>Setting the invoke callback</documentation>
                        <copy>
                            <from>$IncomingError.part1/ns0:callbackAddress</from>
                                <to>$requestInvokeCallbackPartnerLinkWSDLOperationIn.part1/ns2:endPointReference</to>
                        </copy>
                        <copy>
                            <from>$responseMessageRejectedAsStringOut.parameters/return</from>
                                <to>$requestInvokeCallbackPartnerLinkWSDLOperationIn.part1/ns2:fpMLMessageAsString</to>
                        </copy>
                        <copy>
                            <from>$IncomingError.part1/ns0:requestMessageHeader/ns1:sentBy</from>
                                <to>$requestInvokeCallbackPartnerLinkWSDLOperationIn.part1/ns2:senderPartyID</to>
                        </copy>
                        <copy>
                            <from>$requestInsertFpMLMessageIn.part/ns3:FPML_MESSAGE_Record/ns3:ID</from>
                                <to>$requestInvokeCallbackPartnerLinkWSDLOperationIn.part1/ns2:fpmlMessageFK</to>
                        </copy>
                </assign>
                <invoke name="toInvokeCallback" partnerLink="invokeCallBack" operation="invokeCallbackPartnerLinkWSDLOperation" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeBPEL/invokeCallbackPartnerLinkWSDL" portType="tns:invokeCallbackPartnerLinkWSDLPortType" inputVariable="requestInvokeCallbackPartnerLinkWSDLOperationIn">
                    <documentation>Invoke the callback</documentation>
                    <sxt:trace>
                        <sxt:log level="fine" location="onStart">
                            <from>concat(''START toInvokeCallback parsing error: '', sxxf:current-dateTime())</from>
                        </sxt:log>
                        <sxt:log level="fine" location="onComplete">
                            <from>concat(''FINISHED  toInvokeCallback parsing error: '', sxxf:current-dateTime())</from>
                        </sxt:log>
                    </sxt:trace>
                </invoke>
            </sequence>
        </if>
    </sequence>
</process>
'! !

!BPEL20BpelAnalyzerTest methodsFor: 'bpel_source' stamp: 'AlvaroJosePeraltaOcampo 11/12/2014 09:47'!
processOTCRiskError
^ '<?xml version="1.0" encoding="UTF-8"?>
<process
    name="processOTCRiskError"
    targetNamespace="http://enterprise.netbeans.org/bpel/processOTCBusinessError/processOTCRiskError"
    xmlns="http://docs.oasis-open.org/wsbpel/2.0/process/executable"
    xmlns:xsd="http://www.w3.org/2001/XMLSchema"
    xmlns:sxt="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/Trace" 
    xmlns:sxed="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/Editor"
    xmlns:sxeh="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/ErrorHandling"
    xmlns:tns="http://enterprise.netbeans.org/bpel/processOTCBusinessError/processOTCRiskError" xmlns:ns0="http://xml.netbeans.org/schema/processOTCError" xmlns:ns1="http://www.fpml.org/2008/FpML-4-5" xmlns:sxxf="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/XPathFunctions" xmlns:ns2="http://xml.netbeans.org/schema/runtimePartner" xmlns:ns3="http://j2ee.netbeans.org/xsd/tableSchema" xmlns:ns4="http://j2ee.netbeans.org/wsdl/fpMLMessageInDBWSDL" xmlns:ns5="http://schemas.xmlsoap.org/ws/2004/08/addressing">
    <documentation>Manage a risk error</documentation>
    <import namespace="http://j2ee.netbeans.org/wsdl/processOTCBusinessError/getIncomingOTCRiskErrorWSDL" location="getIncomingOTCRiskErrorWSDL.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://j2ee.netbeans.org/wsdl/processNovateTradeBPEL/invokeCallbackPartnerLinkWSDL" location="externalWSDL/invokeCallbackPartnerLinkWSDL.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://enterprise.netbeans.org/bpel/FpMLParserWrapper" location="FpMLParserWrapper.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://parsing.trade.otc.crcc.com/" location="externalWSDL/FpMLParser/FpMLParser.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://enterprise.netbeans.org/bpel/RiskServiceWSWrapper" location="RiskServiceWSWrapper.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://facade.data.risk.otc.crcc.com/" location="externalWSDL/riskEJB/RiskServiceWS.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://enterprise.netbeans.org/bpel/MeffServiceWrapper" location="MeffServiceWrapper.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://facade.data.otc.crcc.com/" location="externalWSDL/commons/MeffService.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://j2ee.netbeans.org/wsdl/fpMLMessageInDBWSDL" location="fpMLMessageInDBWSDL.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://j2ee.netbeans.org/wsdl/FpmlSoapAttachmentWSDL" location="FpmlSoapAttachmentWSDL.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <partnerLinks>
        <partnerLink name="meffService" xmlns:tns="http://enterprise.netbeans.org/bpel/MeffServiceWrapper" partnerLinkType="tns:MeffServiceLinkType" partnerRole="MeffServiceRole"/>
        <partnerLink name="FpMLParser" xmlns:tns="http://enterprise.netbeans.org/bpel/FpMLParserWrapper" partnerLinkType="tns:FpMLParserLinkType" partnerRole="FpMLParserRole"/>
        <partnerLink name="invokeCallBack" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeBPEL/invokeCallbackPartnerLinkWSDL" partnerLinkType="tns:invokeCallbackPartnerLinkWSDL" partnerRole="invokeCallbackPartnerLinkWSDLPortTypeRole"/>
        <partnerLink name="OTCMessage" xmlns:tns="http://j2ee.netbeans.org/wsdl/fpMLMessageInDBWSDL" partnerLinkType="tns:jdbcpartner" partnerRole="jdbcPortTypeRole"/>
        <partnerLink name="SOAP_ATTACHMENT" xmlns:tns="http://j2ee.netbeans.org/wsdl/FpmlSoapAttachmentWSDL" partnerLinkType="tns:jdbcpartner" partnerRole="jdbcPortTypeRole"/>
        <partnerLink name="getRiskError" xmlns:tns="http://j2ee.netbeans.org/wsdl/processOTCBusinessError/getIncomingOTCRiskErrorWSDL" partnerLinkType="tns:getIncomingOTCRiskErrorWSDL" myRole="JMSInPortTypeRole"/>
    </partnerLinks>
    <variables>
        <variable name="responseInsertOutSoapAttach" xmlns:tns="http://j2ee.netbeans.org/wsdl/FpmlSoapAttachmentWSDL" messageType="tns:insertRetMsg"/>
        <variable name="requestInsertInSoapAttach" xmlns:tns="http://j2ee.netbeans.org/wsdl/FpmlSoapAttachmentWSDL" messageType="tns:inputMsg"/>
        <variable name="responseInsertFpMLMessageOut" xmlns:tns="http://j2ee.netbeans.org/wsdl/fpMLMessageInDBWSDL" messageType="tns:insertRetMsg"/>
        <variable name="requestInsertFpMLMessageIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/fpMLMessageInDBWSDL" messageType="tns:inputMsg"/>
        <variable name="requestInvokeCallbackPartnerLinkWSDLOperationIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeBPEL/invokeCallbackPartnerLinkWSDL" messageType="tns:invokeCallbackPartnerLinkWSDLOperationRequest"/>
        <variable name="responseMessageRejectedAsStringOut" xmlns:tns="http://parsing.trade.otc.crcc.com/" messageType="tns:messageRejectedAsStringResponse"/>
        <variable name="requestMessageRejectedAsStringIn" xmlns:tns="http://parsing.trade.otc.crcc.com/" messageType="tns:messageRejectedAsString"/>
        <variable name="responseGetIdMessageOut" xmlns:tns="http://facade.data.otc.crcc.com/" messageType="tns:getIdMessageResponse"/>
        <variable name="requestGetIdMessageIn" xmlns:tns="http://facade.data.otc.crcc.com/" messageType="tns:getIdMessage"/>
        <variable name="IncomingError" xmlns:tns="http://j2ee.netbeans.org/wsdl/processOTCBusinessError/getIncomingOTCRiskErrorWSDL" messageType="tns:JMSInputMessage"/>
    </variables>
    <sequence>
        <receive name="getError" createInstance="yes" partnerLink="getRiskError" operation="JMSInOperation" xmlns:tns="http://j2ee.netbeans.org/wsdl/processOTCBusinessError/getIncomingOTCRiskErrorWSDL" portType="tns:JMSInPortType" variable="IncomingError">
            <documentation>Receive the incoming Error</documentation>
            <sxt:trace>
                <sxt:log level="fine" location="onStart">
                    <from>concat(''START Receive the incoming risk error: '', sxxf:current-dateTime())</from>
                </sxt:log>
                <sxt:log level="fine" location="onComplete">
                    <from>concat(''FINISHED  Receive the incoming risk error: '', sxxf:current-dateTime())</from>
                </sxt:log>
            </sxt:trace>
        </receive>
        <assign name="settingMessageId">
            <documentation>Setting up the incoming parameter for get messageId</documentation>
            <copy>
                <from>''''</from>
                <to variable="requestGetIdMessageIn" part="parameters"/>
            </copy>
        </assign>
        <invoke name="toGetMessageId" partnerLink="meffService" operation="getIdMessage" xmlns:tns="http://facade.data.otc.crcc.com/" portType="tns:MeffService" inputVariable="requestGetIdMessageIn" outputVariable="responseGetIdMessageOut">
            <documentation>Get the next message ID generated by CRCC</documentation>
        </invoke>
        <if name="IfErrorIsNotMessageAlreadyExist">
            <documentation>If the error is not message already exist, insert the message on database otherwise does not insert because doesn''t have the prior message code</documentation>
            <condition>''513'' !!= $IncomingError.part1/ns0:validationException/reasonCode and ''210'' !!= $IncomingError.part1/ns0:validationException/reasonCode</condition>
            <sequence name="nonAlreadyExistSeq">
                <documentation>Execute some activities when the messaage is different to Message already exist</documentation>
                <assign name="settingFpMLMessage">
                    <documentation>configure the insert message by getting the prior message</documentation>
                    <copy>
                            <from>1</from>
                                <to>$requestInsertFpMLMessageIn.part/ns3:FPML_MESSAGE_Record/ns3:sender_FK</to>
                        </copy>
                        <copy>
                            <from>$responseGetIdMessageOut.parameters/return</from>
                                <to>$requestInsertFpMLMessageIn.part/ns3:FPML_MESSAGE_Record/ns3:messageID</to>
                        </copy>
                        <copy>
                            <from>''http://www.camaraderiesgo.com/messageId''</from>
                                <to>$requestInsertFpMLMessageIn.part/ns3:FPML_MESSAGE_Record/ns3:messageSchemaID</to>
                        </copy>
                        <copy>
                            <from>2</from>
                                <to>$requestInsertFpMLMessageIn.part/ns3:FPML_MESSAGE_Record/ns3:messageType_FK</to>
                        </copy>
                    <copy>
                        <from>$IncomingError.part1/ns0:rtcInternalID</from>
                        <to>$requestInsertFpMLMessageIn.part/ns3:FPML_MESSAGE_Record/ns3:priorMessage_FK</to>
                    </copy>
                </assign>
                <invoke name="toInsertFpMLMessage" partnerLink="OTCMessage" operation="insert" portType="ns4:jdbcPortType" inputVariable="requestInsertFpMLMessageIn" outputVariable="responseInsertFpMLMessageOut">
                    <documentation>Insert a message on FPML_MESSAGE</documentation>
                </invoke>
            </sequence>
        </if>
        <assign name="settingMessageRejected">
            <documentation>Set up the message rejected</documentation>
            <copy>
                <from>$IncomingError.part1/ns0:validationException/location</from>
                <to>$requestMessageRejectedAsStringIn.parameters/messageRejected/ns1:reason/ns1:location</to>
            </copy>
            <copy>
                <from>$IncomingError.part1/ns0:validationException/message</from>
                <to>$requestMessageRejectedAsStringIn.parameters/messageRejected/ns1:reason/ns1:description</to>
            </copy>
            <copy>
                <from>$IncomingError.part1/ns0:validationException/reasonCode</from>
                <to>$requestMessageRejectedAsStringIn.parameters/messageRejected/ns1:reason/ns1:reasonCode</to>
            </copy>
            <copy>
                <from>$IncomingError.part1/ns0:validationException/semanticRuleId</from>
                <to>$requestMessageRejectedAsStringIn.parameters/messageRejected/ns1:reason/ns1:validationRuleId</to>
            </copy>
            <copy>
                <from>$IncomingError.part1/ns0:validationException/semanticRuleDescription</from>
                <to>$requestMessageRejectedAsStringIn.parameters/messageRejected/ns1:reason/ns1:additionalData</to>
            </copy>
            <copy>
                <from>$IncomingError.part1/ns0:requestMessageHeader/ns1:messageId</from>
                <to>$requestMessageRejectedAsStringIn.parameters/messageRejected/ns1:header/ns1:inReplyTo</to>
            </copy>
            <copy>
                <from>$IncomingError.part1/ns0:requestMessageHeader/ns1:sentBy</from>
                <to>$requestMessageRejectedAsStringIn.parameters/messageRejected/ns1:header/ns1:sendTo</to>
            </copy>
            <copy>
                <from>''CRCC''</from>
                <to>$requestMessageRejectedAsStringIn.parameters/messageRejected/ns1:header/ns1:sentBy</to>
            </copy>
            <copy>
                <from>''http://www.camaraderiesgo.com.co/partyId''</from>
                <to>$requestMessageRejectedAsStringIn.parameters/messageRejected/ns1:header/ns1:sentBy/@partyIdScheme</to>
            </copy>
            <copy>
                <from>$responseGetIdMessageOut.parameters/return</from>
                <to>$requestMessageRejectedAsStringIn.parameters/messageRejected/ns1:header/ns1:messageId</to>
            </copy>
            <copy>
                <from>''4-5''</from>
                <to>$requestMessageRejectedAsStringIn.parameters/messageRejected/@version</to>
            </copy>
            <copy>
                <from>sxxf:current-dateTime()</from>
                <to>$requestMessageRejectedAsStringIn.parameters/messageRejected/ns1:header/ns1:creationTimestamp</to>
            </copy>
            <copy>
                <from>$IncomingError.part1/ns0:validationException/semanticRuleDescription</from>
                <to>$requestMessageRejectedAsStringIn.parameters/messageRejected/ns1:additionalData</to>
            </copy>
            <copy>
                <from>sxxf:current-date()</from>
                <to>$requestInsertFpMLMessageIn.part/ns3:FPML_MESSAGE_Record/ns3:creationDateTime</to>
            </copy>
            <copy>
                <from>0</from>
                <to>$requestInsertFpMLMessageIn.part/ns3:FPML_MESSAGE_Record/ns3:messageType_FK</to>
            </copy>
            <copy>
                <from>''messageSchemaID''</from>
                <to>$requestInsertFpMLMessageIn.part/ns3:FPML_MESSAGE_Record/ns3:messageSchemaID</to>
            </copy>
            <copy>
                <from>''messageID''</from>
                <to>$requestInsertFpMLMessageIn.part/ns3:FPML_MESSAGE_Record/ns3:messageID</to>
            </copy>
            <copy>
                <from>0</from>
                <to>$requestInsertFpMLMessageIn.part/ns3:FPML_MESSAGE_Record/ns3:priorMessage_FK</to>
            </copy>
            <copy>
                <from>sxxf:current-date()</from>
                <to>$requestInsertFpMLMessageIn.part/ns3:FPML_MESSAGE_Record/ns3:receptionDateSystem</to>
            </copy>
            <copy>
                <from>0</from>
                <to>$requestInsertFpMLMessageIn.part/ns3:FPML_MESSAGE_Record/ns3:sender_FK</to>
            </copy>
            <copy>
                <from>0</from>
                <to>$requestInsertFpMLMessageIn.part/ns3:FPML_MESSAGE_Record/ns3:ID</to>
            </copy>
        </assign>
        <assign name="setMessageIdScheme">
            <documentation>Add the messageIdScheme to the before activity</documentation>
            <copy>
                <from>''http://www.camaraderiesgo.com.co/messageId''</from>
                <to>$requestMessageRejectedAsStringIn.parameters/messageRejected/ns1:header/ns1:messageId/@messageIdScheme</to>
            </copy>
        </assign>
        <invoke name="toGetMessageRejectedAsString" partnerLink="FpMLParser" operation="messageRejectedAsString" xmlns:tns="http://parsing.trade.otc.crcc.com/" portType="tns:FpMLParser" inputVariable="requestMessageRejectedAsStringIn" outputVariable="responseMessageRejectedAsStringOut">
            <documentation>Get the message rejected as string</documentation>
        </invoke>
        <assign name="settingInvokeCallback">
            <documentation>copy the message rejected as stringo into invoke callback FpML Message</documentation>
                <copy>
                    <from>$IncomingError.part1/ns0:callbackAddress</from>
                        <to>$requestInvokeCallbackPartnerLinkWSDLOperationIn.part1/ns2:endPointReference</to>
                </copy>
                <copy>
                    <from>$responseMessageRejectedAsStringOut.parameters/return</from>
                        <to>$requestInvokeCallbackPartnerLinkWSDLOperationIn.part1/ns2:fpMLMessageAsString</to>
                </copy>
                <copy>
                    <from>$IncomingError.part1/ns0:requestMessageHeader/ns1:sentBy</from>
                        <to>$requestInvokeCallbackPartnerLinkWSDLOperationIn.part1/ns2:senderPartyID</to>
                </copy>
            <copy>
                <from>$requestInsertFpMLMessageIn.part/ns3:FPML_MESSAGE_Record/ns3:ID</from>
                <to>$requestInvokeCallbackPartnerLinkWSDLOperationIn.part1/ns2:fpmlMessageFK</to>
            </copy>
        </assign>
        <assign name="setSoapAttachment">
            <copy>
                <from>string($IncomingError.part1/ns0:callbackAddress/ns5:ServiceName/@PortName)</from>
                <to>$requestInsertInSoapAttach.part/ns3:FPML_SOAP_ATTACHMENT_Record/ns3:portName</to>
            </copy>
            <copy>
                <from>string($IncomingError.part1/ns0:callbackAddress/ns5:ServiceName)</from>
                <to>$requestInsertInSoapAttach.part/ns3:FPML_SOAP_ATTACHMENT_Record/ns3:serviceName</to>
            </copy>
            <copy>
                <from>string($IncomingError.part1/ns0:callbackAddress/ns5:PortType)</from>
                <to>$requestInsertInSoapAttach.part/ns3:FPML_SOAP_ATTACHMENT_Record/ns3:portType</to>
            </copy>
            <copy>
                <from>string($IncomingError.part1/ns0:callbackAddress/ns5:Address)</from>
                <to>$requestInsertInSoapAttach.part/ns3:FPML_SOAP_ATTACHMENT_Record/ns3:serviceAddress</to>
            </copy>
            <copy>
                <from>$responseMessageRejectedAsStringOut.parameters/return</from>
                <to>$requestInsertInSoapAttach.part/ns3:FPML_SOAP_ATTACHMENT_Record/ns3:message</to>
            </copy>
            <copy>
                <from>number($responseGetIdMessageOut.parameters/return)</from>
                <to>$requestInsertInSoapAttach.part/ns3:FPML_SOAP_ATTACHMENT_Record/ns3:message_FK</to>
            </copy>
        </assign>
        <invoke name="toInserSOAP_ATTACHMENT" partnerLink="SOAP_ATTACHMENT" operation="insert" xmlns:tns="http://j2ee.netbeans.org/wsdl/FpmlSoapAttachmentWSDL" portType="tns:jdbcPortType" inputVariable="requestInsertInSoapAttach" outputVariable="responseInsertOutSoapAttach"/>
        <invoke name="toInvokeCallback" partnerLink="invokeCallBack" operation="invokeCallbackPartnerLinkWSDLOperation" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeBPEL/invokeCallbackPartnerLinkWSDL" portType="tns:invokeCallbackPartnerLinkWSDLPortType" inputVariable="requestInvokeCallbackPartnerLinkWSDLOperationIn">
            <documentation>Invoke the registration system</documentation>
            <sxt:trace>
                <sxt:log level="fine" location="onStart">
                    <from>concat(''START toInvokeCallback risk error: '', sxxf:current-dateTime())</from>
                </sxt:log>
                <sxt:log level="fine" location="onComplete">
                    <from>concat(''FINISHED  toInvokeCallback risk error: '', sxxf:current-dateTime())</from>
                </sxt:log>
            </sxt:trace>
        </invoke>
    </sequence>
</process>
'! !

!BPEL20BpelAnalyzerTest methodsFor: 'bpel_source' stamp: 'AlvaroJosePeraltaOcampo 11/12/2014 09:47'!
sourceExample1

	^ '<?xml version="1.0" encoding="UTF-8"?>
<process
    name="ManageMEFFAccountsAndParticipants"
    targetNamespace="http://enterprise.netbeans.org/bpel/ManageAccountsAndParticipantsBPEL/ManageMEFFAccountsAndParticipants"
    xmlns="http://docs.oasis-open.org/wsbpel/2.0/process/executable"
    xmlns:xsd="http://www.w3.org/2001/XMLSchema"
    xmlns:sxt="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/Trace" 
    xmlns:sxed="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/Editor"
    xmlns:sxeh="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/ErrorHandling"
    xmlns:tns="http://enterprise.netbeans.org/bpel/ManageAccountsAndParticipantsBPEL/ManageMEFFAccountsAndParticipants">
   <import namespace="http://j2ee.netbeans.org/wsdl/ManageAccountsAndParticipantsBPEL/ReceiveAccountRemoteFileWSDL" location="ReceiveAccountRemoteFileWSDL.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
   <import namespace="http://j2ee.netbeans.org/wsdl/ManageAccountsAndParticipantsBPEL/getParticipantRemoteFileWSDL" location="GetPartiesRemoteFileWSDL.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
   <import namespace="http://enterprise.netbeans.org/bpel/PartiesAccountsServiceServiceWrapper" location="PartiesAccountsServiceServiceWrapper.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
   <import namespace="http://services.accounts.otc.crcc.com/" location="externalWSDL/PartiesAccountsServiceService.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
   <partnerLinks>
      <partnerLink name="plRemoteParticip" xmlns:tns="http://j2ee.netbeans.org/wsdl/ManageAccountsAndParticipantsBPEL/getParticipantRemoteFileWSDL" partnerLinkType="tns:getParticipantRemoteFileWSDL" partnerRole="ReceiveTransferringPortTypeRole">
         <documentation>this object do a ftp request on demand to get de participants information.
The kind from this object is: On demand receive transfer</documentation>
      </partnerLink>
      <partnerLink name="plAccountsServices" xmlns:tns="http://enterprise.netbeans.org/bpel/PartiesAccountsServiceServiceWrapper" partnerLinkType="tns:PartiesAccountsServiceLinkType" partnerRole="PartiesAccountsServiceRole">
         <documentation>This object do the comunication with the web service which expose the upgrade Accounts and parties method.
This method is located in the AccountsEJB project and follow the next steps in order to do the update
1. Inactivate all the parties an its accounts
2. Activate the participants and accounts which exist in the local BD.
3. activate the new participants
4. activate the new accounts</documentation>
      </partnerLink>
      <partnerLink name="plRemoteAccounts" xmlns:tns="http://j2ee.netbeans.org/wsdl/ManageAccountsAndParticipantsBPEL/ReceiveAccountRemoteFileWSDL" partnerLinkType="tns:ReceiveAccountRemoteFileWSDL" myRole="InboundOneWayTransferringPortTypeRole">
         <documentation>This object do a ftp poll in order to find an accounts file in the temporal file.
file name searched: cuentas
Object type: receive request</documentation>
      </partnerLink>
   </partnerLinks>
   <variables>
      <variable name="upgradeAccountsOut" xmlns:tns="http://services.accounts.otc.crcc.com/" messageType="tns:upgradeAccountsResponse"/>
      <variable name="upgradeAccountsIn" xmlns:tns="http://services.accounts.otc.crcc.com/" messageType="tns:upgradeAccounts"/>
      <variable name="getParticipantsOut" xmlns:tns="http://j2ee.netbeans.org/wsdl/ManageAccountsAndParticipantsBPEL/getParticipantRemoteFileWSDL" messageType="tns:ReceiveTransferringOperationResponse"/>
      <variable name="getParticipantsIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/ManageAccountsAndParticipantsBPEL/getParticipantRemoteFileWSDL" messageType="tns:ReceiveTransferringOperationRequest"/>
      <variable name="receivingAccountsIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/ManageAccountsAndParticipantsBPEL/ReceiveAccountRemoteFileWSDL" messageType="tns:InboundOneWayTransferringOperationRequest"/>
   </variables>
   <sequence>
      <receive name="receiveAccounts" createInstance="yes" partnerLink="plRemoteAccounts" operation="InboundOneWayTransferringOperation" xmlns:tns="http://j2ee.netbeans.org/wsdl/ManageAccountsAndParticipantsBPEL/ReceiveAccountRemoteFileWSDL" portType="tns:InboundOneWayTransferringPortType" variable="receivingAccountsIn">
         <documentation>This is the receiver from the poll object wich get the accounts information</documentation>
      </receive>
      <repeatUntil name="repeatUntilParticipantsNotLoaded">
         <documentation>This loop finish when the program find the pariticipants file. When it finish the system could be sure that both files are in the ftp remote location and it can start to do the rest of the process</documentation>
         <sequence name="LookingForParties">
            <assign name="intializeParticipantIn">
               <documentation>this is the first assign to the variable which is used to ask for the participants file.</documentation>
               <copy>
                  <from>''</from>
                     <to variable="getParticipantsIn" part="part1"/>
               </copy>
            </assign>
            <invoke name="getParties" partnerLink="plRemoteParticip" operation="ReceiveTransferringOperation" xmlns:tns="http://j2ee.netbeans.org/wsdl/ManageAccountsAndParticipantsBPEL/getParticipantRemoteFileWSDL" portType="tns:ReceiveTransferringPortType" inputVariable="getParticipantsIn" outputVariable="getParticipantsOut">
               <documentation>This object do the invoke to the object which is able to get the participant file
the filename from the archive is: particip</documentation>
            </invoke>
            <wait name="WaitForSomeSeconds">
               <documentation>this object introduce a delay for the next request from the participantes file (if it doesnt exist)</documentation>
               <for>''P0Y0M0DT0H0M5.0S''</for>
            </wait>
         </sequence>
         <condition>$getParticipantsOut.part1 !!= ''</condition>
      </repeatUntil>
      <assign name="File2UpgradeAccounts">
         <documentation>after the system has both files, this object do the assign for the cuentas an particip files to the remote method called upgradeAccounts</documentation>
         <copy>
               <from variable="receivingAccountsIn" part="part1"/>
                  <to>$upgradeAccountsIn.parameters/accounts</to>
            </copy>
            <copy>
               <from variable="getParticipantsOut" part="part1"/>
                  <to>$upgradeAccountsIn.parameters/parties</to>
            </copy>
      </assign>
      <invoke name="toUpgradeAccounts" partnerLink="plAccountsServices" operation="upgradeAccounts" xmlns:tns="http://services.accounts.otc.crcc.com/" portType="tns:PartiesAccountsService" inputVariable="upgradeAccountsIn" outputVariable="upgradeAccountsOut">
         <documentation>This method do the invoke to the object who call the remote web service</documentation>
      </invoke>
   </sequence>
</process>
'! !

!BPEL20BpelAnalyzerTest methodsFor: 'tests - parsing' stamp: 'AlvaroJosePeraltaOcampo 1/14/2015 20:09'!
testDefaultParsing

	self assert: BPEL20Parser new numberOfDefinedProcesses = 0! !

!BPEL20BpelAnalyzerTest methodsFor: 'tests - parsing' stamp: 'AlvaroJosePeraltaOcampo 1/14/2015 20:09'!
testGettingVariable
	| parser process variable plnk|
	parser := BPEL20Parser parseString: self sourceExample1.
	process := parser processes first.
	variable := process getBPVariableNamed: 'upgradeAccountsOut'.
	plnk := process getBPPartnerLinkName: 'plRemoteParticip'.
	self assert: variable notNil.
	self assert: variable class == BPVariable.	
	self assert: variable variableName = 'upgradeAccountsOut'.
	self assert: variable process == process.
	
	self assert: variable numberOfInvokes = 1.
	self assert: variable invokes first aName = 'toUpgradeAccounts'.
	"partnerlinks"
	self assert: plnk notNil.
	self assert: plnk class == BPPartnerLink.
	self assert: plnk aName = 'plRemoteParticip'.
	"self assert: plnk numberOfRef = 1."! !

!BPEL20BpelAnalyzerTest methodsFor: 'tests - parsing' stamp: 'AlvaroJosePeraltaOcampo 1/14/2015 20:09'!
testParsing
	| parser process |
	parser := BPEL20Parser parseString: self sourceExample1.
	self assert: parser numberOfDefinedProcesses = 1.
	
	process := parser processes first.
	self assert: process processName = 'ManageMEFFAccountsAndParticipants'.
	self assert: process name = 'ManageMEFFAccountsAndParticipants'.
	self assert: process numberOfVariables = 5.
	self assert: process numberOfInvokes = 2.
	
	! !

!BPEL20BpelAnalyzerTest methodsFor: 'tests - model' stamp: 'AlvaroJosePeraltaOcampo 11/12/2014 09:47'!
testProcess

	| process |
	process := BPProcess new.
	self assert: process processName = 'Unnamed'.
	self assert: process numberOfActivities = 0.
	self assert: process numberOfVariables = 0.! !

!BPEL20BpelAnalyzerTest methodsFor: 'tests - parsing' stamp: 'AlvaroJosePeraltaOcampo 11/12/2014 09:47'!
testWSDLParsing
	| parser wsdl wsdlDefinition wsdlPlnkType wsdlPlnkRole value|
	parser := BPParserWSDL parseString: self wsdl_processNovateTradeProcess_getIncomingMessageFromJMSWSDL.
	"self assert: parser numberOfDefinedProcesses = 1."
	value :=parser lstWsdl.
	wsdl :=  value first.
	self assert: wsdl aName = 'getIncomingMessageFromJMSWSDL'.
	wsdlDefinition := ( wsdl wsdlDefinition).
	self assert: wsdlDefinition targetNamespace = 'http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/getIncomingMessageFromJMSWSDL'.
	value :=wsdlDefinition lstPartnertLinkTypes.
	wsdlPlnkType := value at:'getIncomingMessageFromJMSWSDL'.
	self assert:  wsdlPlnkType aName = 'getIncomingMessageFromJMSWSDL'.
	wsdlPlnkRole := wsdlPlnkType role.
	self assert: wsdlPlnkRole aName = 'JMSInPortTypeRole'.
	self assert: wsdlPlnkRole portType = 'tns:JMSInPortType'.
! !

!BPEL20BpelAnalyzerTest methodsFor: 'wsdl_source2_processNovateTradeProcess' stamp: 'AlvaroJosePeraltaOcampo 11/12/2014 09:47'!
wsdl_processNovateTradeProcess_getIncomingMessageFromJMSWSDL
^ '<definitions name="getIncomingMessageFromJMSWSDL" 
   targetNamespace="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/getIncomingMessageFromJMSWSDL"
   xmlns="http://schemas.xmlsoap.org/wsdl/"
   xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/"
   xmlns:xsd="http://www.w3.org/2001/XMLSchema" 
   xmlns:jms="http://schemas.sun.com/jbi/wsdl-extensions/jms/" 	 	   	xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/getIncomingMessageFromJMSWSDL" 
	xmlns:plnk="http://docs.oasis-open.org/wsbpel/2.0/plnktype" xmlns:ns0="http://xml.netbeans.org/schema/novateTradeComposed">
    <types>
        <xsd:schema targetNamespace="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/getIncomingMessageFromJMSWSDL">
            <xsd:import namespace="http://xml.netbeans.org/schema/novateTradeComposed" schemaLocation="novateTradeComposed.xsd"/>
        </xsd:schema>
    </types>   
    <message name="JMSInputMessage">
        <part name="part1" element="ns0:novateTradeComposed"/>
    </message>    
    <portType name="JMSInPortType">
        <operation name="JMSInOperation">
            <input name="input1" message="tns:JMSInputMessage"/>
        </operation>
    </portType>
    <binding name="JMSInBinding" type="tns:JMSInPortType">
        <jms:binding/>
        <operation name="JMSInOperation">
            <jms:operation destination="OTCIncomingMessagesQueue" destinationType="Queue" transaction="XATransaction" concurrencyMode="cc" maxConcurrentConsumers="30"/>
            <input name="input1">
                <jms:message messageType="TextMessage" textPart="part1"/>
            </input>
        </operation>
    </binding>
    <service name="JMSInService">
        <port name="getIncomingMessageFromJMSWSDL_InPort" binding="tns:JMSInBinding">
            <jms:address connectionURL="${JmsDefaultURL}" username="guest" password="guest">
                <jms:jmsjcaOptions><!![CDATA[]]></jms:jmsjcaOptions>
            </jms:address>
        </port>
    </service>
    <plnk:partnerLinkType name="getIncomingMessageFromJMSWSDL">
        <!!-- A partner link type is automatically generated when a new port type is added. Partner link types are used by BPEL processes. 
In a BPEL process, a partner link represents the interaction between the BPEL process and a partner service. Each partner link is associated with a partner link type.
A partner link type characterizes the conversational relationship between two services. The partner link type can have one or two roles.-->
        <plnk:role name="JMSInPortTypeRole" portType="tns:JMSInPortType"/>
    </plnk:partnerLinkType>
</definitions>
'! !

BPEL20BPSourceTest subclass: #BPEL20BpelAnalyzerTest2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-Tests-BPEL20-source'!

!BPEL20BpelAnalyzerTest2 methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 11/12/2014 09:47'!
novateTradeProcess
^ '<?xml version="1.0" encoding="UTF-8"?>
<process
    name="novateTrade"
    targetNamespace="http://enterprise.netbeans.org/bpel/novateTradeProcess/novateTrade"
    xmlns="http://docs.oasis-open.org/wsbpel/2.0/process/executable"
    xmlns:xsd="http://www.w3.org/2001/XMLSchema"
    xmlns:sxt="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/Trace" 
    xmlns:sxed="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/Editor"
    xmlns:sxeh="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/ErrorHandling"
    xmlns:tns="http://enterprise.netbeans.org/bpel/novateTradeProcess/novateTrade" xmlns:ns0="http://xml.netbeans.org/schema/xsdNovateTrade" xmlns:ns1="http://schemas.xmlsoap.org/ws/2004/08/addressing" xmlns:sxxf="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/XPathFunctions">
    <import namespace="http://j2ee.netbeans.org/wsdl/novateTrade-bpel/novateTradeWSDL" location="externalWSDL/novateTradeWSDL.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://j2ee.netbeans.org/wsdl/novateTradeProcess/putIncomingMessageToJMS" location="putIncomingMessageToJMS.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <partnerLinks>
        <partnerLink name="putToJMS" xmlns:tns="http://j2ee.netbeans.org/wsdl/novateTradeProcess/putIncomingMessageToJMS" partnerLinkType="tns:putIncomingMessageToJMS" partnerRole="JMSOutPortTypeRole"/>
        <partnerLink name="novateTradePL" xmlns:tns="http://j2ee.netbeans.org/wsdl/novateTrade-bpel/novateTradeWSDL" partnerLinkType="tns:novateTradeWSDL" myRole="novateTradeWSDLPortTypeRole"/>
    </partnerLinks>
    <variables>
        <variable name="requestNovateTradeIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/novateTrade-bpel/novateTradeWSDL" messageType="tns:novateTradeRequest"/>
        <variable name="requestJMSOutOperationIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/novateTradeProcess/putIncomingMessageToJMS" messageType="tns:JMSInputMessage"/>
    </variables>
    <sequence>
        <receive name="getIncomingMessage" createInstance="yes" partnerLink="novateTradePL" operation="novateTrade" xmlns:tns="http://j2ee.netbeans.org/wsdl/novateTrade-bpel/novateTradeWSDL" portType="tns:novateTradeWSDLPortType" variable="requestNovateTradeIn">
            <documentation>This activity get the incoming message for external client</documentation>
            <sxt:trace>
                <sxt:log level="fine" location="onStart">
                    <from>concat(''START: getIncomingMessage RTC :'', sxxf:current-dateTime())</from>
                </sxt:log>                
            </sxt:trace>
        </receive>
        <assign name="settingJMS">
            <copy>
                <from>$requestNovateTradeIn.rtc/ns0:fpMLMessage</from>
                <to>$requestJMSOutOperationIn.part1/ns0:novateTrade/ns0:fpMLMessage</to>
            </copy>
            <copy>
                <from>$requestNovateTradeIn.headerPart/ns1:EndpointReference</from>
                <to>$requestJMSOutOperationIn.part1/ns0:headerCRCC/ns1:EndpointReference</to>
            </copy>
        </assign>
        <invoke name="toPutToJMS" partnerLink="putToJMS" operation="JMSOutOperation" xmlns:tns="http://j2ee.netbeans.org/wsdl/novateTradeProcess/putIncomingMessageToJMS" portType="tns:JMSOutPortType" inputVariable="requestJMSOutOperationIn">
            <documentation>Invoke the PL to put the incoming message to JMS QUEUE</documentation>
            <sxt:trace>
                <sxt:log level="fine" location="onComplete">
                    <from>concat(''FINISHED: getIncomingMessage putting on JMS :'', sxxf:current-dateTime())</from>
                </sxt:log>                
            </sxt:trace>
        </invoke>
    </sequence>
</process>'! !

!BPEL20BpelAnalyzerTest2 methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 11/12/2014 09:47'!
novateTrade_bpel
^ '<?xml version="1.0" encoding="UTF-8"?>
<process
    name="novateTradeProcess"
    targetNamespace="http://enterprise.netbeans.org/bpel/novateTrade-bpel/novateTradeProcess"
    xmlns="http://docs.oasis-open.org/wsbpel/2.0/process/executable"
    xmlns:xsd="http://www.w3.org/2001/XMLSchema"
    xmlns:sxt="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/Trace" 
    xmlns:sxed="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/Editor"
    xmlns:sxeh="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/ErrorHandling"
    xmlns:tns="http://enterprise.netbeans.org/bpel/novateTrade-bpel/novateTradeProcess" xmlns:ns0="http://xml.netbeans.org/schema/xsdNovateTrade">
    <import namespace="http://j2ee.netbeans.org/wsdl/novateTrade-bpel/novateTradeWSDL" location="novateTradeWSDL.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://j2ee.netbeans.org/wsdl/novateTrade-bpel/fileWSDL" location="fileWSDL.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://j2ee.netbeans.org/wsdl/novateTradeClient-bpl/processNovateResponseWSDL" location="registrySystem/processNovateResponseWSDLPort.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <partnerLinks>
        <partnerLink name="plFile" xmlns:tns="http://j2ee.netbeans.org/wsdl/novateTrade-bpel/fileWSDL" partnerLinkType="tns:fileWSDL" partnerRole="FileOutboundPortTypeRole"/>
        <partnerLink name="plRegistrySystem" xmlns:tns="http://j2ee.netbeans.org/wsdl/novateTradeClient-bpl/processNovateResponseWSDL" partnerLinkType="tns:processNovateResponseWSDL" partnerRole="processNovateResponseWSDLPortTypeRole"/>
        <partnerLink name="plNovateTrade" xmlns:tns="http://j2ee.netbeans.org/wsdl/novateTrade-bpel/novateTradeWSDL" partnerLinkType="tns:novateTradeWSDL" myRole="novateTradeWSDLPortTypeRole"/>
    </partnerLinks>
    <variables>
        <variable name="ProcessNovateResponseIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/novateTradeClient-bpl/processNovateResponseWSDL" messageType="tns:processNovateResponseRequest"/>
        <variable name="WriteIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/novateTrade-bpel/fileWSDL" messageType="tns:WriteInputMessage"/>
        <variable name="NovateTradeIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/novateTrade-bpel/novateTradeWSDL" messageType="tns:novateTradeRequest"/>
    </variables>
    <sequence>
        <receive name="receiveNovateTrade" createInstance="yes" partnerLink="plNovateTrade" operation="novateTrade" xmlns:tns="http://j2ee.netbeans.org/wsdl/novateTrade-bpel/novateTradeWSDL" portType="tns:novateTradeWSDLPortType" variable="NovateTradeIn"/>
        <assign name="string2File">
            <copy>
                <from>$NovateTradeIn.rtc/ns0:fpMLMessage</from>
                <to variable="WriteIn" part="part1"/>
            </copy>
            <copy>
                <from>$NovateTradeIn.rtc/ns0:fpMLMessage</from>
                <to>$ProcessNovateResponseIn.fpMLMessage/ns0:fpMLMessage</to>
            </copy>
        </assign>
        <invoke name="toWriteFile" partnerLink="plFile" operation="write" xmlns:tns="http://j2ee.netbeans.org/wsdl/novateTrade-bpel/fileWSDL" portType="tns:FileOutboundPortType" inputVariable="WriteIn"/>
        <invoke name="toInvokeRegistrySystem" partnerLink="plRegistrySystem" operation="processNovateResponse" xmlns:tns="http://j2ee.netbeans.org/wsdl/novateTradeClient-bpl/processNovateResponseWSDL" portType="tns:processNovateResponseWSDLPortType" inputVariable="ProcessNovateResponseIn"/>
    </sequence>
</process>
'! !

!BPEL20BpelAnalyzerTest2 methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 11/12/2014 09:47'!
processNovateTradeProcess_processNovateTradeProcess
^ '<?xml version="1.0" encoding="UTF-8"?>
<process
    name="processNovateTradeProcess"
    targetNamespace="http://enterprise.netbeans.org/bpel/processNovateTradeProcess/processNovateTradeProcess"
    xmlns="http://docs.oasis-open.org/wsbpel/2.0/process/executable"
    xmlns:xsd="http://www.w3.org/2001/XMLSchema"
    xmlns:sxt="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/Trace" 
    xmlns:sxed="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/Editor"
    xmlns:sxeh="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/ErrorHandling"
    xmlns:tns="http://enterprise.netbeans.org/bpel/processNovateTradeProcess/processNovateTradeProcess" 
    xmlns:ns0="http://xml.netbeans.org/schema/xsdNovateTrade" 
    xmlns:ns1="http://www.fpml.org/2008/FpML-4-5" 
    xmlns:ns2="http://xml.netbeans.org/schema/processTradeConfirmed" 
    xmlns:ns3="http://schemas.xmlsoap.org/ws/2004/08/addressing" 
    xmlns:ns4="http://xml.netbeans.org/schema/processOTCError" 
    xmlns:sxxf="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/XPathFunctions" xmlns:ns5="http://j2ee.netbeans.org/xsd/tableSchema" xmlns:ns6="http://facade.manage.data.otc.crcc.com/">
    <documentation>This process is a sequence of activities for novate a trade</documentation>
    <import namespace="http://enterprise.netbeans.org/bpel/FpMLParserWrapper" location="FpMLParserWrapper.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://parsing.trade.otc.crcc.com/" location="externalWSDL/FpMLParser/FpMLParser.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://enterprise.netbeans.org/bpel/MeffServiceWrapper" location="MeffServiceWrapper.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://facade.data.otc.crcc.com/" location="externalWSDL/commons/MeffService.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/getIncomingMessageFromJMSWSDL" location="getIncomingMessageFromJMSWSDL.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://enterprise.netbeans.org/bpel/RiskServiceWSWrapper" location="RiskServiceWSWrapper.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://facade.data.risk.otc.crcc.com/" location="externalWSDL/riskEJB/RiskServiceWS.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/processTradeConfirmedWSDL" location="processTradeConfirmedWSDL.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/putToParsingErrorJMSWSDL" location="putToParsingErrorJMSWSDL.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/putToRiskErrorJMSWSDL" location="putToRiskErrorJMSWSDL.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/putToUnknownErrorJMSWSDL" location="putToUnknownErrorJMSWSDL.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://j2ee.netbeans.org/wsdl/fpmlSoapAttachmentWSDL" location="fpmlSoapAttachmentWSDL.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://enterprise.netbeans.org/bpel/ManageSystemServiceWrapper" location="ManageSystemServiceWrapper.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://facade.manage.data.otc.crcc.com/" location="externalWSDL/ManageSystem/ManageSystemService.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <partnerLinks>
        <partnerLink name="ManageSystemService" xmlns:tns="http://enterprise.netbeans.org/bpel/ManageSystemServiceWrapper" partnerLinkType="tns:ManageSystemServiceLinkType" partnerRole="ManageSystemServiceRole"/>
        <partnerLink name="getMessageFormJMSPL" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/getIncomingMessageFromJMSWSDL" partnerLinkType="tns:getIncomingMessageFromJMSWSDL" myRole="JMSInPortTypeRole">
            <documentation>This PL get the message from OTCIncomingTopicQUEUE message by message</documentation>
        </partnerLink>
        <partnerLink name="FpMLParser" xmlns:tns="http://enterprise.netbeans.org/bpel/FpMLParserWrapper" partnerLinkType="tns:FpMLParserLinkType" partnerRole="FpMLParserRole"/>
        <partnerLink name="UnknownError" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/putToUnknownErrorJMSWSDL" partnerLinkType="tns:putToUnknownErrorJMSWSDL" partnerRole="JMSOutPortTypeRole"/>
        <partnerLink name="soapAttachment" xmlns:tns="http://j2ee.netbeans.org/wsdl/fpmlSoapAttachmentWSDL" partnerLinkType="tns:jdbcpartner" partnerRole="jdbcPortTypeRole"/>
        <partnerLink name="ParsingErrorJMS" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/putToParsingErrorJMSWSDL" partnerLinkType="tns:putToParsingErrorJMSWSDL" partnerRole="JMSOutPortTypeRole"/>
        <partnerLink name="RiskErrorJMS" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/putToRiskErrorJMSWSDL" partnerLinkType="tns:putToRiskErrorJMSWSDL" partnerRole="JMSOutPortTypeRole"/>
        <partnerLink name="RiskEJB" xmlns:tns="http://enterprise.netbeans.org/bpel/RiskServiceWSWrapper" partnerLinkType="tns:RiskServiceWSLinkType" partnerRole="RiskServiceWSRole"/>
        <partnerLink name="processTradeConfirmed" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/processTradeConfirmedWSDL" partnerLinkType="tns:processTradeConfirmedWSDL" partnerRole="processTradeConfirmedWSDLPortTypeRole"/>
    </partnerLinks>
    <variables>
        <variable name="responseManageParseFpMLNonValidatedOut" xmlns:tns="http://parsing.trade.otc.crcc.com/" messageType="tns:parseFpMLNonValidatedResponse"/>
        <variable name="requestManageParseFpMLNonValidatedOut" xmlns:tns="http://parsing.trade.otc.crcc.com/" messageType="tns:parseFpMLNonValidatedResponse"/>
        <variable name="requestManageParseFpMLNonValidatedIn" xmlns:tns="http://parsing.trade.otc.crcc.com/" messageType="tns:parseFpMLNonValidated"/>
        <variable name="requestManageJMSOutOperationIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/putToRiskErrorJMSWSDL" messageType="tns:JMSInputMessage"/>
        <variable name="requestGetCurrentSystemStateOut" messageType="ns6:getCurrentSystemStateResponse"/>
        <variable name="requestGetCurrentSystemStateIn" messageType="ns6:getCurrentSystemState"/>
        <variable name="requestJMSOutOperationIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/putToRiskErrorJMSWSDL" messageType="tns:JMSInputMessage"/>
        <variable name="responseInsertSoapAttachmentParsingOut" xmlns:tns="http://j2ee.netbeans.org/wsdl/fpmlSoapAttachmentWSDL" messageType="tns:insertRetMsg"/>
        <variable name="requestInsertSoapAttachmentParsingIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/fpmlSoapAttachmentWSDL" messageType="tns:inputMsg"/>
        <variable name="responseInsertSoapAttachmentOut" xmlns:tns="http://j2ee.netbeans.org/wsdl/fpmlSoapAttachmentWSDL" messageType="tns:insertRetMsg"/>
        <variable name="requestInsertSoapAttachmentIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/fpmlSoapAttachmentWSDL" messageType="tns:inputMsg"/>
        <variable name="responseInsertMessageFPMLErrorOut" xmlns:tns="http://facade.data.risk.otc.crcc.com/" messageType="tns:insertMessageFPMLResponse"/>
        <variable name="requestInsertMessageFPMLErrorIn" xmlns:tns="http://facade.data.risk.otc.crcc.com/" messageType="tns:insertMessageFPML"/>
        <variable name="putUnknownErrorJMSOutOperationIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/putToUnknownErrorJMSWSDL" messageType="tns:JMSInputMessage"/>
        <variable name="responseParseFpMLNonValidatedOut" xmlns:tns="http://parsing.trade.otc.crcc.com/" messageType="tns:parseFpMLNonValidatedResponse"/>
        <variable name="requestParseFpMLNonValidatedIn" xmlns:tns="http://parsing.trade.otc.crcc.com/" messageType="tns:parseFpMLNonValidated"/>
        <variable name="requestRiskJMSOutOperationIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/putToRiskErrorJMSWSDL" messageType="tns:JMSInputMessage"/>
        <variable name="requestParsingJMSOutOperationIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/putToParsingErrorJMSWSDL" messageType="tns:JMSInputMessage"/>
        <variable name="requestProcessTradeConfirmedWSDLOperationIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/processTradeConfirmedWSDL" messageType="tns:processTradeConfirmedWSDLOperationRequest"/>
        <variable name="responseInsertMessageFPMLOut" xmlns:tns="http://facade.data.risk.otc.crcc.com/" messageType="tns:insertMessageFPMLResponse"/>
        <variable name="requestInsertMessageFPMLIn" xmlns:tns="http://facade.data.risk.otc.crcc.com/" messageType="tns:insertMessageFPML"/>
        <variable name="responseValidateMemberOut" xmlns:tns="http://facade.data.risk.otc.crcc.com/" messageType="tns:validateMemberResponse"/>
        <variable name="requestValidateMemberIn" xmlns:tns="http://facade.data.risk.otc.crcc.com/" messageType="tns:validateMember"/>
        <variable name="responseEvaluateRiskOut" xmlns:tns="http://facade.data.risk.otc.crcc.com/" messageType="tns:evaluateRiskResponse"/>
        <variable name="requestEvaluateRiskIn" xmlns:tns="http://facade.data.risk.otc.crcc.com/" messageType="tns:evaluateRisk"/>
        <variable name="responseParseFpMLOut" xmlns:tns="http://parsing.trade.otc.crcc.com/" messageType="tns:parseFpMLResponse"/>
        <variable name="requestParseFpMLIn" xmlns:tns="http://parsing.trade.otc.crcc.com/" messageType="tns:parseFpML"/>
        <variable name="JMSInOperationIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/getIncomingMessageFromJMSWSDL" messageType="tns:JMSInputMessage"/>
    </variables>
    <faultHandlers>
        <catch xmlns:tns="http://parsing.trade.otc.crcc.com/" faultMessageType="tns:ValidationException" faultName="tns:ValidationException" faultVariable="parsingException">
            <documentation>This catch manages every validation exception generated by FpML parser not related 
with a not well formed XML, just considers the validation issues, is a not well formed exception 
is throws it be catche by an internal </documentation>
            <sequence name="handlingParsingException">
                <assign name="parsingError2JMS">
                    <documentation>Catch a parsing exception and send to JMS queue in order to other process the parsing error</documentation>
                    <copy>
                        <from variable="parsingException" part="fault"/>
                        <to>$requestParsingJMSOutOperationIn.part1/ns4:validationException</to>
                    </copy>
                    <copy>
                        <from>$JMSInOperationIn.part1/ns0:headerCRCC/ns3:EndpointReference</from>
                        <to>$requestParsingJMSOutOperationIn.part1/ns4:callbackAddress</to>
                    </copy>
                    <copy>
                        <from>$JMSInOperationIn.part1/ns0:novateTrade/ns0:fpMLMessage</from>
                        <to>$requestParseFpMLNonValidatedIn.parameters/fpml</to>
                    </copy>
                </assign>
                <if name="ifNotDefaultProcessingErrorCode">
                    <documentation>If the error was not a default parsing error then execute a parsing FPML, otherwise create a Unknown parsing error</documentation>
                    <condition>''200'' !!= $parsingException.fault/reasonCode</condition>
                    <sequence name="noDefaultErrorSeq">
                        <documentation>Execute some activities when the string is well formed</documentation>
                        <invoke name="toParseNonValidated" partnerLink="FpMLParser" operation="parseFpMLNonValidated" portType="tns:FpMLParser" inputVariable="requestParseFpMLNonValidatedIn" outputVariable="responseParseFpMLNonValidatedOut">
                            <documentation>To parse the string without validate fpml</documentation>
                        </invoke>
                        <assign name="settingFpMLMessage">
                            <documentation>Set up the fpml string</documentation>
                            <copy>
                                <from>$responseParseFpMLNonValidatedOut.parameters/return</from>
                                <to>$requestInsertMessageFPMLErrorIn.parameters/rtc</to>
                            </copy>
                        </assign>
                        <invoke name="toInsertFpMLMessage" partnerLink="RiskEJB" operation="insertMessageFPML" xmlns:tns="http://facade.data.risk.otc.crcc.com/" portType="tns:RiskServiceWS" inputVariable="requestInsertMessageFPMLErrorIn" outputVariable="responseInsertMessageFPMLErrorOut">
                            <documentation>Insert the incoming message on a databasepossible to insert message that no contain the sender information, in this case the system save the recors without sender information</documentation>
                        </invoke>
                        <assign name="settingInsertSoapAttachmentParsing">
                            <copy>
                                <from>string($JMSInOperationIn.part1/ns0:headerCRCC/ns3:EndpointReference/ns3:ServiceName/@PortName)</from>
                                <to>$requestInsertSoapAttachmentParsingIn.part/ns5:FPML_SOAP_ATTACHMENT_Record/ns5:portName</to>
                            </copy>
                            <copy>
                                <from>string($JMSInOperationIn.part1/ns0:headerCRCC/ns3:EndpointReference/ns3:ServiceName)</from>
                                <to>$requestInsertSoapAttachmentParsingIn.part/ns5:FPML_SOAP_ATTACHMENT_Record/ns5:serviceName</to>
                            </copy>
                            <copy>
                                <from>string($JMSInOperationIn.part1/ns0:headerCRCC/ns3:EndpointReference/ns3:PortType)</from>
                                <to>$requestInsertSoapAttachmentParsingIn.part/ns5:FPML_SOAP_ATTACHMENT_Record/ns5:portType</to>
                            </copy>
                            <copy>
                                <from>string($JMSInOperationIn.part1/ns0:headerCRCC/ns3:EndpointReference/ns3:Address)</from>
                                <to>$requestInsertSoapAttachmentParsingIn.part/ns5:FPML_SOAP_ATTACHMENT_Record/ns5:serviceAddress</to>
                            </copy>
                            <copy>
                                <from>$JMSInOperationIn.part1/ns0:novateTrade/ns0:fpMLMessage</from>
                                <to>$requestInsertSoapAttachmentParsingIn.part/ns5:FPML_SOAP_ATTACHMENT_Record/ns5:message</to>
                            </copy>
                            <copy>
                                <from>$responseInsertMessageFPMLErrorOut.parameters/return</from>
                                <to>$requestInsertSoapAttachmentParsingIn.part/ns5:FPML_SOAP_ATTACHMENT_Record/ns5:message_FK</to>
                            </copy>
                        </assign>
                        <invoke name="toInvokeSoapAttachmentParsing" partnerLink="soapAttachment" operation="insert" xmlns:tns="http://j2ee.netbeans.org/wsdl/fpmlSoapAttachmentWSDL" portType="tns:jdbcPortType" inputVariable="requestInsertSoapAttachmentParsingIn" outputVariable="responseInsertSoapAttachmentParsingOut"/>
                        <assign name="settingParsingJMS">
                            <documentation>Set up the message tha will be send it to JMS parsing error</documentation>
                            <copy>
                                    <from>$responseParseFpMLNonValidatedOut.parameters/return/ns1:header</from>
                                        <to>$requestParsingJMSOutOperationIn.part1/ns4:requestMessageHeader</to>
                                </copy>
                            <copy>
                                <from variable="parsingException" part="fault"/>
                                <to>$requestParsingJMSOutOperationIn.part1/ns4:validationException</to>
                            </copy>
                            <copy>
                                <from>$JMSInOperationIn.part1/ns0:headerCRCC/ns3:EndpointReference</from>
                                <to>$requestParsingJMSOutOperationIn.part1/ns4:callbackAddress</to>
                            </copy>
                            <copy>
                                <from>$responseInsertMessageFPMLErrorOut.parameters/return</from>
                                <to>$requestParsingJMSOutOperationIn.part1/ns4:rtcInternalID</to>
                            </copy>
                        </assign>
                        <invoke name="toPutParsingJMS" partnerLink="ParsingErrorJMS" operation="JMSOutOperation" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/putToParsingErrorJMSWSDL" portType="tns:JMSOutPortType" inputVariable="requestParsingJMSOutOperationIn">
                            <documentation>Put the parsing error to JMS in order to process it</documentation>
                        </invoke>
                    </sequence>
                    <else>
                        <sequence name="Sequence4">
                            <assign name="settingUnknownError">
                                <sxt:trace>
                                    <sxt:log level="warning" location="onStart">
                                        <from>concat(''FPML NOT WELL FORMED: '', $JMSInOperationIn.part1/ns0:novateTrade/ns0:fpMLMessage)</from>
                                    </sxt:log>
                                </sxt:trace>
                                <copy>
                                    <from>$JMSInOperationIn.part1/ns0:novateTrade/ns0:fpMLMessage</from>
                                    <to variable="putUnknownErrorJMSOutOperationIn" part="part1"/>
                                </copy>
                            </assign>
                            <invoke name="toPutUnknownErrorrJMS" partnerLink="UnknownError" operation="JMSOutOperation" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/putToUnknownErrorJMSWSDL" portType="tns:JMSOutPortType" inputVariable="putUnknownErrorJMSOutOperationIn"/>
                        </sequence>
                    </else>
                </if>
            </sequence>
        </catch>
        <catch xmlns:tns="http://facade.data.risk.otc.crcc.com/" faultMessageType="tns:ValidationException" faultVariable="riskException" faultName="tns:ValidationException">
            <documentation>This catch manages every validation exception generated by Risk  EJB  </documentation>
            <sequence name="handlingRiskError">
                <assign name="riskError2JMS">
                    <copy>
                        <from variable="riskException" part="fault"/>
                        <to>$requestRiskJMSOutOperationIn.part1/ns4:validationException</to>
                    </copy>
                    <copy>
                        <from>$JMSInOperationIn.part1/ns0:headerCRCC/ns3:EndpointReference</from>
                        <to>$requestRiskJMSOutOperationIn.part1/ns4:callbackAddress</to>
                    </copy>
                    <copy>
                        <from>$responseParseFpMLOut.parameters/return/ns1:header</from>
                        <to>$requestRiskJMSOutOperationIn.part1/ns4:requestMessageHeader</to>
                    </copy>
                </assign>
                <if name="IfNotMessageAlreadyExist">
                    <condition>''513'' !!= $riskException.fault/reasonCode</condition>
                    <assign name="setPriorMessage">
                        <copy>
                            <from>$responseInsertMessageFPMLOut.parameters/return</from>
                            <to>$requestRiskJMSOutOperationIn.part1/ns4:rtcInternalID</to>
                        </copy>
                    </assign>
                </if>
                <invoke name="toPutRiskJMS" partnerLink="RiskErrorJMS" operation="JMSOutOperation" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/putToRiskErrorJMSWSDL" portType="tns:JMSOutPortType" inputVariable="requestRiskJMSOutOperationIn"/>
            </sequence>
        </catch>
        <catch faultName="ns6:ValidationException" faultMessageType="ns6:ValidationException" faultVariable="manageSystemValidation">
            <documentation>Exception to System available</documentation>
            <sequence name="HandlingManageSystemExeception">
                <assign name="parseFpmlNoValidate">
                    <copy>
                        <from>$JMSInOperationIn.part1/ns0:novateTrade/ns0:fpMLMessage</from>
                        <to>$requestManageParseFpMLNonValidatedIn.parameters/fpml</to>
                    </copy>
                </assign>
                <invoke name="toParseFpmlNonValidated" partnerLink="FpMLParser" operation="parseFpMLNonValidated" xmlns:tns="http://parsing.trade.otc.crcc.com/" portType="tns:FpMLParser" inputVariable="requestManageParseFpMLNonValidatedIn" outputVariable="responseManageParseFpMLNonValidatedOut"/>
                <assign name="toSendManageError">
                    <copy>
                        <from>$responseManageParseFpMLNonValidatedOut.parameters/return/ns1:header</from>
                        <to>$requestManageJMSOutOperationIn.part1/ns4:requestMessageHeader</to>
                    </copy>
                    <copy>
                        <from>$JMSInOperationIn.part1/ns0:headerCRCC/ns3:EndpointReference</from>
                        <to>$requestManageJMSOutOperationIn.part1/ns4:callbackAddress</to>
                    </copy>
                    <copy>
                        <from>$manageSystemValidation.fault/additionalData</from>
                        <to>$requestManageJMSOutOperationIn.part1/ns4:validationException/additionalData</to>
                    </copy>
                    <copy>
                        <from>$manageSystemValidation.fault/location</from>
                        <to>$requestManageJMSOutOperationIn.part1/ns4:validationException/location</to>
                    </copy>
                    <copy>
                        <from>$manageSystemValidation.fault/message</from>
                        <to>$requestManageJMSOutOperationIn.part1/ns4:validationException/message</to>
                    </copy>
                    <copy>
                        <from>$manageSystemValidation.fault/reasonCode</from>
                        <to>$requestManageJMSOutOperationIn.part1/ns4:validationException/reasonCode</to>
                    </copy>
                    <copy>
                        <from>$manageSystemValidation.fault/semanticRuleDescription</from>
                        <to>$requestManageJMSOutOperationIn.part1/ns4:validationException/semanticRuleDescription</to>
                    </copy>
                    <copy>
                        <from>$manageSystemValidation.fault/semanticRuleId</from>
                        <to>$requestManageJMSOutOperationIn.part1/ns4:validationException/semanticRuleId</to>
                    </copy>
                </assign>
                <invoke name="toPutRiskJMSManage" partnerLink="RiskErrorJMS" operation="JMSOutOperation" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/putToRiskErrorJMSWSDL" portType="tns:JMSOutPortType" inputVariable="requestManageJMSOutOperationIn"/>
            </sequence>
        </catch>
    </faultHandlers>
    <sequence>
        <receive name="getMessageFromJMS" createInstance="yes" partnerLink="getMessageFormJMSPL" operation="JMSInOperation" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/getIncomingMessageFromJMSWSDL" portType="tns:JMSInPortType" variable="JMSInOperationIn">
            <documentation>Get the message from JMS to BPEL</documentation>
            <sxt:trace>
                <sxt:log level="fine" location="onStart">
                    <from>concat(''START getMessageFromJMS FpmL :'', sxxf:current-dateTime())</from>
                </sxt:log>
            </sxt:trace>
        </receive>
        <assign name="initializeRequestGetSystem">
            <copy>
                <from>''</from>
                <to variable="requestGetCurrentSystemStateIn" part="parameters"/>
            </copy>
        </assign>
        <invoke name="toGetManageSystem" partnerLink="ManageSystemService" operation="getCurrentSystemState" portType="ns6:ManageSystemService" inputVariable="requestGetCurrentSystemStateIn" outputVariable="requestGetCurrentSystemStateOut">
            <documentation>To get the OTC current system state, if not avalaible an exception is thrown, it is handled by Handler Manage System Exception</documentation>
        </invoke>
        <assign name="JMS2Parser">
            <documentation>Get the fpml String and put it on incoming parameter of FpML parser</documentation>
            <copy>
                <from>$JMSInOperationIn.part1/ns0:novateTrade/ns0:fpMLMessage</from>
                <to>$requestParseFpMLIn.parameters/fpml</to>
            </copy>
        </assign>
        <invoke name="toParseFpML" partnerLink="FpMLParser" operation="parseFpML" xmlns:tns="http://parsing.trade.otc.crcc.com/" portType="tns:FpMLParser" inputVariable="requestParseFpMLIn" outputVariable="responseParseFpMLOut">
            <documentation>Invoke parse FpmL that can thorw a handling Parsing Exception</documentation>
            <sxt:trace>
                <sxt:log level="fine" location="onStart">
                    <from>concat(''START Parsing FpmL :'', sxxf:current-dateTime())</from>
                </sxt:log>
                <sxt:log level="fine" location="onComplete">
                    <from>concat(''FINISHED  Parsing FpmL :'', sxxf:current-dateTime())</from>
                </sxt:log>
            </sxt:trace>
        </invoke>
        <assign name="Parser2Risk">
            <documentation>once time the parser return a RTC that message is sent to Risk facade to make some risk validation</documentation>
            <copy>
                <from>$responseParseFpMLOut.parameters/return</from>
                <to>$requestValidateMemberIn.parameters/rtc</to>
            </copy>
            <copy>
                <from>$responseParseFpMLOut.parameters/return</from>
                <to>$requestEvaluateRiskIn.parameters/rtc</to>
            </copy>
            <copy>
                <from>$responseParseFpMLOut.parameters/return</from>
                <to>$requestInsertMessageFPMLIn.parameters/rtc</to>
            </copy>
        </assign>
        <invoke name="toInsertFpML" partnerLink="RiskEJB" operation="insertMessageFPML" xmlns:tns="http://facade.data.risk.otc.crcc.com/" portType="tns:RiskServiceWS" inputVariable="requestInsertMessageFPMLIn" outputVariable="responseInsertMessageFPMLOut">
            <documentation>This method insert the incoming message on database</documentation>
            <sxt:trace>
                <sxt:log level="fine" location="onStart">
                    <from>concat(''START toInsertFpML  :'', sxxf:current-dateTime())</from>
                </sxt:log>
                <sxt:log level="fine" location="onComplete">
                    <from>concat(''FINISHED  toInsertFpML :'', sxxf:current-dateTime())</from>
                </sxt:log>
            </sxt:trace>
        </invoke>
        <assign name="settingSoapAttachment">
            <documentation>setting the soap attachmente by including messageFK</documentation>
            <copy>
                <from>string($JMSInOperationIn.part1/ns0:headerCRCC/ns3:EndpointReference/ns3:ServiceName/@PortName)</from>
                <to>$requestInsertSoapAttachmentIn.part/ns5:FPML_SOAP_ATTACHMENT_Record/ns5:portName</to>
            </copy>
            <copy>
                <from>string($JMSInOperationIn.part1/ns0:headerCRCC/ns3:EndpointReference/ns3:ServiceName)</from>
                <to>$requestInsertSoapAttachmentIn.part/ns5:FPML_SOAP_ATTACHMENT_Record/ns5:serviceName</to>
            </copy>
            <copy>
                <from>string($JMSInOperationIn.part1/ns0:headerCRCC/ns3:EndpointReference/ns3:PortType)</from>
                <to>$requestInsertSoapAttachmentIn.part/ns5:FPML_SOAP_ATTACHMENT_Record/ns5:portType</to>
            </copy>
            <copy>
                <from>string($JMSInOperationIn.part1/ns0:headerCRCC/ns3:EndpointReference/ns3:Address)</from>
                <to>$requestInsertSoapAttachmentIn.part/ns5:FPML_SOAP_ATTACHMENT_Record/ns5:serviceAddress</to>
            </copy>
            <copy>
                <from>$responseInsertMessageFPMLOut.parameters/return</from>
                <to>$requestInsertSoapAttachmentIn.part/ns5:FPML_SOAP_ATTACHMENT_Record/ns5:message_FK</to>
            </copy>
            <copy>
                <from>$JMSInOperationIn.part1/ns0:novateTrade/ns0:fpMLMessage</from>
                <to>$requestInsertSoapAttachmentIn.part/ns5:FPML_SOAP_ATTACHMENT_Record/ns5:message</to>
            </copy>
        </assign>
        <invoke name="toInsertSoapAttachment" partnerLink="soapAttachment" operation="insert" xmlns:tns="http://j2ee.netbeans.org/wsdl/fpmlSoapAttachmentWSDL" portType="tns:jdbcPortType" inputVariable="requestInsertSoapAttachmentIn" outputVariable="responseInsertSoapAttachmentOut">
            <documentation>to insert the soapMessage</documentation>
        </invoke>
        <invoke name="toValidateMembers" partnerLink="RiskEJB" operation="validateMember" xmlns:tns="http://facade.data.risk.otc.crcc.com/" portType="tns:RiskServiceWS" inputVariable="requestValidateMemberIn" outputVariable="responseValidateMemberOut">
            <documentation>To validate if every member included on RTC message exist on OTC database</documentation>
            <sxt:trace>
                <sxt:log level="fine" location="onStart">
                    <from>concat(''START toValidateMembers  :'', sxxf:current-dateTime())</from>
                </sxt:log>
                <sxt:log level="fine" location="onComplete">
                    <from>concat(''FINISHED  toValidateMembers :'', sxxf:current-dateTime())</from>
                </sxt:log>
            </sxt:trace>
        </invoke>            
        <invoke name="toEvaluateRisk" partnerLink="RiskEJB" operation="evaluateRisk" xmlns:tns="http://facade.data.risk.otc.crcc.com/" portType="tns:RiskServiceWS" inputVariable="requestEvaluateRiskIn" outputVariable="responseEvaluateRiskOut">
            <documentation>To verify the current risk of member</documentation>
            <sxt:trace>
                <sxt:log level="fine" location="onStart">
                    <from>concat(''START toEvaluateRisk :'', sxxf:current-dateTime())</from>
                </sxt:log>
                <sxt:log level="fine" location="onComplete">
                    <from>concat(''FINISHED  toEvaluateRisk :'', sxxf:current-dateTime())</from>
                </sxt:log>
            </sxt:trace>
        </invoke>
        <assign name="EvaluateRisk2ProcessTradeC">
            <documentation>If the evaluate risk was sucessfull then get the retun value an assign it to the process trade confirmed process.</documentation>
            <copy>
                <from>$responseEvaluateRiskOut.parameters/return</from>
                <to>$requestProcessTradeConfirmedWSDLOperationIn.tradeConfirmedIn/ns2:tradeConfirmed</to>
            </copy>
            <copy>
                <from>$JMSInOperationIn.part1/ns0:headerCRCC/ns3:EndpointReference</from>
                <to>$requestProcessTradeConfirmedWSDLOperationIn.tradeConfirmedIn/ns2:header/ns3:EndpointReference</to>
            </copy>
            <copy>
                <from>$responseInsertMessageFPMLOut.parameters/return</from>
                <to>$requestProcessTradeConfirmedWSDLOperationIn.tradeConfirmedIn/ns2:rtcInternalID</to>
            </copy>
        </assign>
        <invoke name="toProcessTradeConfirmed" partnerLink="processTradeConfirmed" operation="processTradeConfirmedWSDLOperation" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/processTradeConfirmedWSDL" portType="tns:processTradeConfirmedWSDLPortType" inputVariable="requestProcessTradeConfirmedWSDLOperationIn">
            <documentation>Invoke the bpel that process the confirmed trade</documentation>
            <sxt:trace>
                <sxt:log level="fine" location="onStart">
                    <from>concat(''START ProcessTradeConfirmed :'', sxxf:current-dateTime())</from>
                </sxt:log>
                <sxt:log level="fine" location="onComplete">
                    <from>concat(''FINISHED  ProcessTradeConfirmed :'', sxxf:current-dateTime())</from>
                </sxt:log>
            </sxt:trace>
        </invoke>        
    </sequence>
</process>
'! !

!BPEL20BpelAnalyzerTest2 methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 11/12/2014 09:47'!
wsdl_processNovateTradeProcess_getIncomingMessageFromJMSWSDL
^ '<definitions name="getIncomingMessageFromJMSWSDL" 
   targetNamespace="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/getIncomingMessageFromJMSWSDL"
   xmlns="http://schemas.xmlsoap.org/wsdl/"
   xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/"
   xmlns:xsd="http://www.w3.org/2001/XMLSchema" 
   xmlns:jms="http://schemas.sun.com/jbi/wsdl-extensions/jms/" 	 	   	xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/getIncomingMessageFromJMSWSDL" 
	xmlns:plnk="http://docs.oasis-open.org/wsbpel/2.0/plnktype" xmlns:ns0="http://xml.netbeans.org/schema/novateTradeComposed">
    <types>
        <xsd:schema targetNamespace="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/getIncomingMessageFromJMSWSDL">
            <xsd:import namespace="http://xml.netbeans.org/schema/novateTradeComposed" schemaLocation="novateTradeComposed.xsd"/>
        </xsd:schema>
    </types>   
    <message name="JMSInputMessage">
        <part name="part1" element="ns0:novateTradeComposed"/>
    </message>    
    <portType name="JMSInPortType">
        <operation name="JMSInOperation">
            <input name="input1" message="tns:JMSInputMessage"/>
        </operation>
    </portType>
    <binding name="JMSInBinding" type="tns:JMSInPortType">
        <jms:binding/>
        <operation name="JMSInOperation">
            <jms:operation destination="OTCIncomingMessagesQueue" destinationType="Queue" transaction="XATransaction" concurrencyMode="cc" maxConcurrentConsumers="30"/>
            <input name="input1">
                <jms:message messageType="TextMessage" textPart="part1"/>
            </input>
        </operation>
    </binding>
    <service name="JMSInService">
        <port name="getIncomingMessageFromJMSWSDL_InPort" binding="tns:JMSInBinding">
            <jms:address connectionURL="${JmsDefaultURL}" username="guest" password="guest">
                <jms:jmsjcaOptions><!![CDATA[]]></jms:jmsjcaOptions>
            </jms:address>
        </port>
    </service>
    <plnk:partnerLinkType name="getIncomingMessageFromJMSWSDL">
        <!!-- A partner link type is automatically generated when a new port type is added. Partner link types are used by BPEL processes. 
In a BPEL process, a partner link represents the interaction between the BPEL process and a partner service. Each partner link is associated with a partner link type.
A partner link type characterizes the conversational relationship between two services. The partner link type can have one or two roles.-->
        <plnk:role name="JMSInPortTypeRole" portType="tns:JMSInPortType"/>
    </plnk:partnerLinkType>
</definitions>
'! !

BPEL20BPSourceTest subclass: #BPEL20BpelAnalyzerTest3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-Tests-BPEL20-source'!

!BPEL20BpelAnalyzerTest3 methodsFor: 'bpel' stamp: 'AlvaroJosePeraltaOcampo 11/12/2014 09:46'!
bpel_novateTrade
^ '<?xml version="1.0" encoding="UTF-8"?>
<process
    name="novateTrade"
    targetNamespace="http://enterprise.netbeans.org/bpel/novateTradeProcess/novateTrade"
    xmlns="http://docs.oasis-open.org/wsbpel/2.0/process/executable"
    xmlns:xsd="http://www.w3.org/2001/XMLSchema"
    xmlns:sxt="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/Trace" 
    xmlns:sxed="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/Editor"
    xmlns:sxeh="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/ErrorHandling"
    xmlns:tns="http://enterprise.netbeans.org/bpel/novateTradeProcess/novateTrade" 
    xmlns:ns0="http://xml.netbeans.org/schema/xsdNovateTrade" 
    xmlns:ns1="http://schemas.xmlsoap.org/ws/2004/08/addressing" 
    xmlns:sxxf="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/XPathFunctions">
    <import namespace="http://j2ee.netbeans.org/wsdl/novateTrade-bpel/novateTradeWSDL" 
    location="externalWSDL/novateTradeWSDL.wsdl" 
    importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://j2ee.netbeans.org/wsdl/novateTradeProcess/putIncomingMessageToJMS" 
    location="putIncomingMessageToJMS.wsdl" 
    importType="http://schemas.xmlsoap.org/wsdl/"/>
    <partnerLinks>
        <partnerLink name="putToJMS"
        xmlns:tns="http://j2ee.netbeans.org/wsdl/novateTradeProcess/putIncomingMessageToJMS" 
        partnerLinkType="tns:putIncomingMessageToJMS" 
        partnerRole="JMSOutPortTypeRole" 
        myRole="JMSOutPortTypeRole"/>
        <partnerLink name="novateTradePL" 
        xmlns:tns="http://j2ee.netbeans.org/wsdl/novateTrade-bpel/novateTradeWSDL" 
        partnerLinkType="tns:novateTradeWSDL" 
        myRole="novateTradeWSDLPortTypeRole"/>
    </partnerLinks>
    <variables>
        <variable name="requestNovateTradeIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/novateTrade-bpel/novateTradeWSDL" messageType="tns:novateTradeRequest"/>
        <variable name="requestJMSOutOperationIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/novateTradeProcess/putIncomingMessageToJMS" messageType="tns:JMSInputMessage"/>
    </variables>
    <sequence>
        <receive name="getIncomingMessage" createInstance="yes" partnerLink="novateTradePL" operation="novateTrade" xmlns:tns="http://j2ee.netbeans.org/wsdl/novateTrade-bpel/novateTradeWSDL" portType="tns:novateTradeWSDLPortType" variable="requestNovateTradeIn">
            <documentation>This activity get the incoming message for external client</documentation>
            <sxt:trace>
                <sxt:log level="fine" location="onStart">
                    <from>concat(''START: getIncomingMessage RTC  End of statement list encounted ->:'', sxxf:current-dateTime())</from>
                </sxt:log>                
            </sxt:trace>
        </receive>
        <assign name="settingJMS">
            <copy>
                <from>$requestNovateTradeIn.rtc/ns0:fpMLMessage</from>
                <to>$requestJMSOutOperationIn.part1/ns0:novateTrade/ns0:fpMLMessage</to>
            </copy>
            <copy>
                <from>$requestNovateTradeIn.headerPart/ns1:EndpointReference</from>
                <to>$requestJMSOutOperationIn.part1/ns0:headerCRCC/ns1:EndpointReference</to>
            </copy>
        </assign>
        <invoke name="toPutToJMS" partnerLink="putToJMS" operation="JMSOutOperation" xmlns:tns="http://j2ee.netbeans.org/wsdl/novateTradeProcess/putIncomingMessageToJMS" portType="tns:JMSOutPortType" inputVariable="requestJMSOutOperationIn">
            <documentation>Invoke the PL to put the incoming message to JMS QUEUE</documentation>
            <sxt:trace>
                <sxt:log level="fine" location="onComplete">
                    <from>concat(''FINISHED: getIncomingMessage putting on JMS :'', sxxf:current-dateTime())</from>
                </sxt:log>                
            </sxt:trace>
        </invoke>
    </sequence>
</process>
'! !

!BPEL20BpelAnalyzerTest3 methodsFor: 'bpel' stamp: 'AlvaroJosePeraltaOcampo 11/12/2014 09:46'!
bpel_processNovateTradeProcess
^ '<?xml version="1.0" encoding="UTF-8"?>
<process
    name="processNovateTradeProcess"
    targetNamespace="http://enterprise.netbeans.org/bpel/processNovateTradeProcess/processNovateTradeProcess"
    xmlns="http://docs.oasis-open.org/wsbpel/2.0/process/executable"
    xmlns:xsd="http://www.w3.org/2001/XMLSchema"
    xmlns:sxt="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/Trace" 
    xmlns:sxed="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/Editor"
    xmlns:sxeh="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/ErrorHandling"
    xmlns:tns="http://enterprise.netbeans.org/bpel/processNovateTradeProcess/processNovateTradeProcess" 
    xmlns:ns0="http://xml.netbeans.org/schema/xsdNovateTrade" 
    xmlns:ns1="http://www.fpml.org/2008/FpML-4-5" 
    xmlns:ns2="http://xml.netbeans.org/schema/processTradeConfirmed" 
    xmlns:ns3="http://schemas.xmlsoap.org/ws/2004/08/addressing" 
    xmlns:ns4="http://xml.netbeans.org/schema/processOTCError" 
    xmlns:sxxf="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/XPathFunctions" xmlns:ns5="http://j2ee.netbeans.org/xsd/tableSchema" xmlns:ns6="http://facade.manage.data.otc.crcc.com/">
    <documentation>This process is a sequence of activities for novate a trade</documentation>
    <import namespace="http://enterprise.netbeans.org/bpel/FpMLParserWrapper" location="FpMLParserWrapper.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://parsing.trade.otc.crcc.com/" location="externalWSDL/FpMLParser/FpMLParser.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://enterprise.netbeans.org/bpel/MeffServiceWrapper" location="MeffServiceWrapper.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://facade.data.otc.crcc.com/" location="externalWSDL/commons/MeffService.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/getIncomingMessageFromJMSWSDL" location="getIncomingMessageFromJMSWSDL.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://enterprise.netbeans.org/bpel/RiskServiceWSWrapper" location="RiskServiceWSWrapper.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://facade.data.risk.otc.crcc.com/" location="externalWSDL/riskEJB/RiskServiceWS.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/processTradeConfirmedWSDL" location="processTradeConfirmedWSDL.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/putToParsingErrorJMSWSDL" location="putToParsingErrorJMSWSDL.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/putToRiskErrorJMSWSDL" location="putToRiskErrorJMSWSDL.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/putToUnknownErrorJMSWSDL" location="putToUnknownErrorJMSWSDL.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://j2ee.netbeans.org/wsdl/fpmlSoapAttachmentWSDL" location="fpmlSoapAttachmentWSDL.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://enterprise.netbeans.org/bpel/ManageSystemServiceWrapper" location="ManageSystemServiceWrapper.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://facade.manage.data.otc.crcc.com/" location="externalWSDL/ManageSystem/ManageSystemService.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <partnerLinks>
        <partnerLink name="ManageSystemService" xmlns:tns="http://enterprise.netbeans.org/bpel/ManageSystemServiceWrapper" partnerLinkType="tns:ManageSystemServiceLinkType" partnerRole="ManageSystemServiceRole"/>
        <partnerLink name="getMessageFormJMSPL" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/getIncomingMessageFromJMSWSDL" partnerLinkType="tns:getIncomingMessageFromJMSWSDL" myRole="JMSInPortTypeRole">
            <documentation>This PL get the message from OTCIncomingTopicQUEUE message by message</documentation>
        </partnerLink>
        <partnerLink name="FpMLParser" xmlns:tns="http://enterprise.netbeans.org/bpel/FpMLParserWrapper" partnerLinkType="tns:FpMLParserLinkType" partnerRole="FpMLParserRole"/>
        <partnerLink name="UnknownError" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/putToUnknownErrorJMSWSDL" partnerLinkType="tns:putToUnknownErrorJMSWSDL" partnerRole="JMSOutPortTypeRole"/>
        <partnerLink name="soapAttachment" xmlns:tns="http://j2ee.netbeans.org/wsdl/fpmlSoapAttachmentWSDL" partnerLinkType="tns:jdbcpartner" partnerRole="jdbcPortTypeRole"/>
        <partnerLink name="ParsingErrorJMS" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/putToParsingErrorJMSWSDL" partnerLinkType="tns:putToParsingErrorJMSWSDL" partnerRole="JMSOutPortTypeRole"/>
        <partnerLink name="RiskErrorJMS" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/putToRiskErrorJMSWSDL" partnerLinkType="tns:putToRiskErrorJMSWSDL" partnerRole="JMSOutPortTypeRole"/>
        <partnerLink name="RiskEJB" xmlns:tns="http://enterprise.netbeans.org/bpel/RiskServiceWSWrapper" partnerLinkType="tns:RiskServiceWSLinkType" partnerRole="RiskServiceWSRole"/>
        <partnerLink name="processTradeConfirmed" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/processTradeConfirmedWSDL" partnerLinkType="tns:processTradeConfirmedWSDL" partnerRole="processTradeConfirmedWSDLPortTypeRole"/>
    </partnerLinks>
    <variables>
        <variable name="responseManageParseFpMLNonValidatedOut" xmlns:tns="http://parsing.trade.otc.crcc.com/" messageType="tns:parseFpMLNonValidatedResponse"/>
        <variable name="requestManageParseFpMLNonValidatedOut" xmlns:tns="http://parsing.trade.otc.crcc.com/" messageType="tns:parseFpMLNonValidatedResponse"/>
        <variable name="requestManageParseFpMLNonValidatedIn" xmlns:tns="http://parsing.trade.otc.crcc.com/" messageType="tns:parseFpMLNonValidated"/>
        <variable name="requestManageJMSOutOperationIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/putToRiskErrorJMSWSDL" messageType="tns:JMSInputMessage"/>
        <variable name="requestGetCurrentSystemStateOut" messageType="ns6:getCurrentSystemStateResponse"/>
        <variable name="requestGetCurrentSystemStateIn" messageType="ns6:getCurrentSystemState"/>
        <variable name="requestJMSOutOperationIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/putToRiskErrorJMSWSDL" messageType="tns:JMSInputMessage"/>
        <variable name="responseInsertSoapAttachmentParsingOut" xmlns:tns="http://j2ee.netbeans.org/wsdl/fpmlSoapAttachmentWSDL" messageType="tns:insertRetMsg"/>
        <variable name="requestInsertSoapAttachmentParsingIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/fpmlSoapAttachmentWSDL" messageType="tns:inputMsg"/>
        <variable name="responseInsertSoapAttachmentOut" xmlns:tns="http://j2ee.netbeans.org/wsdl/fpmlSoapAttachmentWSDL" messageType="tns:insertRetMsg"/>
        <variable name="requestInsertSoapAttachmentIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/fpmlSoapAttachmentWSDL" messageType="tns:inputMsg"/>
        <variable name="responseInsertMessageFPMLErrorOut" xmlns:tns="http://facade.data.risk.otc.crcc.com/" messageType="tns:insertMessageFPMLResponse"/>
        <variable name="requestInsertMessageFPMLErrorIn" xmlns:tns="http://facade.data.risk.otc.crcc.com/" messageType="tns:insertMessageFPML"/>
        <variable name="putUnknownErrorJMSOutOperationIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/putToUnknownErrorJMSWSDL" messageType="tns:JMSInputMessage"/>
        <variable name="responseParseFpMLNonValidatedOut" xmlns:tns="http://parsing.trade.otc.crcc.com/" messageType="tns:parseFpMLNonValidatedResponse"/>
        <variable name="requestParseFpMLNonValidatedIn" xmlns:tns="http://parsing.trade.otc.crcc.com/" messageType="tns:parseFpMLNonValidated"/>
        <variable name="requestRiskJMSOutOperationIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/putToRiskErrorJMSWSDL" messageType="tns:JMSInputMessage"/>
        <variable name="requestParsingJMSOutOperationIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/putToParsingErrorJMSWSDL" messageType="tns:JMSInputMessage"/>
        <variable name="requestProcessTradeConfirmedWSDLOperationIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/processTradeConfirmedWSDL" messageType="tns:processTradeConfirmedWSDLOperationRequest"/>
        <variable name="responseInsertMessageFPMLOut" xmlns:tns="http://facade.data.risk.otc.crcc.com/" messageType="tns:insertMessageFPMLResponse"/>
        <variable name="requestInsertMessageFPMLIn" xmlns:tns="http://facade.data.risk.otc.crcc.com/" messageType="tns:insertMessageFPML"/>
        <variable name="responseValidateMemberOut" xmlns:tns="http://facade.data.risk.otc.crcc.com/" messageType="tns:validateMemberResponse"/>
        <variable name="requestValidateMemberIn" xmlns:tns="http://facade.data.risk.otc.crcc.com/" messageType="tns:validateMember"/>
        <variable name="responseEvaluateRiskOut" xmlns:tns="http://facade.data.risk.otc.crcc.com/" messageType="tns:evaluateRiskResponse"/>
        <variable name="requestEvaluateRiskIn" xmlns:tns="http://facade.data.risk.otc.crcc.com/" messageType="tns:evaluateRisk"/>
        <variable name="responseParseFpMLOut" xmlns:tns="http://parsing.trade.otc.crcc.com/" messageType="tns:parseFpMLResponse"/>
        <variable name="requestParseFpMLIn" xmlns:tns="http://parsing.trade.otc.crcc.com/" messageType="tns:parseFpML"/>
        <variable name="JMSInOperationIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/getIncomingMessageFromJMSWSDL" messageType="tns:JMSInputMessage"/>
    </variables>
    <faultHandlers>
        <catch xmlns:tns="http://parsing.trade.otc.crcc.com/" faultMessageType="tns:ValidationException" faultName="tns:ValidationException" faultVariable="parsingException">
            <documentation>This catch manages every validation exception generated by FpML parser not related 
with a not well formed XML, just considers the validation issues, is a not well formed exception 
is throws it be catche by an internal </documentation>
            <sequence name="handlingParsingException">
                <assign name="parsingError2JMS">
                    <documentation>Catch a parsing exception and send to JMS queue in order to other process the parsing error</documentation>
                    <copy>
                        <from variable="parsingException" part="fault"/>
                        <to>$requestParsingJMSOutOperationIn.part1/ns4:validationException</to>
                    </copy>
                    <copy>
                        <from>$JMSInOperationIn.part1/ns0:headerCRCC/ns3:EndpointReference</from>
                        <to>$requestParsingJMSOutOperationIn.part1/ns4:callbackAddress</to>
                    </copy>
                    <copy>
                        <from>$JMSInOperationIn.part1/ns0:novateTrade/ns0:fpMLMessage</from>
                        <to>$requestParseFpMLNonValidatedIn.parameters/fpml</to>
                    </copy>
                </assign>
                <if name="ifNotDefaultProcessingErrorCode">
                    <documentation>If the error was not a default parsing error then execute a parsing FPML, otherwise create a Unknown parsing error</documentation>
                    <condition>'' End of statement list encounted ->200'' !!= $parsingException.fault/reasonCode</condition>
                    <sequence name="noDefaultErrorSeq">
                        <documentation>Execute some activities when the string is well formed</documentation>
                        <invoke name="toParseNonValidated" partnerLink="FpMLParser" operation="parseFpMLNonValidated" portType="tns:FpMLParser" inputVariable="requestParseFpMLNonValidatedIn" outputVariable="responseParseFpMLNonValidatedOut">
                            <documentation>To parse the string without validate fpml</documentation>
                        </invoke>
                        <assign name="settingFpMLMessage">
                            <documentation>Set up the fpml string</documentation>
                            <copy>
                                <from>$responseParseFpMLNonValidatedOut.parameters/return</from>
                                <to>$requestInsertMessageFPMLErrorIn.parameters/rtc</to>
                            </copy>
                        </assign>
                        <invoke name="toInsertFpMLMessage" partnerLink="RiskEJB" operation="insertMessageFPML" xmlns:tns="http://facade.data.risk.otc.crcc.com/" portType="tns:RiskServiceWS" inputVariable="requestInsertMessageFPMLErrorIn" outputVariable="responseInsertMessageFPMLErrorOut">
                            <documentation>Insert the incoming message on a databasepossible to insert message that no contain the sender information, in this case the system save the recors without sender information</documentation>
                        </invoke>
                        <assign name="settingInsertSoapAttachmentParsing">
                            <copy>
                                <from>string($JMSInOperationIn.part1/ns0:headerCRCC/ns3:EndpointReference/ns3:ServiceName/@PortName)</from>
                                <to>$requestInsertSoapAttachmentParsingIn.part/ns5:FPML_SOAP_ATTACHMENT_Record/ns5:portName</to>
                            </copy>
                            <copy>
                                <from>string($JMSInOperationIn.part1/ns0:headerCRCC/ns3:EndpointReference/ns3:ServiceName)</from>
                                <to>$requestInsertSoapAttachmentParsingIn.part/ns5:FPML_SOAP_ATTACHMENT_Record/ns5:serviceName</to>
                            </copy>
                            <copy>
                                <from>string($JMSInOperationIn.part1/ns0:headerCRCC/ns3:EndpointReference/ns3:PortType)</from>
                                <to>$requestInsertSoapAttachmentParsingIn.part/ns5:FPML_SOAP_ATTACHMENT_Record/ns5:portType</to>
                            </copy>
                            <copy>
                                <from>string($JMSInOperationIn.part1/ns0:headerCRCC/ns3:EndpointReference/ns3:Address)</from>
                                <to>$requestInsertSoapAttachmentParsingIn.part/ns5:FPML_SOAP_ATTACHMENT_Record/ns5:serviceAddress</to>
                            </copy>
                            <copy>
                                <from>$JMSInOperationIn.part1/ns0:novateTrade/ns0:fpMLMessage</from>
                                <to>$requestInsertSoapAttachmentParsingIn.part/ns5:FPML_SOAP_ATTACHMENT_Record/ns5:message</to>
                            </copy>
                            <copy>
                                <from>$responseInsertMessageFPMLErrorOut.parameters/return</from>
                                <to>$requestInsertSoapAttachmentParsingIn.part/ns5:FPML_SOAP_ATTACHMENT_Record/ns5:message_FK</to>
                            </copy>
                        </assign>
                        <invoke name="toInvokeSoapAttachmentParsing" partnerLink="soapAttachment" operation="insert" xmlns:tns="http://j2ee.netbeans.org/wsdl/fpmlSoapAttachmentWSDL" portType="tns:jdbcPortType" inputVariable="requestInsertSoapAttachmentParsingIn" outputVariable="responseInsertSoapAttachmentParsingOut"/>
                        <assign name="settingParsingJMS">
                            <documentation>Set up the message tha will be send it to JMS parsing error</documentation>
                            <copy>
                                    <from>$responseParseFpMLNonValidatedOut.parameters/return/ns1:header</from>
                                        <to>$requestParsingJMSOutOperationIn.part1/ns4:requestMessageHeader</to>
                                </copy>
                            <copy>
                                <from variable="parsingException" part="fault"/>
                                <to>$requestParsingJMSOutOperationIn.part1/ns4:validationException</to>
                            </copy>
                            <copy>
                                <from>$JMSInOperationIn.part1/ns0:headerCRCC/ns3:EndpointReference</from>
                                <to>$requestParsingJMSOutOperationIn.part1/ns4:callbackAddress</to>
                            </copy>
                            <copy>
                                <from>$responseInsertMessageFPMLErrorOut.parameters/return</from>
                                <to>$requestParsingJMSOutOperationIn.part1/ns4:rtcInternalID</to>
                            </copy>
                        </assign>
                        <invoke name="toPutParsingJMS" partnerLink="ParsingErrorJMS" operation="JMSOutOperation" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/putToParsingErrorJMSWSDL" portType="tns:JMSOutPortType" inputVariable="requestParsingJMSOutOperationIn">
                            <documentation>Put the parsing error to JMS in order to process it</documentation>
                        </invoke>
                    </sequence>
                    <else>
                        <sequence name="Sequence4">
                            <assign name="settingUnknownError">
                                <sxt:trace>
                                    <sxt:log level="warning" location="onStart">
                                        <from>concat(''FPML NOT WELL FORMED: '', $JMSInOperationIn.part1/ns0:novateTrade/ns0:fpMLMessage)</from>
                                    </sxt:log>
                                </sxt:trace>
                                <copy>
                                    <from>$JMSInOperationIn.part1/ns0:novateTrade/ns0:fpMLMessage</from>
                                    <to variable="putUnknownErrorJMSOutOperationIn" part="part1"/>
                                </copy>
                            </assign>
                            <invoke name="toPutUnknownErrorrJMS" partnerLink="UnknownError" operation="JMSOutOperation" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/putToUnknownErrorJMSWSDL" portType="tns:JMSOutPortType" inputVariable="putUnknownErrorJMSOutOperationIn"/>
                        </sequence>
                    </else>
                </if>
            </sequence>
        </catch>
        <catch xmlns:tns="http://facade.data.risk.otc.crcc.com/" faultMessageType="tns:ValidationException" faultVariable="riskException" faultName="tns:ValidationException">
            <documentation>This catch manages every validation exception generated by Risk  EJB  </documentation>
            <sequence name="handlingRiskError">
                <assign name="riskError2JMS">
                    <copy>
                        <from variable="riskException" part="fault"/>
                        <to>$requestRiskJMSOutOperationIn.part1/ns4:validationException</to>
                    </copy>
                    <copy>
                        <from>$JMSInOperationIn.part1/ns0:headerCRCC/ns3:EndpointReference</from>
                        <to>$requestRiskJMSOutOperationIn.part1/ns4:callbackAddress</to>
                    </copy>
                    <copy>
                        <from>$responseParseFpMLOut.parameters/return/ns1:header</from>
                        <to>$requestRiskJMSOutOperationIn.part1/ns4:requestMessageHeader</to>
                    </copy>
                </assign>
                <if name="IfNotMessageAlreadyExist">
                    <condition>''513'' !!= $riskException.fault/reasonCode</condition>
                    <assign name="setPriorMessage">
                        <copy>
                            <from>$responseInsertMessageFPMLOut.parameters/return</from>
                            <to>$requestRiskJMSOutOperationIn.part1/ns4:rtcInternalID</to>
                        </copy>
                    </assign>
                </if>
                <invoke name="toPutRiskJMS" partnerLink="RiskErrorJMS" operation="JMSOutOperation" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/putToRiskErrorJMSWSDL" portType="tns:JMSOutPortType" inputVariable="requestRiskJMSOutOperationIn"/>
            </sequence>
        </catch>
        <catch faultName="ns6:ValidationException" faultMessageType="ns6:ValidationException" faultVariable="manageSystemValidation">
            <documentation>Exception to System available</documentation>
            <sequence name="HandlingManageSystemExeception">
                <assign name="parseFpmlNoValidate">
                    <copy>
                        <from>$JMSInOperationIn.part1/ns0:novateTrade/ns0:fpMLMessage</from>
                        <to>$requestManageParseFpMLNonValidatedIn.parameters/fpml</to>
                    </copy>
                </assign>
                <invoke name="toParseFpmlNonValidated" partnerLink="FpMLParser" operation="parseFpMLNonValidated" xmlns:tns="http://parsing.trade.otc.crcc.com/" portType="tns:FpMLParser" inputVariable="requestManageParseFpMLNonValidatedIn" outputVariable="responseManageParseFpMLNonValidatedOut"/>
                <assign name="toSendManageError">
                    <copy>
                        <from>$responseManageParseFpMLNonValidatedOut.parameters/return/ns1:header</from>
                        <to>$requestManageJMSOutOperationIn.part1/ns4:requestMessageHeader</to>
                    </copy>
                    <copy>
                        <from>$JMSInOperationIn.part1/ns0:headerCRCC/ns3:EndpointReference</from>
                        <to>$requestManageJMSOutOperationIn.part1/ns4:callbackAddress</to>
                    </copy>
                    <copy>
                        <from>$manageSystemValidation.fault/additionalData</from>
                        <to>$requestManageJMSOutOperationIn.part1/ns4:validationException/additionalData</to>
                    </copy>
                    <copy>
                        <from>$manageSystemValidation.fault/location</from>
                        <to>$requestManageJMSOutOperationIn.part1/ns4:validationException/location</to>
                    </copy>
                    <copy>
                        <from>$manageSystemValidation.fault/message</from>
                        <to>$requestManageJMSOutOperationIn.part1/ns4:validationException/message</to>
                    </copy>
                    <copy>
                        <from>$manageSystemValidation.fault/reasonCode</from>
                        <to>$requestManageJMSOutOperationIn.part1/ns4:validationException/reasonCode</to>
                    </copy>
                    <copy>
                        <from>$manageSystemValidation.fault/semanticRuleDescription</from>
                        <to>$requestManageJMSOutOperationIn.part1/ns4:validationException/semanticRuleDescription</to>
                    </copy>
                    <copy>
                        <from>$manageSystemValidation.fault/semanticRuleId</from>
                        <to>$requestManageJMSOutOperationIn.part1/ns4:validationException/semanticRuleId</to>
                    </copy>
                </assign>
                <invoke name="toPutRiskJMSManage" partnerLink="RiskErrorJMS" operation="JMSOutOperation" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/putToRiskErrorJMSWSDL" portType="tns:JMSOutPortType" inputVariable="requestManageJMSOutOperationIn"/>
            </sequence>
        </catch>
    </faultHandlers>
    <sequence>
        <receive name="getMessageFromJMS" createInstance="yes" partnerLink="getMessageFormJMSPL" operation="JMSInOperation" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/getIncomingMessageFromJMSWSDL" portType="tns:JMSInPortType" variable="JMSInOperationIn">
            <documentation>Get the message from JMS to BPEL</documentation>
            <sxt:trace>
                <sxt:log level="fine" location="onStart">
                    <from>concat(''START getMessageFromJMS FpmL :'', sxxf:current-dateTime())</from>
                </sxt:log>
            </sxt:trace>
        </receive>
        <assign name="initializeRequestGetSystem">
            <copy>
                <from>''</from>
                <to variable="requestGetCurrentSystemStateIn" part="parameters"/>
            </copy>
        </assign>
        <invoke name="toGetManageSystem" partnerLink="ManageSystemService" operation="getCurrentSystemState" portType="ns6:ManageSystemService" inputVariable="requestGetCurrentSystemStateIn" outputVariable="requestGetCurrentSystemStateOut">
            <documentation>To get the OTC current system state, if not avalaible an exception is thrown, it is handled by Handler Manage System Exception</documentation>
        </invoke>
        <assign name="JMS2Parser">
            <documentation>Get the fpml String and put it on incoming parameter of FpML parser</documentation>
            <copy>
                <from>$JMSInOperationIn.part1/ns0:novateTrade/ns0:fpMLMessage</from>
                <to>$requestParseFpMLIn.parameters/fpml</to>
            </copy>
        </assign>
        <invoke name="toParseFpML" partnerLink="FpMLParser" operation="parseFpML" xmlns:tns="http://parsing.trade.otc.crcc.com/" portType="tns:FpMLParser" inputVariable="requestParseFpMLIn" outputVariable="responseParseFpMLOut">
            <documentation>Invoke parse FpmL that can thorw a handling Parsing Exception</documentation>
            <sxt:trace>
                <sxt:log level="fine" location="onStart">
                    <from>concat(''START Parsing FpmL :'', sxxf:current-dateTime())</from>
                </sxt:log>
                <sxt:log level="fine" location="onComplete">
                    <from>concat(''FINISHED  Parsing FpmL :'', sxxf:current-dateTime())</from>
                </sxt:log>
            </sxt:trace>
        </invoke>
        <assign name="Parser2Risk">
            <documentation>once time the parser return a RTC that message is sent to Risk facade to make some risk validation</documentation>
            <copy>
                <from>$responseParseFpMLOut.parameters/return</from>
                <to>$requestValidateMemberIn.parameters/rtc</to>
            </copy>
            <copy>
                <from>$responseParseFpMLOut.parameters/return</from>
                <to>$requestEvaluateRiskIn.parameters/rtc</to>
            </copy>
            <copy>
                <from>$responseParseFpMLOut.parameters/return</from>
                <to>$requestInsertMessageFPMLIn.parameters/rtc</to>
            </copy>
        </assign>
        <invoke name="toInsertFpML" partnerLink="RiskEJB" operation="insertMessageFPML" xmlns:tns="http://facade.data.risk.otc.crcc.com/" portType="tns:RiskServiceWS" inputVariable="requestInsertMessageFPMLIn" outputVariable="responseInsertMessageFPMLOut">
            <documentation>This method insert the incoming message on database</documentation>
            <sxt:trace>
                <sxt:log level="fine" location="onStart">
                    <from>concat(''START toInsertFpML  :'', sxxf:current-dateTime())</from>
                </sxt:log>
                <sxt:log level="fine" location="onComplete">
                    <from>concat(''FINISHED  toInsertFpML :'', sxxf:current-dateTime())</from>
                </sxt:log>
            </sxt:trace>
        </invoke>
        <assign name="settingSoapAttachment">
            <documentation>setting the soap attachmente by including messageFK</documentation>
            <copy>
                <from>string($JMSInOperationIn.part1/ns0:headerCRCC/ns3:EndpointReference/ns3:ServiceName/@PortName)</from>
                <to>$requestInsertSoapAttachmentIn.part/ns5:FPML_SOAP_ATTACHMENT_Record/ns5:portName</to>
            </copy>
            <copy>
                <from>string($JMSInOperationIn.part1/ns0:headerCRCC/ns3:EndpointReference/ns3:ServiceName)</from>
                <to>$requestInsertSoapAttachmentIn.part/ns5:FPML_SOAP_ATTACHMENT_Record/ns5:serviceName</to>
            </copy>
            <copy>
                <from>string($JMSInOperationIn.part1/ns0:headerCRCC/ns3:EndpointReference/ns3:PortType)</from>
                <to>$requestInsertSoapAttachmentIn.part/ns5:FPML_SOAP_ATTACHMENT_Record/ns5:portType</to>
            </copy>
            <copy>
                <from>string($JMSInOperationIn.part1/ns0:headerCRCC/ns3:EndpointReference/ns3:Address)</from>
                <to>$requestInsertSoapAttachmentIn.part/ns5:FPML_SOAP_ATTACHMENT_Record/ns5:serviceAddress</to>
            </copy>
            <copy>
                <from>$responseInsertMessageFPMLOut.parameters/return</from>
                <to>$requestInsertSoapAttachmentIn.part/ns5:FPML_SOAP_ATTACHMENT_Record/ns5:message_FK</to>
            </copy>
            <copy>
                <from>$JMSInOperationIn.part1/ns0:novateTrade/ns0:fpMLMessage</from>
                <to>$requestInsertSoapAttachmentIn.part/ns5:FPML_SOAP_ATTACHMENT_Record/ns5:message</to>
            </copy>
        </assign>
        <invoke name="toInsertSoapAttachment" partnerLink="soapAttachment" operation="insert" xmlns:tns="http://j2ee.netbeans.org/wsdl/fpmlSoapAttachmentWSDL" portType="tns:jdbcPortType" inputVariable="requestInsertSoapAttachmentIn" outputVariable="responseInsertSoapAttachmentOut">
            <documentation>to insert the soapMessage</documentation>
        </invoke>
        <invoke name="toValidateMembers" partnerLink="RiskEJB" operation="validateMember" xmlns:tns="http://facade.data.risk.otc.crcc.com/" portType="tns:RiskServiceWS" inputVariable="requestValidateMemberIn" outputVariable="responseValidateMemberOut">
            <documentation>To validate if every member included on RTC message exist on OTC database</documentation>
            <sxt:trace>
                <sxt:log level="fine" location="onStart">
                    <from>concat(''START toValidateMembers  :'', sxxf:current-dateTime())</from>
                </sxt:log>
                <sxt:log level="fine" location="onComplete">
                    <from>concat(''FINISHED  toValidateMembers :'', sxxf:current-dateTime())</from>
                </sxt:log>
            </sxt:trace>
        </invoke>            
        <invoke name="toEvaluateRisk" partnerLink="RiskEJB" operation="evaluateRisk" xmlns:tns="http://facade.data.risk.otc.crcc.com/" portType="tns:RiskServiceWS" inputVariable="requestEvaluateRiskIn" outputVariable="responseEvaluateRiskOut">
            <documentation>To verify the current risk of member</documentation>
            <sxt:trace>
                <sxt:log level="fine" location="onStart">
                    <from>concat(''START toEvaluateRisk :'', sxxf:current-dateTime())</from>
                </sxt:log>
                <sxt:log level="fine" location="onComplete">
                    <from>concat(''FINISHED  toEvaluateRisk :'', sxxf:current-dateTime())</from>
                </sxt:log>
            </sxt:trace>
        </invoke>
        <assign name="EvaluateRisk2ProcessTradeC">
            <documentation>If the evaluate risk was sucessfull then get the retun value an assign it to the process trade confirmed process.</documentation>
            <copy>
                <from>$responseEvaluateRiskOut.parameters/return</from>
                <to>$requestProcessTradeConfirmedWSDLOperationIn.tradeConfirmedIn/ns2:tradeConfirmed</to>
            </copy>
            <copy>
                <from>$JMSInOperationIn.part1/ns0:headerCRCC/ns3:EndpointReference</from>
                <to>$requestProcessTradeConfirmedWSDLOperationIn.tradeConfirmedIn/ns2:header/ns3:EndpointReference</to>
            </copy>
            <copy>
                <from>$responseInsertMessageFPMLOut.parameters/return</from>
                <to>$requestProcessTradeConfirmedWSDLOperationIn.tradeConfirmedIn/ns2:rtcInternalID</to>
            </copy>
        </assign>
        <invoke name="toProcessTradeConfirmed" partnerLink="processTradeConfirmed" operation="processTradeConfirmedWSDLOperation" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/processTradeConfirmedWSDL" portType="tns:processTradeConfirmedWSDLPortType" inputVariable="requestProcessTradeConfirmedWSDLOperationIn">
            <documentation>Invoke the bpel that process the confirmed trade</documentation>
            <sxt:trace>
                <sxt:log level="fine" location="onStart">
                    <from>concat(''START ProcessTradeConfirmed :'', sxxf:current-dateTime())</from>
                </sxt:log>
                <sxt:log level="fine" location="onComplete">
                    <from>concat(''FINISHED  ProcessTradeConfirmed :'', sxxf:current-dateTime())</from>
                </sxt:log>
            </sxt:trace>
        </invoke>        
    </sequence>
</process>
'! !

!BPEL20BpelAnalyzerTest3 methodsFor: 'bpel' stamp: 'AlvaroJosePeraltaOcampo 11/12/2014 09:46'!
bpel_processTradeConfirmed
	^ '<?xml version="1.0" encoding="UTF-8"?>
<process
    name="processTradeConfirmed"
    targetNamespace="http://enterprise.netbeans.org/bpel/processNovateTradeProcess/processTradeConfirmed"
    xmlns="http://docs.oasis-open.org/wsbpel/2.0/process/executable"
    xmlns:xsd="http://www.w3.org/2001/XMLSchema"
    xmlns:sxt="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/Trace" 
    xmlns:sxed="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/Editor"
    xmlns:sxeh="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/ErrorHandling"
    xmlns:tns="http://enterprise.netbeans.org/bpel/processNovateTradeProcess/processTradeConfirmed" xmlns:ns0="http://xml.netbeans.org/schema/processTradeConfirmed" xmlns:ns1="http://www.fpml.org/2008/FpML-4-5" xmlns:ns2="http://xml.netbeans.org/schema/Meff" xmlns:sxxf="http://www.sun.com/wsbpel/2.0/process/executable/SUNExtension/XPathFunctions" xmlns:ns3="http://xml.netbeans.org/schema/runtimePartner" xmlns:ns4="http://schemas.xmlsoap.org/ws/2004/08/addressing" xmlns:ns5="http://j2ee.netbeans.org/xsd/tableSchema">
    <documentation>Se agregan 3 variables globales 

tradeId = corresponde al codigo alfanumerico que envian los sistemas de registro.

tradeIdLength = Longitud total del tradeId enviado por los sistemas de registro

tradeIdFinal = variable que es calculada por la longitud del tradeId y un numero constante para obtener un tamaño de 10 caracteres en la variable.

Por otra parte estos cambios se realizan para tener el registro el numero de negociacion de los sistemas de registro que el sistema Meff no visualiza en las terminales de las herramientas de camara. Este codigo queda en el campo  referencia intermediario concadenado con el codigo del sistema de registro Ej: CRCC-12345678AS.</documentation>        
    <import namespace="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/processTradeConfirmedWSDL" location="processTradeConfirmedWSDL.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://enterprise.netbeans.org/bpel/RiskServiceWSWrapper" location="RiskServiceWSWrapper.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://facade.data.risk.otc.crcc.com/" location="externalWSDL/riskEJB/RiskServiceWS.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://enterprise.netbeans.org/bpel/FpMLParserWrapper" location="FpMLParserWrapper.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://parsing.trade.otc.crcc.com/" location="externalWSDL/FpMLParser/FpMLParser.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://enterprise.netbeans.org/bpel/MeffServiceWrapper" location="MeffServiceWrapper.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://facade.data.otc.crcc.com/" location="externalWSDL/commons/MeffService.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://j2ee.netbeans.org/wsdl/MeffServicesBPEL/RequestTradeWSDL" location="externalWSDL/meffServicesBPEL/RequestTradeWSDL.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://j2ee.netbeans.org/wsdl/processNovateTradeBPEL/invokeCallbackPartnerLinkWSDL" location="invokeCallbackPartnerLinkWSDL.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://j2ee.netbeans.org/wsdl/fpMLMessageOnDBWSDL" location="fpMLMessageOnDBWSDL.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <import namespace="http://j2ee.netbeans.org/wsdl/fpmlSoapAttachmentWSDL" location="fpmlSoapAttachmentWSDL.wsdl" importType="http://schemas.xmlsoap.org/wsdl/"/>
    <partnerLinks>
        <partnerLink name="FpMLParser" xmlns:tns="http://enterprise.netbeans.org/bpel/FpMLParserWrapper" partnerLinkType="tns:FpMLParserLinkType" partnerRole="FpMLParserRole"/>
        <partnerLink name="fpMLSoapAttachment" xmlns:tns="http://j2ee.netbeans.org/wsdl/fpmlSoapAttachmentWSDL" partnerLinkType="tns:jdbcpartner" partnerRole="jdbcPortTypeRole"/>
        <partnerLink name="OTCDB" xmlns:tns="http://j2ee.netbeans.org/wsdl/fpMLMessageOnDBWSDL" partnerLinkType="tns:jdbcpartner" partnerRole="jdbcPortTypeRole"/>
        <partnerLink name="CommonServices" xmlns:tns="http://enterprise.netbeans.org/bpel/MeffServiceWrapper" partnerLinkType="tns:MeffServiceLinkType" partnerRole="MeffServiceRole"/>
        <partnerLink name="MeffService" xmlns:tns="http://j2ee.netbeans.org/wsdl/MeffServicesBPEL/RequestTradeWSDL" partnerLinkType="tns:RequestTradeWSDL" partnerRole="RequestTradeWSDLPortTypeRole"/>
        <partnerLink name="RiskEJB" xmlns:tns="http://enterprise.netbeans.org/bpel/RiskServiceWSWrapper" partnerLinkType="tns:RiskServiceWSLinkType" partnerRole="RiskServiceWSRole"/>
        <partnerLink name="invokeCallback" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeBPEL/invokeCallbackPartnerLinkWSDL" partnerLinkType="tns:invokeCallbackPartnerLinkWSDL" partnerRole="invokeCallbackPartnerLinkWSDLPortTypeRole"/>
        <partnerLink name="processTradeConfirmed" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/processTradeConfirmedWSDL" partnerLinkType="tns:processTradeConfirmedWSDL" myRole="processTradeConfirmedWSDLPortTypeRole"/>
    </partnerLinks>
    <variables>
        <variable name="tradeIDFinal" type="xsd:string"/>
        <variable name="tradeIdLenght" type="xsd:int"/>
        <variable name="tradeID" type="xsd:string"/>        
        <variable name="responseFindFpmlMessageOut" xmlns:tns="http://j2ee.netbeans.org/wsdl/fpMLMessageOnDBWSDL" messageType="tns:outputMsg"/>
        <variable name="requestFindFpmlMessageIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/fpMLMessageOnDBWSDL" messageType="tns:inputMsg"/>
        <variable name="responseInsertFpmLSoapOut" xmlns:tns="http://j2ee.netbeans.org/wsdl/fpmlSoapAttachmentWSDL" messageType="tns:insertRetMsg"/>
        <variable name="requestInsertFpmLSoapIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/fpmlSoapAttachmentWSDL" messageType="tns:inputMsg"/>
        <variable name="responseInsertFpMLMessageOut" xmlns:tns="http://j2ee.netbeans.org/wsdl/fpMLMessageOnDBWSDL" messageType="tns:insertRetMsg"/>
        <variable name="requestInsertFpMLMessageIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/fpMLMessageOnDBWSDL" messageType="tns:inputMsg"/>
        <variable name="requestInvokeCallbackPartnerLinkWSDLOperationIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeBPEL/invokeCallbackPartnerLinkWSDL" messageType="tns:invokeCallbackPartnerLinkWSDLOperationRequest"/>
        <variable name="responseContractPriceIDOut" xmlns:tns="http://facade.data.risk.otc.crcc.com/" messageType="tns:contractPriceIDResponse"/>
        <variable name="requestContractPriceIDIn" xmlns:tns="http://facade.data.risk.otc.crcc.com/" messageType="tns:contractPriceID"/>
        <variable name="responseTradeWSDLOperationOut" xmlns:tns="http://j2ee.netbeans.org/wsdl/MeffServicesBPEL/RequestTradeWSDL" messageType="tns:RequestTradeWSDLOperationResponse"/>
        <variable name="requestTradeWSDLOperationIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/MeffServicesBPEL/RequestTradeWSDL" messageType="tns:RequestTradeWSDLOperationRequest"/>
        <variable name="responseTradeConfirmedAsStringOut" xmlns:tns="http://parsing.trade.otc.crcc.com/" messageType="tns:tradeConfirmedAsStringResponse"/>
        <variable name="requestTradeConfirmedAsStringIn" xmlns:tns="http://parsing.trade.otc.crcc.com/" messageType="tns:tradeConfirmedAsString"/>
        <variable name="responseGetIdMessageOut" xmlns:tns="http://facade.data.otc.crcc.com/" messageType="tns:getIdMessageResponse"/>
        <variable name="requestGetIdMessageIn" xmlns:tns="http://facade.data.otc.crcc.com/" messageType="tns:getIdMessage"/>
        <variable name="ProcessTradeConfirmedWSDLOperationIn" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/processTradeConfirmedWSDL" messageType="tns:processTradeConfirmedWSDLOperationRequest"/>
    </variables>
    <sequence>
        <receive name="getTradeConfirmed" createInstance="yes" partnerLink="processTradeConfirmed" operation="processTradeConfirmedWSDLOperation" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/processTradeConfirmedWSDL" portType="tns:processTradeConfirmedWSDLPortType" variable="ProcessTradeConfirmedWSDLOperationIn"/>
        <assign name="initializeVariables">
            <documentation>set the contract ID variable
set the getSequence variable</documentation>
            <copy>
                <from>''</from>
                <to variable="requestGetIdMessageIn" part="parameters"/>
            </copy>
            <copy>
                <from>$ProcessTradeConfirmedWSDLOperationIn.tradeConfirmedIn/ns0:tradeConfirmed</from>
                <to>$requestTradeConfirmedAsStringIn.parameters/tradeConfirmed</to>
            </copy>
            <copy>
                <from>substring($ProcessTradeConfirmedWSDLOperationIn.tradeConfirmedIn/ns0:tradeConfirmed/ns1:trade/ns1:fxSingleLeg/ns1:valueDate, 1, 10)</from>
                <to>$requestContractPriceIDIn.parameters/valueDate</to>
            </copy>
        </assign>
        <invoke name="toGetSequence" partnerLink="CommonServices" operation="getIdMessage" xmlns:tns="http://facade.data.otc.crcc.com/" portType="tns:MeffService" inputVariable="requestGetIdMessageIn" outputVariable="responseGetIdMessageOut"/>
        <invoke name="toGetContractID" partnerLink="RiskEJB" operation="contractPriceID" xmlns:tns="http://facade.data.risk.otc.crcc.com/" portType="tns:RiskServiceWS" inputVariable="requestContractPriceIDIn" outputVariable="responseContractPriceIDOut"/>
        <assign name="setMessageId">
            <copy>
                <from>$responseGetIdMessageOut.parameters/return</from>
                <to>$requestTradeConfirmedAsStringIn.parameters/tradeConfirmed/ns1:header/ns1:messageId</to>
            </copy>
        </assign>
        <assign name="setMessageIdSchema">
            <copy>
                <from>''http: Variable or expression expected ->//www.camaraderiesgo.com/messageId''</from>
                <to>$requestTradeConfirmedAsStringIn.parameters/tradeConfirmed/ns1:header/ns1:messageId/@messageIdScheme</to>
            </copy>
        </assign>
        <invoke name="toGetStringFromTradeConfirmed" partnerLink="FpMLParser" operation="tradeConfirmedAsString" xmlns:tns="http://parsing.trade.otc.crcc.com/" portType="tns:FpMLParser" inputVariable="requestTradeConfirmedAsStringIn" outputVariable="responseTradeConfirmedAsStringOut"/>
        <assign name="FPML2OTCDB">
            <copy>
                <from>1</from>
                <to>$requestInsertFpMLMessageIn.part/ns5:FPML_MESSAGE_Record/ns5:sender_FK</to>
            </copy>
            <copy>
                <from>$ProcessTradeConfirmedWSDLOperationIn.tradeConfirmedIn/ns0:rtcInternalID</from>
                <to>$requestInsertFpMLMessageIn.part/ns5:FPML_MESSAGE_Record/ns5:priorMessage_FK</to>
            </copy>
            <copy>
                <from>string($ProcessTradeConfirmedWSDLOperationIn.tradeConfirmedIn/ns0:tradeConfirmed/ns1:header/ns1:messageId/@messageIdScheme)</from>
                <to>$requestInsertFpMLMessageIn.part/ns5:FPML_MESSAGE_Record/ns5:messageSchemaID</to>
            </copy>
            <copy>
                <from>3</from>
                <to>$requestInsertFpMLMessageIn.part/ns5:FPML_MESSAGE_Record/ns5:messageType_FK</to>
            </copy>
            <copy>
                <from>$responseGetIdMessageOut.parameters/return</from>
                <to>$requestInsertFpMLMessageIn.part/ns5:FPML_MESSAGE_Record/ns5:messageID</to>
            </copy>
            <copy>
                <from>string($ProcessTradeConfirmedWSDLOperationIn.tradeConfirmedIn/ns0:tradeConfirmed/ns1:trade/ns1:tradeHeader/ns1:partyTradeIdentifier/ns1:tradeId)</from>
                <to variable="tradeID"/>
            </copy>
            <copy>
                <from>string-length($ProcessTradeConfirmedWSDLOperationIn.tradeConfirmedIn/ns0:tradeConfirmed/ns1:trade/ns1:tradeHeader/ns1:partyTradeIdentifier/ns1:tradeId)</from>
                <to variable="tradeIdLenght"/>
            </copy>
        </assign>
        <invoke name="toInsertOnOTCDB" partnerLink="OTCDB" operation="insert" xmlns:tns="http://j2ee.netbeans.org/wsdl/fpMLMessageOnDBWSDL" portType="tns:jdbcPortType" inputVariable="requestInsertFpMLMessageIn" outputVariable="responseInsertFpMLMessageOut"/>
        <if name="ConditionalReceiver">
            <condition>$ProcessTradeConfirmedWSDLOperationIn.tradeConfirmedIn/ns0:tradeConfirmed/ns1:party[@id = $ProcessTradeConfirmedWSDLOperationIn.tradeConfirmedIn/ns0:tradeConfirmed/ns1:trade/ns1:fxSingleLeg/ns1:exchangedCurrency1/ns1:receiverPartyReference/@href]/ns1:account/ns1:accountId</condition>
            <assign name="setAccountReceiverNull">
                <copy>
                    <from>$ProcessTradeConfirmedWSDLOperationIn.tradeConfirmedIn/ns0:tradeConfirmed/ns1:party[@id = $ProcessTradeConfirmedWSDLOperationIn.tradeConfirmedIn/ns0:tradeConfirmed/ns1:trade/ns1:fxSingleLeg/ns1:exchangedCurrency1/ns1:receiverPartyReference/@href]/ns1:account/ns1:accountId</from>
                    <to>$requestTradeWSDLOperationIn.request/ns2:request/ns2:buyerAccount</to>
                </copy>
                    
            </assign>            
            <else>
                <assign name="setAccountReceiverNotNull">
                    
                     <copy>
                        <from>''P0101''</from>
                        <to>$requestTradeWSDLOperationIn.request/ns2:request/ns2:buyerAccount</to>
                    </copy>
                    
                </assign>
            </else>
        </if>
        
        <if name="ConditionalPayer">
            <condition>$ProcessTradeConfirmedWSDLOperationIn.tradeConfirmedIn/ns0:tradeConfirmed/ns1:party[@id = $ProcessTradeConfirmedWSDLOperationIn.tradeConfirmedIn/ns0:tradeConfirmed/ns1:trade/ns1:fxSingleLeg/ns1:exchangedCurrency1/ns1:payerPartyReference/@href]/ns1:account/ns1:accountId</condition>
            <assign name="setAccountPayerNull">
                <copy>
                    <from>$ProcessTradeConfirmedWSDLOperationIn.tradeConfirmedIn/ns0:tradeConfirmed/ns1:party[@id = $ProcessTradeConfirmedWSDLOperationIn.tradeConfirmedIn/ns0:tradeConfirmed/ns1:trade/ns1:fxSingleLeg/ns1:exchangedCurrency1/ns1:payerPartyReference/@href]/ns1:account/ns1:accountId</from>
                    <to>$requestTradeWSDLOperationIn.request/ns2:request/ns2:sellerAccount</to>
                </copy>            
                    
            </assign>            
            <else>
                <assign name="setAccountPayerNotNull">
                    
                    <copy>
                        <from>''P0101''</from>
                        <to>$requestTradeWSDLOperationIn.request/ns2:request/ns2:sellerAccount</to>
                    </copy>
                    
                </assign>
            </else>
        </if>
        
        <assign name="FpML2MEFF">
            <copy>
                <from>$ProcessTradeConfirmedWSDLOperationIn.tradeConfirmedIn/ns0:tradeConfirmed/ns1:party[@id = $ProcessTradeConfirmedWSDLOperationIn.tradeConfirmedIn/ns0:tradeConfirmed/ns1:trade/ns1:fxSingleLeg/ns1:exchangedCurrency1/ns1:receiverPartyReference/@href]/ns1:partyId</from>
                <to>$requestTradeWSDLOperationIn.request/ns2:request/ns2:buyerCode</to>
            </copy>
            <copy>
                <from>$ProcessTradeConfirmedWSDLOperationIn.tradeConfirmedIn/ns0:tradeConfirmed/ns1:party[@id = $ProcessTradeConfirmedWSDLOperationIn.tradeConfirmedIn/ns0:tradeConfirmed/ns1:trade/ns1:fxSingleLeg/ns1:exchangedCurrency1/ns1:payerPartyReference/@href]/ns1:partyId</from>
                <to>$requestTradeWSDLOperationIn.request/ns2:request/ns2:sellerCode</to>
            </copy>
            <copy>
                <from>''H''</from>
                <to>$requestTradeWSDLOperationIn.request/ns2:request/ns2:operationType</to>
            </copy>
            <copy>
                <from>sxxf:current-date()</from>
                <to>$requestTradeWSDLOperationIn.request/ns2:request/ns2:date</to>
            </copy>
            <copy>
                <from>sxxf:current-time()</from>
                <to>$requestTradeWSDLOperationIn.request/ns2:request/ns2:time</to>
            </copy>
            <copy>
                <from>string($ProcessTradeConfirmedWSDLOperationIn.tradeConfirmedIn/ns0:tradeConfirmed/ns1:trade/ns1:fxSingleLeg/ns1:exchangeRate/ns1:rate)</from>
                <to>$requestTradeWSDLOperationIn.request/ns2:request/ns2:price</to>
            </copy>
            <copy>
                <from>string($ProcessTradeConfirmedWSDLOperationIn.tradeConfirmedIn/ns0:tradeConfirmed/ns1:trade/ns1:fxSingleLeg/ns1:exchangedCurrency1/ns1:paymentAmount/ns1:amount)</from>
                <to>$requestTradeWSDLOperationIn.request/ns2:request/ns2:amount</to>
            </copy>
            <copy>
                <from>$responseContractPriceIDOut.parameters/return/name</from>
                <to>$requestTradeWSDLOperationIn.request/ns2:request/ns2:contractId</to>
            </copy>
            <copy>
                <from>substring($tradeID, $tradeIdLenght - 10, 10)</from>
                <to variable="tradeIDFinal"/>
            </copy>
            <copy>
                <from>string($tradeIDFinal)</from>
                <to>$requestTradeWSDLOperationIn.request/ns2:request/ns2:originalTradeId</to>
            </copy>
            <copy>
                <from>
			concat(string($ProcessTradeConfirmedWSDLOperationIn.tradeConfirmedIn/ns0:tradeConfirmed/ns1:header/ns1:sendTo), ''-'', $tradeIDFinal)</from>
                <to>$requestTradeWSDLOperationIn.request/ns2:request/ns2:registrationSystem</to>
            </copy>
        </assign>
        <assign name="settingSelectFpML">
            <copy>
                <from>$responseGetIdMessageOut.parameters/return</from>
                <to>$requestFindFpmlMessageIn.part/ns5:FPML_MESSAGE_Record/ns5:messageID</to>
            </copy>
            <copy>
                <from>''http://www.camaraderiesgo.com/messageId''</from>
                <to>$requestFindFpmlMessageIn.part/ns5:FPML_MESSAGE_Record/ns5:messageSchemaID</to>
            </copy>
        </assign>
        <invoke name="toFindFpMLMessage" partnerLink="OTCDB" operation="find" xmlns:tns="http://j2ee.netbeans.org/wsdl/fpMLMessageOnDBWSDL" portType="tns:jdbcPortType" inputVariable="requestFindFpmlMessageIn" outputVariable="responseFindFpmlMessageOut"/>
        <assign name="settingFpMLSoap">
            <copy>
                <from>string($ProcessTradeConfirmedWSDLOperationIn.tradeConfirmedIn/ns0:header/ns4:EndpointReference/ns4:ServiceName/@PortName)</from>
                <to>$requestInsertFpmLSoapIn.part/ns5:FPML_SOAP_ATTACHMENT_Record/ns5:portName</to>
            </copy>
            <copy>
                <from>string($ProcessTradeConfirmedWSDLOperationIn.tradeConfirmedIn/ns0:header/ns4:EndpointReference/ns4:ServiceName)</from>
                <to>$requestInsertFpmLSoapIn.part/ns5:FPML_SOAP_ATTACHMENT_Record/ns5:serviceName</to>
            </copy>
            <copy>
                <from>string($ProcessTradeConfirmedWSDLOperationIn.tradeConfirmedIn/ns0:header/ns4:EndpointReference/ns4:PortType)</from>
                <to>$requestInsertFpmLSoapIn.part/ns5:FPML_SOAP_ATTACHMENT_Record/ns5:portType</to>
            </copy>
            <copy>
                <from>string($ProcessTradeConfirmedWSDLOperationIn.tradeConfirmedIn/ns0:header/ns4:EndpointReference/ns4:Address)</from>
                <to>$requestInsertFpmLSoapIn.part/ns5:FPML_SOAP_ATTACHMENT_Record/ns5:serviceAddress</to>
            </copy>
            <copy>
                <from>$responseTradeConfirmedAsStringOut.parameters/return</from>
                <to>$requestInsertFpmLSoapIn.part/ns5:FPML_SOAP_ATTACHMENT_Record/ns5:message</to>
            </copy>
            <copy>
                <from>$responseFindFpmlMessageOut.part/ns5:FPML_MESSAGE_Record/ns5:ID</from>
                <to>$requestInsertFpmLSoapIn.part/ns5:FPML_SOAP_ATTACHMENT_Record/ns5:message_FK</to>
            </copy>
        </assign>
        <invoke name="toInsertFpMLSoap" partnerLink="fpMLSoapAttachment" operation="insert" xmlns:tns="http://j2ee.netbeans.org/wsdl/fpmlSoapAttachmentWSDL" portType="tns:jdbcPortType" inputVariable="requestInsertFpmLSoapIn" outputVariable="responseInsertFpmLSoapOut"/>
        <invoke name="toSendTradeToMeff" partnerLink="MeffService" operation="RequestTradeWSDLOperation" xmlns:tns="http://j2ee.netbeans.org/wsdl/MeffServicesBPEL/RequestTradeWSDL" portType="tns:RequestTradeWSDLPortType" inputVariable="requestTradeWSDLOperationIn" outputVariable="responseTradeWSDLOperationOut"/>
        <assign name="settingInvokeCallback">
            <copy>
                <from>$responseTradeConfirmedAsStringOut.parameters/return</from>
                <to>$requestInvokeCallbackPartnerLinkWSDLOperationIn.part1/ns3:fpMLMessageAsString</to>
            </copy>
            <copy>
                <from>$ProcessTradeConfirmedWSDLOperationIn.tradeConfirmedIn/ns0:header/ns4:EndpointReference</from>
                <to>$requestInvokeCallbackPartnerLinkWSDLOperationIn.part1/ns3:endPointReference</to>
            </copy>
            <copy>
                <from>$ProcessTradeConfirmedWSDLOperationIn.tradeConfirmedIn/ns0:tradeConfirmed/ns1:header/ns1:sendTo</from>
                <to>$requestInvokeCallbackPartnerLinkWSDLOperationIn.part1/ns3:senderPartyID</to>
            </copy>
            <copy>
                <from>$responseFindFpmlMessageOut.part/ns5:FPML_MESSAGE_Record/ns5:ID</from>
                <to>$requestInvokeCallbackPartnerLinkWSDLOperationIn.part1/ns3:fpmlMessageFK</to>
            </copy>
        </assign>
        <invoke name="toInvokeCallBack" partnerLink="invokeCallback" operation="invokeCallbackPartnerLinkWSDLOperation" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeBPEL/invokeCallbackPartnerLinkWSDL" portType="tns:invokeCallbackPartnerLinkWSDLPortType" inputVariable="requestInvokeCallbackPartnerLinkWSDLOperationIn"/>
    </sequence>
</process>
'! !

!BPEL20BpelAnalyzerTest3 methodsFor: 'wsdl' stamp: 'AlvaroJosePeraltaOcampo 11/12/2014 09:46'!
wsdl_FpMLParserWrapper
^ '<?xml version="1.0" encoding="UTF-8"?>

<definitions
    xmlns="http://schemas.xmlsoap.org/wsdl/"
    xmlns:soap="http://schemas.xmlsoap.org/wsdl/soap/"
    xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/"
    xmlns:xsd="http://www.w3.org/2001/XMLSchema" name="FpMLParserWrapper" targetNamespace="http://enterprise.netbeans.org/bpel/FpMLParserWrapper" xmlns:tns="http://enterprise.netbeans.org/bpel/FpMLParserWrapper" xmlns:plnk="http://docs.oasis-open.org/wsbpel/2.0/plnktype" xmlns:ns="http://parsing.trade.otc.crcc.com/">
    <import location="externalWSDL/FpMLParser/FpMLParser.wsdl" namespace="http://parsing.trade.otc.crcc.com/"/>
    <plnk:partnerLinkType name="FpMLParserLinkType">
        <plnk:role name="FpMLParserRole" portType="ns:FpMLParser"/>
    </plnk:partnerLinkType>
</definitions>
'! !

!BPEL20BpelAnalyzerTest3 methodsFor: 'wsdl' stamp: 'AlvaroJosePeraltaOcampo 11/12/2014 09:46'!
wsdl_ManageSystemServiceWrapper
^ '<?xml version="1.0" encoding="UTF-8"?>

<definitions
    xmlns="http://schemas.xmlsoap.org/wsdl/"
    xmlns:soap="http://schemas.xmlsoap.org/wsdl/soap/"
    xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/"
    xmlns:xsd="http://www.w3.org/2001/XMLSchema" name="ManageSystemServiceWrapper" targetNamespace="http://enterprise.netbeans.org/bpel/ManageSystemServiceWrapper" xmlns:tns="http://enterprise.netbeans.org/bpel/ManageSystemServiceWrapper" xmlns:plnk="http://docs.oasis-open.org/wsbpel/2.0/plnktype" xmlns:ns="http://facade.manage.data.otc.crcc.com/">
    <import location="externalWSDL/ManageSystem/ManageSystemService.wsdl" namespace="http://facade.manage.data.otc.crcc.com/"/>
    <plnk:partnerLinkType name="ManageSystemServiceLinkType">
        <plnk:role name="ManageSystemServiceRole" portType="ns:ManageSystemService"/>
    </plnk:partnerLinkType>
</definitions>
'! !

!BPEL20BpelAnalyzerTest3 methodsFor: 'wsdl' stamp: 'AlvaroJosePeraltaOcampo 11/12/2014 09:46'!
wsdl_RiskServiceWSWrapper
^ '<?xml version="1.0" encoding="UTF-8"?>

<definitions
    xmlns="http://schemas.xmlsoap.org/wsdl/"
    xmlns:soap="http://schemas.xmlsoap.org/wsdl/soap/"
    xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/"
    xmlns:xsd="http://www.w3.org/2001/XMLSchema" name="RiskServiceWSWrapper" targetNamespace="http://enterprise.netbeans.org/bpel/RiskServiceWSWrapper" xmlns:tns="http://enterprise.netbeans.org/bpel/RiskServiceWSWrapper" xmlns:plnk="http://docs.oasis-open.org/wsbpel/2.0/plnktype" xmlns:ns="http://facade.data.risk.otc.crcc.com/">
    <import location="externalWSDL/riskEJB/RiskServiceWS.wsdl" namespace="http://facade.data.risk.otc.crcc.com/"/>
    <plnk:partnerLinkType name="RiskServiceWSLinkType">
        <plnk:role name="RiskServiceWSRole" portType="ns:RiskServiceWS"/>
    </plnk:partnerLinkType>
</definitions>
'! !

!BPEL20BpelAnalyzerTest3 methodsFor: 'wsdl' stamp: 'AlvaroJosePeraltaOcampo 11/12/2014 09:46'!
wsdl_getIncomingMessageFromJMSWSDL
^ '<definitions 
	name="getIncomingMessageFromJMSWSDL" 
	targetNamespace="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/getIncomingMessageFromJMSWSDL"
    xmlns="http://schemas.xmlsoap.org/wsdl/"
    xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/"
    xmlns:xsd="http://www.w3.org/2001/XMLSchema" 
    xmlns:jms="http://schemas.sun.com/jbi/wsdl-extensions/jms/" 
    xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/getIncomingMessageFromJMSWSDL" 
    xmlns:plnk="http://docs.oasis-open.org/wsbpel/2.0/plnktype" 
    xmlns:ns0="http://xml.netbeans.org/schema/novateTradeComposed">
    <types>
        <xsd:schema targetNamespace="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/getIncomingMessageFromJMSWSDL">
            <xsd:import namespace="http://xml.netbeans.org/schema/novateTradeComposed" schemaLocation="novateTradeComposed.xsd"/>
        </xsd:schema>
    </types>   
    <message name="JMSInputMessage">
        <part name="part1" element="ns0:novateTradeComposed"/>
    </message>    
    <portType name="JMSInPortType">
        <operation name="JMSInOperation">
            <input name="input1" message="tns:JMSInputMessage"/>
        </operation>
    </portType>
    <binding name="JMSInBinding" type="tns:JMSInPortType">
        <jms:binding/>
        <operation name="JMSInOperation">
            <jms:operation destination="OTCIncomingMessagesQueue" destinationType="Queue" transaction="XATransaction" concurrencyMode="cc" maxConcurrentConsumers="30"/>
            <input name="input1">
                <jms:message messageType="TextMessage" textPart="part1"/>
            </input>
        </operation>
    </binding>
    <service name="JMSInService">
        <port name="getIncomingMessageFromJMSWSDL_InPort" binding="tns:JMSInBinding">
            <jms:address connectionURL="${JmsDefaultURL}" username="guest" password="guest">
                <jms:jmsjcaOptions><!![CDATA[]]></jms:jmsjcaOptions>
            </jms:address>
        </port>
    </service>
    <plnk:partnerLinkType name="getIncomingMessageFromJMSWSDL">
        <!!-- A partner link type is automatically generated when a new port type is added. Partner link types are used by BPEL processes. 
In a BPEL process, a partner link represents the interaction between the BPEL process and a partner service. Each partner link is associated with a partner link type.
A partner link type characterizes the conversational relationship between two services. The partner link type can have one or two roles.-->
        <plnk:role name="JMSInPortTypeRole" portType="tns:JMSInPortType"/>
    </plnk:partnerLinkType>
</definitions>
'! !

!BPEL20BpelAnalyzerTest3 methodsFor: 'wsdl' stamp: 'AlvaroJosePeraltaOcampo 11/12/2014 09:46'!
wsdl_novateTradeWSDL
^ '<?xml version="1.0" encoding="UTF-8"?>
<definitions name="novateTradeWSDL" targetNamespace="http://j2ee.netbeans.org/wsdl/novateTrade-bpel/novateTradeWSDL"
    xmlns="http://schemas.xmlsoap.org/wsdl/"
    xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/"
    xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:tns="http://j2ee.netbeans.org/wsdl/novateTrade-bpel/novateTradeWSDL" xmlns:ns="http://xml.netbeans.org/schema/xsdNovateTrade" xmlns:plnk="http://docs.oasis-open.org/wsbpel/2.0/plnktype" xmlns:soap="http://schemas.xmlsoap.org/wsdl/soap/" xmlns:wsu="http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-utility-1.0.xsd" xmlns:wspp="http://java.sun.com/xml/ns/wsit/policy">
    <types>
        <xsd:schema targetNamespace="http://j2ee.netbeans.org/wsdl/novateTrade-bpel/novateTradeWSDL">
            <xsd:import namespace="http://xml.netbeans.org/schema/xsdNovateTrade" schemaLocation="xsdNovateTrade.xsd"/>
        </xsd:schema>
    </types>
    <message name="novateTradeRequest">
        <part name="rtc" element="ns:novateTrade"/>
	<part name="headerPart" element="ns:headerCRCC"/>
    </message>
    <portType name="novateTradeWSDLPortType">
        <operation name="novateTrade">
            <input name="input1" message="tns:novateTradeRequest"/>
        </operation>
    </portType>
    <binding name="novateTradeWSDLBinding" type="tns:novateTradeWSDLPortType">
        <soap:binding style="document" transport="http://schemas.xmlsoap.org/soap/http"/>
        <operation name="novateTrade">
            <soap:operation soapAction="novateTrade"/>
            <input name="input1">
                <soap:body use="literal" parts="rtc"/>
                <soap:header message="tns:novateTradeRequest" part="headerPart" use="literal"/>                
            </input>
        </operation>
    </binding>
    <service name="novateTradeWSDLService">
        <port name="novateTradeWSDLPort" binding="tns:novateTradeWSDLBinding">
            <soap:address location="http://localhost:${HttpDefaultPort}/novateTradeWSDLService/novateTradeWSDLPort"/>
        </port>
    </service>
    <plnk:partnerLinkType name="novateTradeWSDL">
        <!!-- A partner link type is automatically generated when a new port type is added. Partner link types are used by BPEL processes. 
In a BPEL process, a partner link represents the interaction between the BPEL process and a partner service. Each partner link is associated with a partner link type.
A partner link type characterizes the conversational relationship between two services. The partner link type can have one or two roles.-->
        <plnk:role name="novateTradeWSDLPortTypeRole" portType="tns:novateTradeWSDLPortType"/>
    </plnk:partnerLinkType>
</definitions>
'! !

!BPEL20BpelAnalyzerTest3 methodsFor: 'wsdl' stamp: 'AlvaroJosePeraltaOcampo 11/12/2014 09:46'!
wsdl_processTradeConfirmedWSDL
^ '<?xml version="1.0" encoding="UTF-8"?>
<definitions name="processTradeConfirmedWSDL" targetNamespace="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/processTradeConfirmedWSDL"
    xmlns="http://schemas.xmlsoap.org/wsdl/"
    xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/"
    xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:tns="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/processTradeConfirmedWSDL" xmlns:ns="http://xml.netbeans.org/schema/processTradeConfirmed" xmlns:plnk="http://docs.oasis-open.org/wsbpel/2.0/plnktype" xmlns:soap="http://schemas.xmlsoap.org/wsdl/soap/">
    <types>
        <xsd:schema targetNamespace="http://j2ee.netbeans.org/wsdl/processNovateTradeProcess/processTradeConfirmedWSDL">
            <xsd:import namespace="http://xml.netbeans.org/schema/processTradeConfirmed" schemaLocation="processTradeConfirmed.xsd"/>
        </xsd:schema>
    </types>
    <message name="processTradeConfirmedWSDLOperationRequest">
        <part name="tradeConfirmedIn" element="ns:processNovateTradeIn"/>
    </message>
    <portType name="processTradeConfirmedWSDLPortType">
        <operation name="processTradeConfirmedWSDLOperation">
            <input name="input1" message="tns:processTradeConfirmedWSDLOperationRequest"/>
        </operation>
    </portType>
    <binding name="processTradeConfirmedWSDLBinding" type="tns:processTradeConfirmedWSDLPortType">
        <soap:binding style="document" transport="http://schemas.xmlsoap.org/soap/http"/>
        <operation name="processTradeConfirmedWSDLOperation">
            <soap:operation/>
            <input name="input1">
                <soap:body use="literal"/>
            </input>
        </operation>
    </binding>
    <service name="processTradeConfirmedWSDLService">
        <port name="processTradeConfirmedWSDLPort" binding="tns:processTradeConfirmedWSDLBinding">
            <soap:address location="http://localhost:${HttpDefaultPort}/processTradeConfirmedWSDLService/processTradeConfirmedWSDLPort"/>
        </port>
    </service>
    <plnk:partnerLinkType name="processTradeConfirmedWSDL">
        <!!-- A partner link type is automatically generated when a new port type is added. Partner link types are used by BPEL processes. 
In a BPEL process, a partner link represents the interaction between the BPEL process and a partner service. Each partner link is associated with a partner link type.
A partner link type characterizes the conversational relationship between two services. The partner link type can have one or two roles.-->
        <plnk:role name="processTradeConfirmedWSDLPortTypeRole" portType="tns:processTradeConfirmedWSDLPortType"/>
    </plnk:partnerLinkType>
</definitions>
'! !

!BPEL20BpelAnalyzerTest3 methodsFor: 'wsdl' stamp: 'AlvaroJosePeraltaOcampo 11/12/2014 09:46'!
wsdl_putIncomingMessageToJMS
^ '<definitions name="putIncomingMessageToJMS" targetNamespace="http://j2ee.netbeans.org/wsdl/novateTradeProcess/putIncomingMessageToJMS"
    xmlns="http://schemas.xmlsoap.org/wsdl/"
    xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/"
    xmlns:xsd="http://www.w3.org/2001/XMLSchema" 
    xmlns:jms="http://schemas.sun.com/jbi/wsdl-extensions/jms/" xmlns:tns="http://j2ee.netbeans.org/wsdl/novateTradeProcess/putIncomingMessageToJMS" xmlns:ns="http://xml.netbeans.org/schema/novateTradeComposed" xmlns:plnk="http://docs.oasis-open.org/wsbpel/2.0/plnktype">
    <types>
        <xsd:schema targetNamespace="http://j2ee.netbeans.org/wsdl/novateTradeProcess/putIncomingMessageToJMS">
            <xsd:import namespace="http://xml.netbeans.org/schema/novateTradeComposed" schemaLocation="novateTradeComposed.xsd"/>
        </xsd:schema>
    </types>
    <message name="JMSInputMessage">
        <part name="part1" element="ns:novateTradeComposed"/>
    </message>  
    <portType name="JMSOutPortType">
        <operation name="JMSOutOperation">
            <input name="input1" message="tns:JMSInputMessage"/>
        </operation>
    </portType>
    <binding name="JMSOutBinding" type="tns:JMSOutPortType">
        <jms:binding/>
        <operation name="JMSOutOperation">
            <jms:operation destination="OTCIncomingMessagesQueue" destinationType="Queue" transaction="NoTransaction" deliveryMode="PERSISTENT" priority="4" timeout="300000" maxConcurrentConsumers="30" concurrencyMode="cc"/>
            <input name="input1">
                <jms:message messageType="TextMessage" textPart="part1"/>
            </input>
        </operation>
    </binding>
    <service name="JMSOutService">
        <port name="putIncomingMessageToJMS_OutPort" binding="tns:JMSOutBinding">
            <jms:address connectionURL="${JmsDefaultURL}" username="guest" password="guest">
                <jms:jmsjcaOptions><!![CDATA[]]></jms:jmsjcaOptions>
            </jms:address>
        </port>
    </service>
    <plnk:partnerLinkType name="putIncomingMessageToJMS">
        <!!-- A partner link type is automatically generated when a new port type is added. Partner link types are used by BPEL processes. 
In a BPEL process, a partner link represents the interaction between the BPEL process and a partner service. Each partner link is associated with a partner link type.
A partner link type characterizes the conversational relationship between two services. The partner link type can have one or two roles.-->
        <plnk:role name="JMSOutPortTypeRole" portType="tns:JMSOutPortType"/>
    </plnk:partnerLinkType>
</definitions>
'! !

BPEL20BPSourceTest subclass: #BPEL20BpelAnalyzerTest4
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-Tests-BPEL20-source'!

!BPEL20BpelAnalyzerTest4 class methodsFor: 'bpel' stamp: 'AlvaroJosePeraltaOcampo 12/1/2014 14:54'!
bpelEmpty
	^ ''! !

!BPEL20BpelAnalyzerTest4 class methodsFor: 'bpel' stamp: 'AlvaroJosePeraltaOcampo 11/12/2014 09:58'!
bpel_B2BOrderProcessingEngine
	^ '<?xml version = ''1.0'' encoding = ''UTF-8''?>
<!!--
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  Oracle JDeveloper BPEL Designer 
  
  Created: Wed Nov 19 20:14:51 PST 2008
  Author:  cutschig
  Purpose: Empty BPEL Process
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
-->
<process xml:id="id1" name="B2BOrderProcessingEngine" targetNamespace="http://xmlns.oracle.com/CompositeServices11gMain/B2BX12OrderGateway/B2BOrderProcessingEngine" xmlns="http://schemas.xmlsoap.org/ws/2003/03/business-process/" xmlns:client="http://xmlns.oracle.com/CompositeServices11gMain/B2BX12OrderGateway/B2BOrderProcessingEngine" xmlns:ora="http://schemas.oracle.com/xpath/extension" xmlns:oraext="http://www.oracle.com/XSL/Transform/java/oracle.tip.pc.services.functions.ExtFunc" xmlns:xpath20="http://www.oracle.com/XSL/Transform/java/oracle.tip.pc.services.functions.Xpath20" xmlns:ldap="http://schemas.oracle.com/xpath/extension/ldap" xmlns:bpelx="http://schemas.oracle.com/bpel/extension" xmlns:bpws="http://schemas.xmlsoap.org/ws/2003/03/business-process/" xmlns:ns1="http://www.oracle.com/integration/b2b/B2B_po_X12_inbound/" xmlns:ns2="www.globalcompany.example.com" xmlns:ns3="http://www.oracle.com/integration/b2b/B2B_orderconfirmation_x12/" xmlns:ns4="http://www.globalcompany.example.com/ns/OrderBookingService" xmlns:ns5="/oracle/fodemo/storefront/store/queries/common/" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:dvm="http://www.oracle.com/XSL/Transform/java/oracle.tip.dvm.LookupValue" xmlns:xdk="http://schemas.oracle.com/bpel/extension/xpath/function/xdk" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xref="http://www.oracle.com/XSL/Transform/java/oracle.tip.xref.xpath.XRefXPathFunctions" xmlns:ns6="www.globalcompany.example.com/types/" xmlns:ns7="http://www.globalcompany.example.com/b2b/utils" xmlns:hwf="http://xmlns.oracle.com/bpel/workflow/xpath" xmlns:mhdr="http://www.oracle.com/XSL/Transform/java/oracle.tip.mediator.service.common.functions.GetRequestHeaderExtnFunction" xmlns:med="http://schemas.oracle.com/mediator/xpath" xmlns:ids="http://xmlns.oracle.com/bpel/services/IdentityService/xpath" xmlns:socket="http://www.oracle.com/XSL/Transform/java/oracle.tip.adapter.socket.ProtocolTranslator" xmlns:ns8="/oracle/fodemo/storefront/entities/events/edl/OrderEO" xmlns:ns9="/oracle/fodemo/storefront/entities/events/schema/OrderEO" xmlns:ns10="http://xmlns.oracle.com/CompositeServices11gMain/B2BX12OrderGateway/B2BOrderProcessingEngine/correlationset" xmlns:ns11="urn:oracle:b2b:X12/V4010/855">
  <!!-- 
    ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
      PARTNERLINKS                                                      
      List of services participating in this BPEL process               
    ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  -->
  <bpelx:annotation><bpelx:analysis><bpelx:property name="propertiesFile"><!![CDATA[WSDLs/B2BOrderProcessingEngine_properties.wsdl]]></bpelx:property></bpelx:analysis></bpelx:annotation><partnerLinks xml:id="id2">
    <partnerLink xml:id="id5" myRole="receive_role" name="B2B_po_X12_inbound" partnerLinkType="ns1:B2B_receive_plt"/>
    <partnerLink xml:id="id6" name="StoreFrontService" partnerRole="StoreFrontService" partnerLinkType="ns2:StorefrontService"/>
    <partnerLink xml:id="id7" name="B2B_orderconfirmation_x12" partnerRole="send_role" partnerLinkType="ns3:B2B_send_plt"/>
    <partnerLink xml:id="id8" myRole="OrderProcessorRequester" name="OrderBookingService" partnerRole="OrderProcessorProvider" partnerLinkType="ns4:OrderProcessor"/>
  </partnerLinks>
  <!!-- 
    ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
      VARIABLES                                                        
      List of messages and XML documents used within this BPEL process 
    ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  -->
  <variables xml:id="id3">
    <variable xml:id="id10" name="gX12OrderVariable" messageType="ns1:B2BMsg"/>
    <variable xml:id="id20" name="gX12OrderOrderConfirmationGeneration" messageType="ns3:B2BMsg"/>
    <variable name="Variable_docProtVersion" type="xsd:string"/>
    <variable name="Variable_docTypeName" type="xsd:string"/>
    <variable name="Variable_fromTP" type="xsd:string"/>
    <variable name="Variable_tpTP" type="xsd:string"/>
    <variable name="Variable_msgID" type="xsd:string"/>
    <variable name="Variable_msgType" type="xsd:string"/>
    <variable xml:id="id56" name="gOrderVariable" messageType="ns2:StoreFrontService_createOrderInfoVOSDO"/>
    <variable xml:id="id61" name="gFaultVariable" messageType="ns7:B2BOrderProcessorFault"/>
    <variable name="aperalta" messageType="ns3:B2BMsg"/>
  </variables>
  <faultHandlers xml:id="id59">
    <catchAll xml:id="id60">
      <assign xml:id="id62" name="Assign_ProcessingFault">
        <copy xml:id="id63">
          <from xml:id="id64" expression="ora:getFaultName()"/>
          <to xml:id="id65" variable="gFaultVariable" part="code"/>
        </copy>
        <copy xml:id="id66">
          <from xml:id="id67" expression="ora:getFaultAsString()"/>
          <to xml:id="id68" variable="gFaultVariable" part="summary"/>
        </copy>
      </assign>
    </catchAll>
  </faultHandlers>
  <!!-- 
    ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
     ORCHESTRATION LOGIC                                               
     Set of activities coordinating the flow of messages across the    
     services integrated within this business process                  
    ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  -->
  <sequence xml:id="id4" name="main">
    <receive xml:id="id9" name="Receive_X12Order" createInstance="yes" variable="gX12OrderVariable" partnerLink="B2B_po_X12_inbound" portType="ns1:B2B_receive_ptt" operation="receive"/>
    <scope xml:id="id25" name="Scope_CreateOrder">
      <variables xml:id="id57">
        <variable xml:id="id58" name="lOrderCreationResponse" messageType="ns2:StoreFrontService_createOrderInfoVOSDOResponse"/>
      </variables>
      <sequence xml:id="id51">
        <assign xml:id="id50" name="Transform_850ToCanicalOrder">
          <bpelx:annotation>
            <bpelx:pattern>transformation</bpelx:pattern>
          </bpelx:annotation>
          <copy xml:id="id52">
            <from xml:id="id53" expression="ora:processXSLT(''xsl/Transformation_From850X12_To_CanonicalOrderSchema.xsl'',bpws:getVariableData(''gX12OrderVariable'',''body''))"/>
            <to xml:id="id54" variable="gOrderVariable" part="parameters"/>
          </copy>
        </assign>
        <invoke xml:id="id55" name="Invoke_CreateOrder" inputVariable="gOrderVariable" outputVariable="lOrderCreationResponse" partnerLink="StoreFrontService" portType="ns2:StoreFrontService" operation="createOrderInfoVOSDO"/>
      </sequence>
    </scope>
    <bpelx:exec name="setTitleOfComposite" version="1.5" language="java">
      try  
{ 

    // variable="gOrderVariable" query="/ns6:createOrderInfoVOSDO/ns6:orderInfoVO1/ns5:OrderId" part="parameters"
    String orderId = ((oracle.xml.parser.v2.XMLElement)getVariableData("gOrderVariable","parameters","/ns6:createOrderInfoVOSDO/ns6:orderInfoVO1/ns5:OrderId")).getFirstChild().getNodeValue(); 
    setCompositeInstanceTitle("B2B OrderGateway, processing order: " + orderId); 
} 
catch (Exception e)  
{ 
    addAuditTrailEntry("Could not set title: " + e.getMessage()); 
}
    </bpelx:exec>
    <scope xml:id="id12" name="Scope_FulfillOrderRequest">
      <variables xml:id="id17">
        <variable xml:id="id18" name="lProcessingResponse" messageType="ns4:OrderProcessorResponseMessage"/>
        <variable xml:id="id21" name="lOrderIdForProcessing" messageType="ns4:OrderProcessorRequestMessage"/>
        <variable xml:id="id23" name="lOrderProcessingFault" messageType="ns4:OrderProcessorFault"/>
        <variable xml:id="id76" name="lNewOrderSubmittedEvent" element="ns9:NewOrderSubmittedInfo"/>
        <variable xml:id="id81" name="lOrderCompletedEventInfo" element="ns9:OrderCompletedInfo"/>
      </variables>
      <correlationSets xml:id="id82">
        <correlationSet xml:id="id83" name="CorrelationSet_OrderIdForEvent" properties="ns10:orderId"/>
      </correlationSets>
      <sequence xml:id="id16">
        <switch xml:id="id69" name="Switch_EventBased">
          <case xml:id="id70" condition="ora:getConfigProperty(''use.events'') = ''true''">
            <bpelx:annotation>
              <bpelx:pattern>use.events property = true is set on the composite''s component</bpelx:pattern>
            </bpelx:annotation>
            <sequence xml:id="id75">
              <assign name="Assign_OrderIdIntoEvent">
                <copy>
                  <from variable="gOrderVariable" part="parameters" query="/ns6:createOrderInfoVOSDO/ns6:orderInfoVO1/ns5:OrderId"/>
                  <to variable="lNewOrderSubmittedEvent" query="/ns9:NewOrderSubmittedInfo/ns9:OrderId/ns9:newValue/@value"/>
                </copy>
              </assign>
              <invoke xml:id="id74" name="Invoke_SendEventForProcessor" bpelx:eventName="ns8:NewOrderSubmitted" inputVariable="lNewOrderSubmittedEvent">
                <correlations>
                  <correlation xml:id="id85" initiate="yes" set="CorrelationSet_OrderIdForEvent" pattern="out"/>
                </correlations>
              </invoke>
            </sequence>
          </case>
          <otherwise xml:id="id71">
            <sequence xml:id="id72">
              <assign xml:id="id33" name="Assign_OrderId">
                <copy xml:id="id34">
                  <from xml:id="id35" variable="gOrderVariable" query="/ns6:createOrderInfoVOSDO/ns6:orderInfoVO1/ns5:OrderId" part="parameters"/>
                  <to xml:id="id36" variable="lOrderIdForProcessing" part="payload" query="/ns4:process/ns4:orderId"/>
                </copy>
              </assign>
              <invoke xml:id="id11" name="Invoke_ProcessOrder" inputVariable="lOrderIdForProcessing" partnerLink="OrderBookingService" portType="ns4:OrderProcessor" operation="process"/>
            </sequence>
          </otherwise>
        </switch>
        <switch xml:id="id92" name="Switch_isEventBased">
          <case xml:id="id93" condition="ora:getConfigProperty(''use.events'') = ''true''">
            <bpelx:annotation>
              <bpelx:pattern>in case event is set to true</bpelx:pattern>
            </bpelx:annotation>
            <sequence xml:id="id100">
              <receive xml:id="id95" name="Receive_CompletedEvent" createInstance="no" bpelx:eventName="ns8:OrderCompleted" variable="lOrderCompletedEventInfo">
                <correlations>
                  <correlation xml:id="id97" initiate="no" set="CorrelationSet_OrderIdForEvent"/>
                </correlations>
              </receive>
                  <assign name="Transform_CreateAck">
                    <bpelx:annotation>
                      <bpelx:pattern>transformation</bpelx:pattern>
                    </bpelx:annotation>
                    <copy>
                      <from expression="ora:processXSLT(''xsl/transform_x12OrderToX12Ack.xsl'',bpws:getVariableData(''gX12OrderVariable'',''body''))"/>
                      <to variable="gX12OrderOrderConfirmationGeneration" part="body"/>
                    </copy>
                  </assign>
                  <assign name="Assign_Types">
                <copy>
                  <from expression="&quot;4010&quot;"/>
                  <to variable="Variable_docProtVersion"/>
                </copy>
                <copy>
                  <from expression="&quot;855&quot;"/>
                  <to variable="Variable_docTypeName"/>
                </copy>
                <copy>
                  <from expression="&quot;OracleServices&quot;"/>
                  <to variable="Variable_fromTP"/>
                </copy>
                <copy>
                  <from expression="&quot;MarketInc&quot;"/>
                  <to variable="Variable_tpTP"/>
                </copy>
                <copy>
                  <from expression="oraext:generate-guid()"/>
                  <to variable="Variable_msgID"/>
                </copy>
                <copy>
                  <from expression="&quot;1&quot;"/>
                  <to variable="Variable_msgType"/>
                </copy>
              </assign>
                  <invoke name="Invoke_OrderOrderConfirmationGeneration" inputVariable="gX12OrderOrderConfirmationGeneration" partnerLink="B2B_orderconfirmation_x12" portType="ns3:B2B_send_ptt" operation="send">
                    <bpelx:inputProperty name="b2b.documentProtocolVersion" variable="Variable_docProtVersion"/>
                    <bpelx:inputProperty name="b2b.documentTypeName" variable="Variable_docTypeName"/>
                    <bpelx:inputProperty name="b2b.fromTradingPartnerId" variable="Variable_fromTP"/>
                    <bpelx:inputProperty name="b2b.messageId" variable="Variable_msgID"/>
                    <bpelx:inputProperty name="b2b.messageType" variable="Variable_msgType"/>
                    <bpelx:inputProperty name="b2b.toTradingPartnerId" variable="Variable_tpTP"/>
                  </invoke>
            </sequence>
          </case>
          <otherwise xml:id="id94">
            <pick xml:id="id13" name="Pick_OrderProcessingresult">
              <onMessage xml:id="id15" variable="lProcessingResponse" partnerLink="OrderBookingService" portType="ns4:OrderProcessorCallback" operation="processResponse">
                <sequence xml:id="id45">
                  <assign xml:id="id44" name="Transform_CreateAck">
                    <bpelx:annotation>
                      <bpelx:pattern>transformation</bpelx:pattern>
                    </bpelx:annotation>
                    <copy xml:id="id46">
                      <from xml:id="id47" expression="ora:processXSLT(''xsl/transform_x12OrderToX12Ack.xsl'',bpws:getVariableData(''gX12OrderVariable'',''body''))"/>
                      <to xml:id="id48" variable="gX12OrderOrderConfirmationGeneration" part="body"/>
                    </copy>
                  </assign>
                  <assign name="Assign_Types">
                    <copy>
                      <from expression="&quot;4010&quot;"/>
                      <to variable="Variable_docProtVersion"/>
                    </copy>
                    <copy>
                      <from expression="&quot;855&quot;"/>
                      <to variable="Variable_docTypeName"/>
                    </copy>
                    <copy>
                      <from expression="&quot;OracleServices&quot;"/>
                      <to variable="Variable_fromTP"/>
                    </copy>
                    <copy>
                      <from expression="&quot;MarketInc&quot;"/>
                      <to variable="Variable_tpTP"/>
                    </copy>
                    <copy>
                      <from expression="oraext:generate-guid()"/>
                      <to variable="Variable_msgID"/>
                    </copy>
                    <copy>
                      <from expression="&quot;1&quot;"/>
                      <to variable="Variable_msgType"/>
                    </copy>
                  </assign>
                  <invoke xml:id="id19" name="Invoke_OrderOrderConfirmationGeneration" inputVariable="gX12OrderOrderConfirmationGeneration" partnerLink="B2B_orderconfirmation_x12" portType="ns3:B2B_send_ptt" operation="send">
                    <bpelx:inputProperty name="b2b.documentProtocolVersion" variable="Variable_docProtVersion"/>
                    <bpelx:inputProperty name="b2b.documentTypeName" variable="Variable_docTypeName"/>
                    <bpelx:inputProperty name="b2b.fromTradingPartnerId" variable="Variable_fromTP"/>
                    <bpelx:inputProperty name="b2b.messageId" variable="Variable_msgID"/>
                    <bpelx:inputProperty name="b2b.messageType" variable="Variable_msgType"/>
                    <bpelx:inputProperty name="b2b.toTradingPartnerId" variable="Variable_tpTP"/>
                  </invoke>
                </sequence>
              </onMessage>
              <onMessage xml:id="id22" variable="lOrderProcessingFault" partnerLink="OrderBookingService" portType="ns4:OrderProcessorCallback" operation="processFault">
                <bpelx:annotation>
                  <bpelx:pattern/>
                </bpelx:annotation>
                <terminate xml:id="id24" name="Terminate_Instance"/>
              </onMessage>
            </pick>
          </otherwise>
        </switch>
      </sequence>
    </scope>
  </sequence>
</process>
	'! !

!BPEL20BpelAnalyzerTest4 class methodsFor: 'bpel' stamp: 'AlvaroJosePeraltaOcampo 11/12/2014 09:58'!
bpel_CustomerAndOrderService
^ '<?xml version = "1.0" encoding = "UTF-8" ?>
<!!--
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  Oracle JDeveloper BPEL Designer 
  
  Created: Sun Oct 12 15:20:24 PDT 2008
  Author:  cutschig
  Purpose: Synchronous BPEL Process
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
-->
<process name="CustomerAndOrderService"
               targetNamespace="http://xmlns.oracle.com/TestRules/OrderSDOComposite/CustomerAndOrderService"
               xmlns="http://schemas.xmlsoap.org/ws/2003/03/business-process/"
               xmlns:client="http://xmlns.oracle.com/TestRules/OrderSDOComposite/CustomerAndOrderService"
               xmlns:ora="http://schemas.oracle.com/xpath/extension"
               xmlns:orcl="http://www.oracle.com/XSL/Transform/java/oracle.tip.pc.services.functions.ExtFunc"
               xmlns:xp20="http://www.oracle.com/XSL/Transform/java/oracle.tip.pc.services.functions.Xpath20"
               xmlns:ldap="http://schemas.oracle.com/xpath/extension/ldap"
               xmlns:bpelx="http://schemas.oracle.com/bpel/extension"
               xmlns:ns1="www.globalcompany.example.com"
               xmlns:bpws="http://schemas.xmlsoap.org/ws/2003/03/business-process/"
         xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
         xmlns:ns2="www.globalcompany.example.com/types/"
         xmlns:ns3="/oracle/fodemo/storefront/store/queries/common/"
         xmlns:ns9="http://www.oracle.com/XSL/Transform/java/oracle.tip.dvm.LookupValue"
         xmlns:ns7="http://www.oracle.com/XSL/Transform/java/oracle.tip.mediator.service.common.functions.GetRequestHeaderExtnFunction"
         xmlns:ns6="http://xmlns.oracle.com/bpel/services/IdentityService/xpath"
         xmlns:ns10="http://schemas.oracle.com/bpel/extension/xpath/function/xdk"
         xmlns:ns8="http://www.oracle.com/XSL/Transform/java/oracle.tip.xref.xpath.XRefXPathFunctions"
         xmlns:ns4="http://xmlns.oracle.com/adf/svc/types/"
         xmlns:ns5="http://xmlns.oracle.com/adf/svc/errors/"
         xmlns:hwf="http://xmlns.oracle.com/bpel/workflow/xpath"
         xmlns:med="http://schemas.oracle.com/mediator/xpath"
         xmlns:socket="http://www.oracle.com/XSL/Transform/java/oracle.tip.adapter.socket.ProtocolTranslator"
         xmlns:xsd="http://www.w3.org/2001/XMLSchema">

  <!!-- 
    ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
      PARTNERLINKS                                                      
      List of services participating in this BPEL process               
    ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  --> 
  <partnerLinks>
    <!!-- 
      The ''client'' role represents the requester of this service. It is 
      used for callback. The location and correlation information associated
      with the client role are automatically set using WS-Addressing.
    -->
    <partnerLink name="customerandorderservice_client" partnerLinkType="ns1:StorefrontService" 
        myRole="StoreFrontService"/>
  </partnerLinks>

  <!!-- 
    ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
      VARIABLES                                                        
      List of messages and XML documents used within this BPEL process 
    ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  -->
  <variables>
    <!!-- Reference to the message passed as input during initiation -->
    <variable name="inputVariable" messageType="ns1:StoreFrontService_findCustomerInfoVO1"/>

    <!!-- Reference to the message that will be returned to the requester-->
    <variable name="outputVariable" messageType="ns1:StoreFrontService_findCustomerInfoVO1Response"/>
    <variable name="OnMessage_findCustomerInfoVO1CustomerInfoVOCriteria_InputVariable"
              messageType="ns1:StoreFrontService_findCustomerInfoVO1CustomerInfoVOCriteria"/>
    <variable name="Reply_findCustomerInfoVOByCriteria_findCustomerInfoVO1CustomerInfoVOCriteria_OutputVariable"
              messageType="ns1:StoreFrontService_findCustomerInfoVO1CustomerInfoVOCriteriaResponse"/>
    <variable name="OnMessage_getOrderInfoVOSDO_InputVariable"
              messageType="ns1:StoreFrontService_getOrderInfoVOSDO"/>
    <variable name="Reply_getOrderInfoVO_getOrderInfoVOSDO_OutputVariable"
              messageType="ns1:StoreFrontService_getOrderInfoVOSDOResponse"/>
    <variable name="OnMessage_findOrderInfoVOSDO_InputVariable"
              messageType="ns1:StoreFrontService_findOrderInfoVOSDO"/>
    <variable name="Reply_findOrderInfoVO_findOrderInfoVOSDO_OutputVariable"
              messageType="ns1:StoreFrontService_findOrderInfoVOSDOResponse"/>
    <variable name="OnMessage_processOrderInfoVOSDO_InputVariable"
              messageType="ns1:StoreFrontService_processOrderInfoVOSDO"/>
    <variable name="Reply_ProcessOrderInfoVO_processOrderInfoVOSDO_OutputVariable"
              messageType="ns1:StoreFrontService_processOrderInfoVOSDOResponse"/>
    <variable name="OnMessage_processCSOrderInfoVOSDO_InputVariable"
              messageType="ns1:StoreFrontService_processCSOrderInfoVOSDO"/>
    <variable name="Reply_ProcessOrderVOCS_processCSOrderInfoVOSDO_OutputVariable"
              messageType="ns1:StoreFrontService_processCSOrderInfoVOSDOResponse"/>
    <variable name="OnMessage_updateOrderInfoVOSDO_InputVariable"
              messageType="ns1:StoreFrontService_updateOrderInfoVOSDO"/>
    <variable name="Reply_UpdateOrderInfoVO_updateOrderInfoVOSDO_OutputVariable"
              messageType="ns1:StoreFrontService_updateOrderInfoVOSDOResponse"/>
    <variable xml:id="id80" name="createOrderInfoVOSDO_InputVariable"
              messageType="ns1:StoreFrontService_createOrderInfoVOSDO"/>
    <variable xml:id="id82" name="createOrderInfoVOSDO_OutputVariable"
              messageType="ns1:StoreFrontService_createOrderInfoVOSDOResponse"/>
  </variables>

  <!!-- 
    ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
     ORCHESTRATION LOGIC                                               
     Set of activities coordinating the flow of messages across the    
     services integrated within this business process                  
    ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  -->
  <sequence name="main">

    <!!-- Receive input from requestor. (Note: This maps to operation defined in CustomerAndOrderService.wsdl) -->

    <!!-- Generate reply to synchronous request -->
    <pick name="Pick_Operation" createInstance="yes">
      <onMessage variable="inputVariable"
                 partnerLink="customerandorderservice_client"
                 portType="ns1:StoreFrontService"
                 operation="findCustomerInfoVO1">
        <sequence>
          <assign name="Assign_FindCustomerInfo">
            <copy>
              <from>
                <ns2:result xmlns:ns2="www.globalcompany.example.com/types/"
                            xmlns:ns3="/oracle/fodemo/storefront/store/queries/common/">
                  <ns3:PersonId>10</ns3:PersonId>
                  <ns3:FirstName>Clemens</ns3:FirstName>
                  <ns3:LastName>Utschig</ns3:LastName>
                  <ns3:ConfirmedEmail>clemens.utschig@oracle.example.com</ns3:ConfirmedEmail>
                  <ns3:MobilePhoneNumber/>
                  <ns3:MembershipId/>
                  <ns3:MembershipTypeCode/>
                </ns2:result>
              </from>
              <to variable="outputVariable" part="parameters"
                  query="/ns2:findCustomerInfoVO1Response/ns2:result"/>
            </copy>
            <copy xml:id="id1">
              <from xml:id="id2" variable="inputVariable" part="parameters"
                    query="/ns2:findCustomerInfoVO1"/>
              <to xml:id="id3" variable="inputVariable" part="parameters"
                  query="/ns2:findCustomerInfoVO1"/>
            </copy>
          </assign>
          <reply name="Reply_findCustomerInfo" variable="outputVariable"
                 partnerLink="customerandorderservice_client"
                 portType="ns1:StoreFrontService"
                 operation="findCustomerInfoVO1"/>
        </sequence>
      </onMessage>
      <onMessage variable="OnMessage_findCustomerInfoVO1CustomerInfoVOCriteria_InputVariable"
                 partnerLink="customerandorderservice_client"
                 portType="ns1:StoreFrontService"
                 operation="findCustomerInfoVO1CustomerInfoVOCriteria">
        <bpelx:annotation>
          <bpelx:pattern></bpelx:pattern>
        </bpelx:annotation>
        <sequence>
          <assign name="Assign_FindCustomerInfoByVC">
            <copy xml:id="id4">
              <from xml:id="id5"
                    variable="OnMessage_findCustomerInfoVO1CustomerInfoVOCriteria_InputVariable"
                    part="parameters"
                    query="/ns2:findCustomerInfoVO1CustomerInfoVOCriteria"/>
              <to xml:id="id6"
                  variable="OnMessage_findCustomerInfoVO1CustomerInfoVOCriteria_InputVariable"
                  part="parameters"
                  query="/ns2:findCustomerInfoVO1CustomerInfoVOCriteria"/>
            </copy>
            <copy>
              <from>
                <ns2:result xmlns:ns2="www.globalcompany.example.com/types/"
                            xmlns:ns3="/oracle/fodemo/storefront/store/queries/common/">
                  <ns3:PersonId/>
                  <ns3:FirstName/>
                  <ns3:LastName/>
                  <ns3:ConfirmedEmail/>
                  <ns3:MobilePhoneNumber/>
                  <ns3:MembershipId/>
                  <ns3:MembershipTypeCode/>
                </ns2:result>
              </from>
              <to variable="Reply_findCustomerInfoVOByCriteria_findCustomerInfoVO1CustomerInfoVOCriteria_OutputVariable"
                  part="parameters"
                  query="/ns2:findCustomerInfoVO1CustomerInfoVOCriteriaResponse/ns2:result"/>
            </copy>
          </assign>
          <switch xml:id="id13" name="Switch_ByCustomerId">
            <case xml:id="id20"
                  condition="bpws:getVariableData(''OnMessage_findCustomerInfoVO1CustomerInfoVOCriteria_InputVariable'',''parameters'',''/ns2:findCustomerInfoVO1CustomerInfoVOCriteria/ns2:CustId'') = 20">
              <bpelx:annotation>
                <bpelx:pattern>customerId = 20</bpelx:pattern>
              </bpelx:annotation>
              <assign xml:id="id21" name="Assign_CustomerWithId20">
                <copy xml:id="id22">
                  <from xml:id="id23">
                    <ns2:result xmlns:ns2="www.globalcompany.example.com/types/"
                                xmlns:ns3="/oracle/fodemo/storefront/store/queries/common/">
                      <ns3:PersonId>20</ns3:PersonId>
                      <ns3:FirstName>Deborah</ns3:FirstName>
                      <ns3:LastName>Steiner</ns3:LastName>
                      <ns3:ConfirmedEmail>deborah.steiner@oracle.example.com</ns3:ConfirmedEmail>
                      <ns3:MobilePhoneNumber>1235550112</ns3:MobilePhoneNumber>
                      <ns3:MembershipId/>
                      <ns3:MembershipTypeCode/>
                    </ns2:result>
                  </from>
                  <to xml:id="id24"
                      variable="Reply_findCustomerInfoVOByCriteria_findCustomerInfoVO1CustomerInfoVOCriteria_OutputVariable"
                      part="parameters"
                      query="/ns2:findCustomerInfoVO1CustomerInfoVOCriteriaResponse/ns2:result"/>
                </copy>
              </assign>
            </case>
            <case xml:id="id14"
                  condition="bpws:getVariableData(''OnMessage_findCustomerInfoVO1CustomerInfoVOCriteria_InputVariable'',''parameters'',''/ns2:findCustomerInfoVO1CustomerInfoVOCriteria/ns2:CustId'') = 10">
              <bpelx:annotation>
                <bpelx:pattern>customerId = 10</bpelx:pattern>
              </bpelx:annotation>
              <assign xml:id="id16" name="Assign_CustomerWithId10">
                <copy xml:id="id17">
                  <from xml:id="id18">
                    <ns2:result xmlns:ns2="www.globalcompany.example.com/types/"
                                xmlns:ns3="/oracle/fodemo/storefront/store/queries/common/">
                      <ns3:PersonId>10</ns3:PersonId>
                      <ns3:FirstName>Clemens</ns3:FirstName>
                      <ns3:LastName>Utschig</ns3:LastName>
                      <ns3:ConfirmedEmail>clemens.utschig@oracle.example.com</ns3:ConfirmedEmail>
                      <ns3:MobilePhoneNumber>1235550111</ns3:MobilePhoneNumber>
                      <ns3:MembershipId/>
                      <ns3:MembershipTypeCode/>
                    </ns2:result>
                  </from>
                  <to xml:id="id19"
                      variable="Reply_findCustomerInfoVOByCriteria_findCustomerInfoVO1CustomerInfoVOCriteria_OutputVariable"
                      part="parameters"
                      query="/ns2:findCustomerInfoVO1CustomerInfoVOCriteriaResponse/ns2:result"/>
                </copy>
              </assign>
            </case>
          </switch>
          <reply name="Reply_findCustomerInfoVOByCriteria"
                 variable="Reply_findCustomerInfoVOByCriteria_findCustomerInfoVO1CustomerInfoVOCriteria_OutputVariable"
                 partnerLink="customerandorderservice_client"
                 portType="ns1:StoreFrontService"
                 operation="findCustomerInfoVO1CustomerInfoVOCriteria"/>
        </sequence>
      </onMessage>
      <onMessage variable="OnMessage_findOrderInfoVOSDO_InputVariable"
                 partnerLink="customerandorderservice_client"
                 portType="ns1:StoreFrontService"
                 operation="findOrderInfoVOSDO">
        <bpelx:annotation>
          <bpelx:pattern></bpelx:pattern>
        </bpelx:annotation>
        <sequence>
          <scope xml:id="id31" name="Scope_ForId">
            <variables xml:id="id33">
              <variable xml:id="id34" name="lOrderId" type="xsd:integer"/>
            </variables>
            <sequence xml:id="id32" name="Sequence_1">
              <assign name="Assign_findOrderInfoVO">
                <copy xml:id="id7">
                  <from xml:id="id8"
                        variable="OnMessage_findOrderInfoVOSDO_InputVariable"
                        part="parameters" query="/ns2:findOrderInfoVOSDO"/>
                  <to xml:id="id9"
                      variable="OnMessage_findOrderInfoVOSDO_InputVariable"
                      part="parameters" query="/ns2:findOrderInfoVOSDO"/>
                </copy>
                <copy xml:id="id35">
                  <from xml:id="id36"
                        variable="OnMessage_findOrderInfoVOSDO_InputVariable"
                        part="parameters"
                        query="/ns2:findOrderInfoVOSDO/ns2:findCriteria/ns4:filter/ns4:group/ns4:item/ns4:value"/>
                  <to xml:id="id37" variable="lOrderId"/>
                </copy>
              </assign>
              <switch xml:id="id28" name="Switch_OrderById">
                <case xml:id="id29"
                      condition="bpws:getVariableData(''lOrderId'') &lt;= 1000">
                  <bpelx:annotation>
                    <bpelx:pattern>OrderId &lt;= 1000</bpelx:pattern>
                  </bpelx:annotation>
                  <assign xml:id="id38" name="Assign_OrderAmountLowerThan2000">
                    <copy xml:id="id48">
                      <from xml:id="id49">
                        <ns2:result xmlns:ns2="www.globalcompany.example.com/types/"
                                    xmlns:ns3="/oracle/fodemo/storefront/store/queries/common/">
                          <ns3:OrderId/>
                          <ns3:OrderDate>2008-08-28T07:17:04.0Z</ns3:OrderDate>
                          <ns3:OrderStatusCode>PENDING</ns3:OrderStatusCode>
                          <ns3:OrderTotal>1999</ns3:OrderTotal>
                          <ns3:CustomerId>10</ns3:CustomerId>
                          <ns3:ShipToName>Clemens Utschig</ns3:ShipToName>
                          <ns3:ShipToPhoneNumber>1235550111</ns3:ShipToPhoneNumber>
                          <ns3:AddressId>10</ns3:AddressId>
                          <ns3:Address1>100 Oracle Parkway</ns3:Address1>
                          <ns3:City>Redwood Shores</ns3:City>
                          <ns3:PostalCode>94065</ns3:PostalCode>
                          <ns3:StateProvince>CA</ns3:StateProvince>
                          <ns3:CountryId>US</ns3:CountryId>
                          <ns3:AccountNumber>41</ns3:AccountNumber>
                          <ns3:CardTypeCode>AMEX</ns3:CardTypeCode>
                          <ns3:ExpireDate>2010-10-26T21:32:52</ns3:ExpireDate>
                          <ns3:CheckDigits>1234</ns3:CheckDigits>
                          <ns3:OrderItemsInfoVO>
                            <ns3:OrderId/>
                            <ns3:LineItemId>1</ns3:LineItemId>
                            <ns3:ProductId>1</ns3:ProductId>
                            <ns3:Quantity>1</ns3:Quantity>
                            <ns3:UnitPrice>1999</ns3:UnitPrice>
                            <ns3:ProductName>something</ns3:ProductName>
                            <ns3:SupplierName>from someone</ns3:SupplierName>
                          </ns3:OrderItemsInfoVO>
                        </ns2:result>
                      </from>
                      <to xml:id="id50"
                          variable="Reply_findOrderInfoVO_findOrderInfoVOSDO_OutputVariable"
                          part="parameters"
                          query="/ns2:findOrderInfoVOSDOResponse/ns2:result"/>
                    </copy>
                  </assign>
                </case>
                <otherwise xml:id="id30">
                  <assign xml:id="id51" name="AssignAmoutHigher2000">
                    <copy xml:id="id52">
                      <from xml:id="id53">
                        <ns2:result xmlns:ns2="www.globalcompany.example.com/types/"
                                    xmlns:ns3="/oracle/fodemo/storefront/store/queries/common/">
                          <ns3:OrderId/>
                          <ns3:OrderDate>2008-08-28T07:17:04.0Z</ns3:OrderDate>
                          <ns3:OrderStatusCode>PENDING</ns3:OrderStatusCode>
                          <ns3:OrderTotal>2001</ns3:OrderTotal>
                          <ns3:CustomerId>20</ns3:CustomerId>
                          <ns3:ShipToName>Clemens Utschig</ns3:ShipToName>
                          <ns3:ShipToPhoneNumber>1235550111</ns3:ShipToPhoneNumber>
                          <ns3:AddressId>10</ns3:AddressId>
                          <ns3:Address1>100 Oracle Parkway</ns3:Address1>
                          <ns3:City>Redwood Shores</ns3:City>
                          <ns3:PostalCode>94065</ns3:PostalCode>
                          <ns3:StateProvince>CA</ns3:StateProvince>
                          <ns3:CountryId>US</ns3:CountryId>
                          <ns3:AccountNumber>41</ns3:AccountNumber>
                          <ns3:CardTypeCode>AMEX</ns3:CardTypeCode>
                          <ns3:ExpireDate>2010-10-26T21:32:52</ns3:ExpireDate>
                          <ns3:CheckDigits>1234</ns3:CheckDigits>
                          <ns3:OrderItemsInfoVO>
                            <ns3:OrderId/>
                            <ns3:LineItemId>1</ns3:LineItemId>
                            <ns3:ProductId>1</ns3:ProductId>
                            <ns3:Quantity>1</ns3:Quantity>
                            <ns3:UnitPrice>2001</ns3:UnitPrice>
                            <ns3:ProductName>something</ns3:ProductName>
                            <ns3:SupplierName>from someone</ns3:SupplierName>
                          </ns3:OrderItemsInfoVO>
                        </ns2:result>
                      </from>
                      <to xml:id="id54"
                          variable="Reply_findOrderInfoVO_findOrderInfoVOSDO_OutputVariable"
                          part="parameters"
                          query="/ns2:findOrderInfoVOSDOResponse/ns2:result"/>
                    </copy>
                  </assign>
                </otherwise>
              </switch>
              <assign xml:id="id55" name="Assign_OrderId">
                <copy xml:id="id56">
                  <from xml:id="id57" variable="lOrderId"/>
                  <to xml:id="id58"
                      variable="Reply_findOrderInfoVO_findOrderInfoVOSDO_OutputVariable"
                      part="parameters"
                      query="/ns2:findOrderInfoVOSDOResponse/ns2:result/ns3:OrderId"/>
                </copy>
                <copy xml:id="id59">
                  <from xml:id="id60" variable="lOrderId"/>
                  <to xml:id="id61"
                      variable="Reply_findOrderInfoVO_findOrderInfoVOSDO_OutputVariable"
                      part="parameters"
                      query="/ns2:findOrderInfoVOSDOResponse/ns2:result/ns3:OrderItemsInfoVO[1]/ns3:OrderId"/>
                </copy>
              </assign>
            </sequence>
          </scope>
          <reply name="Reply_findOrderInfoVO"
                 partnerLink="customerandorderservice_client"
                 portType="ns1:StoreFrontService" operation="findOrderInfoVOSDO"
                 variable="Reply_findOrderInfoVO_findOrderInfoVOSDO_OutputVariable"/>
        </sequence>
      </onMessage>
      <onMessage variable="OnMessage_getOrderInfoVOSDO_InputVariable"
                 partnerLink="customerandorderservice_client"
                 portType="ns1:StoreFrontService" operation="getOrderInfoVOSDO">
        <bpelx:annotation>
          <bpelx:pattern></bpelx:pattern>
        </bpelx:annotation>
        <sequence>
          <switch xml:id="id62" name="Switch_OrderId">
            <case xml:id="id63"
                  condition="bpws:getVariableData(''OnMessage_getOrderInfoVOSDO_InputVariable'',''parameters'',''/ns2:getOrderInfoVOSDO/ns2:orderId'') &lt;= 1000">
              <bpelx:annotation>
                <bpelx:pattern>orderid &lt;= 1000</bpelx:pattern>
              </bpelx:annotation>
              <assign name="Assign_getOrderInfo">
                <copy xml:id="id10">
                  <from xml:id="id11"
                        variable="OnMessage_getOrderInfoVOSDO_InputVariable"
                        part="parameters" query="/ns2:getOrderInfoVOSDO"/>
                  <to xml:id="id12"
                      variable="OnMessage_getOrderInfoVOSDO_InputVariable"
                      part="parameters" query="/ns2:getOrderInfoVOSDO"/>
                </copy>
                <copy>
                  <from>
                    <ns2:result xmlns:ns2="www.globalcompany.example.com/types/"
                                xmlns:ns3="/oracle/fodemo/storefront/store/queries/common/">
                      <ns3:OrderId/>
                      <ns3:OrderDate>2008-08-28T07:17:04.0Z</ns3:OrderDate>
                      <ns3:OrderStatusCode>PENDING</ns3:OrderStatusCode>
                      <ns3:OrderTotal>1999</ns3:OrderTotal>
                      <ns3:CustomerId>10</ns3:CustomerId>
                      <ns3:ShipToName>Clemens Utschig</ns3:ShipToName>
                      <ns3:ShipToPhoneNumber>1235550111</ns3:ShipToPhoneNumber>
                      <ns3:AddressId>10</ns3:AddressId>
                      <ns3:Address1>100 Oracle Parkway</ns3:Address1>
                      <ns3:City>Redwood Shores</ns3:City>
                      <ns3:PostalCode>94065</ns3:PostalCode>
                      <ns3:StateProvince>CA</ns3:StateProvince>
                      <ns3:CountryId>US</ns3:CountryId>
                      <ns3:AccountNumber>41</ns3:AccountNumber>
                      <ns3:CardTypeCode>AMEX</ns3:CardTypeCode>
                      <ns3:ExpireDate>2010-10-26T21:32:52</ns3:ExpireDate>
                      <ns3:CheckDigits>1234</ns3:CheckDigits>
                      <ns3:OrderItemsInfoVO>
                        <ns3:OrderId/>
                        <ns3:LineItemId>1</ns3:LineItemId>
                        <ns3:ProductId>1</ns3:ProductId>
                        <ns3:Quantity>1</ns3:Quantity>
                        <ns3:UnitPrice>1999</ns3:UnitPrice>
                        <ns3:ProductName>something</ns3:ProductName>
                        <ns3:SupplierName>from someone</ns3:SupplierName>
                      </ns3:OrderItemsInfoVO>
                    </ns2:result>
                  </from>
                  <to variable="Reply_getOrderInfoVO_getOrderInfoVOSDO_OutputVariable"
                      part="parameters"
                      query="/ns2:getOrderInfoVOSDOResponse/ns2:result"/>
                </copy>
              </assign>
            </case>
            <otherwise xml:id="id64">
              <assign xml:id="id65" name="Assign_OrderLarger2000">
                <copy xml:id="id76">
                  <from xml:id="id77"
                        variable="OnMessage_getOrderInfoVOSDO_InputVariable"
                        part="parameters" query="/ns2:getOrderInfoVOSDO"/>
                  <to xml:id="id78"
                      variable="OnMessage_getOrderInfoVOSDO_InputVariable"
                      part="parameters" query="/ns2:getOrderInfoVOSDO"/>
                </copy>
                <copy xml:id="id66">
                  <from xml:id="id67">
                    <ns2:result xmlns:ns2="www.globalcompany.example.com/types/"
                                xmlns:ns3="/oracle/fodemo/storefront/store/queries/common/">
                      <ns3:OrderId/>
                      <ns3:OrderDate>2008-08-28T07:17:04.0Z</ns3:OrderDate>
                      <ns3:OrderStatusCode>PENDING</ns3:OrderStatusCode>
                      <ns3:OrderTotal>2001</ns3:OrderTotal>
                      <ns3:CustomerId>20</ns3:CustomerId>
                      <ns3:ShipToName>Clemens Utschig</ns3:ShipToName>
                      <ns3:ShipToPhoneNumber>1234</ns3:ShipToPhoneNumber>
                      <ns3:AddressId>10</ns3:AddressId>
                      <ns3:Address1>100 Oracle Parkway</ns3:Address1>
                      <ns3:City>Redwood Shores</ns3:City>
                      <ns3:PostalCode>94065</ns3:PostalCode>
                      <ns3:StateProvince>CA</ns3:StateProvince>
                      <ns3:CountryId>US</ns3:CountryId>
                      <ns3:AccountNumber>41</ns3:AccountNumber>
                      <ns3:CardTypeCode>AMEX</ns3:CardTypeCode>
                      <ns3:ExpireDate>2010-10-26T21:32:52</ns3:ExpireDate>
                      <ns3:CheckDigits>1234</ns3:CheckDigits>
                      <ns3:OrderItemsInfoVO>
                        <ns3:OrderId/>
                        <ns3:LineItemId>1</ns3:LineItemId>
                        <ns3:ProductId>1</ns3:ProductId>
                        <ns3:Quantity>1</ns3:Quantity>
                        <ns3:UnitPrice>2001</ns3:UnitPrice>
                        <ns3:ProductName>something</ns3:ProductName>
                        <ns3:SupplierName>from someone</ns3:SupplierName>
                      </ns3:OrderItemsInfoVO>
                    </ns2:result>
                  </from>
                  <to xml:id="id68"
                      variable="Reply_getOrderInfoVO_getOrderInfoVOSDO_OutputVariable"
                      part="parameters"
                      query="/ns2:getOrderInfoVOSDOResponse/ns2:result"/>
                </copy>
              </assign>
            </otherwise>
          </switch>
          <assign xml:id="id69" name="Assign_OrderId">
            <copy xml:id="id70">
              <from xml:id="id71"
                    variable="OnMessage_getOrderInfoVOSDO_InputVariable"
                    part="parameters"
                    query="/ns2:getOrderInfoVOSDO/ns2:orderId"/>
              <to xml:id="id72"
                  variable="Reply_getOrderInfoVO_getOrderInfoVOSDO_OutputVariable"
                  part="parameters"
                  query="/ns2:getOrderInfoVOSDOResponse/ns2:result/ns3:OrderId"/>
            </copy>
            <copy xml:id="id73">
              <from xml:id="id74"
                    variable="OnMessage_getOrderInfoVOSDO_InputVariable"
                    part="parameters"
                    query="/ns2:getOrderInfoVOSDO/ns2:orderId"/>
              <to xml:id="id75"
                  variable="Reply_getOrderInfoVO_getOrderInfoVOSDO_OutputVariable"
                  part="parameters"
                  query="/ns2:getOrderInfoVOSDOResponse/ns2:result/ns3:OrderItemsInfoVO[1]/ns3:OrderId"/>
            </copy>
          </assign>
          <reply name="Reply_getOrderInfo"
                 variable="Reply_getOrderInfoVO_getOrderInfoVOSDO_OutputVariable"
                 partnerLink="customerandorderservice_client"
                 portType="ns1:StoreFrontService"
                 operation="getOrderInfoVOSDO"/>
        </sequence>
      </onMessage>
      <onMessage variable="OnMessage_processOrderInfoVOSDO_InputVariable"
                 partnerLink="customerandorderservice_client"
                 portType="ns1:StoreFrontService"
                 operation="processOrderInfoVOSDO">
        <bpelx:annotation>
          <bpelx:pattern></bpelx:pattern>
        </bpelx:annotation>
        <sequence>
          <assign name="Assign_ProcessOrderInfo">
            <copy>
              <from>
                <ns2:result xmlns:ns2="www.globalcompany.example.com/types/"
                            xmlns:ns3="/oracle/fodemo/storefront/store/queries/common/">
                  <ns3:OrderId>1000</ns3:OrderId>
                  <ns3:OrderStatusCode>PENDING</ns3:OrderStatusCode>
                  <ns3:OrderTotal>2001</ns3:OrderTotal>
                  <ns3:CustomerId>10</ns3:CustomerId>
                  <ns3:ShipToName>Clemens Utschig</ns3:ShipToName>
                  <ns3:ShipToPhoneNumber>1235550111</ns3:ShipToPhoneNumber>
                  <ns3:AddressId>10</ns3:AddressId>
                  <ns3:Address1>100 Oracle Parkway</ns3:Address1>
                  <ns3:City>Redwood Shores</ns3:City>
                  <ns3:PostalCode>94065</ns3:PostalCode>
                  <ns3:StateProvince>CA</ns3:StateProvince>
                  <ns3:CountryId>US</ns3:CountryId>
                  <ns3:AccountNumber>41</ns3:AccountNumber>
                  <ns3:CardTypeCode>AMEX</ns3:CardTypeCode>
                  <ns3:ExpireDate>2010-10-26T21:32:52</ns3:ExpireDate>
                  <ns3:CheckDigits>1234</ns3:CheckDigits>
                  <ns3:OrderItemsInfoVO>
                    <ns3:OrderId>10</ns3:OrderId>
                    <ns3:LineItemId>1</ns3:LineItemId>
                    <ns3:ProductId>1</ns3:ProductId>
                    <ns3:Quantity>1</ns3:Quantity>
                    <ns3:UnitPrice>2001</ns3:UnitPrice>
                    <ns3:ProductName>something</ns3:ProductName>
                    <ns3:SupplierName>from someone</ns3:SupplierName>
                  </ns3:OrderItemsInfoVO>
                </ns2:result>
              </from>
              <to variable="Reply_ProcessOrderInfoVO_processOrderInfoVOSDO_OutputVariable"
                  part="parameters"
                  query="/ns2:processOrderInfoVOSDOResponse/ns2:result"/>
            </copy>
          </assign>
          <reply name="Reply_ProcessOrderInfoVO"
                 variable="Reply_ProcessOrderInfoVO_processOrderInfoVOSDO_OutputVariable"
                 partnerLink="customerandorderservice_client"
                 portType="ns1:StoreFrontService"
                 operation="processOrderInfoVOSDO"/>
        </sequence>
      </onMessage>
      <onMessage variable="OnMessage_processCSOrderInfoVOSDO_InputVariable"
                 partnerLink="customerandorderservice_client"
                 portType="ns1:StoreFrontService"
                 operation="processCSOrderInfoVOSDO">
        <bpelx:annotation>
          <bpelx:pattern></bpelx:pattern>
        </bpelx:annotation>
        <sequence>
          <assign name="Assign_ProcessOrderInfoVOCS">
            <copy>
              <from>
                <ns0:Value xsi:type="ns1:OrderInfoVOSDO"
                           xmlns:ns0="http://xmlns.oracle.com/adf/svc/types/"
                           xmlns:ns1="/oracle/fodemo/storefront/store/queries/common/"
                           xmlns:ns2="www.globalcompany.example.com/types/"
                           xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
                           xmlns:tns="http://xmlns.oracle.com/adf/svc/errors/">
                  <ns1:OrderId>1010</ns1:OrderId>
                  <ns1:OrderDate>2008-08-28T07:17:04.0Z</ns1:OrderDate>
                  <ns1:OrderShippedDate xsi:nil="true"/>
                  <ns1:OrderStatusCode>complete</ns1:OrderStatusCode>
                  <ns1:OrderTotal>1259.98</ns1:OrderTotal>
                  <ns1:CustomerId>120</ns1:CustomerId>
                  <ns1:ShipToName xsi:nil="true"/>
                  <ns1:ShipToPhoneNumber xsi:nil="true"/>
                  <ns1:AddressId>21</ns1:AddressId>
                  <ns1:Address1>5415 W 11th St</ns1:Address1>
                  <ns1:Address2 xsi:nil="true"/>
                  <ns1:City>Greeley</ns1:City>
                  <ns1:PostalCode>80634</ns1:PostalCode>
                  <ns1:StateProvince>CO</ns1:StateProvince>
                  <ns1:CountryId>US</ns1:CountryId>
                  <ns1:PaymentOptionId>1015</ns1:PaymentOptionId>
                  <ns1:BillingAddressId>21</ns1:BillingAddressId>
                  <ns1:AccountNumber>5555555555554444</ns1:AccountNumber>
                  <ns1:CardTypeCode>MSTR</ns1:CardTypeCode>
                  <ns1:ExpireDate>2010-11-30T08:16:09.0Z</ns1:ExpireDate>
                  <ns1:CheckDigits>333</ns1:CheckDigits>
                  <ns1:RoutingIdentifier xsi:nil="true"/>
                  <ns1:InstitutionName xsi:nil="true"/>
                  <ns1:ShipToAddressId>21</ns1:ShipToAddressId>
                  <ns1:ObjectVersionId>3</ns1:ObjectVersionId>
                  <ns1:ShippingOptionId>2</ns1:ShippingOptionId>
                  <ns1:ObjectVersionId1>0</ns1:ObjectVersionId1>
                  <ns1:FreeShippingFlag>N</ns1:FreeShippingFlag>
                  <ns1:ObjectVersionId2>0</ns1:ObjectVersionId2>
                  <ns1:CustomerCollectFlag>N</ns1:CustomerCollectFlag>
                  <ns1:GiftwrapFlag>N</ns1:GiftwrapFlag>
                  <ns1:PaymentOptionId1>1015</ns1:PaymentOptionId1>
                  <ns1:OrderItemsInfoVO>
                    <ns1:OrderId>1010</ns1:OrderId>
                    <ns1:LineItemId>1</ns1:LineItemId>
                    <ns1:ProductId>31</ns1:ProductId>
                    <ns1:Quantity>2</ns1:Quantity>
                    <ns1:UnitPrice>629.99</ns1:UnitPrice>
                    <ns1:ProductName>7 Megapixel Digital Camera</ns1:ProductName>
                    <ns1:SupplierName>Transistor City</ns1:SupplierName>
                    <ns1:ProductId1>31</ns1:ProductId1>
                  </ns1:OrderItemsInfoVO>
                </ns0:Value>
              </from>
              <to variable="Reply_ProcessOrderVOCS_processCSOrderInfoVOSDO_OutputVariable"
                  part="parameters"
                  query="/ns2:processCSOrderInfoVOSDOResponse/ns2:result/ns4:Value"/>
            </copy>
            <copy>
              <from>
                <ns0:ChangeSummary logging="false" xmlns:sdo="commonj.sdo"
                                   xmlns:ns0="http://xmlns.oracle.com/adf/svc/types/"/>
              </from>
              <to variable="Reply_ProcessOrderVOCS_processCSOrderInfoVOSDO_OutputVariable"
                  part="parameters"
                  query="/ns2:processCSOrderInfoVOSDOResponse/ns2:result/ns4:ChangeSummary"/>
            </copy>
          </assign>
          <reply name="Reply_ProcessOrderVOCS"
                 variable="Reply_ProcessOrderVOCS_processCSOrderInfoVOSDO_OutputVariable"
                 partnerLink="customerandorderservice_client"
                 portType="ns1:StoreFrontService"
                 operation="processCSOrderInfoVOSDO"/>
        </sequence>
      </onMessage>
      <onMessage variable="OnMessage_updateOrderInfoVOSDO_InputVariable"
                 partnerLink="customerandorderservice_client"
                 portType="ns1:StoreFrontService"
                 operation="updateOrderInfoVOSDO">
        <bpelx:annotation>
          <bpelx:pattern></bpelx:pattern>
        </bpelx:annotation>
        <sequence>
          <assign name="Assign_UpdateOrderInfoVO">
            <copy>
              <from variable="OnMessage_updateOrderInfoVOSDO_InputVariable"
                    part="parameters"
                    query="/ns2:updateOrderInfoVOSDO/ns2:orderInfoVO1/ns3:OrderId"/>
              <to variable="Reply_UpdateOrderInfoVO_updateOrderInfoVOSDO_OutputVariable"
                  part="parameters"
                  query="/ns2:updateOrderInfoVOSDOResponse/ns2:result/ns3:OrderId"/>
            </copy>
          </assign>
          <reply name="Reply_UpdateOrderInfoVO"
                 variable="Reply_UpdateOrderInfoVO_updateOrderInfoVOSDO_OutputVariable"
                 partnerLink="customerandorderservice_client"
                 portType="ns1:StoreFrontService"
                 operation="updateOrderInfoVOSDO"/>
        </sequence>
      </onMessage>
      <onMessage xml:id="id79" variable="createOrderInfoVOSDO_InputVariable"
                 partnerLink="customerandorderservice_client"
                 portType="ns1:StoreFrontService"
                 operation="createOrderInfoVOSDO">
        <bpelx:annotation>
          <bpelx:pattern></bpelx:pattern>
        </bpelx:annotation>
        <sequence xml:id="id84">
          <assign xml:id="id88" name="Transform_CreateOrderInfo">
            <bpelx:annotation>
              <bpelx:pattern>transformation</bpelx:pattern>
            </bpelx:annotation>
            <copy xml:id="id89">
              <from xml:id="id90"
                    expression="ora:processXSLT(''xsl/Transformation_CreateOrderInfo.xsl'',bpws:getVariableData(''createOrderInfoVOSDO_InputVariable'',''parameters''))"/>
              <to xml:id="id91" variable="createOrderInfoVOSDO_OutputVariable"
                  part="parameters"/>
            </copy>
          </assign>
          <reply xml:id="id81" name="Reply_CreateOrderInfoVO"
                 variable="createOrderInfoVOSDO_OutputVariable"
                 partnerLink="customerandorderservice_client"
                 portType="ns1:StoreFrontService"
                 operation="createOrderInfoVOSDO"/>
        </sequence>
      </onMessage>
    </pick>
  </sequence>
</process>
'! !

!BPEL20BpelAnalyzerTest4 class methodsFor: 'bpel' stamp: 'AlvaroJosePeraltaOcampo 11/12/2014 09:58'!
bpel_OrderProcessor
	^ '
<?xml version = "1.0" encoding = "UTF-8" ?>
<!!--
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  Oracle JDeveloper BPEL Designer 
  
  Created: Fri Sep 12 14:19:45 PDT 2008
  Author:  lloywill
  Purpose: Asynchronous BPEL Process
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
-->
<process name="OrderProcessor"
         targetNamespace="http://www.globalcompany.example.com/ns/OrderBookingService"
         xmlns="http://schemas.xmlsoap.org/ws/2003/03/business-process/"
         xmlns:client="http://www.globalcompany.example.com/ns/OrderBookingService"
         xmlns:ora="http://schemas.oracle.com/xpath/extension"
         xmlns:orcl="http://www.oracle.com/XSL/Transform/java/oracle.tip.pc.services.functions.ExtFunc"
         xmlns:xp20="http://www.oracle.com/XSL/Transform/java/oracle.tip.pc.services.functions.Xpath20"
         xmlns:ldap="http://schemas.oracle.com/xpath/extension/ldap"
         xmlns:bpelx="http://schemas.oracle.com/bpel/extension"
         xmlns:bpws="http://schemas.xmlsoap.org/ws/2003/03/business-process/"
         xmlns:ns1="http://www.globalcompany.example.com/ns/InternalWarehouse"
         xmlns:ns2="http://www.globalcompany.example.com/ns/CreditAuthorizationService"
         xmlns:ns3="www.globalcompany.example.com"
         xmlns:ns4="/oracle/fodemo/storefront/store/queries/common/"
         xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
         xmlns:dvm="http://www.oracle.com/XSL/Transform/java/oracle.tip.dvm.LookupValue"
         xmlns:hwf="http://xmlns.oracle.com/bpel/workflow/xpath"
         xmlns:mhdr="http://www.oracle.com/XSL/Transform/java/oracle.tip.mediator.service.common.functions.GetRequestHeaderExtnFunction"
         xmlns:med="http://schemas.oracle.com/mediator/xpath"
         xmlns:ids="http://xmlns.oracle.com/bpel/services/IdentityService/xpath"
         xmlns:xdk="http://schemas.oracle.com/bpel/extension/xpath/function/xdk"
         xmlns:xref="http://www.oracle.com/XSL/Transform/java/oracle.tip.xref.xpath.XRefXPathFunctions"
         xmlns:ns5="http://www.globalcompany.example.com/ns/OrderProcessor"
         xmlns:ns6="www.globalcompany.example.com/types/"
         xmlns:ns7="http://xmlns.oracle.com/adf/svc/types/"
         xmlns:ns8="http://www.globalcompany.example.com/ns/CCAuthorizationService"
         xmlns:ns9="www.globalcompany.example.com/ns/OrderProcessor"
         xmlns:ns10="http://www.globalcompany.example.com/ns/OrderBookingService/rules"
         xmlns:ns11="http://xmlns.oracle.com/RequiresApprovalRule/OracleRules1_DecisionService_1"
         xmlns:ns12="http://xmlns.oracle.com/bpel"
         xmlns:xsd="http://www.w3.org/2001/XMLSchema"
         xmlns:wf="http://schemas.oracle.com/bpel/extension/workflow"
         xmlns:ns13="http://xmlns.oracle.com/bpel/workflow/common/tsc"
         xmlns:ns14="http://xmlns.oracle.com/bpel/workflow/TaskEvidenceService"
         xmlns:ns15="http://xmlns.oracle.com/WebLogicFusionOrderDemo/OrderBookingComposite/PartnerSupplierMediator"
         xmlns:ns16="http://www.globalcompany.com/ns/OrderBooking"
         xmlns:ns17="http://xmlns.oracle.com/WebLogicFusionOrderDemo/OrderBookingComposite/FulfillOrder"
         xmlns:ns18="http://xmlns.oracle.com/ias/pcbpel/NotificationService"
         queryLanguage="http://www.w3.org/TR/1999/REC-xpath-19991116"
         expressionLanguage="http://www.w3.org/TR/1999/REC-xpath-19991116"
         suppressJoinFailure="no" enableInstanceCompensation="no"
         abstractProcess="no"
         xmlns:ns19="http://xmlns.oracle.com/EvaluatePreferredSupplierRule/OracleRules1_DecisionService_1"
         xmlns:ns20="http://www.oracle.com/XSL/Transform/java/oracle.tip.adapter.socket.ProtocolTranslator"
         xmlns:task="http://xmlns.oracle.com/bpel/workflow/task"
         xmlns:taskservice="http://xmlns.oracle.com/bpel/workflow/taskService"
         xmlns:wfcommon="http://xmlns.oracle.com/bpel/workflow/common"
         xmlns:bpel2="http://docs.oasis-open.org/wsbpel/2.0/process/executable">

    <!!-- 
      ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
        PARTNERLINKS                                                      
        List of services participating in this BPEL process               
      ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    --> 
    <partnerLinks>
        <!!-- 
      The ''client'' role represents the requester of this service. It is 
      used for callback. The location and correlation information associated
      with the client role are automatically set using WS-Addressing.
    -->
        <partnerLink name="orderprocessor_client_ep"
                     partnerLinkType="client:OrderProcessor"
                     myRole="OrderProcessorProvider"
                     partnerRole="OrderProcessorRequester"/>
        <partnerLink myRole="InternalWarehouseServiceRequester"
                     name="InternalWarehouseService"
                     partnerRole="InternalWarehouseServiceProvider"
                     partnerLinkType="ns1:InternalWarehouseService"/>
        <partnerLink name="CreditCardAuthorizationService"
                     partnerRole="CreditAuthorizationPort"
                     partnerLinkType="ns2:CreditCardAuthorizationService"/>
        <partnerLink name="StoreFrontService" partnerRole="StoreFrontService"
                     partnerLinkType="ns3:StorefrontService"/>
        <partnerLink myRole="TaskServiceCallbackListener"
                     name="TaskService"
                     partnerRole="TaskService"
                     partnerLinkType="taskservice:TaskService"/>
        <partnerLink name="PartnerSupplierMediator"
                     myRole="callback_ptt"
                     partnerRole="execute_ptt"
                     partnerLinkType="ns15:PartnerSupplierMediator.PartnerSupplierMediator"/>
        <partnerLink name="NotificationService_WSDL"
                     partnerLinkType="ns18:NotificationServiceLink"
                     partnerRole="NotificationServiceProvider"/>
        <partnerLink name="RequiresApprovalRule_OracleRules1_DecisionService_1"
                     partnerLinkType="ns11:IDecisionService_PL"
                     partnerRole="IDecisionService_Role"/>
        <partnerLink name="FulfillOrder.FulfillOrder" partnerRole="execute_ptt"
                     partnerLinkType="ns17:FulfillOrder.FulfillOrder"/>
        <partnerLink name="EvaluatePreferredSupplierRule.OracleRules1_DecisionService_1"
                     partnerRole="IDecisionService_Role"
                     partnerLinkType="ns19:IDecisionService_PL"/>
    </partnerLinks>

    <!!-- 
      ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
        VARIABLES                                                        
        List of messages and XML documents used within this BPEL process 
      ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    -->
    <variables>
        <!!-- Reference to the message passed as input during initiation -->

        <!!-- Reference to the message that will be sent back to the requester during callback -->
        <variable name="inputVariable"
                  messageType="client:OrderProcessorRequestMessage"/>
        <variable name="outputVariable"
                  messageType="client:OrderProcessorResponseMessage"/>
        <variable name="ApprovalHumanTask_1_globalVariable"
                  messageType="taskservice:taskMessage"/>
        <variable name="gOrderInfoVariable" element="ns4:orderInfoVOSDO"
                  bpelx:entity.si="StoreFrontService"/>
        <variable name="gCustomerInfoVariable"
                  messageType="ns3:StoreFrontService_findCustomerInfoVO1CustomerInfoVOCriteriaResponse"/>
        <variable name="gWarehouseQuotes" element="ns1:WarehouseList"/>
        <variable name="gPreferredSupplier" element="ns1:WarehouseResponse"/>
        <variable name="gOrderProcessorFaultVariable"
                  messageType="client:OrderProcessorFault"/>
    </variables>
    <faultHandlers>
        <catch faultName="client:OrderProcessorFault">
            <sequence xml:id="id5">
                <assign name="Assign_FaultedStatusToOrder">
                    <copy>
                        <from expression="string(''FAULTED'')"/>
                        <to variable="gOrderInfoVariable"
                            query="/ns4:orderInfoVOSDO/ns4:OrderStatusCode"/>
                    </copy>
                    <copy>
                        <from expression="concat (''OrderProcessor, order: '', bpws:getVariableData(''inputVariable'',''payload'',''/client:process/client:orderId''), '' fault'')"/>
                        <to variable="gOrderProcessorFaultVariable" part="fault"
                            query="/client:orderProcessFault/client:code"/>
                    </copy>
                </assign>
                <invoke xml:id="id4"
                        name="Invoke_FaultOrderProcessorFaultCallback"
                        inputVariable="gOrderProcessorFaultVariable"
                        partnerLink="orderprocessor_client_ep"
                        portType="client:OrderProcessorCallback"
                        operation="processFault"/>
            </sequence>
        </catch>
        <catchAll>
            <sequence>
                <assign name="Assign_Fault">
                    <copy>
                        <from expression="ora:getFaultAsString()"/>
                        <to variable="gOrderProcessorFaultVariable" part="fault"
                            query="/client:orderProcessFault/client:detail"/>
                    </copy>
                    <copy>
                        <from expression="ora:getFaultName()"/>
                        <to variable="gOrderProcessorFaultVariable" part="fault"
                            query="/client:orderProcessFault/client:code"/>
                    </copy>
                    <copy xml:id="id9">
                        <from xml:id="id10"
                              expression="concat(bpws:getVariableData(''inputVariable'',''payload'',''/client:process/client:orderId''), string('' failed to process, detail: ''), ora:getFaultAsString())"/>
                        <to xml:id="id11"
                            variable="gOrderProcessorFaultVariable" part="fault"
                            query="/client:orderProcessFault/client:summary"/>
                    </copy>
                </assign>
                <invoke name="Invoke_FaultCallback"
                        inputVariable="gOrderProcessorFaultVariable"
                        partnerLink="orderprocessor_client_ep"
                        portType="client:OrderProcessorCallback"
                        operation="processFault"/>
            </sequence>
        </catchAll>
    </faultHandlers>
    <!!-- 
      ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
       ORCHESTRATION LOGIC                                               
       Set of activities coordinating the flow of messages across the    
       services integrated within this business process                  
      ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    -->
    <sequence name="main">
        <!!-- Receive input from requestor. (Note: This maps to operation defined in OrderProcessor.wsdl) -->
        <receive name="receiveInput" partnerLink="orderprocessor_client_ep" portType="client:OrderProcessor" operation="process" variable="inputVariable" createInstance="yes"/>

        <!!-- 
          Asynchronous callback to the requester. (Note: the callback location and correlation id is transparently handled using WS-addressing.)
        -->
        <scope name="Scope_RetrieveOrder">
            <variables xml:id="id12">
                <variable xml:id="id13" name="lTmpOrderInfoVariable"
                          element="ns4:orderInfoVOSDO"/>
            </variables>
            <sequence xml:id="id15">
                <bpelx:bindEntity name="findOrderById"
                                  variable="gOrderInfoVariable">
                    <bpelx:key keyname="ns4:OrderId">bpws:getVariableData(''inputVariable'',''payload'',''/client:process/client:orderId'')</bpelx:key>
                </bpelx:bindEntity>
                <assign xml:id="id14" name="Assign_lVariableForSensor">
                    <copy xml:id="id16">
                        <from xml:id="id17" variable="gOrderInfoVariable"
                              query="/ns4:orderInfoVOSDO"/>
                        <to xml:id="id18" variable="lTmpOrderInfoVariable"
                            query="/ns4:orderInfoVOSDO"/>
                    </copy>
                </assign>
            </sequence>
        </scope>
        <scope name="Scope_RetrieveCustomerForOrder">
            <variables>
                <variable name="lFindCustomerInfo_InputVariable"
                          messageType="ns3:StoreFrontService_findCustomerInfoVO1CustomerInfoVOCriteria"/>
            </variables>
            <sequence>
                <assign name="AssignCustomerId">
                    <copy>
                        <from variable="gOrderInfoVariable"
                              query="/ns4:orderInfoVOSDO/ns4:CustomerId"/>
                        <to variable="lFindCustomerInfo_InputVariable"
                            part="parameters"
                            query="/ns6:findCustomerInfoVO1CustomerInfoVOCriteria/ns6:CustId"/>
                    </copy>
                    <copy>
                        <from expression="-1"/>
                        <to variable="lFindCustomerInfo_InputVariable"
                            part="parameters"
                            query="/ns6:findCustomerInfoVO1CustomerInfoVOCriteria/ns6:findCriteria/ns7:fetchStart"/>
                    </copy>
                    <copy>
                        <from expression="1"/>
                        <to variable="lFindCustomerInfo_InputVariable"
                            part="parameters"
                            query="/ns6:findCustomerInfoVO1CustomerInfoVOCriteria/ns6:findCriteria/ns7:fetchSize"/>
                    </copy>
                    <copy>
                        <from expression="false()"/>
                        <to variable="lFindCustomerInfo_InputVariable"
                            part="parameters"
                            query="/ns6:findCustomerInfoVO1CustomerInfoVOCriteria/ns6:findCriteria/ns7:excludeAttribute"/>
                    </copy>
                    <copy>
                        <from expression="false()"/>
                        <to variable="lFindCustomerInfo_InputVariable"
                            part="parameters"
                            query="/ns6:findCustomerInfoVO1CustomerInfoVOCriteria/ns6:findControl/ns7:retrieveAllTranslations"/>
                    </copy>
                </assign>
                <invoke name="InvokeFindCustomer"
                        inputVariable="lFindCustomerInfo_InputVariable"
                        outputVariable="gCustomerInfoVariable"
                        partnerLink="StoreFrontService"
                        portType="ns3:StoreFrontService"
                        operation="findCustomerInfoVO1CustomerInfoVOCriteria"/>
            </sequence>
        </scope>
        <scope name="Scope_AuthorizeCreditCard">
            <variables>
                <variable name="lCreditCardInput"
                          messageType="ns2:CreditAuthorizationRequestMessage"/>
                <variable name="lCreditCardOutput"
                          messageType="ns2:CreditAuthorizationResponseMessage"/>
            </variables>
            <faultHandlers>
                <catch faultName="bpws:selectionFailure">
                    <sequence>
                        <assign name="Assign_noCCNumber">
                            <copy>
                                <from expression="string(''CreditCardCheck - NO CreditCard'')"/>
                                <to variable="gOrderProcessorFaultVariable"
                                    part="fault"
                                    query="/client:orderProcessFault/client:summary"/>
                            </copy>
                        </assign>
                        <throw name="Throw_NoCreditCard"
                               faultVariable="gOrderProcessorFaultVariable"
                               faultName="client:OrderProcessorFault"/>
                    </sequence>
                </catch>
                <catch faultName="ns2:InvalidCredit">
                    <sequence>
                        <assign name="Assign_InvalidCreditFault">
                            <copy>
                                <from expression="concat(bpws:getVariableData(''gOrderInfoVariable'',''/ns4:orderInfoVOSDO/ns4:CardTypeCode''), '' is not a valid creditcard type'')"/>
                                <to variable="gOrderProcessorFaultVariable"
                                    part="fault"
                                    query="/client:orderProcessFault/client:detail"/>
                            </copy>
                            <copy>
                                <from expression="string(''CreditCardCheck - NOT VALID'')"/>
                                <to variable="gOrderProcessorFaultVariable"
                                    part="fault"
                                    query="/client:orderProcessFault/client:summary"/>
                            </copy>
                        </assign>
                        <throw name="Throw_OrderProcessingFault"
                               faultName="client:OrderProcessorFault"
                               faultVariable="gOrderProcessorFaultVariable"/>
                    </sequence>
                </catch>
            </faultHandlers>
            <sequence>
                <assign name="Assign_CreditCheckInput">
                    <copy>
                        <from variable="gOrderInfoVariable"
                              query="/ns4:orderInfoVOSDO/ns4:OrderTotal"/>
                        <to variable="lCreditCardInput" part="Authorization"
                            query="/ns8:AuthInformation/ns8:PurchaseAmount"/>
                    </copy>
                    <copy>
                        <from variable="gOrderInfoVariable"
                              query="/ns4:orderInfoVOSDO/ns4:CardTypeCode"/>
                        <to variable="lCreditCardInput" part="Authorization"
                            query="/ns8:AuthInformation/ns8:CCType"/>
                    </copy>
                    <copy>
                        <from variable="gOrderInfoVariable"
                              query="/ns4:orderInfoVOSDO/ns4:AccountNumber"/>
                        <to variable="lCreditCardInput" part="Authorization"
                            query="/ns8:AuthInformation/ns8:CCNumber"/>
                    </copy>
                </assign>
                <invoke name="InvokeCheckCreditCard"
                        inputVariable="lCreditCardInput"
                        outputVariable="lCreditCardOutput"
                        partnerLink="CreditCardAuthorizationService"
                        portType="ns2:CreditAuthorizationPort"
                        operation="AuthorizeCredit"/>
                <switch name="Switch_EvaluateCCResult">
                    <case condition="bpws:getVariableData(''lCreditCardOutput'',''status'',''/ns8:status'') !!= ''APPROVED''">
                        <bpelx:annotation>
                            <bpelx:pattern>status &lt;&gt; approved</bpelx:pattern>
                            <bpelx:general>
                                <bpelx:property name="userLabel">Check if CC
                                                                 card was
                                                                 validated and
                                                                 amount approved</bpelx:property>
                            </bpelx:general>
                        </bpelx:annotation>
                        <sequence>
                            <assign name="Assign_StatusAndMessage">
                                <copy>
                                    <from expression="concat(''Creditcard: '', bpws:getVariableData(''lCreditCardInput'',''Authorization'',''/ns8:AuthInformation/ns8:CCNumber''), '' Status: '', bpws:getVariableData(''lCreditCardOutput'',''status'',''/ns8:status'') )"/>
                                    <to variable="gOrderProcessorFaultVariable"
                                        part="fault"
                                        query="/client:orderProcessFault/client:summary"/>
                                </copy>
                            </assign>
                            <throw name="Throw_Fault_CC_Denied"
                                   faultName="client:OrderProcessorFault"
                                   faultVariable="gOrderProcessorFaultVariable"/>
                        </sequence>
                    </case>
                </switch>
            </sequence>
        </scope>
        <scope name="Scope_CheckApprovalLimit">
            <variables>
                <variable name="lOrderApproved" type="xsd:string"/>
            </variables>
            <sequence>
                <assign name="Assign_DefaultNotRequiresApproval">
                    <copy>
                        <from expression="string(''false'')"/>
                        <to variable="lOrderApproved"/>
                    </copy>
                </assign>
                <scope name="BusinessRule_ApprovalRequired">
                    <bpelx:annotation>
                        <bpelx:pattern patternName="bpelx:decide"></bpelx:pattern>
                    </bpelx:annotation>
                    <variables>
                        <variable name="com_example_globalcompany_ns_orderbookingservice_rules_Approve_i"
                                  element="ns10:approve"/>
                        <variable name="com_example_globalcompany_ns_orderbookingservice_rules_Approve_o"
                                  element="ns10:approve"/>
                        <variable name="dsIn"
                                  messageType="ns11:callFunctionStatelessMessage"/>
                        <variable name="dsOut"
                                  messageType="ns11:callFunctionStatelessDecisionMessage"/>
                    </variables>
                    <sequence name="Sequence_1">
                        <assign name="BPEL_Var_To_Rule_Facts">
                            <copy>
                                <from variable="gOrderInfoVariable"
                                      query="/ns4:orderInfoVOSDO/ns4:OrderTotal"/>
                                <to variable="com_example_globalcompany_ns_orderbookingservice_rules_Approve_i"
                                    query="/ns10:approve/ns10:price"/>
                            </copy>
                            <copy>
                                <from variable="lOrderApproved"/>
                                <to variable="com_example_globalcompany_ns_orderbookingservice_rules_Approve_i"
                                    query="/ns10:approve/ns10:approvalRequired"/>
                            </copy>
                        </assign>
                        <assign name="Facts_To_Rule_Service">
                            <copy>
                                <from variable="com_example_globalcompany_ns_orderbookingservice_rules_Approve_i"/>
                                <to variable="dsIn" part="payload"
                                    query="/ns11:callFunctionStateless/ns11:parameterList/ns10:approve"/>
                            </copy>
                        </assign>
                        <assign name="BPEL_Header">
            <copy>
                <from expression="''OracleRules1_DecisionService_1''"/>
                <to variable="dsIn" part="payload"
                    query="/ns11:callFunctionStateless/@name"/>
            </copy>
        </assign>
                        <invoke name="Invoke"
                                partnerLink="RequiresApprovalRule_OracleRules1_DecisionService_1"
                                portType="ns11:IDecisionService"
                                operation="callFunctionStateless"
                                inputVariable="dsIn" outputVariable="dsOut"/>
                        <assign name="Rule_Service_To_Facts">
                            <copy>
                                <from variable="dsOut" part="payload"
                                      query="/ns11:callFunctionStatelessDecision/ns11:resultList/ns10:approve"/>
                                <to variable="com_example_globalcompany_ns_orderbookingservice_rules_Approve_o"/>
                            </copy>
                        </assign>
                        <assign name="Facts_To_BPEL_Var">
                            <copy>
                                <from variable="com_example_globalcompany_ns_orderbookingservice_rules_Approve_o"
                                      query="/ns10:approve/ns10:approvalRequired"/>
                                <to variable="lOrderApproved"/>
                            </copy>
                        </assign>
                    </sequence>
                </scope>
                <switch name="Switch_ApprovalRequired">
                    <case condition="bpws:getVariableData(''lOrderApproved'') = ''true''">
                        <bpelx:annotation>
                            <bpelx:pattern>approval required = true</bpelx:pattern>
                        </bpelx:annotation>
                        <sequence>
                            <scope name="ApprovalHumanTask_1"
                                   xmlns:wf="http://schemas.oracle.com/bpel/extension/workflow"
                                   wf:key="ApprovalHumanTask_1_globalVariable">
            <bpelx:annotation xmlns:bpelx="http://schemas.oracle.com/bpel/extension">
                <bpelx:pattern patternName="bpelx:workflow"></bpelx:pattern>
            </bpelx:annotation>
        <variables>
            <variable name="initiateTaskInput"
                   messageType="taskservice:initiateTaskMessage"/>
            <variable name="initiateTaskResponseMessage"
                   messageType="taskservice:initiateTaskResponseMessage"/>
            </variables>
            <sequence>
                <assign name="ApprovalHumanTask_1_AssignTaskAttributes">
                                        <copy>
                                            <from expression="number(3)"/>
                                            <to variable="initiateTaskInput"
                                                part="payload"
                                                query="/taskservice:initiateTask/task:task/task:priority"/>
                                        </copy>
                                        <copy>
                                            <from>
                                                <payload xmlns="http://xmlns.oracle.com/bpel/workflow/task">
                                                    <orderId xmlns="http://xmlns.oracle.com/bpel/workflow/task"/>
                                                </payload>
                                            </from>
                                            <to variable="initiateTaskInput"
                                                part="payload"
                                                query="/taskservice:initiateTask/task:task/task:payload"/>
                                        </copy>
                                        <copy>
                                            <from variable="gOrderInfoVariable"
                                                  query="/ns4:orderInfoVOSDO/ns4:OrderId"/>
                                            <to variable="initiateTaskInput"
                                                part="payload"
                                                query="/taskservice:initiateTask/task:task/task:payload/task:orderId"/>
                                        </copy>
                                        <copy>
                                            <from expression="concat(bpws:getVariableData(''gCustomerInfoVariable'',''parameters'',''/ns6:findCustomerInfoVO1CustomerInfoVOCriteriaResponse/ns6:result/ns4:FirstName''), '' '', bpws:getVariableData(''gCustomerInfoVariable'',''parameters'',''/ns6:findCustomerInfoVO1CustomerInfoVOCriteriaResponse/ns6:result/ns4:LastName''))"/>
                                            <to variable="initiateTaskInput"
                                                part="payload"
                                                query="/taskservice:initiateTask/task:task/task:creator"/>
                                        </copy>
                                        <copy>
                                            <from expression="concat(string(''Order approval for order (''), bpws:getVariableData(''inputVariable'',''payload'',''/client:process/client:orderId''), string('')''))"/>
                                            <to variable="initiateTaskInput"
                                                part="payload"
                                                query="/taskservice:initiateTask/task:task/task:title"/>
                                        </copy>
                                    </assign>
                <invoke name="initiateTask_ApprovalHumanTask_1"
                        partnerLink="TaskService"
                        portType="taskservice:TaskService"
                        operation="initiateTask"
                        inputVariable="initiateTaskInput"
                        outputVariable="initiateTaskResponseMessage">
                </invoke>
                <receive name="receiveCompletedTask_ApprovalHumanTask_1"
                         partnerLink="TaskService"
                         portType="taskservice:TaskServiceCallback"
                         operation="onTaskCompleted"
                         variable="ApprovalHumanTask_1_globalVariable"
                         createInstance="no">
                </receive>
            </sequence>
        </scope>
                            <switch name="taskSwitch">
                                <case condition="bpws:getVariableData(''ApprovalHumanTask_1_globalVariable'', ''payload'', ''/task:task/task:systemAttributes/task:state'') = ''COMPLETED'' and bpws:getVariableData(''ApprovalHumanTask_1_globalVariable'', ''payload'', ''/task:task/task:systemAttributes/task:outcome'') = ''REJECT''">
                                    <bpelx:annotation>
                                        <bpelx:pattern>Task outcome is REJECT</bpelx:pattern>
                                    </bpelx:annotation>
                                    <sequence>
                                        <assign name="Assign_FaultDetails">
                                            <copy>
                                                <from expression="concat(''Approval for order was rejected by: '', bpws:getVariableData(''ApprovalHumanTask_1_globalVariable'',''payload'',''/task:task/task:systemAttributes/task:updatedBy/task:id''))"/>
                                                <to variable="gOrderProcessorFaultVariable"
                                                    part="fault"
                                                    query="/client:orderProcessFault/client:summary"/>
                                            </copy>
                                        </assign>
                                        <throw name="Throw_OrderProcessorFault"
                                               faultName="client:OrderProcessorFault"
                                               faultVariable="gOrderProcessorFaultVariable"/>
                                    </sequence>
                                </case>
                                <case condition="bpws:getVariableData(''ApprovalHumanTask_1_globalVariable'', ''payload'', ''/task:task/task:systemAttributes/task:state'') = ''COMPLETED'' and bpws:getVariableData(''ApprovalHumanTask_1_globalVariable'', ''payload'', ''/task:task/task:systemAttributes/task:outcome'') = ''APPROVE''">
                                    <bpelx:annotation>
                                        <bpelx:pattern>Task outcome is APPROVE</bpelx:pattern>
                                    </bpelx:annotation>
                                    <sequence>
                                        <empty/>
                                    </sequence>
                                </case>
                                <otherwise>
                                    <sequence>
                                        <assign name="Assign_FaultDetails">
                                            <copy>
                                                <from expression="concat (''Approval task changed state'', bpws:getVariableData(''ApprovalHumanTask_1_globalVariable'',''payload'',''/task:task/task:systemAttributes/task:state''))"/>
                                                <to variable="gOrderProcessorFaultVariable"
                                                    part="fault"
                                                    query="/client:orderProcessFault/client:summary"/>
                                            </copy>
                                        </assign>
                                        <throw name="Throw_OrderProcessingFault"
                                               faultName="client:OrderProcessorFault"
                                               faultVariable="gOrderProcessorFaultVariable"/>
                                    </sequence>
                                </otherwise>
                            </switch>
                        </sequence>
                    </case>
                </switch>
            </sequence>
        </scope>
        <scope name="Scope_RetrieveQuotes">
            <variables>
                <variable name="lPartnerSupplierInputVariable"
                          messageType="ns15:requestMessage"/>
                <variable name="lPartnerResponseVariable"
                          messageType="ns15:callbackMessage"/>
                <variable name="lInternalWarehouseResponseVariable"
                          messageType="ns1:InternalWarehouseServiceResponseMessage"/>
                <variable name="lInternalWarehouseInputVariable"
                          messageType="ns1:InternalWarehouseServiceRequestMessage"/>
            </variables>
            <flow name="Retrieve_QuotesFromSuppliers">
                <sequence name="Sequence_4">
                    <assign name="Assign_InternalWarehouseRequest">
                        <copy>
                            <from variable="gOrderInfoVariable"
                                  query="/ns4:orderInfoVOSDO/ns4:OrderId"/>
                            <to variable="lInternalWarehouseInputVariable"
                                part="payload"
                                query="/ns1:WarehouseRequest/ns1:orderId"/>
                        </copy>
                    </assign>
                    <invoke name="Invoke_InternalWarehouse"
                            inputVariable="lInternalWarehouseInputVariable"
                            partnerLink="InternalWarehouseService"
                            portType="ns1:InternalWarehouseService"
                            operation="process"/>
                    <receive name="Receive_InternalWarehouse"
                             createInstance="no"
                             variable="lInternalWarehouseResponseVariable"
                             partnerLink="InternalWarehouseService"
                             portType="ns1:InternalWarehouseServiceCallback"
                             operation="processResponse"/>
                    <assign name="Assign_InterWHResponse">
                        <bpelx:append>
                            <bpelx:from variable="lInternalWarehouseResponseVariable"
                                        part="payload"
                                        query="/ns1:WarehouseResponse"/>
                            <bpelx:to variable="gWarehouseQuotes"
                                      query="/ns1:WarehouseList"/>
                        </bpelx:append>
                    </assign>
                </sequence>
                <sequence name="Sequence_4">
                    <assign name="Assign_PartnerRequest">
                        <copy>
                            <from variable="gOrderInfoVariable"
                                  query="/ns4:orderInfoVOSDO"/>
                            <to variable="lPartnerSupplierInputVariable"
                                part="request" query="/ns4:orderInfoVOSDO"/>
                        </copy>
                    </assign>
                    <invoke name="Invoke_PartnerSupplier"
                            partnerLink="PartnerSupplierMediator"
                            portType="ns15:execute_ptt" operation="execute"
                            inputVariable="lPartnerSupplierInputVariable"/>
                    <receive name="Receive_PartnerResponse"
                             createInstance="no"
                             variable="lPartnerResponseVariable"
                             partnerLink="PartnerSupplierMediator"
                             portType="ns15:callback_ptt" operation="callback"/>
                    <assign name="Assign_PartnerWHResponse">
                        <bpelx:append>
                            <bpelx:from variable="lPartnerResponseVariable"
                                        part="callback"
                                        query="/ns1:WarehouseResponse"/>
                            <bpelx:to variable="gWarehouseQuotes"
                                      query="/ns1:WarehouseList"/>
                        </bpelx:append>
                    </assign>
                </sequence>
            </flow>
        </scope>
        <scope name="Scope_SelectPreferredSupplier">
            <!!--scope name="BusinessRule_1">
                <bpelx:annotation>
                    <bpelx:pattern patternName="bpelx:decide"></bpelx:pattern>
                </bpelx:annotation>
            </scope-->
            <scope name="BusinessRule_SelectPreferredSupplier">
                <bpelx:annotation>
                    <bpelx:pattern patternName="bpelx:decide"></bpelx:pattern>
                </bpelx:annotation>
                <variables>
                    <variable name="com_example_globalcompany_ns_internalwarehouse_WarehouseList_i"
                              element="ns1:WarehouseList"/>
                    <variable name="com_example_globalcompany_ns_internalwarehouse_WarehouseResponse_o"
                              element="ns1:WarehouseResponse"/>
                    <variable name="dsIn"
                              messageType="ns19:callFunctionStatelessMessage"/>
                    <variable name="dsOut"
                              messageType="ns19:callFunctionStatelessDecisionMessage"/>
                </variables>
                <sequence name="Sequence_6">
                    <assign name="BPEL_Var_To_Rule_Facts">
                        <copy>
                            <from variable="gWarehouseQuotes"
                                  query="/ns1:WarehouseList"/>
                            <to variable="com_example_globalcompany_ns_internalwarehouse_WarehouseList_i"
                                query="/ns1:WarehouseList"/>
                        </copy>
                    </assign>
                    <assign name="Facts_To_Rule_Service">
                        <copy>
                            <from variable="com_example_globalcompany_ns_internalwarehouse_WarehouseList_i"/>
                            <to variable="dsIn" part="payload"
                                query="/ns19:callFunctionStateless/ns19:parameterList/ns1:WarehouseList"/>
                        </copy>
                    </assign>
                    <assign name="BPEL_Header">
                        <copy>
                            <from expression="''OracleRules1_DecisionService_1''"/>
                            <to variable="dsIn" part="payload"
                                query="/ns19:callFunctionStateless/@name"/>
                        </copy>
                    </assign>
                    <invoke name="Invoke"
                            partnerLink="EvaluatePreferredSupplierRule.OracleRules1_DecisionService_1"
                            portType="ns19:IDecisionService"
                            operation="callFunctionStateless"
                            inputVariable="dsIn" outputVariable="dsOut"/>
                    <assign name="Rule_Service_To_Facts">
                        <copy>
                            <from variable="dsOut" part="payload"
                                  query="/ns19:callFunctionStatelessDecision/ns19:resultList/ns1:WarehouseResponse"/>
                            <to variable="com_example_globalcompany_ns_internalwarehouse_WarehouseResponse_o"/>
                        </copy>
                    </assign>
                    <assign name="Facts_To_BPEL_Var">
                        <copy>
                            <from variable="com_example_globalcompany_ns_internalwarehouse_WarehouseResponse_o"
                                  query="/ns1:WarehouseResponse"/>
                            <to variable="gPreferredSupplier"
                                query="/ns1:WarehouseResponse"/>
                        </copy>
                    </assign>
                </sequence>
            </scope>
        </scope>
        <scope name="Scope_FulfillOrder">
            <variables>
                <variable name="lFulfillOrder_InputVariable"
                          messageType="ns17:requestMessage"/>
            </variables>
            <sequence>
                <assign name="Assign_OrderData">
                    <copy>
                        <from variable="gOrderInfoVariable"
                              query="/ns4:orderInfoVOSDO"/>
                        <to variable="lFulfillOrder_InputVariable"
                            part="request" query="/ns4:orderInfoVOSDO"/>
                    </copy>
                </assign>
                <invoke name="Invoke_FulfillOrder"
                        inputVariable="lFulfillOrder_InputVariable"
                        partnerLink="FulfillOrder.FulfillOrder"
                        portType="ns17:execute_ptt" operation="execute"/>
            </sequence>
        </scope>
        <scope name="Scope_UpdateStatusToComplete">
            <assign name="UpdateOrderStatus">
                <copy>
                    <from expression="string(''complete'')"/>
                    <to variable="gOrderInfoVariable"
                        query="/ns4:orderInfoVOSDO/ns4:OrderStatusCode"/>
                </copy>
                <copy xml:id="id1">
                    <from xml:id="id2" variable="inputVariable" part="payload"
                          query="/client:process/client:orderId"/>
                    <to xml:id="id3" variable="outputVariable" part="payload"
                        query="/client:processResponse/client:result"/>
                </copy>
            </assign>
        </scope>
        <scope name="Scope_NotifyCustomerOfCompletion">
            <scope name="Email_ConfirmationToCustomer">
                <bpelx:annotation>
                    <bpelx:pattern patternName="bpelx:email"></bpelx:pattern>
                </bpelx:annotation>
                <variables>
                    <variable name="varNotificationReq"
                              messageType="ns18:EmailNotificationRequest"/>
                    <variable name="varNotificationResponse"
                              messageType="ns18:ArrayOfResponse"/>
                    <variable name="NotificationServiceFaultVariable"
                              messageType="ns18:NotificationServiceErrorMessage"/>
                </variables>
                <sequence name="Sequence_5">
                    <assign name="EmailParamsAssign">
                        <copy>
                            <from expression="string(''Default'')"/>
                            <to variable="varNotificationReq"
                                part="EmailPayload"
                                query="/EmailPayload/ns18:FromAccountName"/>
                        </copy>
                        <copy>
                            <from expression="string('''')"/>
                            <to variable="varNotificationReq"
                                part="EmailPayload"
                                query="/EmailPayload/ns18:Bcc"/>
                        </copy>
                        <copy>
                            <from expression="string('''')"/>
                            <to variable="varNotificationReq"
                                part="EmailPayload"
                                query="/EmailPayload/ns18:Cc"/>
                        </copy>
                        <copy>
                            <from expression="string('''')"/>
                            <to variable="varNotificationReq"
                                part="EmailPayload"
                                query="/EmailPayload/ns18:ReplyToAddress"/>
                        </copy>
                        <copy>
                            <from expression="concat(string(''Order with id ''), bpws:getVariableData(''gOrderInfoVariable'',''/ns4:orderInfoVOSDO/ns4:OrderId''), string('' shipped!!''))"/>
                            <to variable="varNotificationReq"
                                part="EmailPayload"
                                query="/EmailPayload/ns18:Subject"/>
                        </copy>
                        <copy>
                            <from expression="bpws:getVariableData(''gCustomerInfoVariable'',''parameters'',''/ns6:findCustomerInfoVO1CustomerInfoVOCriteriaResponse/ns6:result/ns4:ConfirmedEmail'')"/>
                            <to variable="varNotificationReq"
                                part="EmailPayload"
                                query="/EmailPayload/ns18:To"/>
                        </copy>
                        <copy>
                            <from expression="concat(string(''Dear ''), bpws:getVariableData(''gCustomerInfoVariable'',''parameters'',''/ns6:findCustomerInfoVO1CustomerInfoVOCriteriaResponse/ns6:result/ns4:FirstName'') , string('',
your order has been shipped.''))"/>
                            <to variable="varNotificationReq"
                                part="EmailPayload"
                                query="/EmailPayload/ns18:Content/ns18:ContentBody"/>
                        </copy>
                        <copy>
                            <from expression="string(''text/html; charset=UTF-8'')"/>
                            <to variable="varNotificationReq"
                                part="EmailPayload"
                                query="/EmailPayload/ns18:Content/ns18:MimeType"/>
                        </copy>
                    </assign>
                    <invoke name="InvokeNotificationService"
                            portType="ns18:NotificationService"
                            partnerLink="NotificationService_WSDL"
                            inputVariable="varNotificationReq"
                            outputVariable="varNotificationResponse"
                            operation="sendEmailNotification"/>
                </sequence>
            </scope>
        </scope>
        <invoke name="callbackClient" partnerLink="orderprocessor_client_ep" portType="client:OrderProcessorCallback" operation="processResponse" inputVariable="outputVariable"/>
    </sequence>
</process>
'! !
